<?php
/*************************************************************************/
/* DOCEBO CMS - Content Management System                                */
/* ============================================                          */
/*                                                                       */
/* Copyright (c) 2005 by Giovanni Derks <virtualdarkness[AT]gmail-com>   */
/* http://www.docebocms.org                                              */
/*                                                                       */
/* This program is free software. You can redistribute it and/or modify  */
/* it under the terms of the GNU General Public License as published by  */
/* the Free Software Foundation; either version 2 of the License.        */
/*************************************************************************/


function getCmsLang() {
	//REQUIRES: $newLang exist
	//EFFECTS : return the correct language
	global $defaultCmsLanguage;

	if(isset($_SESSION['sesCmsLanguage']) && ($_SESSION['sesCmsLanguage'] != ''))
		return $_SESSION['sesCmsLanguage'];
	else return getLanguage();
}


/* old
function loadCmsLang($name, $pre="") {
	//REQUIRES: $name valid
	//EFFECTS : include language files
	$fn='modules/'.$name.'/'.getCmsLang().'/'.$pre.'language.php';
	@include($fn);
	//--debug--//
	if (!file_exists($fn)) echo("[DEBUG] Not Found: $fn");
} */



function getLangFlags() {
	$use_mod_rewrite=$GLOBALS["cms"]["use_mod_rewrite"];

	$res="";

	$lang=& DoceboLanguage::createInstance('blind_navigation', 'cms');
	$blind_link="<li><a href=\"#lang_box\">".$lang->def("_LANG_SELECT")."</a></li>";
	$GLOBALS["page"]->add($blind_link, "blind_navigation");

	$qtxt="";
	$qtxt.="SELECT t1.lang_code, t1.lang_description FROM ".$GLOBALS["prefix_fw"]."_lang_language as t1, ".$GLOBALS["prefix_cms"]."_area as t2 ";
	$qtxt.="WHERE t2.langdef='1' AND t2.publish='1' AND t1.lang_code=t2.title";

	$q=mysql_query($qtxt);

	if (($q) && (mysql_num_rows($q) > 0)) {
		while ($row=mysql_fetch_array($q)) {
			$name=$row["lang_description"];

			if (strtolower($use_mod_rewrite) == "off") {
				$res.="\n<a href=\"index.php?special=changelang&amp;newLang=".$row["lang_code"]."\">";
			}
			else {
				$file_title=format_mod_rewrite_title($name);
				$res.="<a href=\"set-language_".$file_title."-".$row["lang_code"].".html\">";
			}

			$res.="<img src=\"".getPathImage()."language/".$row["lang_code"].".gif\" alt=\"$name\" title=\"$name\" /></a>\n";
		}
	}

	return $res;
}



function loadMenuOver() {
	$use_mod_rewrite=$GLOBALS["cms"]["use_mod_rewrite"];

	$lang_root=get_lang_root();
	$current=getIdArea();

	$lang=& DoceboLanguage::createInstance('blind_navigation', 'cms');
	$blind_link="<li><a href=\"#menuover_box\">".$lang->def("_MENU_OVER")."</a></li>";
	$GLOBALS["page"]->add($blind_link, "blind_navigation");

	$res="";

	$query = "
	SELECT area.idArea, area.title, area.mr_title, area.alias, area.home, area.link
	FROM ".$GLOBALS["prefix_cms"]."_area AS area
	WHERE area.lev = '2' AND
		area.path LIKE '$lang_root%' AND
		area.publish = '1'
		ORDER BY area.path";
	$reMenu = mysql_query($query);

	$res.="<ul>";

	//$res.='<div class="menublockclose"></div>';
	while(list($id_area, $page_title, $mr_title, $alias, $home, $link) = mysql_fetch_row($reMenu)) {

		if (checkRoleForItem("page", $id_area)) {

			$class=($current == $id_area ? "class=\"selected\"" : "class=\"link\"");
			$class_ext=($current == $id_area ? "selected" : "link");

			if ($alias != "")
				$title=$alias;
			else
				$title=$page_title;

			if ($link != "") {
				$host=$_SERVER['HTTP_HOST'];
				if (!strstr($link, $host)) $new_win=true; else $new_win=false;

				if (!$new_win)
					$res.="<li><a ".$class." href=\"$link\">";
				else
					$res.="<li>".open_ext_link($link, $class_ext);
			}
			else {

				if ($home) {
					$res.='<li><a '.$class.' href="'.$GLOBALS["where_cms_relative"].'/">';
				}
				else {

					if (strtolower($use_mod_rewrite) == "off") {
						$res.='<li><a '.$class.' href="index.php?special=changearea&amp;newArea='.$id_area.'">';
					}
					else {
						$res.="<li>".getMrOpenLink($id_area, $title, $mr_title, $class);
					}

				}
			}

			$res.=$title;

			$res.='</a></li>';
		}
	}

	$res.="</ul>";

	return $res;
}


function getMrOpenLink($id_area, $title, $mr_title, $class) {

	if ($mr_title != "") {
		$file_title=format_mod_rewrite_title($mr_title);
	}
	else {
		$file_title=format_mod_rewrite_title($title);
	}
	$res="<a ".$class." href=\"page/".$id_area."/".$file_title.".html\">";

	return $res;
}


// -------------------------- Header/Meta information output -----------------------------

/**
 * function loadCmsMeta
 * output the meta information for the selected page according to the id of the selected
 * area. It also checks for orphans parent blocks (pb) id and when they are found a
 * NO INDEX tag is added to prevent search engine indexing an empty page
 *
 * @return a string with the meta information that has to be displayed in the page header
 * @author Giovanni Derks
 **/
function setCmsTitle() {

	$header_meta="";

	// Looking for orphans blocks and prevent them to be indexed

	$meta_noindex_page ="<meta name=\"robots\" content=\"noindex\" />\n"; //, nofollow
	$meta_noindex_page.="<meta name=\"robots\" content=\"noarchive\" />\n";
	if ((isset($GLOBALS)) && ((int)$GLOBALS["pb"] > 0)) {
		$qtxt="SELECT * FROM ".$GLOBALS["prefix_cms"]."_area_block WHERE idBlock='".(int)$GLOBALS["pb"]."'";
		$q=mysql_query($qtxt);

		if ($q) {
			if (mysql_num_rows($q) <= 0) {
				$header_meta.=$meta_noindex_page;
				return "";
			}
		}

	}

	// ---------------------------------------------------------

	$idArea=getIdArea();

	$fields="browser_title, keyword, sitedesc";
	$qtxt="SELECT $fields FROM ".$GLOBALS["prefix_cms"]."_area WHERE idArea='$idArea'";
	$q=mysql_query($qtxt);

	if (($q) && (mysql_num_rows($q) > 0)) {
		$row=mysql_fetch_array($q);

		$browser_title=$row["browser_title"];
		$keyword=$row["keyword"];
		$sitedesc=$row["sitedesc"];
	}
	else // Query failed, aborting..
		return "";

	$load_default=0;
	foreach ($row as $key=>$val) {
		if ($val == "") $load_default=1;
	}

	if ($load_default) {
		//$lang=get_area_lang($idArea);
		$default_info=get_default_meta(getLanguage());

		if ($browser_title == "") $browser_title=$default_info["browser_title"];
		if ($keyword == "") $keyword=$default_info["keyword"];
		if ($sitedesc == "") $sitedesc=$default_info["sitedesc"];
	}

	$keyword=preg_replace("(\n|\r)", "", $keyword);
	$sitedesc=preg_replace("(\n|\r)", "", $sitedesc);

	$GLOBALS["title_page"]=stripslashes($browser_title);
	$header_meta.="<meta name=\"keywords\" content=\"".stripslashes($keyword)."\" />\n";
	$header_meta.="<meta name=\"description\" content=\"".stripslashes($sitedesc)."\" />\n";

	$GLOBALS["header_meta"]=$header_meta;
}


function setPageTemplate() {
	$area_id=getIdArea();

	$key=array("page_template", $area_id, "name");

	if (!getItemValue($key)) {
		$fields="template";
		$qtxt="SELECT $fields FROM ".$GLOBALS["prefix_cms"]."_area WHERE idArea='".$area_id."'";
		$q=mysql_query($qtxt); //echo("\n\n<!-- $qtxt -->\n\n");

		$row=array();
		$template="";
		if (($q) && (mysql_num_rows($q) > 0)) {
			$row=mysql_fetch_array($q);
			$template=$row["template"];
		}

		setItemValue($key, $template);
	}
	else
		$template=getItemValue($key);

	setTemplate($template);
}


function get_default_meta($lang) {

	$key=array("cms_default", $lang, "isset");

	if (!getItemValue($key)) {
		$fields="browser_title, keyword, sitedesc";
		$qtxt="SELECT $fields FROM ".$GLOBALS["prefix_cms"]."_area WHERE title='$lang' AND langdef='1'";
		$q=mysql_query($qtxt); //echo("\n\n<!-- $qtxt -->\n\n");

		$row=array();
		if (($q) && (mysql_num_rows($q) > 0)) {
			$row=mysql_fetch_array($q);
		}

		setItemValue(array("cms_default", $lang, "isset"), 1);
		setItemValue(array("cms_default", $lang, "browser_title"), $row["browser_title"]);
		setItemValue(array("cms_default", $lang, "keyword"), $row["keyword"]);
		setItemValue(array("cms_default", $lang, "sitedesc"), $row["sitedesc"]);

		return $row;
	}
	else {
		$res["browser_title"]=getItemValue(array("cms_default", $lang, "browser_title"));
		$res["keyword"]=getItemValue(array("cms_default", $lang, "keyword"));
		$res["sitedesc"]=getItemValue(array("cms_default", $lang, "sitedesc"));

		return $res;
	}

}



/**
 * @param string	$text		The title of the area
 * @param string	$image		not used
 * @param string	$alt_image	not used
 *
 * @return string 	the code for a graceful title area
 */
function getCmsTitleArea($text, $image = '', $alt_image = '') {

	$image="not used!";
	$alt_image="not used!";

	$is_first = true;
	if(!is_array($text))
		$text = array($text);

	$html = '<div class="area_block">'."\n";

	foreach($text as $link => $title) {

		if($is_first) {

			$is_first = false;

			// Area title
			//$html .= '<h1 id="main_area_title" class="main_title_'.$image.'">'.$title.'</h1>'."\n";

			$GLOBALS['page']->add('<li><a href="#main_area_title">'.def('_JUMP_TO', 'standard').' '.$title.'</a></li>', 'blind_navigation');

			// Init navigation
			if(count($text) > 1) {
				$html .= '<ul class="navigation">';
				if(!is_int($link)) {
					$html .= '<li><a href="'.$link.'">'.def('_START_PAGE', 'standard').' '.strtolower($title).'</a></li>';
				} else $html .= '<li>'.def('_START_PAGE', 'standard').' '.strtolower($title).'</li>';
			}
		} else {

			if(is_int($link)) $html .= '<li> &gt; '.$title.'</li>';
			else $html .= ' <li> &gt; <a href="'.$link.'">'.$title.'</a></li>';
		}
	}
	if(count($text) > 1) $html .= '</ul>'."\n";
	$html .= '</div>'."\n";


	if (count($text) <= 1)
		$html="";

	return $html;
}


function setPageLanguage($check_language=TRUE) {
	$area_id=getIdArea();

	$key=array("page_language", $area_id, "name");

	if (!getItemValue($key)) {
		$language=get_area_lang($area_id, TRUE);
		setItemValue($key, $language);
	}
	else
		$language=getItemValue($key);


	setLanguage($language);
	if ($check_language)
		checkCmsLanguage();
}


function checkCmsLanguage() {

	if (!isset($_SESSION["cms_lang_check"])) {

		$cms_lang=get_lang_list();

		if ((is_array($cms_lang)) && (count($cms_lang) > 0) && (!in_array(getLanguage(), $cms_lang))) {

			setLanguage($cms_lang[0]);

		}
	}

	$_SESSION["cms_lang_check"]=1;
}


function getAdminQuickLink() {
	$res="";

	$level=$GLOBALS["current_user"]->getUserLevelId();
	$is_admin=($level == ADMIN_GROUP_ADMIN ? TRUE : FALSE);
	$is_god_admin=($level == ADMIN_GROUP_GODADMIN ? TRUE : FALSE);
	if (($is_admin) || ($is_god_admin)) {

		$title=def('_GOTO_ADMIN', 'standard');
		$img="<img src=\"".getPathImage()."standard/goto_admin.gif\" alt=\"".$title."\" title=\"".$title."\" />";
		$res.="<a href=\"".$GLOBALS["where_framework_relative"]."/\">".$img."</a>";

	}

	return $res;
}


function getLogoutQuickLink() {
	$res="";

	if (!$GLOBALS["current_user"]->isAnonymous()) {

		$title=def('_LOG_LOGOUT', 'login');
		$img="<img src=\"".getPathImage()."standard/logout.gif\" alt=\"".$title."\" title=\"".$title."\" />";
		$res.="<a href=\"index.php?action=logout\">".$img."</a>";

	}

	return $res;
}


// ---------------------------------------------------------------------------------------


?>
