<?php
/*************************************************************************/
/* DOCEBO CMS - Content Management System                                */
/* ============================================                          */
/*                                                                       */
/* Copyright (c) 2005 by Giovanni Derks <virtualdarkness[AT]gmail-com>   */
/* http://www.docebocms.org                                              */
/*                                                                       */
/* This program is free software. You can redistribute it and/or modify  */
/* it under the terms of the GNU General Public License as published by  */
/* the Free Software Foundation; either version 2 of the License.        */
/*************************************************************************/

define("_MODERATOR", "moderate");
$GLOBALS["page"]->add('<link href="'.getPathTemplate().'style/style_teleskill.css" rel="stylesheet" type="text/css" />'."\n", "page_head");

function teleskill() {
	//checkTeleskillPerm('view');
	$lang=& DoceboLanguage::createInstance('chat', 'cms');

	require_once($GLOBALS['where_framework'].'/lib/lib.newtypeone.php');
	require_once($GLOBALS['where_scs'].'/lib/lib.teleskill.php');

	$role = 1;
	$conference = new Teleskill_Management();

	$GLOBALS['page']->add(
		getCmsTitleArea($lang->def('_TELESKILL_TITLE'), 'teleskill')
		.'<div class="std_block">', 'content');

	if(checkTeleskillPerm(_MODERATOR, true)) {

		$role = 2;
		$can_open_room = $conference->canOpenRoom(date("Y-m-d H:i:s"), date("Y-m-d H:i:s", time() + 3600));
		if($can_open_room['errorcode'] == 0) {

			$GLOBALS['page']->add(
				'<div class="teleskill_createnew_home">'
				.'<ul>'
				.'<li><a id="customroom" href="index.php?mn=chat&amp;pi='.getPI().'&amp;op=createroom">'.$lang->def('_CANOPENNEWROOM').'</a></li>'
				.'<li><a id="quickroom" href="index.php?mn=chat&amp;pi='.getPI().'&amp;op=quickroom">'.$lang->def('_QUICK_OPEN').'</a></li>'
				.'</ul>'
				.'</div>', 'content');
		} else {

			$GLOBALS['page']->add(getErrorUi($can_open_room['errormessage']), 'content');
		}
	}
	$re_room = $conference->roomActive($GLOBALS["pb"], 'cms', date("Y-m-d H:i:s"));
	$room_number = $conference->totalRoom($re_room);

	switch($room_number) {
		case 0 : {

			$GLOBALS['page']->add('<strong id="noroom">'.$lang->def('_NO_ROOM_AVAILABLE').'</strong>', 'content');
		};break;
		default : {

			$tb = new TypeOne(0, $lang->def('_ROOM_AVAILABLE'), $lang->def('_SUMMARY_ROOM_AVAILABLE'));
			$tb->setTableStyle('teleskill_room_available');

			$cont_h = array(	$lang->def('_TH_ROOM_TITLE'),
								$lang->def('_TH_START_DATE'),
								$lang->def('_TH_END_TIME'),
								$lang->def('_ROOM_LOGIN') );
			$type_h = array('room_title', 'teleskill_date', 'teleskill_date', 'teleskill_login');
			$tb->setColsStyle($type_h);
			$tb->addHead($cont_h);

			while($room = $conference->nextRow($re_room)) {

				$login_info = $conference->loginIntoRoom(	$room[TELESKILL_ROOMID],
										$role,
										getLogUserId(),
										$GLOBALS['current_user']->getUserName() );

				$open_for = fromDatetimeToTimestamp($room[TELESKILL_END_DATE]) - time();

				$cont = array();
				$cont[] = $room[TELESKILL_TITLE];
				$cont[] = $GLOBALS['regset']->databaseToRegional($room[TELESKILL_START_DATE]);
				$cont[] = (int)($open_for / 60).$lang->def('_MINUTE_SYMBOL').' '.($open_for % 60).$lang->def('_SECOND_SYMBOL');
				if($login_info['errorcode'] == 0) {

					if($login_info['fullroom'] == 1) {

						$cont[] = $lang->def('_FULLROOM');
					} else {

						$cont[] = '<a href="'.$login_info['url'].'"
								onclick="window.open(\''.$login_info['url'].'\', \'TeleSkill\', \'width=1000,height=700,toolbar=no,menubar=no,directories=no,resizable=yes,scrollbar=yes\'); return false;"
								onkeypress="window.open(\''.$login_info['url'].'\', \'TeleSkill\', \'width=1000,height=700,toolbar=no,menubar=no,directories=no,resizable=yes,scrollbar=yes\'); return false;">'
							.$lang->def('_ACCESS_TO_CONFERENCE')
							.'</a>';
					}
				} else {

					$cont[] = '';
				}
				$tb->addBody($cont);
			}
			$GLOBALS['page']->add($tb->getTable(), 'content');
		}
	}
	// ------------------------------------------------------
	$re_next_room = $conference->roomPlanned($GLOBALS["pb"], 'cms', date("Y-m-d H:i:s"));
	if($conference->totalRoom($re_next_room) > 0) {

		$tbf = new TypeOne(0, $lang->def('_ROOM_PLANNED'), $lang->def('_SUMMARY_ROOM_PLANNED'));
		$tbf->setTableStyle('teleskill_room_available');

		$cont_h = array(	$lang->def('_TH_ROOM_TITLE'),
							$lang->def('_TH_START_DATE'),
							$lang->def('_TH_DURATION') );
		$type_h = array('room_title', 'teleskill_date', 'teleskill_date');
		$tbf->setColsStyle($type_h);
		$tbf->addHead($cont_h);

		while($room = $conference->nextRow($re_next_room)) {

			$open_for = fromDatetimeToTimestamp($room[TELESKILL_END_DATE]) - fromDatetimeToTimestamp($room[TELESKILL_START_DATE]);
			$distance = getArrayGap(fromDatetimeToTimestamp($room[TELESKILL_START_DATE]), time());

			$cont = array();
			$cont[] = $room[TELESKILL_TITLE];
			$cont[] = $GLOBALS['regset']->databaseToRegional($room[TELESKILL_START_DATE]).' ';
			$cont[] = (int)($open_for / 60).$lang->def('_MINUTE_SYMBOL');

			$tbf->addBody($cont);
		}
		$GLOBALS['page']->add($tbf->getTable(), 'content');
	}
	$GLOBALS['page']->add('</div>', 'content');
}

function createroom() {
	checkTeleskillPerm(_MODERATOR);
	$lang=& DoceboLanguage::createInstance('chat', 'cms');

	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_scs'].'/lib/lib.teleskill.php');

	$role = 1;
	$conference = new Teleskill_Management();

	$conference->deleteOldRoom($GLOBALS["pb"],
							'cms',
							date("Y-m-d H:i:s", time() - 1800) );

	if(isset($_POST['create_room'])) {

		$conference = new Teleskill_Management();

		$start_date = $GLOBALS['regset']->regionalToDatabase($_POST['start_date'], 'date');
		$start_date = substr($start_date, 0, 10);

		$start_time = ( strlen($_POST['start_time']['hour']) == 1 ? '0' : '' ).$_POST['start_time']['hour'].':'
			.( strlen($_POST['start_time']['minute']) == 1 ? '0' : '' ).$_POST['start_time']['minute'].':00';

		$start_timestamp = fromDatetimeToTimestamp($start_date.' '.$start_time);
		$end_timestamp = $start_timestamp + ($_POST['session_hour']+1) * 3600;
		$end_date = date("Y-m-d H:i:s", $end_timestamp);
		$re_creation_room = $conference->openRoom($GLOBALS["pb"], 'cms', $_POST['room_title'], $start_date.' '.$start_time, $end_date);
		if($re_creation_room['errorcode'] != 0) {

			jumpTo('index.php?mn=chat&amp;pi='.getPI().'&amp;op=teleskill');
		}
		jumpTo('index.php?mn=chat&amp;pi='.getPI().'&amp;op=teleskill');
	}

	$session_hours 			= range(1, 4);
	$start_time['hour'] 	= date('H');
	$start_time['minute'] 	= date('i');
	$start_date = importVar('start_date', false, date("Y-m-d H:i:s"));

	$GLOBALS['page']->add(
		getCmsTitleArea($lang->def('_TELESKILL_TITLE'), 'teleskill')
		.'<div class="std_block">'

		.Form::openForm('createroom', 'index.php?mn=chat&amp;pi='.getPI().'&amp;op=createroom')
		.Form::openElementSpace()

		.Form::getTextfield($lang->def('_ROOM_TITLE'), 	'room_title', 'room_title', 255, importVar('room_title', false, ''))
		.Form::getDatefield($lang->def('_START_DATE'), 	'start_date', 'start_date',
			$GLOBALS['regset']->databaseToRegional($start_date, 'date') )
		.Form::getLineBox(
			$lang->def('_AT_HOUR'),
			Form::getInputDropdown('', 'start_time_hour', 'start_time[hour]', range(0, 23),
				$start_time['hour'], '')
			.' : '.Form::getInputDropdown('', 'start_time_minute', 'start_time[minute]', range(0, 59),
				$start_time['minute'], '')
		)
		.Form::getDropdown($lang->def('_SESSION_HOUR'), 'session_hour', 'session_hour', $session_hours, importVar('session_hour', true, 0))

		.Form::closeElementSpace()

		.Form::openButtonSpace()
		.Form::getButton('create_room', 'create_room', $lang->def('_CREATE_ROOM'))
		.Form::getButton('undo', 'undo', $lang->def('_UNDO'))
		.Form::closeButtonSpace()
		.Form::closeForm()
		.'</div>' , 'content');
}

function quickroom() {
	checkTeleskillPerm(_MODERATOR);
	$lang=& DoceboLanguage::createInstance('chat', 'cms');

	require_once($GLOBALS['where_scs'].'/lib/lib.teleskill.php');

	$block_id=$GLOBALS["pb"];
	$b_info=getBlockInfo($block_id);

	$conference = new Teleskill_Management();

	// delete old room from database
	$conference->deleteOldRoom($block_id,
							'cms',
							date("Y-m-d H:i:s", time() - 1800) );

	$re_creation_room = $conference->openRoom(	$GLOBALS["pb"],
												'cms',
												$b_info["title"],
												date("Y-m-d H:i:s"),
												date("Y-m-d H:i:s", time() + 3600));
	jumpTo('index.php?mn=chat&amp;pi='.getPI().'&amp;op=teleskill');
}


// ----------------------------------------------------------------------------

function checkTeleskillPerm($mode, $return_value=FALSE) {

    $block_id=$GLOBALS["pb"];
    $role_id="/cms/chat/teleskill/block/".$block_id."/".$mode;

    $acl=$GLOBALS["current_user"]->getAcl();
    if ($acl->getRoleST($role_id))
        $res=$GLOBALS["current_user"]->matchUserRole($role_id);
    else
        $res=FALSE;

    if ($return_value)
        return $res;
    else
        if (!$res) die("You can't access!");
} 

// ----------------------------------------------------------------------------


function teleskillDispatch($op) {

	$GLOBALS['page']->add('<link href="'.getPathTemplate().'style/style_teleskill.css" rel="stylesheet" type="text/css" />'."\n", 'page_head');

	if(isset($_POST['undo'])) $op = 'teleskill';
	switch($op) {
		case "quickroom" : {
			quickroom();
		};
		case "teleskill" : {
			teleskill();
		};break;
		case "createroom" : {
			createroom();
		};break;
	}
}

?>