<?php

/*************************************************************************/
/* DOCEBO FRAMEWORK                                                      */
/* ============================================                          */
/*                                                                       */
/* Copyright (c) 2005 by Giovanni Derks <giovanni[AT]docebo-com>         */
/* http://www.docebo.com                                                 */
/*                                                                       */
/* This program is free software. You can redistribute it and/or modify  */
/* it under the terms of the GNU General Public License as published by  */
/* the Free Software Foundation; either version 2 of the License.        */
/*************************************************************************/


if(!defined('IN_DOCEBO')) die('You cannot access this file directly!');


require_once($GLOBALS['where_framework'].'/lib/lib.utils.php');

$page_url = getPopupBaseUrl();

if ((isset($_GET["op"])) && ($_GET["op"] != ""))
	$op=substr($_GET["op"], 0, 60);
else
	$op="main";

// ---------- Popup Menu ----------------------

$menu_label 	= array();
$menu_url 		= array();

if(canAccessPersonalMedia()) {
	$menu_label["personal"]=$lang->def("_PERSONAL_MEDIA");
	$menu_url["personal"]=$page_url."&amp;op=personal";
}

if(canAccessCmsMedia()) {
	$menu_label["cms"]=$lang->def("_CMS_MEDIA");
	$menu_url["cms"]=$page_url."&amp;op=cms";
}

// ---------------------------------------------

if ((canAccessPersonalMedia()) || (canAccessCmsMedia()))
	drawMenu($menu_label, $menu_url, $op);

// --------------------------------------------------------------------------------------------

$GLOBALS['page']->add(
		'<link href="'.$GLOBALS["where_framework_relative"].'/templates/standard/style/style_treeview.css" rel="stylesheet" type="text/css" />'."\n",
		'page_head');

// --------------------------------------------------------------------------------------------

define("_USER_FPATH_INTERNAL", "/common/users/");
define("_USER_FPATH", $GLOBALS["where_files_relative"]._USER_FPATH_INTERNAL);

define("_FPATH_INTERNAL", "/doceboCms/media/");
define("_FPATH", $GLOBALS["where_files_relative"]._FPATH_INTERNAL);

define("_PPATH_INTERNAL", "/doceboCms/media/preview/");
define("_PPATH", $GLOBALS["where_files_relative"]._PPATH_INTERNAL);


switch ($op) {

	case "main": {
		show_main($out, $lang);
	} break;

	case "cms": {
		show_cms_media($out, $lang);
	} break;

	case "personal": {
		show_personal_media($out, $lang);
	} break;

	case "addpersonal": {
		add_personal_media($out, $lang);
	} break;

	case "inspersonal": {
		ins_personal_media();
	} break;

	case "delpersonal": {
		del_personal_media($out, $lang);
	} break;

	case "select": {
		select_media($out, $lang);
	} break;
}

// --------------------------------------------------------------------------------------------

function canAccessPersonalMedia() {

	$level_id = $GLOBALS['current_user']->getUserLevelId();
	if($GLOBALS['current_user']->isAnonymous()) return false;
	
	if ( (($GLOBALS["fck_image_godadmin"]) && ($level_id == ADMIN_GROUP_GODADMIN)) ||
		(($GLOBALS["fck_image_admin"]) && ($level_id == ADMIN_GROUP_ADMIN)) ||
		(($GLOBALS["fck_image_user"]) && ($level_id == ADMIN_GROUP_USER)) ) {
		
		return true;
	} else {
		return false;
	}
}


function canAccessCmsMedia() {

	require_once($GLOBALS['where_framework'].'/lib/lib.platform.php');
	$pl =& PlatformManager::createInstance();
	
	if(!$pl->isLoaded('cms')) return false;
	
	$level_id = $GLOBALS['current_user']->getUserLevelId();
	if($GLOBALS['current_user']->isAnonymous()) return false;
	
	if ( (($GLOBALS["fck_image_godadmin"]) && ($level_id == ADMIN_GROUP_GODADMIN)) ||
		(($GLOBALS["fck_image_admin"]) && ($level_id == ADMIN_GROUP_ADMIN)) ||
		(($GLOBALS["fck_image_user"]) && ($level_id == ADMIN_GROUP_USER))) {

		if (($GLOBALS["where_cms"] === false) || ($GLOBALS["where_cms_relative"] === false))
			return false; // There is no CMS installed!
		else
			return true;
	} else {
		return false;
	}
}



function show_main(& $out, & $lang) {
	
	if ((canAccessPersonalMedia()) || (canAccessCmsMedia()))
		$out->add($lang->def("_POPUP_MEDIA_INTRO"));
	else
		$out->add("<span style=\"color: #FF0000;\">".$lang->def("_POPUP_MEDIA_NOACCESS")."</span>\n");
}



function show_personal_media(& $out, & $lang) {
	
	if (!canAccessPersonalMedia())
		die("You can't access!");
		
	require_once($GLOBALS["where_framework"]."/lib/lib.newtypeone.php");
	require_once($GLOBALS["where_framework"]."/lib/lib.mimetype.php");
	
	$url 		= getPopupBaseUrl();
	$tab 		= new typeOne();
	$user_id 	= (int)$GLOBALS["current_user"]->getIdSt();
	
	$head = array($lang->def("_PREVIEW"), $lang->def("_TYPE"), $lang->def("_FILENAME"));
	$head[] = "<img src=\"".getPathImage()."standard/attach.gif\" alt=\"".$lang->def("_ATTACH")."\" title=\"".$lang->def("_ATTACH")."\" />";
	$head[] = "<img src=\"".getPathImage()."standard/rem.gif\" alt=\"".$lang->def("_ALT_DEL")."\" title=\"".$lang->def("_ALT_DEL")."\" />";
	$head_type = array('preview80', 'image', '', 'image', 'image');
	
	$tab->setColsStyle($head_type);
	$tab->addHead($head);
	
	$qtxt = "
	SELECT * 
	FROM ".$GLOBALS["prefix_fw"]."_user_file 
	WHERE user_idst='".$user_id."'";
	$q = mysql_query($qtxt);
	
	if (($q) && (mysql_num_rows($q) > 0)) {
		while($row = mysql_fetch_array($q)) {
			
			$rowcnt = array();
			
/*			$file=_DOCS_FPATH.$row["real_fname"];
			$url="download.php?type=docs&amp;pb=$pb&amp;id=".$row["idDocs"];
			$img ="<img src=\"".getPathImage().mimeDetect($file)."\" alt=\"".$row["fname"]."\" title=\"".$lang->def("_DOWNLOAD").": ";
			$img.=$row["fname"]."\" />\n";
			$rowcnt[]="<a class=\"icon_link\" href=\"".$url."\">".$img."</a>\n";

			//$url="index.php?mn=docs&amp;pi=".getPI()."&amp;op=showdoc&amp;folder=".$row["idFolder"]."&amp;id=".$row["idDocs"];
			//$rowcnt[]="<a class=\"details_link\" href=\"".$url."\">".$row["fname"]."</a>\n";
			if ($row["title"] != "")
				$rowcnt[]=open_ext_link($url, "file_link").$row["title"]."</a>";
			else
				$rowcnt[]=open_ext_link($url, "file_link").$row["fname"]."</a>";

			$img="<img class=\"cat_item_img\" src=\"".getPathImage()."block/description.gif\" alt=\" \" title=\" \" />\n";
			$showitem_url="index.php?mn=docs&amp;pi=".getPI()."&amp;op=showdoc&amp;folder=".$row["idFolder"]."&amp;id=".$row["idDocs"];
			$img_comment="<img class=\"cat_item_img\" src=\"".getPathImage()."block/comments.gif\" alt=\" \" title=\" \" />\n";
			$link="<a href=\"".$showitem_url."\">".$img."</a>\n";
			$rowcnt[]=$link.$row["sdesc"]; //."<div class=\"details_link\">".$img_comment.$link."</div>\n";

			$img="<img class=\"cat_item_img\" src=\"".getPathImage()."block/clicks.gif\" alt=\" \" title=\" \" />\n";
			$rowcnt[]=$img."( ".$row["click"]." )";
			$rowcnt[]="<a href=\"".$showitem_url."\">".$img_comment."</a>( <a href=\"".$showitem_url."\">".$row["com_cnt"]."</a> )\n";; */
			
			$file = _USER_FPATH.rawurlencode($row["real_fname"]);
			$rowcnt[] = "<img src=\"".$file."\" alt=\"".$row["fname"]."\" title=\"".$row["fname"]."\" />";
			
			$img = "<img src=\"".getPathImage('fw').mimeDetect($file)."\" alt=\"".$row["fname"]."\" title=\" ";
			$img .= $row["fname"]."\" />\n";
			$rowcnt[] = $img;
			
			$rowcnt[]=$row["fname"];
			
			$img = "<img src=\"".getPathImage('fw')."standard/attach.gif\" alt=\"".$lang->def("_ATTACH")."\" title=\"".$lang->def("_ATTACH")."\" />\n";
			$rowcnt[] = "<a href=\"".$url."&amp;op=select&amp;from=personal&amp;item_id=".$row["id"]."\">".$img."</a>\n";
			
			$img = "<img src=\"".getPathImage('fw')."standard/rem.gif\" alt=\"".$lang->def("_ALT_DEL")."\" title=\"".$lang->def("_ALT_DEL")."\" />\n";
			$rowcnt[] = "<a href=\"".$url."&amp;op=delpersonal&amp;item_id=".$row["id"]."\">".$img."</a>\n";
			
			$tab->addBody($rowcnt);
		}
	}
	$url = getPopupBaseUrl()."&amp;op=addpersonal";
	$tab->addActionAdd("<a href=\"".$url."\">".$lang->def("_ADDELEM")."</a>");
	
	if(isset($_GET['result'])) {
		switch($_GET['result']) {
			case "invalid_ext" : $out->add(getErrorUi($lang->def('_INVALID_EXTENSION')));break;
			case "upload_err" 	: $out->add(getErrorUi($lang->def('_ERROR_UPLOAD')));break;
			case "upload_ok" 	: $out->add(getResultUi($lang->def('_OPERATION_SUCCESSFUL')));break;
		}
	}
	$out->add($tab->getTable());
}

function add_personal_media(& $out, & $lang) {
	
	if (!canAccessPersonalMedia())
		die("You can't access!");
	
	require_once($GLOBALS["where_framework"]."/lib/lib.form.php");
	
	$url 	= getPopupBaseUrl()."&amp;op=inspersonal";
	$form 	= new Form();

	$out->add(
 		$form->openForm("popup_form", $url, false, false, "multipart/form-data")
		
		.$form->openElementSpace()
		.$form->getFilefield($lang->def("_FILENAME"), "file", "file")
		.$form->closeElementSpace()
		
		.$form->openButtonSpace()
		.$form->getButton('save', 'save', $lang->def('_SAVE'))
		.$form->getReset('undo', 'undo', $lang->def('_UNDO'))
		.$form->closeButtonSpace()
		
		.$form->closeForm()
	);
}


function ins_personal_media() {
	
	if (!canAccessPersonalMedia())
		die("You can't access!");
	
	include_once($GLOBALS['where_framework']."/lib/lib.upload.php");
	
	$url = getPopupBaseUrl()."&amp;op=personal";
	$user_id 		= $GLOBALS["current_user"]->getIdSt();
	
	$fname 			= $_FILES["file"]["name"];
	$size 			= $_FILES["file"]["size"];
	$tmp_fname 		= $_FILES["file"]["tmp_name"];
	$real_fname 	= $user_id.'_'.mt_rand(0,100).'_'.time().'_'.$fname;
	
	$valid_ext = array("png", "mng", "gif", "jpg", "jpeg");
	$ext = strtolower(end(explode(".", $fname)));
	if (!in_array($ext, $valid_ext))
		jumpTo($url.'&result=invalid_ext');
		
	sl_open_fileoperations();
	$f1 = sl_upload($tmp_fname, _USER_FPATH_INTERNAL.$real_fname);
	sl_close_fileoperations();
	if(!$f1) {
		// upload error
		jumpTo($url.'&result=upload_err');
	}
	
	$qtxt = "INSERT INTO ".$GLOBALS["prefix_fw"]."_user_file ";
	$qtxt .= " ( user_idst, type, fname, real_fname, size, uldate ) VALUES ";
	$qtxt .= " ('".$user_id."', 'image', '".$fname."', '".$real_fname."', '".$size."', NOW())";
	$q = mysql_query($qtxt);
	
	jumpTo($url.'&result='.( $q ? 'upload_ok' : 'upload_err' ));
}



function del_personal_media(& $out, & $lang) {

	include_once($GLOBALS['where_framework']."/lib/lib.upload.php");
	include_once($GLOBALS['where_framework']."/lib/lib.form.php");

	if (isset($_POST["canc_del"])) {
		jumpTo(getPopupBaseUrl()."&amp;op=personal");
	}
	else if (isset($_POST["conf_del"])) {

		$id=(int)$_POST["id"];

		$user_id=$GLOBALS["current_user"]->getIdSt();

		$qtxt ="SELECT real_fname FROM ".$GLOBALS["prefix_fw"]."_user_file ";
		$qtxt.="WHERE id='".$id."' AND user_idst='".$user_id."' AND type='image'";
		$q=mysql_query($qtxt);

		if (($q) && (mysql_num_rows($q) > 0)) {
			$row=mysql_fetch_array($q);
			$real_fname=$row["real_fname"];

			//@sl_unlink(_USER_FPATH.$real_fname);

			$qtxt="DELETE FROM ".$GLOBALS["prefix_fw"]."_user_file WHERE id='$id';";
			$q=mysql_query($qtxt);
		}

		jumpTo(getPopupBaseUrl()."&amp;op=personal");
	}
	else {

		//load info
		$id=(int)importVar("item_id");
		$user_id=$GLOBALS["current_user"]->getIdSt();
		list($fname) = mysql_fetch_row(mysql_query("
		SELECT fname
		FROM ".$GLOBALS["prefix_fw"]."_user_file
		WHERE id='".$id."' AND user_idst='".$user_id."'"));

		$out->add("<div class=\"std_block\">\n");

		$form=new Form();

		$out->add($form->openForm("popup_form", getPopupBaseUrl()."&amp;op=delpersonal"));

		$out->add($form->getHidden("id", "id", $id));

		$out->add(getDeleteUi(
		$lang->def('_AREYOUSURE'),
			'<span class="text_bold">'.$lang->def('_FILENAME').' :</span> '.$fname.'<br />',
			false,
			'conf_del',
			'canc_del'));

		$out->add($form->closeForm());
		$out->add("</div>\n");
	}

}



function show_cms_media(& $out, & $lang) {

	if (!canAccessCmsMedia())
		die("You can't access!");

	require_once($GLOBALS["where_framework"]."/lib/lib.form.php");

	$form=new Form();

	$res="";
	$url=getPopupBaseUrl()."&amp;op=cms";
 	$res.=$form->openForm("block_form", $url);

 	$res.=$form->openElementSpace();

	// ------- mostro albero ----------------------------------------------\

	include_once($GLOBALS["where_cms"]."/admin/modules/media/media_class.php");

	$tree=createTreeView();

	if( isset($_POST[$tree->_getFolderNameId()]) ) { // Al cambio cartella:
		$folderid = $_POST[$tree->_getFolderNameId()];
	}
	else { // La prima volta che carica la pagina con l'albero:
		$folderid = $tree->getSelectedFolderId();
	}

 	$tree->show_icons=0;
 	$tree->setSelMode(true);
 	$tree->setSelModeUrl(getPopupBaseUrl()."&amp;op=select&amp;from=cms");

	$folder=$tree->tdb->getFolderById( $tree->getSelectedFolderId() );
	$res.=$form->getHidden($tree->_getFolderNameId(), $tree->_getFolderNameId(), $folderid);
	$res.=$form->getHidden("folder_id", "folder_id", $tree->getSelectedFolderId());
	//$res.='<div><b>'.$lang->def("_FOLDER").':</b></div>';
	$res.=$tree->load();

	$res.="<br />\n\n";
	$listView = $tree->getListView();
	$listView->setInsNew( false );
	$res.=$listView->printOut();
	// --------------------------------------------------------------------/

 	$res.=$form->closeElementSpace();

	/*$res.=$form->openButtonSpace();
	$res.=$form->getButton('undo', 'undo', $lang->def('_BACK'));
	$res.=$form->closeButtonSpace(); */

	$res.=$form->closeForm();


	$out->add($res);

}

function select_media(& $out, & $lang) {

	require_once($GLOBALS["where_framework"]."/lib/lib.form.php");

	$form=new Form();

	$from=importVar("from");
	$item_id=(int)importVar("item_id");

	$src="";
	$title="";
	$path="";

	switch($from) {

		case "cms": {

			if (!canAccessCmsMedia())
				die("You can't access!");

			$path=_FPATH_INTERNAL;
			$preview_path=_PPATH;

			$qtxt ="SELECT t1.real_fname, t2.title FROM ".$GLOBALS["prefix_cms"]."_media as t1 ";
			$qtxt.="LEFT JOIN ".$GLOBALS["prefix_cms"]."_media_info as t2 ON (t2.idm=t1.idMedia) ";
			$qtxt.="WHERE t1.idMedia='".$item_id."' AND t1.publish='1'";
			$q=mysql_query($qtxt);

			if (($q) && (mysql_num_rows($q) > 0)) {
				$row=mysql_fetch_array($q);
				$src=$row["real_fname"];
				$title=$row["title"];
			}

		} break;

		case "personal": {

			if (!canAccessPersonalMedia())
				die("You can't access!");

			$user_id=$GLOBALS["current_user"]->getIdSt();
			$path=_USER_FPATH_INTERNAL;
			$preview_path=_USER_FPATH;

			$qtxt ="SELECT real_fname FROM ".$GLOBALS["prefix_fw"]."_user_file ";
			$qtxt.="WHERE id='".$item_id."' AND user_idst='".$user_id."' AND type='image'";
			$q=mysql_query($qtxt);

			if (($q) && (mysql_num_rows($q) > 0)) {
				$row=mysql_fetch_array($q);
				$src=$row["real_fname"];
			}

		} break;

	}

	$src=rawurlencode($src);

	$res="";
	$url=getPopupBaseUrl()."&amp;op=main";

	addMediaPopupJS($path.$src);

	$style="width: 100px; padding: 2px; border: 1px solid #AAAAAA; margin-bottom: 0.4em;";
	$res.="<img style=\"".$style."\" src=\"".$preview_path.$src."\" alt=\"".$title."\" title=\"".$title."\" />\n";


 	$res.=$form->openForm("popup_form", $url, false, false, '', "onSubmit=\"insItem();\" onReset=\"closePopup();\"");

 	$res.=$form->openElementSpace();

	$res.=$form->getTextfield($lang->def("_ALT_TXT"), "alt_text", "alt_text", 255, $title);
	$res.=$form->getTextfield($lang->def("_TITLE_TXT"), "title_text", "title_text", 255, $title);
	$res.=$form->getTextfield($lang->def("_BORDER"), "border", "border", 3, "0");

 	$res.=$form->closeElementSpace();

	$res.=$form->openButtonSpace();
	$res.=$form->getButton('apply', 'apply', $lang->def('_OK'));
	$res.=$form->getReset('undo', 'undo', $lang->def('_UNDO'));
	$res.=$form->closeButtonSpace();

	$res.=$form->closeForm();

	$out->add($res);
}



function addMediaPopupJS($src) {

	$res="";

	$sn=$GLOBALS["platform"];
/*	if ($sn != "framework")
		$src=$GLOBALS[$sn]["url"].$GLOBALS["where_files_relative"]."/".$src;
	else
		$src=$GLOBALS["url"].$GLOBALS["where_files_relative"]."/".$src; */

	$path =(strlen(dirname($_SERVER['PHP_SELF'])) != 1 ? dirname($_SERVER['PHP_SELF']) : '' ).'/';
	$path.=$GLOBALS["where_files_relative"]."/";

	//-- test : //
	//echo(cleanUrlPath("http://127.0.0.1:88/folder/folder/doceboCore//addons/./mod_media/../../../files/common/")); return 0;


	$site_url="http://".$_SERVER['HTTP_HOST'].$path;
	$src=cleanUrlPath($site_url.$src);

//	$src=str_replace("//", "/", $src);

	$res.="<script type=\"text/javascript\"><!--\n";

		$res.="function GetE( elementId )\n";
		$res.="{\n";
			$res.="return document.getElementById( elementId )  ;\n";
		$res.="}\n";

		$res.="function insItem() {\n";

		$res.="dialogArguments = window.opener.FCKLastDialogInfo ;\n";
		$res.="var oEditor		= dialogArguments.Editor ;\n";
		$res.="var FCK			= oEditor.FCK ;\n";
		$res.="var FCKLang		= oEditor.FCKLang ;\n";
		$res.="var FCKConfig	= oEditor.FCKConfig ;\n";

		$res.="var titleTxt = GetE('title_text').value;\n";
		$res.="var altTxt = GetE('alt_text').value;\n";
		$res.="var borderVal = GetE('border').value;\n";

		$res.="// Get the selected image (if available).\n";
		$res.="var oImage = FCK.Selection.GetSelectedElement() ;\n";

		$res.="var bHasImage = ( oImage != null ) ;\n";

		$res.="if ( !bHasImage ) {\n";
			$res.="oImage = FCK.CreateElement( 'IMG' ) ;\n";
		$res.="}\n";

		$res.="oImage.src=\"".$src."\" ;\n";
		$res.="oImage.title=titleTxt ;\n";
		$res.="oImage.alt=altTxt ;\n";
		$res.="oImage.border=borderVal ;\n";

		$res.="window.close();\n";
		$res.="}\n\n";


		$res.="function closePopup() {\n";
			$res.="window.close();\n";
		$res.="}\n";

	$res.="--></script>\n";


	$GLOBALS["page"]->add($res, "page_head");
}

?>
