<?php
/*************************************************************************/
/* DOCEBO CORE - Framework                                               */
/* =============================================                         */
/*                                                                       */
/* Copyright (c) 2006 by Giovanni Derks <virtualdarkness[AT]gmail-com>   */
/* http://www.docebo.com                                                 */
/*                                                                       */
/* This program is free software. You can redistribute it and/or modify  */
/* it under the terms of the GNU General Public License as published by  */
/* the Free Software Foundation; either version 2 of the License.        */
/*************************************************************************/

/**
 * @version  $Id: lib.company.php 180 2006-03-29 09:17:25Z giovanni $
 */
// ----------------------------------------------------------------------------


Class CoreCompanyManager {

	var $prefix=NULL;
	var $dbconn=NULL;

	var $company_info=array();


	function CoreCompanyManager($prefix="core", $dbconn=NULL) {
		$this->prefix=$prefix;
		$this->dbconn=$dbconn;
	}


	function _executeQuery( $query ) {
		if( $GLOBALS['do_debug'] == 'on' && isset($GLOBALS['page']) )  $GLOBALS['page']->add( "\n<!-- debug $query -->", 'debug' );
		else echo "\n<!-- debug $query -->";
		if( $this->dbconn === NULL )
			$rs = mysql_query( $query );
		else
			$rs = mysql_query( $query, $this->dbconn );
		return $rs;
	}


	function _executeInsert( $query ) {
		if( $GLOBALS['do_debug'] == 'on' ) $GLOBALS['page']->add( "\n<!-- debug $query -->" , 'debug' );
		if( $this->dbconn === NULL ) {
			if( !mysql_query( $query ) )
				return FALSE;
		} else {
			if( !mysql_query( $query, $this->dbconn ) )
				return FALSE;
		}
		if( $this->dbconn === NULL )
			return mysql_insert_id();
		else
			return mysql_insert_id($this->dbconn);
	}


	function getCompanyTable() {
		return $this->prefix."_company";
	}

	function getCompanyUsersTable() {
		return $this->prefix."_company_user";
	}


	function getCompanyFieldEntryTable() {
		return $this->prefix."_company_fieldentry";
	}


	function getCompanyTypeFieldTable() {
		return $this->prefix."_ctype_field";
	}


	function getCompanyStatusFieldTable() {
		return $this->prefix."_cstatus_field";
	}


	function getCompanyList($ini=FALSE, $vis_item=FALSE, $in_arr=FALSE) {

		$data_info=array();
		$data_info["data_arr"]=array();

		$fields="*";
		$qtxt ="SELECT ".$fields." FROM ".$this->getCompanyTable()." ";

		if (($in_arr !== FALSE) && (is_array($in_arr)) && (count($in_arr) > 0)) {
			$qtxt.="WHERE company_id IN (".implode(",", $in_arr).") ";
		}

		$qtxt.="ORDER BY name ";
		$q=$this->_executeQuery($qtxt);

		if ($q)
			$data_info["data_tot"]=mysql_num_rows($q);
		else
			$data_info["data_tot"]=0;

		if (($ini !== FALSE) && ($vis_item !== FALSE)) {
			$qtxt.="LIMIT ".$ini.",".$vis_item;
			$q=$this->_executeQuery($qtxt);
		}

		if (($q) && (mysql_num_rows($q) > 0)) {
			$i=0;
			while($row=mysql_fetch_array($q)) {

				$id=$row["company_id"];
				$data_info["data_arr"][$i]=$row;
				$this->company_info[$id]=$row;

				if (!empty($row["code"])) {
					$code=$row["code"];
					$this->company_info["code"][$code]=$row;
				}

				$i++;
			}
		}

		return $data_info;
	}


	function loadCompanyInfo($id) {
		$res=array();

		$fields="*";
		$qtxt ="SELECT ".$fields." FROM ".$this->getCompanyTable()." ";
		$qtxt.="WHERE company_id='".(int)$id."'";
		$q=$this->_executeQuery($qtxt);

		if (($q) && (mysql_num_rows($q) > 0)) {
			$res=mysql_fetch_array($q);
		}

		return $res;
	}


	function getCompanyInfo($id) {

		if (!isset($this->company_info[$id])) {

			$info=$this->loadCompanyInfo($id);
			$this->company_info[$id]=$info;

			if (!empty($info["code"])) {
				$code=$info["code"];
				$this->company_info["code"][$code]=$info;
			}

		}

		return $this->company_info[$id];
	}


	function loadCompanyInfoFromCode($code) {
		$res=array();

		if (empty($code))
			return $res;

		$fields="*";
		$qtxt ="SELECT ".$fields." FROM ".$this->getCompanyTable()." ";
		$qtxt.="WHERE code='".$code."'";
		$q=$this->_executeQuery($qtxt);

		if (($q) && (mysql_num_rows($q) > 0)) {
			$res=mysql_fetch_array($q);
		}
		else
			$res=FALSE;

		return $res;
	}


	function getCompanyInfoFromCode($code) {

		if (!isset($this->company_info["code"][$code])) {

			$info=$this->loadCompanyInfoFromCode($code);
			$this->company_info["code"][$code]=$info;

			if (($info !== FALSE) && (isset($info["company_id"]))) {
				$id=$info["company_id"];
				$this->company_info[$id]=$info;
			}

		}

		return $this->company_info["code"][$code];
	}



	/**
	 * @return array list of companies that user is a member of.
	 **/
	function getUserCompanies($user_id) {
		$res=array();

		$qtxt="SELECT company_id FROM ".$this->getCompanyUsersTable()." WHERE user_id='".(int)$user_id."'";
		$q=$this->_executeQuery($qtxt);

		if (($q) && (mysql_num_rows($q) > 0)) {
			while($row=mysql_fetch_array($q)) {
				$res[]=$row["company_id"];
			}
		}

		return $res;
	}


	function getCompanyUsers($company_id) {
		$res=array();

		$qtxt="SELECT user_id FROM ".$this->getCompanyUsersTable()." WHERE company_id='".$company_id."'";
		$q=$this->_executeQuery($qtxt);

		$idst_arr=array();

		if (($q) && (mysql_num_rows($q) > 0)) {
			while($row=mysql_fetch_array($q)) {
				$idst_arr[]=$row["user_id"];
			}
		}

		if (count($idst_arr) > 0) {
			$acl_manager=$GLOBALS["current_user"]->getAclManager();
			$user_info=$acl_manager->getUsers($idst_arr);
			foreach ($idst_arr as $idst) {
				$res[$idst]=$acl_manager->relativeId($user_info[$idst][ACL_INFO_USERID]);
			}
		}

		return $res;
	}


}









// ---------------------------- | lib.companytype.php | -----------------------


Class CompanyTypeManager {

	var $prefix=NULL;
	var $dbconn=NULL;

	var $ctype_info=array();


	function CompanyTypeManager($prefix="core", $dbconn=NULL) {
		$this->prefix=$prefix;
		$this->dbconn=$dbconn;
	}


	function _executeQuery( $query ) {
		if( $GLOBALS['do_debug'] == 'on' && isset($GLOBALS['page']) )  $GLOBALS['page']->add( "\n<!-- debug $query -->", 'debug' );
		else echo "\n<!-- debug $query -->";
		if( $this->dbconn === NULL )
			$rs = mysql_query( $query );
		else
			$rs = mysql_query( $query, $this->dbconn );
		return $rs;
	}


	function _executeInsert( $query ) {
		if( $GLOBALS['do_debug'] == 'on' ) $GLOBALS['page']->add( "\n<!-- debug $query -->" , 'debug' );
		if( $this->dbconn === NULL ) {
			if( !mysql_query( $query ) )
				return FALSE;
		} else {
			if( !mysql_query( $query, $this->dbconn ) )
				return FALSE;
		}
		if( $this->dbconn === NULL )
			return mysql_insert_id();
		else
			return mysql_insert_id($this->dbconn);
	}


	function _getMainTable() {
		return $this->prefix."_companytype";
	}


	function GetLastOrd($table) {
		require_once($GLOBALS["where_framework"]."/lib/lib.utils.php");
		return utilGetLastOrd($table, "ord");
	}


	function moveItem($direction, $id_val) {
		require_once($GLOBALS["where_framework"]."/lib/lib.utils.php");

		$table=$this->_getMainTable();

		utilMoveItem($direction, $table, "ctype_id", $id_val, "ord");
	}


	function getCompanyTypeList($ini=FALSE, $vis_item=FALSE) {

		$data_info=array();
		$data_info["data_arr"]=array();

		$fields="*";
		$qtxt ="SELECT ".$fields." FROM ".$this->_getMainTable()." ";
		$qtxt.="ORDER BY ord ";
		$q=$this->_executeQuery($qtxt);

		if ($q)
			$data_info["data_tot"]=mysql_num_rows($q);
		else
			$data_info["data_tot"]=0;

		if (($ini !== FALSE) && ($vis_item !== FALSE)) {
			$qtxt.="LIMIT ".$ini.",".$vis_item;
			$q=$this->_executeQuery($qtxt);
		}

		if (($q) && (mysql_num_rows($q) > 0)) {
			$i=0;
			while($row=mysql_fetch_array($q)) {

				$id=$row["ctype_id"];
				$data_info["data_arr"][$i]=$row;
				$this->ctype_info[$id]=$row;

				$i++;
			}
		}

		return $data_info;
	}


	function loadCompanyTypeInfo($id) {
		$res=array();

		$fields="*";
		$qtxt ="SELECT ".$fields." FROM ".$this->_getMainTable()." ";
		$qtxt.="WHERE ctype_id='".(int)$id."'";
		$q=$this->_executeQuery($qtxt);

		if (($q) && (mysql_num_rows($q) > 0)) {
			$res=mysql_fetch_array($q);
		}

		return $res;
	}


	function getCompanyTypeInfo($id) {

		if (!isset($this->ctype_info[$id]))
			$this->ctype_info[$id]=$this->loadCompanyTypeInfo($id);

		return $this->ctype_info[$id];
	}



	function saveData($data) {

		$id=(int)$data["id"];
		$label=$data["label"];

		if ($id == 0) {
			$ord=$this->getLastOrd($this->_getMainTable())+1;

			if (empty($label)) {
				$lang=& DoceboLanguage::createInstance("companytype", "crm");
				$label=$lang->def("_NO_LABEL");
			}

			$field_list="label, ord";
			$field_val="'".$label."', '".$ord."'";

			$qtxt="INSERT INTO ".$this->_getMainTable()." (".$field_list.") VALUES(".$field_val.")";
			$id=$this->_executeInsert($qtxt);
		}
		else if ($id > 0) {

			$qtxt="UPDATE ".$this->_getMainTable()." SET label='".$label."' WHERE ctype_id='".$id."'";
			$q=$this->_executeQuery($qtxt);

		}

		return $id;
	}


	function deleteCompanyType($id) {
		$qtxt="DELETE FROM ".$this->_getMainTable()." WHERE ctype_id='".$id."' AND is_used='0' LIMIT 1";
		$q=$this->_executeQuery($qtxt);

		return $q;
	}

}









// ---------------------------- | lib.companystatus.php | -----------------------



Class CompanyStatusManager {

	var $prefix=NULL;
	var $dbconn=NULL;

	var $cstatus_info=array();


	function CompanyStatusManager($prefix="core", $dbconn=NULL) {
		$this->prefix=$prefix;
		$this->dbconn=$dbconn;
	}


	function _executeQuery( $query ) {
		if( $GLOBALS['do_debug'] == 'on' && isset($GLOBALS['page']) )  $GLOBALS['page']->add( "\n<!-- debug $query -->", 'debug' );
		else echo "\n<!-- debug $query -->";
		if( $this->dbconn === NULL )
			$rs = mysql_query( $query );
		else
			$rs = mysql_query( $query, $this->dbconn );
		return $rs;
	}


	function _executeInsert( $query ) {
		if( $GLOBALS['do_debug'] == 'on' ) $GLOBALS['page']->add( "\n<!-- debug $query -->" , 'debug' );
		if( $this->dbconn === NULL ) {
			if( !mysql_query( $query ) )
				return FALSE;
		} else {
			if( !mysql_query( $query, $this->dbconn ) )
				return FALSE;
		}
		if( $this->dbconn === NULL )
			return mysql_insert_id();
		else
			return mysql_insert_id($this->dbconn);
	}


	function _getMainTable() {
		return $this->prefix."_companystatus";
	}


	function GetLastOrd($table) {
		require_once($GLOBALS["where_framework"]."/lib/lib.utils.php");
		return utilGetLastOrd($table, "ord");
	}


	function moveItem($direction, $id_val) {
		require_once($GLOBALS["where_framework"]."/lib/lib.utils.php");

		$table=$this->_getMainTable();

		utilMoveItem($direction, $table, "cstatus_id", $id_val, "ord");
	}


	function getCompanyStatusList($ini=FALSE, $vis_item=FALSE) {

		$data_info=array();
		$data_info["data_arr"]=array();

		$fields="*";
		$qtxt ="SELECT ".$fields." FROM ".$this->_getMainTable()." ";
		$qtxt.="ORDER BY ord ";
		$q=$this->_executeQuery($qtxt);

		if ($q)
			$data_info["data_tot"]=mysql_num_rows($q);
		else
			$data_info["data_tot"]=0;

		if (($ini !== FALSE) && ($vis_item !== FALSE)) {
			$qtxt.="LIMIT ".$ini.",".$vis_item;
			$q=$this->_executeQuery($qtxt);
		}

		if (($q) && (mysql_num_rows($q) > 0)) {
			$i=0;
			while($row=mysql_fetch_array($q)) {

				$id=$row["cstatus_id"];
				$data_info["data_arr"][$i]=$row;
				$this->cstatus_info[$id]=$row;

				$i++;
			}
		}

		return $data_info;
	}


	function loadCompanyStatusInfo($id) {
		$res=array();

		$fields="*";
		$qtxt ="SELECT ".$fields." FROM ".$this->_getMainTable()." ";
		$qtxt.="WHERE cstatus_id='".(int)$id."'";
		$q=$this->_executeQuery($qtxt);

		if (($q) && (mysql_num_rows($q) > 0)) {
			$res=mysql_fetch_array($q);
		}

		return $res;
	}


	function getCompanyStatusInfo($id) {

		if (!isset($this->cstatus_info[$id]))
			$this->cstatus_info[$id]=$this->loadCompanyStatusInfo($id);

		return $this->cstatus_info[$id];
	}



	function saveData($data) {

		$id=(int)$data["id"];
		$label=$data["label"];

		if ($id == 0) {
			$ord=$this->getLastOrd($this->_getMainTable())+1;

			if (empty($label)) {
				$lang=& DoceboLanguage::createInstance("companystatus", "crm");
				$label=$lang->def("_NO_LABEL");
			}

			$field_list="label, ord";
			$field_val="'".$label."', '".$ord."'";

			$qtxt="INSERT INTO ".$this->_getMainTable()." (".$field_list.") VALUES(".$field_val.")";
			$id=$this->_executeInsert($qtxt);
		}
		else if ($id > 0) {

			$qtxt="UPDATE ".$this->_getMainTable()." SET label='".$label."' WHERE cstatus_id='".$id."'";
			$q=$this->_executeQuery($qtxt);

		}

		return $id;
	}


	function deleteCompanyStatus($id) {
		$qtxt="DELETE FROM ".$this->_getMainTable()." WHERE cstatus_id='".$id."' AND is_used='0' LIMIT 1";
		$q=$this->_executeQuery($qtxt);

		return $q;
	}

}





?>
