<?php

/************************************************************************/
/* DOCEBO CORE - Framework												*/
/* ============================================							*/
/*																		*/
/* Copyright (c) 2004													*/
/* http://www.docebo.com												*/
/*																		*/
/* This program is free software. You can redistribute it and/or modify	*/
/* it under the terms of the GNU General Public License as published by	*/
/* the Free Software Foundation; either version 2 of the License.		*/
/************************************************************************/

/**
 * @package 	DoceboCore
 * @category 	File managment
 * @author 		Fabio Pirovano <fabio@docebo.com>
 * @version 	$Id: lib.download.php 113 2006-03-08 18:08:42Z ema $
 */

/**
 * able the user to download a specified file as an attachment
 *
 * @param string	$path		where the files is on the server filesystem without the filename
 * @param string	$filename	the name of the file
 * @param string	$ext		the extension of the file (.txt, .jpg ...)
 * @param string	$sendname	the name given to the downlodable file, if not passed it will be constructed in this way:
 *								assumed that $filename is [number]_[number]_[time]_[filename]
 *								the file sended will have the name [filename].$ext
 * 
 * @return nothing
 */
function sendFile($path, $filename, $ext, $sendname = NULL) {
	//empty and close buffer
	
	$path = $GLOBALS['where_files_relative'].$path;
	if($sendname === NULL) {
		
		$break_apart = explode('_', $filename);
		$break_apart[0] = $break_apart[1] = $break_apart[2] = '';
		$sendname = implode('', $break_apart);
		if($sendname == '') $sendname = $filename;
	}
	else $sendname .= '.'.$ext;
	
	/** to try and check
	header("Pragma: public");
	header("Expires: 0");
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	header("Cache-Control: private",false);
	
	
	// i have also found this but.... i'm not still sure about this : application/force-download
	
	header("Content-Type: application/octet-stream");
	header("Content-Disposition: attachment; filename=\"".$sendname."\";");
	header("Content-Transfer-Encoding: binary");
	header("Content-Length: ".filesize($path.$filename));
	*/
	ob_end_clean();
	session_write_close();
	//Download file
	//send file length info
	header('Content-Length:'. filesize($path.$filename));
	//content type forcing dowlad
	header("Content-type: application/download\n");
	//cache control
	header("Cache-control: private");
	//sending creation time
	header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
	//content type
	header('Content-Disposition: attachment; filename="'.$sendname.'"');
	//sending file
	readfile($path.$filename);
	//and now exit
	exit();
}

?>
