/************************************************************************/
/* DOCEBO CORE - Framework												*/
/* ============================================							*/
/*																		*/
/* Copyright (c) 2005													*/
/* http://www.docebo.com												*/
/*																		*/
/* This program is free software. You can redistribute it and/or modify	*/
/* it under the terms of the GNU General Public License as published by	*/
/* the Free Software Foundation; either version 2 of the License.		*/
/************************************************************************/

/**
 * This function set all the checkbox of a specified form
 *
 * @param 	string	form_name	the name of the form
 * @param 	string	check_name	the name of the checkbox i.e. check_name[34]
 * @param 	int		assign		the value to assign, if omitted the checbox value is inverted
 **/

function checkall( form_name, check_name, assign ) {
	var form = document.forms[form_name];
	for (var i = 0; i < form.elements.length; i++) {
		if( form.elements[i].name.indexOf( check_name + "[" ) >= 0 ) 
			if( arguments.length > 2 ) 
				form.elements[i].checked = assign;
			else
				form.elements[i].checked = !form.elements[i].checked;
	}
}

/**
 * This function set all the checkbox of a specified form
 *
 * @param 	string	form_name	the name of the form
 * @param 	string	check_name	the name of the checkbox from the end of the name i.e. [34]
 * @param 	int		assign		the value to assign, if omitted the checbox value is inverted
 **/
 
function checkall_fromback( form_name, check_name, assign ) {
	var form = document.forms[form_name];
	for (var i = 0; i < form.elements.length; i++) {
		if( form.elements[i].name.indexOf( "]" + check_name  ) >= 0 ) 
			if( arguments.length > 2 ) 
				form.elements[i].checked = assign;
			else
				form.elements[i].checked = !form.elements[i].checked;
	}
}
