<?php

/*************************************************************************/
/* DOCEBO FRAMEWORK                                                      */
/* ============================================                          */
/*                                                                       */
/* Copyright (c) 2005 by Giovanni Derks <giovanni[AT]docebo-com>         */
/* http://www.docebo.com                                                 */
/*                                                                       */
/* This program is free software. You can redistribute it and/or modify  */
/* it under the terms of the GNU General Public License as published by  */
/* the Free Software Foundation; either version 2 of the License.        */
/*************************************************************************/

function newsletter() {
	//access control
	//-TP// funAdminAccess('OP');
	checkPerm('view');
	

	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');

	$out=& $GLOBALS['page'];
	$out->setWorkingZone("content");
	$lang=& DoceboLanguage::createInstance('admin_newsletter', 'framework');

	$form=new Form();

	$out->add(getTitleArea($lang->def("_NEWSLETTER"), "newsletter"));

	$out->add("<div class=\"std_block\">\n");

	$acl_manager=$GLOBALS["current_user"]->getAclManager();
	$user_info=$acl_manager->getUser($GLOBALS["current_user"]->getIdSt(), false);
	$myemail=$user_info[ACL_INFO_EMAIL];

	if ((isset($err)) && ($err != ""))
		$out->add("<b><span class=\"fontRed\">$err</span><br />\n");

	$out->add($form->openForm("newsletter_form", "index.php?modname=newsletter&amp;op=initsend"));
	$out->add($form->openElementSpace());

	$out->add($form->getTextfield($lang->def("_SENDER"), "fromemail", "fromemail", 255, $myemail));
	$out->add($form->getTextfield($lang->def("_SUBJECT"), "sub", "sub", 255, ""));
	$out->add($form->getSimpleTextarea($lang->def("_TEXT"), "msg", "msg", ""));

	$lang_list=$GLOBALS['globLangManager']->getAllLangCode();
	$out->add($form->getDropdown($lang->def("_LANGUAGE"), "sel_lang", "sel_lang", $lang_list));

	$out->add($form->closeElementSpace());
	$out->add($form->openButtonSpace());
	$out->add($form->getButton('send', 'send', $lang->def('_SEND')));
	$out->add($form->closeButtonSpace());
	$out->add($form->closeForm());

/*
	$out->add("<br /><div class=\"title\">"._SENDTO.":</div>\n");
	//$groups = listGroup();
	$out->add("<div class=\"groupsperm\">");
	while(list($idCommon, $nameGroup) = each($groups)) {
		if ($idCommon >= 0) {
			echo("<input type=\"checkbox\" id=\"idGroups[".$idCommon."]\" name=\"idGroups[".$idCommon."]\" value=\"".$idCommon."\" />\n");
			echo("<label for=\"idGroups[".$idCommon."]\">".$nameGroup."</label><br />\n");
		}
	}
	$out->add('</div>'."\n\n");

	$out->add("<br /><div class=\"title\">"._LANGUAGE.":\n");
	$lang_list=$GLOBALS['globLangManager']->getAllLangCode();
	$out->add("<select id=\"sel_lang\" name=\"sel_lang\">\n");
	foreach ($lang_list as $key=>$val) {
		$out->add("<option value=\"$val\">$val</option>\n");
	}
	$out->add("</select></div>\n");

	$out->add("<br /><br /><input class=\"button\" type=\"submit\" value=\""._SEND."\" />\n");
	$out->add("</form>\n"); */

	$out->add("</div>\n");
}


function send_newsletter($send_id) {
	checkPerm('view');
	
	//access control
	$nl_sendpercycle=$GLOBALS["framework"]["nl_sendpercycle"];
	//-TP// funAdminAccess('OP');

	//@set_time_limit(60*15); // 15 minutes!

	$out=& $GLOBALS['page'];
	$out->setWorkingZone("content");
	$lang=& DoceboLanguage::createInstance('admin_newsletter', 'framework');


	$out->add(getTitleArea($lang->def("_NEWSLETTER"), "newsletter"));

	$out->add("<div class=\"std_block\">\n");


	$info=get_send_info($send_id);

	$sel_groups=$info["sel_groups"];
	$sel_lang=$info["sel_lang"];
	$tot=$info["tot"];

	$sub=$info["sub"];
	$msg=$info["msg"];
	$fromemail=$info["fromemail"];



	$cycle=(int)$_GET["cycle"];

	// Items per cycle
	$ipc=$nl_sendpercycle;


	if (($cycle+1)*$ipc < $tot) {
		$sendcomplete=0;
	}
	else {
		$sendcomplete=1;
	}


	$limit=$cycle*$ipc.", ".$ipc;
	$arr_st=getSendToIdst($send_id, $limit);
	$acl_manager=$GLOBALS["current_user"]->getAclManager();
	$user_info=$acl_manager->getUsersByLanguage($sel_lang, $arr_st);


	foreach($user_info as $info) {

		// Send the email: ------------------------------

		$email=$info[ACL_INFO_EMAIL];

		if ($email != "") {

			mail($email, $sub, $msg,
						"From: $fromemail\r\n".
						"Reply-To: $fromemail\r\n".
						"X-Mailer: DoceboFramework\r\n".
						"Content-Type: text/plain; charset=UTF-8");

		}

		// ----------------------------------------------

	}



	if ($sendcomplete) {

		$url="index.php?modname=newsletter&op=complete";
		jumpTo($url);

	}
	else {

		$url="index.php?modname=newsletter&op=pause&ipc=".$ipc."&cycle=".($cycle+1)."&id_send=".$send_id;
		jumpTo($url);

	}



	$out->add("</div><br />\n");

	$out->add("<form action=\"index.php?modname=newsletter&amp;op=newsletter\" method=\"post\">\n");
	$out->add("<div class=\"std_block\">\n");
	$out->add("<input class=\"button\" type=\"submit\" value=\"".$lang->def("_BACK")."\" />\n");
	$out->add("</div>\n");
	$out->add("</form>\n");
}


function getSendToIdst($id_send, $limit) {
	checkPerm('view');
	

	$res=array();

	$qtxt="SELECT idst FROM ".$GLOBALS["prefix_fw"]."_newsletter_sendto WHERE id_send='".(int)$id_send."' LIMIT ".$limit;
	$q=mysql_query($qtxt);

	if (($q) && (mysql_num_rows($q) > 0)) {
		while($row=mysql_fetch_array($q)) {
			$res[]=$row["idst"];
		}
	}

	return $res;
}



function nl_pause() {
	checkPerm('view');
	
	$delay=$GLOBALS["framework"]["nl_sendpause"];

	$out=& $GLOBALS['page'];
	$out->setWorkingZone("content");
	$lang=& DoceboLanguage::createInstance('admin_newsletter', 'framework');


	$out->add(getTitleArea($lang->def("_NEWSLETTER"), "newsletter"));

	$out->add("<div class=\"std_block\">\n");

	$cycle=(int)$_GET["cycle"];
	$ipc=(int)$_GET["ipc"];
	$id_send=(int)$_GET["id_send"];

	$out->add("<br />".$lang->def("_SENDING_MSG_FROM")." ".($cycle*$ipc)." ".$lang->def("_SENDING_MSG_TO")." ".($cycle*$ipc+$ipc)."<br />\n");

	$out->add("<br /><br />...".$delay." ".$lang->def("_SEC_OF_PAUSE")."...\n");
//Non chiudere la pagina finch&eacute; non compare la scritta \"Operazione completata\"
	$out->add("<br />".$lang->def("_DONT_CLOSE_THISWIN")."<br /><br />\n");

	$out->add("</div>\n");

	$url="index.php?modname=newsletter&amp;op=send&amp;cycle=".$cycle."&amp;id_send=".$id_send;
	$out->add("<meta http-equiv=\"refresh\" content=\"".$delay.";url=".$url."\">\n", "page_head");

}



function nl_sendcomplete() {
	checkPerm('view');
	

	//-TP// funAdminAccess('OP');

	$out=& $GLOBALS['page'];
	$out->setWorkingZone("content");
	$lang=& DoceboLanguage::createInstance('admin_newsletter', 'framework');


	$out->add(getTitleArea($lang->def("_NEWSLETTER"), "newsletter"));

	$out->add("<div class=\"std_block\">\n");

	$out->add("<br /><b>".$lang->def("_SEND_COMPLETE")."</b><br /><br />\n");

	$out->add("</div><br />\n");

	$out->add("<form action=\"index.php?modname=newsletter&amp;op=newsletter\" method=\"post\">\n");
	$out->add("<div class=\"std_block\">\n");
	$out->add("<input class=\"button\" type=\"submit\" value=\"".$lang->def("_BACK")."\" />\n");
	$out->add("</div>\n");
	$out->add("</form>\n");
}



function init_send() {
	checkPerm('view');
	
	require_once($GLOBALS["where_framework"]."/lib/lib.utils.php");

	$lang_list=$GLOBALS['globLangManager']->getAllLangCode();
	$sel_lang=$lang_list[$_POST["sel_lang"]];
	//$sel_groups=$_POST["idGroups"];


	$translate_table = getTranslateTable();

	$sub=translateChr($_POST["sub"], $translate_table, true);
	$msg=translateChr($_POST["msg"], $translate_table, true);
	$fromemail=$_POST["fromemail"];


	// ..who said spring cleanings have to be done in spring??
	$qtxt="DELETE FROM ".$GLOBALS["prefix_fw"]."_newsletter WHERE stime < (DATE_SUB(NOW(), INTERVAL 1 DAY))";
	$q=mysql_query($qtxt);

	$qtxt="DELETE FROM ".$GLOBALS["prefix_fw"]."_newsletter_sendto WHERE stime < (DATE_SUB(NOW(), INTERVAL 1 DAY))";
	$q=mysql_query($qtxt);



	$qtxt ="INSERT INTO ".$GLOBALS["prefix_fw"]."_newsletter (sub, msg, fromemail, language, stime) ";
	$qtxt.="VALUES ('".$sub."', '".$msg."', '".$fromemail."', '".$sel_lang."', NOW())";
	$q=mysql_query($qtxt); //echo mysql_error();

	$qtxt="SELECT LAST_INSERT_ID() as last_id FROM ".$GLOBALS["prefix_fw"]."_newsletter";
	$q=mysql_query($qtxt);


	$row=mysql_fetch_array($q);
	$last_id=$row["last_id"];

	$qtxt="UPDATE ".$GLOBALS["prefix_fw"]."_newsletter SET id_send='".$last_id."' WHERE id='$last_id'";
	$q=mysql_query($qtxt);


	$url="index.php?modname=newsletter&amp;op=selsendto&amp;id_send=".$last_id;
	jumpTo($url);

}


function get_send_info($send_id) {


	$sel_lang="";
	$sel_groups=array();
	$res=array();

	$qtxt="SELECT sub, msg, fromemail, language, tot FROM ".$GLOBALS["prefix_fw"]."_newsletter WHERE id='".$send_id."'";
	$q=mysql_query($qtxt); //echo $qtxt;

	if (($q) && (mysql_num_rows($q) > 0)) {
		while($row=mysql_fetch_array($q)) {

			if ($sel_lang == "") $sel_lang=$row["language"];

			if ($row["tot"] > 0) $tot=$row["tot"];
			if ($row["sub"] != "") $sub=$row["sub"];
			if ($row["msg"] != "") $msg=$row["msg"];
			if ($row["fromemail"] != "") $fromemail=$row["fromemail"];

		}
	}

	$res["sel_lang"]=$sel_lang;
	$res["tot"]=$tot;
	$res["sub"]=$sub;
	$res["msg"]=$msg;
	$res["fromemail"]=$fromemail;

	return $res;
}


function selSendTo() {
	checkPerm('view');
	
// [TODO] check write or mod. permissions
// http://127.0.0.1:82/claudio/lms_cvs/doceboCore/index.php?modname=newsletter&op=selsendto&id_send=1
	if ((isset($_GET["id_send"])) && ($_GET["id_send"] > 0)) {
		$id_send=$_GET["id_send"];
	}
	else
	 die("Newsletter setup error.");

	require_once($GLOBALS['where_framework']."/class.module/class.directory.php");
	$mdir=new Module_Directory();

	$out=& $GLOBALS['page'];
	$out->setWorkingZone("content");
	$lang=& DoceboLanguage::createInstance('admin_newsletter', 'framework');

	$back_url="index.php?modname=newsletter&amp;op=selsendto&amp;id_send=".$id_send;


	if( isset($_POST['okselector']) ) {
		$arr_selection=$mdir->getSelection($_POST);
/*		$arr_unselected=$mdir->getUnselected();

		foreach($arr_unselected as $idstMember) {
			//$mdir->aclManager->removeFromGroup($st_id, $idstMember );
		} */

		$send_to_idst=array();

		foreach($arr_selection as $idstMember) {
			$arr=$mdir->aclManager->getGroupAllUser($idstMember);
			if ((is_array($arr)) && (count($arr) > 0)) {
				$send_to_idst=array_merge($arr, $send_to_idst);
				$send_to_idst=array_unique($send_to_idst);
			}
			else
				$send_to_idst[]=$idstMember;
		}
		/* echo "<br /><br /><br />";
		print_r($send_to_idst); die(); */

		foreach ($send_to_idst as $key=>$val) {
			$qtxt ="INSERT INTO ".$GLOBALS["prefix_fw"]."_newsletter_sendto (id_send, idst, stime) ";
			$qtxt.="VALUES ('".(int)$id_send."', '".(int)$val."', NOW())";
			$q=mysql_query($qtxt);
		}

		$qtxt="SELECT language FROM ".$GLOBALS["prefix_fw"]."_newsletter WHERE id='".$id_send."'";
		$q=mysql_query($qtxt);

		list($lang)=mysql_fetch_row($q);

		$tot=count($mdir->aclManager->getUsersIdstByLanguage($lang, $send_to_idst));

		$qtxt="UPDATE ".$GLOBALS["prefix_fw"]."_newsletter SET tot='".$tot."' WHERE id='$id_send'";
		$q=mysql_query($qtxt);

		$back_url="index.php?modname=newsletter&amp;op=send&amp;id_send=".$id_send;
		jumpTo(str_replace("&amp;", "&", $back_url));
	}
	else if( isset($_POST['cancelselector']) ) {
		//jumpTo(str_replace("&amp;", "&", $back_url));
	}
	else {

		/* if( !isset($_GET['stayon']) ) {
			$mdir->resetSelection($mdir->aclManager->getGroupMembers($st_id));
		} */

		$url="index.php?modname=newsletter&amp;op=selsendto&amp;id_send=".$id_send."&amp;stayon=1";
		$mdir->show_user_selector = TRUE;
		$mdir->show_group_selector = TRUE;
		if( $GLOBALS['use_org_chart'] == '1' ) {
			$mdir->show_orgchart_selector = TRUE;
			$mdir->show_orgchart_simple_selector = TRUE;
		} else {
			$mdir->show_orgchart_selector = FALSE;
		}
		$mdir->loadSelector($url,
			$lang->def( '_NEWSLETTER_SENDTO' ), "", TRUE);
	}

}



function add_to_array($arr, & $add_to) {

	if (!is_array($add_to))
		$add_to=array();

	if (!is_array($arr))
		return 0;

	foreach ($arr as $key=>$val) {
		if (!in_array($val, $add_to))
			$add_to[]=$val;
	}

}



$op=importVar("op");
switch($op) {
	case "newsletter" : {
		newsletter();
	};break;

	case "initsend": {
		init_send();
	} break;

	case "selsendto": {
		selSendTo();
	} break;

	case "send" : {
		$id_send=(int)$_GET["id_send"];
		send_newsletter($id_send);
	};break;

	case "pause" : {
		nl_pause();
	};break;

	case "complete": {
		nl_sendcomplete();
	}
}

?>