<?php

/************************************************************************/
/* DOCEBO KMS                                                           */
/* ============================================                         */
/*                                                                      */
/* Copyright (c) 2005                                                   */
/* http://www.docebo.com                                                */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/


define("_FPATH_INTERNAL", "/doceboKms/files/");
define("_FPATH", $GLOBALS["where_files_relative"]._FPATH_INTERNAL);

define("NOT_PUBLISHED", 0);
define("PUBLISHED_CURRENT", 1);
define("PUBLISHED_OLD", 2);

class kmsFileSystem {

	var $lang = NULL;
	var $aclManager = NULL;
	var $docman = NULL;
	var $selection = array();
	var $selector_mode = FALSE;

	/** Array with file permissions */
	var $file_perm=NULL;


	function kmsFileSystem() {
		$this->aclManager = new DoceboACLManager();
		$this->docman=new DocumentsManager($this);
		$this->lang =& DoceboLanguage::createInstance('documents', 'kms');
	}


	function kmsDocuments() {
		require_once(dirname(__FILE__).'/tree.documents.php');
		require_once(dirname(__FILE__).'/lib.filelist.php');
		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
		require_once($GLOBALS['where_framework'].'/lib/lib.acl.php');

		$out=& $GLOBALS["page"];
		$lang=DoceboLanguage::createInstance("documents", "kms");

		$out->setWorkingZone("content");


		$acl=new DoceboACL();
		$acl_manager=$acl->getAclManager();

		$userlevelid = $GLOBALS['current_user']->getUserLevelId();

		$repoDb = new TreeDb_FilesystemDb($GLOBALS['prefix_kms'].'_filesystem_tree');
		$repoDb->folder_perm_list=$this->getFolderPermissionsList();

		$treeView = new TreeView_FilesystemView($repoDb, 'organization_chart', $GLOBALS['title_organigram_chart']);
		$treeView->setFilePath(_FPATH, _FPATH_INTERNAL);
		$treeView->setLanguage( $lang );
		$treeView->aclManager =& $this->aclManager;

		/*$treeView->selector_mode = $this->selector_mode;
		$treeView->simple_selector = $this->show_orgchart_simple_selector;
		$treeView->itemSelectedMulti = $this->selection; */
		if( $userlevelid != ADMIN_GROUP_GODADMIN ) {
			require_once($GLOBALS['where_framework'].'/lib/lib.adminmanager.php');
			$adminManager = new AdminManager();
			//$treeView->setFilterNodes($adminManager->getAdminTree($GLOBALS['current_user']->getIdSt()));

			$acl_manager=$GLOBALS['current_user']->getAclManager();
			$view_groups=$acl_manager->getBasePathGroupST("/KMS_Folder_view_");
			//$user_groups=$acl_manager->getGroupsContainer($GLOBALS['current_user']->getIdSt());
			//$allowed_items=array_intersect($view_groups, $user_groups);

			if (!$this->docman->isGodAdmin()) {
				// ------ Filter the folders showing only the one visible by the  user:
				$folder_id_arr=array();
				foreach ($view_groups as $key=>$val) {
					$folder_id=end(explode("_", $key));
					if (($GLOBALS['current_user']->matchUserST($val)) && (!in_array($folder_id, $folder_id_arr)))
					//if ((!in_array($folder_id, $folder_id_arr)))
						$folder_id_arr[]=$folder_id;
				}

				$treeView->setFilterNodes($folder_id_arr);

			}

		}

		$treeView->loadState();
		$treeView->parsePositionData($_POST, $_POST, $_POST);
		$treeView->saveState();

		// ------ Change the icon of the folders that contains some files but that have zero files visible to the user
		// $folder_id_arr contains the folder visible to the user so we can search only in these.

		if (!isset($folder_id_arr))
			$folder_id_arr=FALSE;

		$empty_folders=$treeView->getEmptyFolders($folder_id_arr);

		$image_arr=array();
		foreach($empty_folders as $key=>$val) {
			$image_arr[$val]="treeview/menu_folder_open_ghost.gif";
		}
		$treeView->setCustomFolderImage($image_arr);

		// -----------------------------------------------------------


		$out->add('<link href="'.getPathTemplate().'style/style_treeview.css" rel="stylesheet" type="text/css" />', 'page_head');
		$out->setWorkingZone('content');

		$out->add( getTitleArea($lang->def('_DOCUMENTS'), 'documents' ) );
		$out->add("<div class=\"std_block\">\n");

		$out->add( Form::openForm('filesystem_form', 'index.php?modname=documents&amp;op=documents') );

		if((isset($treeView->op)) && ($treeView->op != "")) {

			switch( $treeView->op ) {
				case 'newfolder':
					$GLOBALS['page']->add($treeView->loadNewFolder());
				break;
				case 'deletefolder':
					$GLOBALS['page']->add($treeView->loadDeleteFolder());
				break;
				case 'renamefolder':
					$GLOBALS['page']->add($treeView->loadRenameFolder());
				break;
				case 'movefolder':
					$GLOBALS['page']->add($treeView->loadMoveFolder());
				break;
				case 'assign2_field':
					$GLOBALS['page']->add($treeView->loadAssignField2());
				break;
				case 'assign_field':
					$GLOBALS['page']->add($treeView->loadAssignField());
				break;
				case 'folder_field':
					$GLOBALS['page']->add($treeView->loadFolderField());
				break;
				case 'create_document':
					jumpTo( 'index.php?modname=documents&op=kms_createdocument&treeid='.$treeView->getSelectedFolderId() );
				break;

				case "addtotree": {
					$processed = TRUE;
					jumpTo( 'index.php?modname=documents&op=addtotree&treeid='.$treeView->getSelectedFolderId() );
				} break;

				case "monitorfolder": {
					jumpTo( 'index.php?modname=documents&op=monitorfolder&treeid='.$treeView->getSelectedFolderId() );
				} break;
			}

		}
		else {

			$folder_id=$treeView->getSelectedFolderId();

			$treeView->fl_data = new FileSystemRetriever($GLOBALS['dbConn'], $GLOBALS['prefix_kms']);
			$rend = new TypeOne(20);
			$treeView->fl_data->setFolder($folder_id);
			$treeView->fl_view = new FileListView('', $treeView->fl_data, $rend, 'filesystemdirectory');
			$treeView->fl_view->setLinkPagination( "index.php?modname=documents&amp;op=documents" );
			$treeView->fl_view->aclManager =& $this->aclManager;



			if (!$this->docman->isGodAdmin()) {
				$file_perm=$this->docman->getFilePerm($folder_id, false);
				if (isset($file_perm["viewfile"]))
					$view_perm=$file_perm["viewfile"];
				else
					$view_perm=array(0);

				//$treeView->fl_data->setFileFilter($view_perm);
				//x/ $unfiltered_tot=$treeView->fl_data->getTotalRows();

				$where=$treeView->fl_data->getFileTable().".file_id IN (".implode(",", $view_perm).")";
				$treeView->fl_data->addCustomFilter("", $where);

				/* $tot=$treeView->fl_data->getTotalRows();
				if (($unfiltered_tot > $tot) && ($tot == 0)) {
					$image_arr=array();
					$image_arr[$folder_id]="treeview/menu_folder_open_ghost.gif";
					$treeView->setCustomFolderImage($image_arr);
				} */
			}

			$treeView->fl_view->parsePositionData( $_POST );

			switch($treeView->fl_view->getOp()) {

				case "editfile": {
					jumpTo( 'index.php?modname=documents&op=editfile&fileid='.$treeView->fl_view->getIdSelectedItem().'&treeid='.$folder_id );
				} break;

				case "deletefile": {
					jumpTo( 'index.php?modname=documents&op=deletefile&fileid='.$treeView->fl_view->getIdSelectedItem().'&treeid='.$folder_id );
				} break;

				case "editfileperm": {
					jumpTo( 'index.php?modname=documents&op=editfileperm&fileid='.$treeView->fl_view->getIdSelectedItem().'&treeid='.$folder_id );
				} break;

				case "filemonitor": {
					jumpTo( 'index.php?modname=documents&op=filemonitor&fileid='.$treeView->fl_view->getIdSelectedItem().'&treeid='.$folder_id );
				} break;

				case "filestatus": {
					jumpTo( 'index.php?modname=documents&op=filestatus&cvid='.$treeView->fl_view->getIdSelectedItem().'&treeid='.$folder_id );
				} break;

				case "fileversion": {
					jumpTo( 'index.php?modname=documents&op=fileversion&fileid='.$treeView->fl_view->getIdSelectedItem().'&treeid='.$folder_id );
				} break;

				case "commentfile": {
					jumpTo( 'index.php?modname=documents&op=commentfile&fileid='.$treeView->fl_view->getIdSelectedItem().'&treeid='.$folder_id );
				} break;

			}

			$out->add($treeView->load());
			$out->add($treeView->loadActions());

			//$this->membersTree($groupid, $treeView);
			$id_org = $treeView->getSelectedFolderId();
			if( $id_org > 0 && $treeView->isFolderAccessible()) {
				if( $treeView->fl_view->flat_mode ) {
					$groupid = $treeView->tdb->getGroupDescendantsId($id_org);
				} else {
					$groupid = $treeView->tdb->getGroupId($id_org);
				}
			}
			if( $id_org > 0 && $treeView->isFolderAccessible() )
				$this->membersTree($groupid, $treeView);
			elseif($id_org == 0)
				$this->membersTree('', $treeView);

		}

		$out->add( Form::closeForm() );

		if((!isset($treeView->op)) || ($treeView->op == "")) {

			$this->showItemsToBePublished($folder_id);

		}

		$out->add("</div>\n");

	}



	function showItemsToBePublished($folder_id) {
		require_once($GLOBALS["where_framework"]. "/lib/lib.typeone.php");
		require_once($GLOBALS["where_framework"]. "/lib/lib.mimetype.php");

		$out=& $GLOBALS["page"];
		$lang=DoceboLanguage::createInstance("documents", "kms");

		$out->setWorkingZone("content");

		$user_st=$GLOBALS["current_user"]->getIdSt();

		$qtxt ="SELECT * FROM ".$GLOBALS["prefix_kms"]."_file_version WHERE published='".NOT_PUBLISHED."' ";
		$qtxt.="AND folder_id='".$folder_id."' ";

		if ($GLOBALS["current_user"]->getUserLevelId() != ADMIN_GROUP_GODADMIN)
			$qtxt.="AND owner='".$user_st."' ";

		$qtxt.="ORDER BY version_id DESC";
		$q=mysql_query($qtxt);

		if (($q) && (mysql_num_rows($q) > 0)) {

			$out->add("</div>\n"); // <-- ???!
			$out->add("<div class=\"std_block\">\n");

			$table = new typeOne(0);
			$out->add($table->OpenTable($this->lang->def("_ITEMS_TO_PUBLISH")));

			$head = array($lang->def("_DIRECTORY_FILETYPE"), $lang->def("_DIRECTORY_FILENAME"),
				$this->lang->def("_FILE_DATE"), $this->lang->def("_DOCUMENTS_STATUS"),
				'<img src="'.getPathImage().'documents/updown.gif" alt="'.$lang->def("_ALT_CTYPE").'" title="'.$lang->def("_ALT_CTYPE").'" />',
				'<img src="'.getPathImage().'documents/status.gif" alt="'.$lang->def("_DOCUMENTS_FILESTATUS").'" title="'.$lang->def("_DOCUMENTS_FILESTATUS").'" />',
				'<img src="'.getPathImage().'standard/rem.gif" alt="'.$lang->def("_ALT_DEL").'" title="'.$lang->def("_ALT_DEL").'" />');
			$head_type = array('img', '', '', '', 'img', 'img', 'img');

			$out->add($table->WriteHeader($head, $head_type));

			while($row=mysql_fetch_array($q)) {

				$rowcnt=array();

				$type=mimetype(end(explode(".", $row["fname"])));
				$rowcnt[]="<img src=\"".getPathImage().mimeDetect($row["fname"])."\" alt=\"$type\" title=\"$type\" />\n";


				$file_url ="index.php?modname=documents&amp;op=download";
				$file_url.="&amp;treeid=".$folder_id."&amp;cvid=".$row["version_id"];

				$rowcnt[]="<a href=\"".$file_url."\">".$row["fname"]."</a>\n";
				$rowcnt[]=$GLOBALS["regset"]->databaseToRegional($row["file_date"]);
				$rowcnt[]="&nbsp;";

				switch($row["ctype"]) {
					case "none": {
						$rowcnt[]="&nbsp;";
					} break;
					case "upgrade": {
						$alt=$lang->def("_ALT_UPGRADE");
						$rowcnt[]="<img src=\"".getPathImage()."documents/up.gif\" alt=\"".$alt."\" title=\"$alt\" />\n";
					} break;
					case "downgrade": {
						$alt=$lang->def("_ALT_DOWNGRADE");
						$rowcnt[]="<img src=\"".getPathImage()."documents/down.gif\" alt=\"".$alt."\" title=\"$alt\" />\n";
					} break;
				}

				$img ="<img src=\"".getPathImage()."documents/status.gif\" alt=\"".$lang->def("_DOCUMENTS_FILESTATUS")."\" ";
				$img.="title=\"".$lang->def("_DOCUMENTS_FILESTATUS")."\" />";
				$url="index.php?modname=documents&amp;op=filestatus&amp;cvid=".$row["version_id"]."&amp;treeid=".$folder_id;
				$rowcnt[]="<a href=\"".$url."\">".$img."</a>\n";

				$img ="<img src=\"".getPathImage()."standard/rem.gif\" alt=\"".$lang->def("_ALT_DEL")."\" ";
				$img.="title=\"".$lang->def("_ALT_DEL")."\" />";
				$url="index.php?modname=documents&amp;op=remversion&amp;cvid=".$row["version_id"]."&amp;treeid=".$folder_id;
				$rowcnt[]="<a href=\"".$url."\">".$img."</a>\n";

				$out->add($table->WriteRow($rowcnt));
			}

			$out->add($table->CloseTable());
			//$out->add("</div>\n");

		}

	}



	function membersTree( $groupid, &$treeView ) {
		require_once($GLOBALS["where_framework"]. "/lib/lib.form.php");
		$data =& $treeView->fl_data;
		$fl =& $treeView->fl_view;
		if( $groupid === FALSE )
			return;
		if( $groupid != '' ) {
			$arrGroup = $this->aclManager->getGroup( FALSE, $groupid );
			if( $arrGroup !== FALSE ) {
				$idst = $arrGroup[0];
				$description = $arrGroup[2];
			}
		} else {
			$fl->show_flat_mode_flag = FALSE;
		}

		if( $fl->op == 'deleteperson' ) {
			$userid = $fl->getIdSelectedItem();
			$idst_user = $this->aclManager->getUserST( $userid );
			$id_org = $treeView->getSelectedFolderId();
			$idst_group = $treeView->tdb->getGroupST($id_org);
			$this->aclManager->removeFromGroup( $idst_group, $idst_user );
			$idst_group_desc = $treeView->tdb->getGroupDescendantsST($id_org);
			$this->aclManager->removeFromGroup( $idst_group_desc, $idst_user );
		}
/*		if( $groupid != '' )
			$data->setGroupFilter($idst, $fl->flat_mode ); */
		$userlevelid = $GLOBALS['current_user']->getUserLevelId();
		if( $userlevelid != ADMIN_GROUP_GODADMIN ) {
			require_once($GLOBALS['where_framework'].'/lib/lib.adminmanager.php');
			$adminManager = new AdminManager();
			$data->intersectGroupFilter($adminManager->getAdminTree($GLOBALS['current_user']->getIdSt()));
		}
		$GLOBALS['page']->add($fl->printOut(), 'content');
		//$this->selected = $fl->printedItems;
	}



	function loadBody() {

		// XXX: switch
		switch($GLOBALS['op']) {

			default: case "documents": {
				$this->kmsDocuments();
			} break;

			case 'kms_createdocument':
				$this->kms_createDocument();
			break;

			case "monitorfolder": {
				$this->editFolderMonitor();
			} break;

			case "addtotree": {
				$this->selDocFolderPerm();
			} break;

			case "editfile": {
				$this->editDocument((int)$_GET["fileid"]);
			} break;

			case "deletefile": {
				$this->deleteDocument((int)$_GET["fileid"]);
			} break;

			case "selnewdocperm": {
				$this->selNewDocPerm();
			} break;

			case "checkpublish": {
				$this->checkPublish();
			} break;

			case "editfileperm": {
				$this->selDocFilePerm();
			} break;

			case "filemonitor": {
				$this->editFileMonitor();
			} break;

			case "filestatus": {
				$this->editFileStatus();
			} break;

			case "fileversion": {
				$this->showVersionHistory();
			} break;

			case "remversion": {
				$this->deleteVersion();
			} break;

			case "commentfile": {
				$this->showComments();
			} break;

			case "download": {
				$this->downloadDocument();
			} break;

		}
	}



	function kms_createDocument( $treeid = FALSE ) {
		require_once($GLOBALS["where_framework"] . "/lib/lib.form.php");

		// if( isset($_POST['okselector']) ) {
			// go to user creation with folders selected
			require_once(dirname(__FILE__).'/tree.documents.php');
			$repoDb = new TreeDb_FilesystemDb($GLOBALS['prefix_kms'].'_filesystem_tree');

			$arr_selection = array(); /*= $this->getSelection($_POST);
			if( count($arr_selection) > 0 )
				$arr_selection = array_merge( $arr_selection, $repoDb->getDescendantsSTFromST($arr_selection));
			$arr_selection = array_merge( 	$arr_selection,
											$this->aclManager->getArrGroupST( array('/oc_0', '/ocd_0') ) ); */
			$this->editDocument( FALSE, $arr_selection );
		// }
		/* elseif( isset($_POST['cancelselector']) ) {
			jumpTo( 'index.php?modname=directory&op=org_chart' );
		} else {
			if( !isset($_GET['stayon']) ) {
				if( $treeid === FALSE && isset($_GET['treeid']) )
					$treeid = (int)$_GET['treeid'];
				if( $treeid != 0 ) {
					require_once(dirname(__FILE__).'/../modules/org_chart/tree.org_chart.php');
					$repoDb = new TreeDb_OrgDb($GLOBALS['prefix_fw'].'_org_chart_tree');
					$idst = $repoDb->getGroupST($treeid);
					$this->resetSelection(array($idst));
				} else {
					$this->resetSelection(array());
				}

			}
			$this->show_user_selector = FALSE;
			$this->show_group_selector = TRUE;
			$this->show_orgchart_selector = TRUE;
			$this->show_orgchart_simple_selector = TRUE;
			$this->loadSelector('index.php?modname=directory&amp;op=org_createuser&amp;stayon=1',
							$this->lang->def( '_DIRECTORY_TREECREATEUSER' ),
							$this->lang->def( '_DIRECTORY_TREECREATEUSERDESCR' ),
							TRUE);
		} */

	}


	function editDocument($file_id = FALSE, $arr_idst_groups = FALSE) {
		require_once($GLOBALS["where_framework"] . "/lib/lib.form.php");
		require_once($GLOBALS["where_framework"] . "/lib/lib.adminmanager.php");
		/* if( $userid === FALSE ) {
			$userid	= importVar('userid',	FALSE, 	'' );
			$userLabel = importVar('userid',	FALSE, 	$this->lang->def( '_DOCUMENTS_NEWDOCUMENT' ) );
		} else {
			$userLabel = $userid;
		} */
		$userLabel = "";

		if (isset($_GET["treeid"]))
			$folder_id=(int)$_GET["treeid"];
		else
			$folder_id=-1;

		$firstname = '';
		$lastname = '';
		$email = '';
		$pass = '';
		$idst = '';
		// get all levels
		$arr_levels_id = $this->aclManager->getAdminLevels();
		$arr_levels_idst = array_values($arr_levels_id);
		$arr_levels_id = array_flip( $arr_levels_id );
		$arr_levels_translation = array();
		foreach( $arr_levels_id as $lev_idst => $lev_id ) {
			$arr_levels_translation[$lev_idst] = $this->lang->def('_DIRECTORY_'.$lev_id);
		}
		// set default level
		$userlevel = $arr_levels_idst[0];
		if( $file_id != '' ) { /*
			$arrUser = $this->aclManager->getUser( FALSE, $file_id );
			if( $arrUser !== FALSE ) {
				$idst = $arrUser[0];
				$firstname = $arrUser[2];
				$lastname = $arrUser[3];
				$email = $arrUser[5];
				// compute user level
				$arr_groups = $this->aclManager->getGroupsContainer($idst);

				$arr_user_level = array_intersect( $arr_levels_idst, $arr_groups );
				$arr_user_level = array_values($arr_user_level);
				if( count( $arr_user_level ) > 0 )
					$userlevel = $arr_user_level[0];
				else
					$userlevel = $arr_levels_idst[0];
			} else {
				// the user don't exist
				$firstname = $_POST['firstname'];
				$lastname = $_POST['lastname'];
				$email = $_POST['email'];
				// get arr_folders to know collect custom fields
				if( $arr_idst_groups === FALSE && isset( $_POST['arr_idst_groups'] ) ) {
					$arr_idst_groups = unserialize( urldecode( $_POST['arr_idst_groups'] ) );
				}
			} */
		} else {
			if( $arr_idst_groups === FALSE && isset( $_POST['arr_idst_groups'] ) ) {
				$arr_idst_groups = unserialize( urldecode( $_POST['arr_idst_groups'] ) );
			}
		}
		$GLOBALS['page']->add( getTitleArea($this->lang->def( '_DOCUMENTS_DOCUMENTVIEWTITLE' )
								.': '.$userLabel, 'directory_people' ), 'content' );

		$GLOBALS['page']->add( '<div class="std_block">', 'content');
		$GLOBALS['page']->add( Form::getFormHeader( $this->lang->def( '_DOCUMENTS_EDITDOCUMENT' ) ), 'content' );
		$GLOBALS['page']->add( Form::openForm( 	'kmseditdocument',
												'index.php?modname=documents&amp;op=documents',
												FALSE,
												'post',
												'multipart/form-data'),
								'content');
		$GLOBALS['page']->add( Form::openElementSpace(), 'content' );

		$GLOBALS['page']->add( Form::getOpenFieldset( $this->lang->def( '_DOCUMENTS_EDITDOCUMENT' ).' - '.$userLabel ), 'content' );
/*		$GLOBALS['page']->add( Form::getTextfield( $this->lang->def( '_DIRECTORY_USERID' ), "userid", "userid", 50, $userid), 'content' );
		$GLOBALS['page']->add( Form::getTextfield( $this->lang->def( '_DIRECTORY_FIRSTNAME' ), "firstname", "firstname", 50, $firstname), 'content' );
		$GLOBALS['page']->add( Form::getTextfield( $this->lang->def( '_DIRECTORY_LASTNAME' ), "lastname", "lastname", 50, $lastname), 'content' );
		$GLOBALS['page']->add( Form::getTextfield( $this->lang->def( '_DIRECTORY_EMAIL' ), "email", "email", 50, $email), 'content' );
		$GLOBALS['page']->add( Form::getTextfield( $this->lang->def( '_DIRECTORY_PASS' ), "pass", "pass", 50, $pass), 'content' );

		$GLOBALS['page']->add( Form::getDropdown(
										$this->lang->def( '_DIRECTORY_USER_LEVEL' ),
										"userlevel",
										"userlevel",
										$arr_levels_translation,
										$userlevel),
								'content'); */
		$GLOBALS['page']->add( Form::getHidden('olduserlevel', 'olduserlevel', $userlevel), 'content' );
		$GLOBALS['page']->add( Form::getHidden('idst', 'idst', $idst), 'content' );
		$GLOBALS['page']->add( Form::getHidden('file_id', 'file_id', $file_id), 'content' );
		$GLOBALS['page']->add( Form::getHidden('folder_id', 'folder_id', (int)$folder_id), 'content' );

	/*	$GLOBALS['page']->add( Form::getCloseFieldset(), 'content' );
		$GLOBALS['page']->add( Form::closeElementSpace(), 'content' );
		$GLOBALS['page']->add( Form::openButtonSpace(), 'content' );
		$GLOBALS['page']->add( Form::getButton("editdocumentsave","editdocumentsave",$this->lang->def( '_SAVE' )), 'content' );
		$GLOBALS['page']->add( Form::getButton("editdocumentcancel","editdocumentcancel",$this->lang->def( '_CANCEL' )), 'content' );
		$GLOBALS['page']->add( Form::closeButtonSpace(), 'content' );
		$GLOBALS['page']->add( Form::openElementSpace(), 'content' ); */


		$GLOBALS['page']->add(Form::getFilefield($this->lang->def("_FILENAME"), "file", "file", ""), 'content');


		//-extra field-----------------------------------------------
		//$GLOBALS['page']->add( Form::getOpenFieldset( $this->lang->def( '_ASSIGNED_EXTRAFIELD' ) ), 'content' );
		require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
		$fields = new FieldList();
		$fields->setGroupFieldsTable($GLOBALS['prefix_kms']."_filesystem_field");
		$fields->setFieldEntryTable($GLOBALS['prefix_kms']."_filesystem_fieldentry");
		$acl =& $GLOBALS['current_user']->getACL();
		$acl_manager=$acl->getAclManager();

		$arr_idst_groups=array();
		$arr_idst_groups[]=$folder_id;
		$arr_idst_groups[]=$folder_id-1;
		$parents_arr=$this->getParentsFieldsForDescendants($folder_id);

		$arr_idst_groups=array_merge($arr_idst_groups, $parents_arr);

		if( $arr_idst_groups != FALSE ) {
			$arr_idst_all = $acl->getArrSTGroupsST($arr_idst_groups);
		} else
			$arr_idst_all = FALSE;


		//$arr_idst_all=array(229);
		/*$GLOBALS['page']->add( $fields->playFieldsForUser(
															( $userid !== false ? $idst : -1 ),
															$arr_idst_all
														), 'content' ); */
		$GLOBALS['page']->add( $fields->playFieldsForUser(
																	( $file_id !== false ? $file_id : -1 ),
																	$arr_idst_all // -> deve essere l'array con la lista dei campi della cartella [?]
																), 'content' );
		$GLOBALS['page']->add( Form::getCloseFieldset(), 'content' );
		//-----------------------------------------------------------

		$GLOBALS['page']->add( Form::getHidden('arr_idst_groups',
												'arr_idst_groups',
												urlencode(serialize($arr_idst_groups))),
								'content' );

		$GLOBALS['page']->add( Form::closeElementSpace(), 'content' );
		$GLOBALS['page']->add( Form::openButtonSpace(), 'content' );
		$GLOBALS['page']->add( Form::getButton("editdocumentsave","editdocumentsave",$this->lang->def( '_SAVE' )), 'content' );
		$GLOBALS['page']->add( Form::getButton("editdocumentcancel","editdocumentcancel",$this->lang->def( '_CANCEL' )), 'content' );
		$GLOBALS['page']->add( Form::closeButtonSpace(), 'content' );
		$GLOBALS['page']->add( Form::closeForm(), 'content' );
		$GLOBALS['page']->add( '</div>', 'content');
	}


	function deleteDocument($file_id) {

		include_once($GLOBALS['where_framework']."/lib/lib.form.php");
		include_once($GLOBALS['where_framework']."/lib/lib.upload.php");

		$out=& $GLOBALS['page'];
		$out->setWorkingZone("content");
		$lang=& DoceboLanguage::createInstance('documents', 'kms');

		if (isset($_GET["treeid"]))
			$folder_id=(int)$_GET["treeid"];
		else
			die();

		$url="index.php?modname=documents&amp;op=deletefile&amp;fileid=".$file_id."&amp;treeid=".$folder_id;

		if (isset($_POST["canc_del"])) {
			jumpTo("index.php?modname=documents&op=documents");
		}
		else if (isset($_POST["conf_del"])) {

// 			mysql_query("DELETE FROM ".$GLOBALS["prefix_cms"]."_news_attach WHERE idNews='".$id."';");

			$qtxt="SELECT real_fname FROM ".$GLOBALS["prefix_kms"]."_file_version WHERE file_id='".$file_id."';";
			$q=mysql_query($qtxt);

			$to_del=array();
			if (($q) && (mysql_num_rows($q) > 0)) {
				while($row=mysql_fetch_array($q)) {
					$to_del[]=$row["real_fname"];
				}
			}

			$del_all=true;
			foreach ($to_del as $key=>$val) {
				$del=sl_unlink(_FPATH_INTERNAL.$val);
				if ((!$del) && (file_exists(_FPATH.$val)))
					$del_all=false;
			}

			if ($del_all) {
				$this->remFileFromDb($file_id);
			}

			jumpTo("index.php?modname=documents&op=documents");
		}
		else {

			//load info
			list($fname) = mysql_fetch_row(mysql_query("
			SELECT fname
			FROM ".$GLOBALS["prefix_kms"]."_file
			WHERE file_id  = '".$file_id."'"));

			$out->add("<div class=\"std_block\">\n");

			$form=new Form();

			$out->add($form->openForm("document_form", $url));

			$out->add(getDeleteUi(
			$lang->def('_AREYOUSURE'),
				'<span class="text_bold">'.$lang->def('_FILENAME').' :</span> '.$fname.
				'<div>'.$lang->def('_CONTINUEWILLDELALL').'</div>',
				false,
				'conf_del',
				'canc_del'));

			$out->add($form->closeForm());
			$out->add("</div>\n");
		}

	}


	function remFileFromDb($file_id) {
		mysql_query("DELETE FROM ".$GLOBALS["prefix_kms"]."_file WHERE file_id='".$file_id."';");
		mysql_query("DELETE FROM ".$GLOBALS["prefix_kms"]."_file_perm WHERE file_id='".$file_id."';");
		mysql_query("DELETE FROM ".$GLOBALS["prefix_kms"]."_file_version WHERE file_id='".$file_id."';");
		mysql_query("DELETE FROM ".$GLOBALS["prefix_kms"]."_sysforum WHERE key1='document_comment' AND key2='".$file_id."';");
		mysql_query("DELETE FROM ".$GLOBALS["prefix_kms"]."_filesystem_fieldentry WHERE id_user='".$file_id."';");
		mysql_query("DELETE FROM ".$GLOBALS["prefix_kms"]."_monitorized WHERE item_type='file' AND item_id='".$file_id."';");
	}


	function getParentsFieldsForDescendants($folder_id) {

		require_once(dirname(__FILE__).'/tree.documents.php');
		$tdb = new TreeDb_FilesystemDb($GLOBALS['prefix_kms'].'_filesystem_tree');

		$folder=$tdb->getRootFolder();
		$rootname=str_replace("/", "", $folder->path);
		$folder=$tdb->getFolderById($folder_id);
		$path=$folder->path;

		$path_arr=explode("/", trim($path, "/"));

		if ($rootname != "")
			$cur_path="/".$rootname;
		else
			$cur_path="";

		$in_path_arr=array();
		foreach($path_arr as $key=>$val) {

			if ($val != $rootname) {
				$cur_path.="/".$val;
				$in_path_arr[]="'".$cur_path."'";
			}
		}

		$in_path_str=implode(", ", $in_path_arr);

		$qtxt="SELECT d_folder_id FROM ".$GLOBALS["prefix_kms"]."_filesystem_tree WHERE path IN ($in_path_str)";
		$q=mysql_query($qtxt);

		$res=array();
		if (($q) && (mysql_num_rows($q) > 0)) {
			while($row=mysql_fetch_array($q)) {

				$res[]=$row["d_folder_id"];

			}
		}

		return $res;
	}



	function getFolderPermissionsList() {

		$res=array();
		$res[]="view";
		$res[]="addfolder";
		$res[]="addfile";

		return $res;
	}



	function selDocFolderPerm() {

		require_once($GLOBALS['where_framework']."/class.module/class.directory.php");
		require_once($GLOBALS['where_framework']."/lib/lib.permission.php");

		$out=& $GLOBALS['page'];
		$lang=& DoceboLanguage::createInstance('documents', 'kms');
		//$form=new Form();

		$out->setWorkingZone("content");

		$mdir=new Module_Directory();
		$mdir->show_orgchart_selector=FALSE;

		$mdir->use_multi_sel=true;

		$perm=array(); // Has to match with the result of the getFolderPermissionsList method
		$perm["view"]["img"]=getPathImage()."standard/view.gif";
		$perm["view"]["alt"]=$lang->def("_ALT_VIEWFOLDER");
		$perm["addfolder"]["img"]=getPathImage()."documents/add_node.gif";
		$perm["addfolder"]["alt"]=$lang->def("_ALT_ADDFOLDER");
		$perm["addfile"]["img"]=getPathImage()."standard/add.gif";
		$perm["addfile"]["alt"]=$lang->def("_ALT_ADDFILE");

		$mdir->sel_extend->setExtraSel($perm);
		if (isset($_POST[DIRECTORY_ID]))
			$mdir->sel_extend->setPrintedItems($mdir->getPrintedItems($_POST));

		$tree_id=importVar("treeid");
		$this->docman->requireFolderPerm($tree_id, "addfolder");

		//$out->add(getTitleArea($lang->def("_PUBLICATION_FLOW_STEP_PERM"), "pubflow"));
		//$out->add("<div class=\"std_block\">\n");

		$back_url="index.php?modname=documents&amp;op=documents";// &amp;treeid=".$tree_id;
		//$out->add( getBackUi($back_url, $lang->def( '_BACK' ) ));



		if( isset($_POST['okselector']) ) {  // Saving permissions..

			$pl=$this->getFolderPermissionsList();
			$acl_manager=& $GLOBALS['current_user']->getACLManager();
			$pfx="selector";
			$selected_items=$mdir->sel_extend->getSelectedItems(); //print_r($selected_items); die();
			$database_items=$mdir->sel_extend->getDatabaseItemsFromVar($_POST[$pfx."_database_items"]);
			foreach($pl as $key=>$val) {
				if ((isset($selected_items[$val])) && (is_array($selected_items[$val]))) {

					$idst=$acl_manager->getGroupST("KMS_Folder_".$val."_".$tree_id);
					$idst_d=$acl_manager->getGroupST("KMS_Folder_".$val."_d_".$tree_id);

					foreach($selected_items[$val] as $pk=>$pv) {
						if (!in_array($pv, array_keys($database_items[$val]))) {
							$acl_manager->addToGroup($idst, $pv);
							$acl_manager->addToGroup($idst_d, $pv);
						}
					}

					$to_rem=array_diff(array_keys($database_items[$val]), $selected_items[$val]);
					foreach($to_rem  as $pk=>$pv) {
						$acl_manager->removeFromGroup($idst, $pv);
						$acl_manager->removeFromGroup($idst_d, $pv);
					}

				}
			}

			jumpTo(str_replace("&amp;", "&", $back_url));
		}
		else if( isset($_POST['cancelselector']) ) { // Undo..
			jumpTo(str_replace("&amp;", "&", $back_url));
		}
		else { // Show selector


			$url="index.php?modname=documents&amp;op=addtotree&amp;treeid=".$tree_id."&amp;stayon=1";

			if( !isset($_GET['stayon']) ) {
				$saved_perm=$this->docman->loadFolderSavedPerm($tree_id);
				$mdir->sel_extend->grabSelectedItems($saved_perm);
				$mdir->sel_extend->setDatabaseItems($saved_perm);
				//$mdir->resetSelection($mdir->aclManager->getGroupMembers($st_id));
			}
			else {
				$mdir->sel_extend->grabSelectedItems($_POST);
				//$out->add($mdir->sel_extend->writeSelectedInfo());
			}

			// Shows only the users that can view the selected folder
			if (!$this->docman->isGodAdmin()) {
				$acl_manager=$GLOBALS["current_user"]->getAclManager();
				$grp_path="/KMS_Folder_view_".$tree_id;
				$group_info=$acl_manager->getGroup(false, $grp_path);
				$groupIdSt_arr=array();
				$groupIdSt_arr[]=$group_info[ACL_INFO_IDST];
				$mdir->setUserFilter("group", $groupIdSt_arr);
				$mdir->setGroupFilter("path", array($grp_path));
			}

			$mdir->loadSelector($url,
				$lang->def( '_DOCUMENTS_FOLDER_PERM' ), "", TRUE);
		}


	}



	function getFilePermissionsList() {

		$res=array();
		$res[]="viewfile";
		$res[]="editfile";
		if ($GLOBALS["kms"]["feature_comments"] == "on")
			$res[]="commentfile";
		$res[]="delfile";

		return $res;
	}


	function checkPublish() {

		$cv_id=importVar("cvid");
		$folder_id=importVar("treeid");

		// One Step publication flow?
		require_once($GLOBALS["where_framework"]."/lib/lib.pubflow.php");
		$pf_manager=new PublicationFlowManager();
		if ($this->docman->getFolderFlowId($folder_id) == $pf_manager->getFlowIdFromCode(_PUBFLOW_CODE_ONESTATE)) {
			$this->docman->updateFileToPublished($cv_id);
			$qtxt ="UPDATE ".$GLOBALS["prefix_kms"]."_file_version SET published='".PUBLISHED_CURRENT."' ";
			$qtxt.="WHERE version_id='".$cv_id."'";
			$q=mysql_query($qtxt);
		}

		jumpTo("index.php?modname=documents&op=documents");
	}


	function selNewDocPerm() {
		// [TODO] check write or mod. permissions [?]
		require_once($GLOBALS['where_framework']."/lib/lib.form.php");

		$out=& $GLOBALS['page'];
		$out->setWorkingZone("content");
		$lang=& DoceboLanguage::createInstance('documents', 'kms');

		$form=new Form();
		$cv_id=importVar("cvid");
		$file_id=importVar("file_id");
		$folder_id=importVar("treeid");
		$radio_name="get_perm_from";

		if ((isset($_POST[$radio_name])) && $_POST[$radio_name] == "folder") {

			$acl_manager=& $GLOBALS['current_user']->getACLManager();

			// Inerith VIEW permissions:

			$idst=$acl_manager->getGroupST("KMS_Folder_"."view"."_".$folder_id);
			$can_view_folder=$acl_manager->getGroupMembers($idst);

			// [TODO] use a constant/define instead of "viewfile" [?]
			foreach($can_view_folder as $key=>$val) {
				$this->addFilePerm($file_id, "viewfile", $val);
			}

			// Inerith FILE permissions:

			$idst=$acl_manager->getGroupST("KMS_Folder_"."addfile"."_".$folder_id);
			$can_edit_folder=$acl_manager->getGroupMembers($idst);

			// [TODO] use a constant/define instead of "viewfile" [?]
			foreach($can_edit_folder as $key=>$val) {
				$this->addFilePerm($file_id, "commentfile", $val);
				$this->addFilePerm($file_id, "editfile", $val);
				$this->addFilePerm($file_id, "delfile", $val);
			}


			$url="index.php?modname=documents&op=checkpublish&cvid=".$cv_id."&treeid=".$folder_id;
			jumpTo($url);
		}
		else if ((isset($_POST[$radio_name])) && $_POST[$radio_name] == "user") {

			$url ="index.php?modname=documents&op=editfileperm&fileid=".$file_id;
			$url.="&newdoc=1&cvid=".$cv_id."&treeid=".$folder_id;
			jumpTo($url);
		}
		else {

			$out->add("<div class=\"std_block\">\n");

			$url ="index.php?modname=documents&amp;op=selnewdocperm&amp;file_id=".$file_id;
			$url.="&amp;cvid=".$cv_id."&amp;treeid=".$folder_id;
			$out->add($form->openForm("document_form", $url));
			$out->add($form->openElementSpace());

			$out->add("<h2>".$lang->def("_HOW_GET_PERM").":</h2>\n");

			$out->add($form->getRadio($lang->def("_PERM_FROM_FOLDER"),
				$radio_name."_folder", $radio_name, "folder", true));
			$out->add($form->getRadio($lang->def("_PERM_FROM_USER"),
				$radio_name."_user", $radio_name, "user"));

			$out->add($form->closeElementSpace());
			$out->add($form->openButtonSpace());
			$out->add($form->getButton('save', 'save', $lang->def('_CONTINUE')));
			$out->add($form->closeButtonSpace());
			$out->add($form->closeForm());

			$out->add("</div>\n");
		}
	}


	function selDocFilePerm() {
		// [TODO] check write or mod. permissions

		require_once($GLOBALS['where_framework']."/class.module/class.directory.php");
		require_once($GLOBALS['where_framework']."/lib/lib.permission.php");

		$out=& $GLOBALS['page'];
		$lang=& DoceboLanguage::createInstance('documents', 'kms');

		$out->setWorkingZone("content");

		$mdir=new Module_Directory();
		$mdir->show_orgchart_selector=FALSE;

		$mdir->use_multi_sel=true;

		$perm=array(); // Has to match with the result of the getFilePermissionsList method
		$perm["viewfile"]["img"]=getPathImage()."documents/viewfile.gif";
		$perm["viewfile"]["alt"]=$lang->def("_ALT_VIEWFILE");
		$perm["editfile"]["img"]=getPathImage()."documents/editfile.gif";
		$perm["editfile"]["alt"]=$lang->def("_ALT_EDITFILE");
		if ($GLOBALS["kms"]["feature_comments"] == "on") {
			$perm["commentfile"]["img"]=getPathImage()."documents/commentfile.gif";
			$perm["commentfile"]["alt"]=$lang->def("_ALT_COMMENTFILE");
		}
		$perm["delfile"]["img"]=getPathImage()."documents/delete.gif";
		$perm["delfile"]["alt"]=$lang->def("_ALT_DELFILE");

		$mdir->sel_extend->setExtraSel($perm);
		if (isset($_POST[DIRECTORY_ID]))
			$mdir->sel_extend->setPrintedItems($mdir->getPrintedItems($_POST));

		$file_id=importVar("fileid");
		$folder_id=importVar("treeid");

		if (isset($_GET["newdoc"])) {
			$cv_id=importVar("cvid");
			$back_url="index.php?modname=documents&op=checkpublish&cvid=".$cv_id."&treeid=".$folder_id;
		}
		else {
			$back_url="index.php?modname=documents&amp;op=documents";// &amp;treeid=".$tree_id;
		}

		if( isset($_POST['okselector']) ) {  // Saving permissions..

			$pl=$this->getFilePermissionsList();
			$pfx="selector";
			$selected_items=$mdir->sel_extend->getSelectedItems();
			$database_items=$mdir->sel_extend->getDatabaseItemsFromVar($_POST[$pfx."_database_items"]);
			foreach($pl as $key=>$val) {
				if ((isset($selected_items[$val])) && (is_array($selected_items[$val]))) {

					foreach($selected_items[$val] as $pk=>$pv) {
						if ((!isset($database_items[$val])) || (!is_array($database_items[$val]))
						   || (!in_array($pv, array_keys($database_items[$val])))) {
							$this->addFilePerm($file_id, $val, $pv);
						}
					}

					if ((isset($database_items[$val])) && (is_array($database_items[$val]))) {
						$to_rem=array_diff(array_keys($database_items[$val]), $selected_items[$val]);
						foreach($to_rem  as $pk=>$pv) {
							$this->delFilePerm($file_id, $val, $pv);
						}
					}

				}
			}

/*			$pl=$this->getFolderPermissionsList();
			$acl_manager=& $GLOBALS['current_user']->getACLManager();
			$pfx="selector";
			$selected_items=$mdir->sel_extend->getSelectedItems(); //print_r($selected_items); die();
			$database_items=$mdir->sel_extend->getDatabaseItemsFromVar($_POST[$pfx."_database_items"]);
			foreach($pl as $key=>$val) {
				if ((isset($selected_items[$val])) && (is_array($selected_items[$val]))) {

					$idst=$acl_manager->getGroupST("KMS_Folder_".$val."_".$file_id);
					$idst_d=$acl_manager->getGroupST("KMS_Folder_".$val."_d_".$tree_id);

					foreach($selected_items[$val] as $pk=>$pv) {
						$acl_manager->addToGroup($idst, $pv);
						$acl_manager->addToGroup($idst_d, $pv);
					}

					$to_rem=array_diff(array_keys($database_items[$val]), $selected_items[$val]);
					foreach($to_rem  as $pk=>$pv) {
						$acl_manager->removeFromGroup($idst, $pv);
						$acl_manager->removeFromGroup($idst_d, $pv);
					}

				}
			} */

			jumpTo(str_replace("&amp;", "&", $back_url));
		}
		else if( isset($_POST['cancelselector']) ) { // Undo..
			jumpTo(str_replace("&amp;", "&", $back_url));
		}
		else { // Show selector


			$url ="index.php?modname=documents&amp;op=editfileperm&amp;fileid=".$file_id."&amp;stayon=1";
			if (isset($_GET["newdoc"])) {
				$cv_id=importVar("cvid");
				$folder_id=importVar("treeid");
				$url.="&amp;newdoc=1&amp;cvid=".$cv_id."&amp;treeid=".$folder_id;
			}

			if( !isset($_GET['stayon']) ) {
				$saved_perm=$this->loadFileSavedPerm($file_id);
				$mdir->sel_extend->grabSelectedItems($saved_perm);
				$mdir->sel_extend->setDatabaseItems($saved_perm);
			}
			else {
				$mdir->sel_extend->grabSelectedItems($_POST);
			}

			// Shows only the users that can view the selected folder
			if (!$this->docman->isGodAdmin()) {
				$acl_manager=$GLOBALS["current_user"]->getAclManager();
				$grp_path="/KMS_Folder_view_".$folder_id;
				$group_info=$acl_manager->getGroup(false, $grp_path);
				$groupIdSt_arr=array();
				$groupIdSt_arr[]=$group_info[ACL_INFO_IDST];
				$mdir->setUserFilter("group", $groupIdSt_arr);
				$mdir->setGroupFilter("path", array($grp_path));
			}

			$mdir->loadSelector($url,
				$lang->def( '_DOCUMENTS_FILE_PERM' ), "", TRUE);
		}


	}

	function addFilePerm($file_id, $perm_name, $idst) {
		$qtxt ="INSERT INTO ".$GLOBALS["prefix_kms"]."_file_perm (file_id, perm_name, idst) ";
		$qtxt.="VALUES ('".(int)$file_id."', '".$perm_name."', '".(int)$idst."')";

		$q=mysql_query($qtxt);
	}

	function delFilePerm($file_id, $perm_name, $idst) {
		$qtxt ="DELETE FROM ".$GLOBALS["prefix_kms"]."_file_perm WHERE ";
		$qtxt.="file_id='".(int)$file_id."' AND perm_name='".$perm_name."' AND idst='".(int)$idst."'";

		$q=mysql_query($qtxt);
	}

	function loadFileSavedPerm($file_id) {

		$res=array();

		$qtxt ="SELECT * FROM ".$GLOBALS["prefix_kms"]."_file_perm WHERE ";
		$qtxt.="file_id='".(int)$file_id."'";

		$q=mysql_query($qtxt);

		if (($q) && (mysql_num_rows($q) > 0)) {
			while($row=mysql_fetch_array($q)) {
				$res[$row["perm_name"]][$row["idst"]]=1;
			}
		}

		/*$pl=$this->getFolderPermissionsList();
		$acl_manager=& $GLOBALS['current_user']->getACLManager();
		foreach($pl as $key=>$val) {

			$idst=$acl_manager->getGroupST("KMS_Folder_".$val."_".$folder_id);
			//$idst_d=$acl_manager->getGroupST("KMS_Folder_".$val."_d_".$tree_id);

			$res[$val]=array_flip($acl_manager->getGroupMembers($idst));

		}*/

		return $res;
	}



	function showComments() {
		require_once($GLOBALS['where_framework'].'/lib/lib.sysforum.php');

		$file_id=importVar("fileid");
		$folder_id=importVar("treeid");
		$this->docman->reqFilePerm($file_id, "commentfile");

		$out=& $GLOBALS["page"];
		$lang=DoceboLanguage::createInstance("documents", "kms");
		$out->setWorkingZone('content');

		$out->add( getTitleArea($lang->def('_DOCUMENTS'), 'documents' ) );
		$out->add("<div class=\"std_block\">\n");

		$back_url="index.php?modname=documents&amp;op=documents";
		$out->add( getBackUi($back_url, $lang->def( '_BACK' ) ));

		$out->add($lang->def("_COMMENTS_FOR_FILE").": filename");

		$sf=new sys_forum("kms", "document_comment", $file_id);
		$sf->setPrefix("kms");
		$sf->can_write=!$GLOBALS["current_user"]->isAnonymous();
		$sf->can_moderate=$this->docman->isGodAdmin();
		$sf->can_upload=false;

		$sf->url="index.php?modname=documents&amp;op=commentfile&amp;fileid=".$file_id."&amp;treeid=".$folder_id;
		$sf->show();

		//-alert-----------------------------------------------------
		if ((isset($_GET["sf_event"])) && ($_GET["sf_event"] == "add")) {

			$qtxt="SELECT fname FROM ".$GLOBALS["prefix_kms"]."_file WHERE file_id='".$file_id."'";
			list($fname)=mysql_fetch_row(mysql_query($qtxt));

			require_once($GLOBALS["where_kms"] . "/lib/lib.kms_common.php");
			$members=$this->docman->getUsersMonitoringFile($file_id);
			$alert_url=$GLOBALS["kms"]["url"].$sf->url;
			$replace=array("[fname]"=>$fname, "[url]"=>$alert_url);
			sendKmsGenericEvent(
					/* members:    */ $members,
					/* class:      */ "KmsDocumentCommented",
					/* module:     */ "documents",
					/* action:     */ "addcomment",
					/* log:        */ "Added a comment to document ".$file_id,
					/* sub_string: */ "_DOCUMENTS_NEWCOMMENT_ALERT_SUB",
					/* txt_string: */ "_DOCUMENTS_NEWCOMMENT_ALERT_TXT",
					/* replace:    */ $replace
				);

			$reload_url=str_replace("&amp;", "&", $sf->url);
			jumpTo($reload_url);
		}
		//-----------------------------------------------------------

		$out->add("</div>\n");

	}


	function showVersionHistory() {
		require_once($GLOBALS['where_framework'].'/lib/lib.typeone.php');
		require_once($GLOBALS["where_framework"]."/lib/lib.mimetype.php");

		$file_id=importVar("fileid");
		$folder_id=importVar("treeid");

		$out=& $GLOBALS["page"];
		$lang=DoceboLanguage::createInstance("documents", "kms");
		$out->setWorkingZone('content');

		$out->add( getTitleArea($lang->def('_DOCUMENTS'), 'documents' ) );
		$out->add("<div class=\"std_block\">\n");

		$back_url="index.php?modname=documents&amp;op=documents";
		$out->add( getBackUi($back_url, $lang->def( '_BACK' ) ));

		$table = new typeOne(0);
		$out->add($table->OpenTable(""));

		$head = array($this->lang->def("_DIRECTORY_FILETYPE"), $this->lang->def("_DIRECTORY_FILENAME"), $this->lang->def("_FILE_DATE"),
			'<img src="'.getPathImage().'standard/flag.gif" alt="'.$this->lang->def("_CURRENT_VER").'" title="'.$this->lang->def("_CURRENT_VER").'" />',
			'<img src="'.getPathImage().'standard/view.gif" alt="'.$this->lang->def("_VIEWFILE").'" title="'.$this->lang->def("_VIEWFILE").'" />',
			'<img src="'.getPathImage().'standard/rem.gif" alt="'.$this->lang->def("_ALT_DEL").'" title="'.$this->lang->def("_ALT_DEL").'" />');
		$head_type = array('img', '', '', 'img', 'img', 'img');
		$out->add($table->WriteHeader($head, $head_type));

		$qtxt="SELECT * FROM ".$GLOBALS["prefix_kms"]."_file_version WHERE file_id='".$file_id."' ORDER BY version_id DESC, file_date DESC";
		$q=mysql_query($qtxt);

		if (($q) && (mysql_num_rows($q) > 0)) {
			while($row=mysql_fetch_array($q)) {

				$rowcnt=array();

				$type=mimetype(end(explode(".", $row["fname"])));
				$rowcnt[]="<img src=\"".getPathImage().mimeDetect($row["fname"])."\" alt=\"$type\" title=\"$type\" />\n";

				$rowcnt[]=$row["fname"];
				$rowcnt[]=$GLOBALS["regset"]->databaseToRegional($row["file_date"]);

				if ($row["published"] == PUBLISHED_CURRENT) {
					$img ="<img src=\"".getPathImage()."standard/flag.gif\" alt=\"".$this->lang->def("_CURRENT_VER")."\" ";
					$img.="title=\"".$this->lang->def("_CURRENT_VER")."\" />\n";
					$rowcnt[]=$img;
				}
				else {
					$rowcnt[]="&nbsp;";
				}


				$file_url ="index.php?modname=documents&amp;op=download";
				$file_url.="&amp;treeid=".$folder_id."&amp;cvid=".$row["version_id"];

				$img ="<img src=\"".getPathImage()."standard/view.gif\" alt=\"".$this->lang->def("_VIEWFILE")."\" ";
				$img.="title=\"".$this->lang->def("_VIEWFILE")."\" />";
				$rowcnt[]="<a href=\"".$file_url."\">".$img."</a>\n";

				if (($row["published"] != PUBLISHED_CURRENT) && (!$GLOBALS["current_user"]->isAnonymous())) {
					$img ="<img src=\"".getPathImage()."standard/rem.gif\" alt=\"".$lang->def("_ALT_DEL")."\" ";
					$img.="title=\"".$lang->def("_ALT_DEL")."\" />";
					$url="index.php?modname=documents&amp;op=remversion&amp;cvid=".$row["version_id"]."&amp;treeid=".$folder_id;
					$rowcnt[]="<a href=\"".$url."\">".$img."</a>\n";
				}
				else {
					$rowcnt[]="&nbsp;";
				}

				$out->add($table->WriteRow($rowcnt));
			}
		}

		$out->add($table->CloseTable());
		$out->add("</div>\n");

	}


	function deleteVersion() {

		include_once($GLOBALS['where_framework']."/lib/lib.form.php");
		include_once($GLOBALS['where_framework']."/lib/lib.upload.php");

		$cv_id=importVar("cvid");
		$folder_id=importVar("treeid");

		$out=& $GLOBALS['page'];
		$out->setWorkingZone("content");


		$url="index.php?modname=documents&amp;op=remversion&amp;cvid=".$cv_id."&amp;treeid=".$folder_id;

		if (isset($_POST["canc_del"])) {
			jumpTo("index.php?modname=documents&op=documents");
		}
		else if (isset($_POST["conf_del"])) {

			$qtxt="SELECT file_id,real_fname FROM ".$GLOBALS["prefix_kms"]."_file_version WHERE version_id='".$cv_id."';";
			$q=mysql_query($qtxt);

			$to_del=array();
			if (($q) && (mysql_num_rows($q) > 0)) {
				while($row=mysql_fetch_array($q)) {
					$to_del[]=$row["real_fname"];

					if (!isset($file_id))
						$file_id=$row["file_id"];
				}
			}

			$qtxt="SELECT * FROM ".$GLOBALS["prefix_kms"]."_file_version WHERE file_id='".$file_id."';";
			$q=mysql_query($qtxt);

			if (($q) && (mysql_num_rows($q) == 1)) {
				$this->remFileFromDb($file_id);
			}

			$del_all=true;
			foreach ($to_del as $key=>$val) {
				$del=sl_unlink(_FPATH_INTERNAL.$val);
				if ((!$del) && (file_exists(_FPATH.$val)))
					$del_all=false;
			}

			if ($del_all) {
				mysql_query("DELETE FROM ".$GLOBALS["prefix_kms"]."_file_version WHERE version_id='".$cv_id."';");
			}

			jumpTo("index.php?modname=documents&op=documents");
		}
		else {

			//load info
			list($fname) = mysql_fetch_row(mysql_query("
			SELECT fname
			FROM ".$GLOBALS["prefix_kms"]."_file_version
			WHERE version_id  = '".$cv_id."'"));

			$out->add("<div class=\"std_block\">\n");

			$form=new Form();

			$out->add($form->openForm("document_form", $url));

			$out->add(getDeleteUi(
			$this->lang->def('_AREYOUSURE'),
				'<span class="text_bold">'.$this->lang->def('_FILENAME').' :</span> '.$fname,
				false,
				'conf_del',
				'canc_del'));

			$out->add($form->closeForm());
			$out->add("</div>\n");
		}

	}


	function editFileMonitor() {

		include_once($GLOBALS['where_framework']."/lib/lib.form.php");

		$file_id=importVar("fileid");
		$folder_id=importVar("treeid");

		$out=& $GLOBALS['page'];
		$out->setWorkingZone("content");


		$url="index.php?modname=documents&amp;op=filemonitor&amp;fileid=".$file_id."&amp;treeid=".$folder_id;

		if (isset($_POST["canc_op"])) {
			jumpTo("index.php?modname=documents&op=documents");
		}
		else if (isset($_POST["conf_op"])) {

			if ($_POST["monitoring"] == 1) { // Remove monitor
				$qtxt ="DELETE FROM ".$GLOBALS["prefix_kms"]."_monitorized ";
				$qtxt.="WHERE item_type='file' AND item_id='".$file_id."' ";
				$qtxt.="AND user_idst='".$GLOBALS["current_user"]->getIdSt()."' LIMIT 1";
			}
			else if ($_POST["monitoring"] == 0) {  // Add monitor
				$qtxt ="INSERT INTO ".$GLOBALS["prefix_kms"]."_monitorized ";
				$qtxt.="(item_type, item_id, user_idst) ";
				$qtxt.="VALUES('file', '".$file_id."', '".$GLOBALS["current_user"]->getIdSt()."')";
			}

			$q=mysql_query($qtxt);

			jumpTo("index.php?modname=documents&op=documents");
		}
		else {

			//load info
			list($fname) = mysql_fetch_row(mysql_query("
			SELECT fname
			FROM ".$GLOBALS["prefix_kms"]."_file_version
			WHERE version_id  = '".$file_id."'"));


			$qtxt ="SELECT item_id FROM ".$GLOBALS["prefix_kms"]."_monitorized ";
			$qtxt.="WHERE item_type='file' AND item_id='".$file_id."' ";
			$qtxt.="AND user_idst='".$GLOBALS["current_user"]->getIdSt()."'";

			$monitoring=(mysql_num_rows(mysql_query($qtxt)) > 0  ? "1":"0");

			if ($monitoring) {
				$sure_title=$this->lang->def('_SURE_FILE_MONITOR_SWITCH_OFF');
				$sure_msg=$this->lang->def('_MONITOR_SWITCH_OFF_MSG');
			}
			else {
				$sure_title=$this->lang->def('_SURE_FILE_MONITOR_SWITCH_ON');
				$sure_msg=$this->lang->def('_MONITOR_SWITCH_ON_MSG');
			}

			$out->add("<div class=\"std_block\">\n");

			$form=new Form();

			$out->add($form->openForm("document_form", $url));

			$out->add($form->getHidden("monitoring", "monitoring", $monitoring));

			$out->add(getDeleteUi(
			$sure_title,
				'<span class="text_bold">'.$this->lang->def('_FILENAME').' :</span> '.$fname.
				"<div>".$sure_msg."</div>",
				false,
				'conf_op',
				'canc_op'));

			$out->add($form->closeForm());
			$out->add("</div>\n");
		}

	}

	function editFolderMonitor() {

		include_once($GLOBALS['where_framework']."/lib/lib.form.php");

		$folder_id=importVar("treeid");

		$out=& $GLOBALS['page'];
		$out->setWorkingZone("content");


		$url="index.php?modname=documents&amp;op=monitorfolder&amp;treeid=".$folder_id;

		if (isset($_POST["canc_op"])) {
			jumpTo("index.php?modname=documents&op=documents");
		}
		else if (isset($_POST["conf_op"])) {

			if ($_POST["monitoring"] == 1) { // Remove monitor
				$qtxt ="DELETE FROM ".$GLOBALS["prefix_kms"]."_monitorized ";
				$qtxt.="WHERE item_type='folder' AND item_id='".$folder_id."' ";
				$qtxt.="AND user_idst='".$GLOBALS["current_user"]->getIdSt()."' LIMIT 1";
			}
			else if ($_POST["monitoring"] == 0) {  // Add monitor
				$qtxt ="INSERT INTO ".$GLOBALS["prefix_kms"]."_monitorized ";
				$qtxt.="(item_type, item_id, user_idst) ";
				$qtxt.="VALUES('folder', '".$folder_id."', '".$GLOBALS["current_user"]->getIdSt()."')";
			}

			$q=mysql_query($qtxt);

			jumpTo("index.php?modname=documents&op=documents");
		}
		else {

			//load info
			/* list($fname) = mysql_fetch_row(mysql_query("
			SELECT fname
			FROM ".$GLOBALS["prefix_kms"]."_file_version
			WHERE version_id  = '".$file_id."'")); */


			$qtxt ="SELECT item_id FROM ".$GLOBALS["prefix_kms"]."_monitorized ";
			$qtxt.="WHERE item_type='folder' AND item_id='".$folder_id."' ";
			$qtxt.="AND user_idst='".$GLOBALS["current_user"]->getIdSt()."'";

			$monitoring=(mysql_num_rows(mysql_query($qtxt)) > 0  ? "1":"0");

			if ($monitoring) {
				$sure_title=$this->lang->def('_SURE_FOLDER_MONITOR_SWITCH_OFF');
				$sure_msg=$this->lang->def('_MONITOR_SWITCH_OFF_MSG');
			}
			else {
				$sure_title=$this->lang->def('_SURE_FOLDER_MONITOR_SWITCH_ON');
				$sure_msg=$this->lang->def('_MONITOR_SWITCH_ON_MSG');
			}

			$out->add("<div class=\"std_block\">\n");

			$form=new Form();

			$out->add($form->openForm("document_form", $url));

			$out->add($form->getHidden("monitoring", "monitoring", $monitoring));

			$out->add(getDeleteUi(
			$sure_title,
				/* '<span class="text_bold">'.$this->lang->def('_FILENAME').' :</span> '.$fname.  */
				"<div>".$sure_msg."</div>",
				false,
				'conf_op',
				'canc_op'));

			$out->add($form->closeForm());
			$out->add("</div>\n");
		}

	}


	function editFileStatus() {

		require_once($GLOBALS["where_framework"]."/lib/lib.pubflow.php");

		$cv_id=importVar("cvid");
		$folder_id=importVar("treeid");
		$stepsel=new FlowStepSelector("kms", "kms", "documents", "document", $cv_id);

		if (isset($_POST["save"])) { // Save status

			$sel_step=$stepsel->getNextStep();
			$step_info=$stepsel->pfManager->getStepInfo($sel_step);
			$st_id=$step_info["st_id"];
			if (($sel_step != $_POST["old_step"]) && ($stepsel->pfManager->canSetStep($st_id))) {

				$ok=$stepsel->setStatusTo($sel_step);
				$stepsel->saveChangeLog($sel_step);

				if ($ok) { // Sending alert..

					$qtxt="SELECT fname, file_id FROM ".$GLOBALS["prefix_kms"]."_file_version WHERE version_id='".$cv_id."'";
					list($fname, $file_id)=mysql_fetch_row(mysql_query($qtxt));

					$old_st_id=$stepsel->pfManager->getStId($_POST["old_step"]);
					$sel_st_id=$stepsel->pfManager->getStId($sel_step);

					require_once($GLOBALS["where_kms"] . "/lib/lib.kms_common.php");
					$members=array();
					$members=array_merge($members, $stepsel->pfManager->getGroupMembers($old_st_id));
					$members=array_merge($members, $stepsel->pfManager->getGroupMembers($sel_st_id));
					$members=array_unique($members);
					$have_view_perm=$this->docman->getUsersWithPerm($file_id, "viewfile");
					$members=array_intersect($members, $have_view_perm);
					$replace=array("[fname]"=>$fname);
					sendKmsGenericEvent(
							/* members:    */ $members,
							/* class:      */ "KmsFlowOperation",
							/* module:     */ "documents",
							/* action:     */ "editfilestatus",
							/* log:        */ "Changed status of file ".$file_id,
							/* sub_string: */ "_DOCUMENTS_CHANGEDSTATUS_ALERT_SUB",
							/* txt_string: */ "_DOCUMENTS_CHANGEDSTATUS_ALERT_TXT",
							/* replace:    */ $replace
							);

					if ($_POST["old_step"] < $sel_step)
						$ctype="upgrade";
					else if ($_POST["old_step"] > $sel_step)
						$ctype="downgrade";

					$to_set=array();
					$to_set[]="ctype='".$ctype."'";

					if (($stepsel->stepIsPublished($sel_step)) && (!$_POST["old_was_published"])) { // :: Publish ::

						if ($this->docman->updateFileToPublished($cv_id)) // <- This will update the published file
							$to_set[]="published='".PUBLISHED_CURRENT."'";

					}
					else if ((!$stepsel->stepIsPublished($sel_step)) && ($_POST["old_was_published"])) { // :: Unpublish ::

						if ($this->docman->updateFileToUnPublished($cv_id)) // <- This will unpublish the file
							$to_set[]="published='".NOT_PUBLISHED."'";

					}

					$qtxt="UPDATE ".$GLOBALS["prefix_kms"]."_file_version SET ".implode(", ", $to_set)." WHERE version_id='".$cv_id."'";
					$q=mysql_query($qtxt);

				}

			}

			jumpTo("index.php?modname=documents&op=documents");
		}
		else if (isset($_POST["undo"])) { // Cancel
			jumpTo("index.php?modname=documents&op=documents");
		}
		else { // Show change status dialog and log

			if ($folder_id != 0) {
				$qtxt="SELECT flow_id FROM ".$GLOBALS["prefix_kms"]."_filesystem_tree WHERE folder_id='$folder_id'";
				$q=mysql_query($qtxt);
				if (($q) && (mysql_num_rows($q) > 0)) {
					$row=mysql_fetch_array($q);
					$flow_id=$row["flow_id"];
				}
				else
					return 0;
			}
			else {
				$flow_id=0;
			}

			$out=& $GLOBALS["page"];
			$lang=DoceboLanguage::createInstance("documents", "kms");
			$out->setWorkingZone('content');

			$out->add( getTitleArea($lang->def('_DOCUMENTS'), 'documents' ) );
			$out->add("<div class=\"std_block\">\n");

			require_once($GLOBALS["where_framework"]."/lib/lib.form.php");
			$form=new Form();
			$cs=$stepsel->getCurrentStep();
			if ($cs === FALSE) {
				$cs=$stepsel->getDefaultStep($flow_id);
			}
			$stepsel->setCurrentStep($cs);

			$url ="index.php?modname=documents&amp;op=filestatus";
			$url.="&amp;cvid=".$cv_id."&amp;treeid=".$folder_id;
			$out->add($form->openForm("document_form", $url));
			$out->add($form->openElementSpace());

			$out->add($stepsel->selectNextStep($form));


			$out->add($form->closeElementSpace());
			$out->add($form->openButtonSpace());
			$out->add($form->getButton('save', 'save', $lang->def('_OK')));
			$out->add($form->getButton('undo', 'undo', $lang->def('_UNDO')));
			$out->add($form->closeButtonSpace());
			$out->add($form->closeForm());

			$out->add($stepsel->showStatusChangeLog($url));

			$out->add("</div>\n");
		}

	}


	function downloadDocument() {
		require_once($GLOBALS["where_framework"]."/lib/lib.download.php");

		$cv_id=importVar("cvid");
		$folder_id=importVar("treeid");

		$qtxt="SELECT * FROM ".$GLOBALS["prefix_kms"]."_file_version WHERE version_id='$cv_id'";
		$q=mysql_query($qtxt);

		if (($q) && (mysql_num_rows($q) > 0)) {
			$row=mysql_fetch_array($q);
		}
		else {
			return 0;
		}

		$file_id=$row["file_id"];

		if ((!$row["published"]) && ($row["owner"] != getLogUserId()))
			die();
		else if ($row["published"])
			$this->docman->reqFilePerm($file_id, "viewfile");

		$fn=$row["real_fname"];
		$ext=end(explode(".", $fn));
		$fname=basename($row["fname"], ".".end(explode(".", $row["fname"])));

		sendFile(_FPATH_INTERNAL, $fn, $ext, $fname);
	}


}



// General pourpose functions used by the document manager module
class DocumentsManager {

	var $parent_obj=NULL;
	var $monitorized_files=NULL;
	var $monitorized_folders=NULL;

	function DocumentsManager(& $parent_obj) {
		$this->parent_obj=& $parent_obj;
	}



	// --------------- Folder permissions -----------------------------

	function loadFolderSavedPerm($folder_id) {

		$res=array();

		$pl=$this->parent_obj->getFolderPermissionsList();
		$acl_manager=& $GLOBALS['current_user']->getACLManager();
		foreach($pl as $key=>$val) {

			$idst=$acl_manager->getGroupST("KMS_Folder_".$val."_".$folder_id);
			//$idst_d=$acl_manager->getGroupST("KMS_Folder_".$val."_d_".$tree_id);

			$res[$val]=array_flip($acl_manager->getGroupMembers($idst));

		}

		return $res;
	}


	function checkFolderPerm($perm, $saved_perm) {

		$res=false;

		if ((isset($saved_perm[$perm])) && (is_array($saved_perm[$perm]))) {

			//$acl=& $GLOBALS['current_user']->getACL();
			$perm_array=array_keys($saved_perm[$perm]);
			/*echo "<br /><br />$perm : ";
			print_r($saved_perm); print_r($perm_array);*/

			//$res=$acl->matchUserSTArray($GLOBALS['current_user']->getUserId(), $perm_array);

			reset($perm_array);
			while(($val=current($perm_array)) && (!$res)) {

				if ($GLOBALS['current_user']->matchUserST($val))
					$res=true;

				next($perm_array);
			}
		}

		return $res;
	}


	function hasFolderPerm($folder_id, $perm) {

		$saved_perm=$this->loadFolderSavedPerm($folder_id);

		if(($this->checkFolderPerm($perm, $saved_perm)) || ($this->isGodAdmin())) {
			$folder_perm=true;
		}
		else {
			$folder_perm=false;
		}

		return $folder_perm;
	}


	function requireFolderPerm($folder_id, $perm) {

		if (!$this->hasFolderPerm($folder_id, $perm))
			die("You can't access!");

	}



	// --------------- File permissions -----------------------------


	function loadFilePerm($folder_id=FALSE, $filde_id=FALSE, $reload=FALSE) {

		if ((isset($this->parent_obj->file_perm)) && (is_array($this->parent_obj->file_perm)) && (!$reload)) {
			return 0;
		}

		$user_idst=$GLOBALS['current_user']->getArrST();
		$idst_list=implode(",", $user_idst);

		$fields="t2.file_id, t2.perm_name";
		$qtxt ="SELECT $fields FROM ".$GLOBALS["prefix_kms"]."_file as t1, ".$GLOBALS["prefix_kms"]."_file_perm as t2 ";
		$qtxt.="WHERE t1.file_id=t2.file_id AND t2.idst IN (".$idst_list.")";

		if ($folder_id !== FALSE)
			$qtxt.=" AND t1.folder_id='".(int)$folder_id."'";

		if ($filde_id !== FALSE)
			$qtxt.=" AND t1.file_id='".(int)$filde_id."'";

		$q=mysql_query($qtxt);

		$res=array();
		if (($q) && (mysql_num_rows($q) > 0)) {
			while($row=mysql_fetch_array($q)) {

				if ((!isset($res[$row["perm_name"]])) || (!in_array($row["file_id"], $res[$row["perm_name"]]))) {
					$res[$row["perm_name"]][]=$row["file_id"];
				}

			}
		}

		$this->parent_obj->file_perm=$res;
	}


	function getFilePerm($folder_id=FALSE, $file_id=FALSE, $reload=FALSE) {

		if ((!isset($this->parent_obj->file_perm)) || (!is_array($this->parent_obj->file_perm))) {
			$this->loadFilePerm($folder_id, $file_id, $reload);
		}

		return $this->parent_obj->file_perm;
	}


	function userHavePermForFile($file_id, $perm) {

		if ($this->isGodAdmin())
			return TRUE;

		if ((!isset($this->parent_obj->file_perm)) || (!is_array($this->parent_obj->file_perm))) {
			$this->loadFilePerm(false, $file_id);
		}

		if (isset($this->parent_obj->file_perm[$perm]))
			return in_array($file_id, $this->parent_obj->file_perm[$perm]);
		else
			return FALSE;
	}


	function getUsersWithPerm($file_id, $perm) {

		$qtxt ="SELECT idst FROM ".$GLOBALS["prefix_kms"]."_file_perm ";
		$qtxt.="WHERE file_id='".$file_id."' AND perm_name='".$perm."'";

		$q=mysql_query($qtxt);

		// We start with god admins
		$acl_manager=$GLOBALS["current_user"]->getAclManager();
		$admin_role_st=$acl_manager->getGroupST(ADMIN_GROUP_GODADMIN);
		$res=$acl_manager->getGroupMembers($admin_role_st);

		if (($q) && (mysql_num_rows($q) > 0)) {
			while($row=mysql_fetch_array($q)) {
				$res[]=$row["idst"];
			}
		}

		return $res;
	}


	function reqFilePerm($file_id, $perm) {

		if (!$this->userHavePermForFile($file_id, $perm))
			die("You can't access!");

	}


	// --------------- File publication flow ------------------------


	function updateFileToPublished($cv_id) {

		$qtxt="SELECT * FROM ".$GLOBALS["prefix_kms"]."_file_version WHERE version_id='$cv_id'";
		$q=mysql_query($qtxt);
		if (($q) && (mysql_num_rows($q) > 0)) {
			$new_file=mysql_fetch_array($q);

			//-alert-----------------------------------------------------
			// Return some results only if publish_date is 0 that means
			// that it is the first time the file is published, so we send
			// a "new file created" alert.
			$qtxt ="SELECT folder_id FROM ".$GLOBALS["prefix_kms"]."_file ";
			$qtxt.="WHERE file_id='".$new_file["file_id"]."' AND publish_date='0'";

			$q=mysql_query($qtxt);
			if (($q) && (mysql_num_rows($q) > 0)) {
				$row=mysql_fetch_array($q);
				require_once($GLOBALS["where_kms"] . "/lib/lib.kms_common.php");
				$members=$this->getUsersMonitoringFolder($row["folder_id"]);
				$have_view_perm=$this->getUsersWithPerm($new_file["file_id"], "viewfile");
				$members=array_intersect($members, $have_view_perm);
				$replace=array("[fname]"=>$new_file["fname"]);
				sendKmsGenericEvent(
						/* members:    */ $members,
						/* class:      */ "KmsDocumentCreated",
						/* module:     */ "documents",
						/* action:     */ "add",
						/* log:        */ "Added document ".$new_file["file_id"],
						/* sub_string: */ "_DOCUMENTS_CREATED_ALERT_SUB",
						/* txt_string: */ "_DOCUMENTS_CREATED_ALERT_TXT",
						/* replace:    */ $replace
					);
			}
			//-----------------------------------------------------------

			$qtxt ="UPDATE ".$GLOBALS["prefix_kms"]."_file_version SET ";
			$qtxt.="published='".PUBLISHED_OLD."' "; // approved but not published
			$qtxt.="WHERE file_id='".$new_file["file_id"]."' AND version_id!='".$cv_id."'";
			$q=mysql_query($qtxt);


			$qtxt ="UPDATE ".$GLOBALS["prefix_kms"]."_file SET ";
			$qtxt.="cv_id='".$cv_id."', owner='".$new_file["owner"]."', fname='".$new_file["fname"]."', ";
			$qtxt.="real_fname='".$new_file["real_fname"]."', publish_date=NOW(), published='".PUBLISHED_CURRENT."' ";
			$qtxt.="WHERE file_id='".$new_file["file_id"]."' LIMIT 1";
			$q=mysql_query($qtxt);

			if ($q)
				return true;
			else
				return false;
		}
		else
			return false;
	}


	function updateFileToUnPublished($cv_id) {

		$qtxt="SELECT * FROM ".$GLOBALS["prefix_kms"]."_file WHERE cv_id='".$cv_id."'";
		$q=mysql_query($qtxt);
		if (($q) && (mysql_num_rows($q) > 0)) {
			$old_file=mysql_fetch_array($q);

			$qtxt ="UPDATE ".$GLOBALS["prefix_kms"]."_file SET ";
			$qtxt.="cv_id='0', published='".NOT_PUBLISHED."' ";
			$qtxt.="WHERE file_id='".$old_file["file_id"]."' LIMIT 1";
			$q=mysql_query($qtxt); //echo $qtxt;

			if ($q)
				return true;
			else
				return false;
		}
		else
			return false;
	}


	function getFolderFlowId($folder_id) {
		$res=0;

		$qtxt="SELECT flow_id FROM ".$GLOBALS["prefix_kms"]."_filesystem_tree WHERE folder_id='".$folder_id."'";
		$q=mysql_query($qtxt);

		if (($q) && (mysql_num_rows($q) > 0)) {
			$row=mysql_fetch_array($q);

			$res=$row["flow_id"];
		}

		return $res;
	}


	// --------------- File/Folder monitoring -----------------------

	function getMonitorizedFiles($folder_arr=FALSE, $user_idst=FALSE, $reload=FALSE) {

		if ((!isset($this->monitorized_files)) || ($reload)) {
			$this->monitorized_files=$this->loadMonitorizedFiles($folder_arr, $user_idst);
		}

		return $this->monitorized_files;
	}


	function loadMonitorizedFiles($folder_arr=FALSE, $user_idst=FALSE) {

		if ($user_idst === FALSE) {
			$user_idst=$GLOBALS["current_user"]->getIdSt();
		}

		$fields="t1.file_id";
		$qtxt ="SELECT $fields FROM ".$GLOBALS["prefix_kms"]."_file as t1, ";
		$qtxt.=$GLOBALS["prefix_kms"]."_monitorized as t2 ";
		$qtxt.="WHERE t2.item_type='file' AND t2.item_id=t1.file_id AND t2.user_idst='".$user_idst."'";

		$in_folder_qstr=($folder_arr === FALSE ? "" : " AND t1.folder_id IN (".implode(",", $folder_arr).")");

		$qtxt.=$in_folder_qstr;

		$q=mysql_query($qtxt);

		$res=array();
		if (($q) && (mysql_num_rows($q) > 0)) {
			while($row=mysql_fetch_array($q)) {
				$res[]=$row["file_id"];
			}
		}

		return $res;
	}


	function getUsersMonitoringFile($file_id) {
		$qtxt ="SELECT user_idst FROM ";
		$qtxt.=$GLOBALS["prefix_kms"]."_monitorized ";
		$qtxt.="WHERE item_type='file' AND item_id='".$file_id."'";

		$q=mysql_query($qtxt);

		$res=array();
		if (($q) && (mysql_num_rows($q) > 0)) {
			while($row=mysql_fetch_array($q)) {
				$res[]=$row["user_idst"];
			}
		}

		return $res;
	}


	function getMonitorizedFolders($folder_arr=FALSE, $user_idst=FALSE, $reload=FALSE) {

		if ((!isset($this->monitorized_folders)) || ($reload)) {
			$this->monitorized_folders=$this->loadMonitorizedFolders($folder_arr, $user_idst);
		}

		return $this->monitorized_folders;
	}


	function loadMonitorizedFolders($folder_arr=FALSE, $user_idst=FALSE) {

		if ($user_idst === FALSE) {
			$user_idst=$GLOBALS["current_user"]->getIdSt();
		}

		$fields="item_id";
		$qtxt ="SELECT $fields FROM ";
		$qtxt.=$GLOBALS["prefix_kms"]."_monitorized ";
		$qtxt.="WHERE item_type='folder' AND user_idst='".$user_idst."'";

		$in_folder_qstr=($folder_arr === FALSE ? "" : " AND t1.folder_id IN (".implode(",", $folder_arr).")");

		$qtxt.=$in_folder_qstr;

		$q=mysql_query($qtxt);

		$res=array();
		if (($q) && (mysql_num_rows($q) > 0)) {
			while($row=mysql_fetch_array($q)) {
				$res[]=$row["item_id"];
			}
		}

		return $res;
	}


	function getUsersMonitoringFolder($folder_id) {
		$qtxt ="SELECT user_idst FROM ";
		$qtxt.=$GLOBALS["prefix_kms"]."_monitorized ";
		$qtxt.="WHERE item_type='folder' AND item_id='".$folder_id."'";

		$q=mysql_query($qtxt);

		$res=array();
		if (($q) && (mysql_num_rows($q) > 0)) {
			while($row=mysql_fetch_array($q)) {
				$res[]=$row["user_idst"];
			}
		}

		return $res;
	}


	// --------------------------------------------------------------

	function isGodAdmin() {
//-debug-// return false;
		$userlevelid = $GLOBALS['current_user']->getUserLevelId();
		if( $userlevelid != ADMIN_GROUP_GODADMIN ) {
			return false;
		}
		else {
			return true;
		}

	}


}




class FileSystemRetriever extends DataRetriever {

	var $idFilters = NULL;
	var $folder_id=0;
	var $field_filter = array();
	var $custom_join = array();
	var $custom_where = array();
	var $prefix = "";

	function FileSystemRetriever($dbconn = FALSE, $prefix = FALSE ) {
		parent::DataRetriever( $dbconn, $prefix );

		if ($prefix === FALSE) {
			$this->prefix=$GLOBALS["prefix_kms"];
		}
		else {
			$this->prefix=$prefix;
		}

		//$this->aclManager = new DoceboACLManager($dbconn , $prefix );
		$this->aclManager = new DoceboACLManager($dbconn , FALSE );
	}

	function setFolder($folder_id) {
		$this->folder_id=$folder_id;
	}

	function getFileTable() {
		return $this->prefix."_file";
	}

	function setGroupFilter( $idst_group, $deep = FALSE ) {
		if ($idst_group > 0)
			$arr_users = $this->aclManager->getGroupUMembers($idst_group);
		else
			$arr_users = array();
		if( $deep ) {
			$arr_desc = $this->aclManager->getGroupUDescendants($idst_group);
			$arr_users = array_merge( $arr_users, $arr_desc  );
		}
		$this->addFilter( $arr_users );
	}

	function intersectGroupFilter( $arr_idst_group ) {
		$arr_users = array();
		foreach( $arr_idst_group as $idst_group ) {
			if ($idst_group > 0)
				$arr_users = array_merge( $arr_users, $this->aclManager->getGroupUMembers($idst_group));
		}
		if( is_array($this->idFilters) ) {
			$this->idFilters = array_intersect( $this->idFilters, $arr_users );
		} else if (count($arr_users) > 0) {
			// if not is set all user was in filter so intersection is $arr_users
			$this->idFilters = $arr_users;
		}
		else {
			$this->idFilters = NULL; // Else keep it null to get right results in FileSystemRetriever::getTotalRows ;)
		}
	}

	function addFilter( $idFilters ) {
		if( is_array($this->idFilters) ) {
			$this->idFilters = array_merge( $this->idFilters, $idFilters );
		} else {
			$this->idFilters = $idFilters;
		}
	}

	function addFieldFilter( $field, $value, $op = ' = ' ) {
			if( $field == 'userid' && strlen($value) > 0 )
				$this->field_filter[] = "`".$field."`".$op."'".$this->aclManager->absoluteId($value)."'";
			else
				$this->field_filter[] =  "`".$field."`".$op."'".$value."'";
	}

	function addCustomFilter( $join_part, $where_part ) {
		$this->custom_join[] = $join_part;
		$this->custom_where[] = $where_part;
	}

	function getRows( $startRow, $numRows ) {
		$query = "SELECT file_id, folder_id, cv_id, owner, publish_date, fname, real_fname FROM ".$this->prefix."_file ";
		foreach( $this->custom_join as $add_join )
			$query .= $add_join;
		/* if( $this->idFilters !== NULL ) {
			if( count($this->idFilters) > 0 )
				$query .= " WHERE idst IN (".implode ( ',', $this->idFilters ).")";
			else
				$query .= " WHERE 0";
		} else  */
			$query .= " WHERE 1";

		foreach( $this->field_filter as $filter_add )
			$query .= " AND ".$filter_add;

		foreach( $this->custom_where as $add_where )
			$query .= " AND ".$add_where;

		$query.=" AND folder_id='".$this->folder_id."' AND published='".PUBLISHED_CURRENT."'"; //echo $query; // die();

		return $this->_getData( $query, $startRow, $numRows );
	}

	function getFilteredWhere($table="") {
		$query="";

		foreach( $this->custom_join as $add_join )
			$query .= $add_join;
		if( $this->idFilters !== NULL ) {
			if( count($this->idFilters) > 0 )
				$query .= " WHERE ".($table != "" ? $table.".":"")."file_id IN (".implode ( ',', $this->idFilters ).")";
			else
				$query .= " WHERE 0";
		} else
			$query .= " WHERE 1";

		foreach( $this->field_filter as $filter_add )
			$query .= " AND ".$filter_add;

		foreach( $this->custom_where as $add_where )
			$query .= " AND ".$add_where;

		return $query;
	}

	function getTotalRows() {
		$query = "SELECT count(file_id) FROM ".$this->prefix."_file ";

		$query.=$this->getFilteredWhere();

		$query.=" AND folder_id='".$this->folder_id."' AND published='".PUBLISHED_CURRENT."'";

		if( $this->dbConn === NULL )
			$rs = mysql_query( $query );
		else
			$rs = mysql_query( $query, $this->dbConn );
		list( $count ) = mysql_fetch_row( $rs );
		return $count;
	}
}


?>