<?php
/************************************************************************/
/* DOCEBO KMS                                                           */
/* ============================================                         */
/*                                                                      */
/* Copyright (c) 2005                                                   */
/* http://www.docebo.com                                                */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

if(!defined('IN_DOCEBO')) die('You cannot access this file directly');

require_once($GLOBALS['where_framework'].'/lib/lib.aclmanager.php');
require_once($GLOBALS['where_framework'].'/lib/lib.listview.php' );

define( 'DIRECTORY_TAB', 'DIRECTORY_TAB' );
define( 'PEOPLEVIEW_TAB', 'PEOPLEVIEW_TAB' );
define( 'GROUPVIEW_TAB', 'GROUPVIEW_TAB' );
define( 'ORGVIEW_TAB', 'ORGVIEW_TAB' );

define( 'DIRECTORY_ID', 'directory_id');
define( 'DIRECTORY_OP_SELECTITEM', 'directory_op_selectitem');
define( 'DIRECTORY_OP_SELECTRADIO', 'directory_op_selectradio' );
define( 'DIRECTORY_ID_PRINTEDITEM', 'directory_id_printeditem');
define( 'DIRECTORY_OP_ADDFIELD', 'directory_op_addfield');

define( 'DIRECTORY_CFIELD', 'DIR_CFIELD' );

define("GROUP_FIELD_NO","No");
define("GROUP_FIELD_NORMAL","Normal");
define("GROUP_FIELD_DESCEND","Descend");
define("GROUP_FIELD_INHERIT","Inherit");

class FileListView extends ListView {
	var $lang = NULL;
	var $selector_mode = FALSE;
	var $tree_mode = FALSE;
	var $itemSelectedMulti = array();
	var $printedItems = array();
	var $link_pagination = '';

	var $show_flat_mode_flag = TRUE;
	var $flat_mode = FALSE;

	var $more_filter = 'less';
	// FieldList object for custom fields management
	var $field_list = NULL;
	// array of custom fields selected in columns
	var $cFields = NULL;
	// number of customizable columns in listview
	var $nFields = 2;

	/** Array with file permissions */
	var $file_perm=NULL;

	// list of all filter fields with their names
	var $arr_fields_translation = NULL;

	// list of all column fields woth theyr translation
	var $arr_fields_col_translation = NULL;

	// list of currents filter fields
	var $arr_fields_filter = array();

	var $docman=NULL;

	// array of natural fields
	// key is fieldid as in db (used in db for filter)
	// value is an array with:
	//		filter_field : TRUE if this is a field for filter (find)
	//		filter_base  : TRUE put this field in base filter section
	//		column_field : TRUE if this is a field for custom columns
	//		field_type   : the type of field as for custom fields
	var $add_nat_fields = array(
								'file_id' => array(
													'fieldname' => 'file_id',
													'filter_field' => TRUE,
													'filter_base' => TRUE,
													'column_field' => FALSE,
													'field_type' => 'textfield',
													),
								'fname' => array(
													'fieldname' => 'fname',
													'filter_field' => TRUE,
													'filter_base' => TRUE,
													'column_field' => FALSE,
													'field_type' => 'textfield'
													)
						/*		'lastname' => array(
													'fieldname' => 'lastname',
													'filter_field' => TRUE,
													'filter_base' => TRUE,
													'column_field' => FALSE,
													'field_type' => 'textfield'
													),
								'email' => array(
													'fieldname' => 'email',
													'filter_field' => TRUE,
													'filter_base' => FALSE,
													'column_field' => TRUE,
													'field_type' => 'textfield'
													) */ /*,
								'avatar' => array(
													'fieldname' => 'avatar',
													'filter_field' => TRUE,
													'filter_base' => FALSE,
													'column_field' => TRUE,
													'field_type' => 'upload'
													),
								'photo' => array(
													'fieldname' => 'photo',
													'filter_field' => TRUE,
													'filter_base' => FALSE,
													'column_field' => TRUE,
													'field_type' => 'upload'
													)*/

								);
	function _getOpEditItemId() 	{ return 'listview_opedititem_';	}
	function _getEditLabel() { return $this->lang->def('_DOCUMENTS_EDITDOC'); }
	function _getEditAlt() { return $this->lang->def('_DOCUMENTS_EDITDOC'); }
	function _getEditImage() { return getPathImage().'standard/mod.gif'; }

	function _getOpFilepermId() 	{ return 'listview_opfileperm_';	}
	function _getFilepermLabel() { return $this->lang->def('_DOCUMENTS_FILEPERM'); }
	function _getFilepermAlt() { return $this->lang->def('_DOCUMENTS_FILEPERM'); }

	function _getOpDeleteItemId() 	{ return 'listview_opdeleteitem_';	}
	function _getDeleteLabel() { return $this->lang->def('_DOCUMENTS_DELDOC'); }
	function _getDeleteAlt() { return $this->lang->def('_DOCUMENTS_DELDOC'); }
	function _getDeleteImage() { return getPathImage().'standard/rem.gif'; }

	function _getOpFileVersionId() 	{ return 'listview_opfileversion_';	}
	function _getOpFileStatusId() 	{ return 'listview_opfilestatus_';	}
	function _getOpFileMonitorId() 	{ return 'listview_opfilemonitor_';	}

	function _getOpCommentFileId() 	{ return 'listview_opcommentfile_';	}
	function _getCommentFileLabel() { return $this->lang->def('_DOCUMENTS_COMMENTDOC'); }
	function _getCommentFileAlt() { return $this->lang->def('_DOCUMENTS_COMMENTDOC'); }

	function _getOpSelectedItemId() 	{ return 'listview_opselecteduser_';	}
	function _getSelectedLabel() { return $this->lang->def('_DIRECTORY_SELECTUSER'); }
	function _getSelectedAlt() { return $this->lang->def('_DIRECTORY_SELECTUSER'); }

	function FileListView($title, &$data, &$rend, $id) {

		$this->docman=new DocumentsManager($this);

		require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
		$this->field_list = new FieldList();
		$this->field_list->setGroupFieldsTable($GLOBALS['prefix_kms']."_filesystem_field");
		$this->field_list->setFieldEntryTable($GLOBALS['prefix_kms']."_filesystem_fieldentry");
		parent::ListView($title, $data, $rend, $id);
		$this->lang =& DoceboLanguage::createInstance('documents', 'kms');
		for( $i = 0; $i < $this->nFields; $i++ ) {
			$this->cFields[] = 0;
		}
		$arr_fields = $this->field_list->getAllFields();  // <- fargli caricare campi cartella*

		$this->arr_fields_translation = array();
		$this->arr_fields_col_translation = array();
		foreach( $this->add_nat_fields as $nat_id => $nat_info ) {
			$this->arr_fields_translation[$nat_id] = $this->lang->def('_DIRECTORY_FILTER_'.$nat_id);
			if( $nat_info['column_field'] )
				$this->arr_fields_col_translation[$nat_id] = $this->arr_fields_translation[$nat_id];
		}
		foreach( $arr_fields as $field_info ) {
			$this->arr_fields_translation[$field_info[FIELD_INFO_ID]] = $field_info[FIELD_INFO_TRANSLATION];
			$this->arr_fields_col_translation[$field_info[FIELD_INFO_ID]] = $field_info[FIELD_INFO_TRANSLATION];
		}
	}

	/*function getOp() {
		return $this->op;
	}

	function getIdSelectedItem() {
		return $this->op;
	}*/

	function printState() {
		$out = parent::printState();
		$out .= '<input type="hidden"'
			.' id="'.$this->id.'_cfield_state"'
			.' name="'.$this->id.'[cfield_state]"'
			.' value="'.urlencode(serialize($this->cFields)).'" />'."\n";
		$out .= '<input type="hidden"'
			.' id="'.DIRECTORY_ID.DIRECTORY_ID_PRINTEDITEM.'"'
			.' name="'.DIRECTORY_ID.'['.DIRECTORY_ID_PRINTEDITEM.']"'
			.' value="'.urlencode(serialize($this->printedItems)).'" />'."\n";
		// save state of custom columns
		$GLOBALS['current_user']->preference->setPreference(
						'ui.kms.documents.custom_columns',
						urlencode(serialize($this->cFields)));
		// save state of filter
		$GLOBALS['current_user']->preference->setPreference(
						'ui.kms.documents.filters.current',
						urlencode(serialize($this->arr_fields_filter)));

		return $out;
	}

	function setLinkPagination( $link_pagination ) {
		$this->link_pagination = $link_pagination;
	}

	function _getLinkPagination() {
		return $this->link_pagination.'&amp;ord='
				.$this->_getOrd()
				.'&amp;ini=';
	}

	function _getCols() {
		require_once($GLOBALS['where_framework']."/lib/lib.form.php");
		$this->lang =& DoceboLanguage::createInstance('documents', 'kms');

		$totCol = $this->data->getFieldCount();
		$colInfos = array();
		if( $this->selector_mode ) {
			$colInfos[] = array( 	'hLabel' => '',
									'hClass' => "image",
									'fieldClass' => "image",
									'data' => 'selection',
									'toDisplay' => true,
									'sortable' => false );
		}
		$colInfos[] = array( 	'hLabel' => $this->lang->def( '_DIRECTORY_FILEID' ),
								'hClass' => "",
								'fieldClass' => "",
								'data' => 'file_id',
								'toDisplay' => true,
								'sortable' => true );

		$colInfos[] = array( 	'hLabel' => $this->lang->def( '_DIRECTORY_FILETYPE' ),
								'hClass' => "",
								'fieldClass' => "image",
								'data' => 'ftype',
								'toDisplay' => true,
								'sortable' => true );
		$colInfos[] = array( 	'hLabel' => $this->lang->def( '_DIRECTORY_FILENAME' ),
								'hClass' => "",
								'fieldClass' => "",
								'data' => 'fname',
								'toDisplay' => true,
								'sortable' => true );
		/*$colInfos[] = array( 	'hLabel' => $this->lang->def( '_DIRECTORY_LASTNAME' ),
								'hClass' => "",
								'fieldClass' => "",
								'data' => 'lastname',
								'toDisplay' => true,
								'sortable' => true );*/

		for( $i = 0; $i < $this->nFields; $i++ ) {
			$colInfos[] = array( 	'hLabel' => Form::getInputDropdown(
												'dropdown',
												DIRECTORY_CFIELD.'_'.$i,
												$this->id.'['.DIRECTORY_CFIELD.']['.$i.']',
												$this->arr_fields_col_translation,
												$this->cFields[$i],
												'onchange="window.document.forms[0].submit()"'
												),
									'hClass' => "directory_custom_columns",
									'fieldClass' => "directory_custom_columns",
									'data' => DIRECTORY_CFIELD.'_'.$i,
									'toDisplay' => true,
									'sortable' => true );
		}

		if( !$this->selector_mode ) {

			if (!$GLOBALS["current_user"]->isAnonymous()) {

				$colInfos[] = array( 	'hLabel' => '<img src="'.getPathImage().'standard/monitor_off.gif" '
											.'alt="'.$this->lang->def( '_DOCUMENTS_FILESMONITOR' ).'" '
											.'title="'.$this->lang->def( '_DOCUMENTS_FILESMONITOR' ).'" />',
										'hClass' => "image",
										'fieldClass' => "image",
										'data' => 'filemonitor',
										'toDisplay' => true,
										'sortable' => false );

				$colInfos[] = array( 	'hLabel' => '<img src="'.getPathImage().'documents/status.gif" '
											.'alt="'.$this->lang->def( '_DOCUMENTS_FILESTATUS' ).'" '
											.'title="'.$this->lang->def( '_DOCUMENTS_FILESTATUS' ).'" />',
										'hClass' => "image",
										'fieldClass' => "image",
										'data' => 'filestatus',
										'toDisplay' => true,
										'sortable' => false );
			}

			$colInfos[] = array( 	'hLabel' => '<img src="'.getPathImage().'documents/file_version.gif" '
										.'alt="'.$this->lang->def( '_DOCUMENTS_FILEVERSION' ).'" '
										.'title="'.$this->lang->def( '_DOCUMENTS_FILEVERSION' ).'" />',
									'hClass' => "image",
									'fieldClass' => "image",
									'data' => 'fileversion',
									'toDisplay' => true,
									'sortable' => false );

			if ($GLOBALS["kms"]["feature_comments"] == "on") {
				$colInfos[] = array( 	'hLabel' => '<img src="'.getPathImage().'documents/comment.gif" '
											.'alt="'.$this->lang->def( '_DOCUMENTS_COMMENTDOC' ).'" '
											.'title="'.$this->lang->def( '_DOCUMENTS_COMMENTDOC' ).'" />',
										'hClass' => "image",
										'fieldClass' => "image",
										'data' => 'commentfile',
										'toDisplay' => true,
										'sortable' => false );
			}

			if (!$GLOBALS["current_user"]->isAnonymous()) {
				if( !$this->tree_mode ) {
					$colInfos[] = array( 	'hLabel' => '<img src="'.getPathImage().'documents/assign_user.gif" '
												.'alt="'.$this->lang->def( '_DOCUMENTS_EDITDOC' ).'" '
												.'title="'.$this->lang->def( '_DOCUMENTS_EDITDOC' ).'" />',
											'hClass' => "image",
											'fieldClass' => "image",
											'data' => 'fileperm',
											'toDisplay' => true,
											'sortable' => false );
					$colInfos[] = array( 	'hLabel' => '<img src="'.$this->_getEditImage().'" '
												.'alt="'.$this->lang->def( '_DOCUMENTS_EDITDOC' ).'" '
												.'title="'.$this->lang->def( '_DOCUMENTS_EDITDOC' ).'" />',
											'hClass' => "image",
											'fieldClass' => "image",
											'data' => 'edit',
											'toDisplay' => true,
											'sortable' => false );
				}
				$colInfos[] = array( 	'hLabel' => '<img src="'.$this->_getDeleteImage().'" '
											.'alt="'.$this->lang->def( '_DOCUMENTS_DELDOC' ).'" '
											.'title="'.$this->lang->def( '_DOCUMENTS_DELDOC' ).'" />',
										'hClass' => "image",
										'fieldClass' => "image",
										'data' => 'delete',
										'toDisplay' => true,
										'sortable' => false );
			}
		}
		return $colInfos;
	}

	function extendedParsing( $arrayState ) {

		// set filter for base fields
		require_once($GLOBALS['where_framework'].'/modules/field/class.field.php');
		$arr_fields = Field::getArrFieldValue_Filter( $_POST, $this->add_nat_fields, $this->id, '_' );
		foreach( $arr_fields as $fname => $fvalue )
			if( isset( $fvalue['value'] ) /*&& $fvalue['value'] != ''*/ )
				$this->arr_fields_filter[$fname] = $fvalue;



		// set filter for custom fields
		$arr_all_fields = $this->field_list->getAllFields();
		$arr_fields = Field::getArrFieldValue_Filter( $_POST, $arr_all_fields, $this->id, '_' );
		foreach( $arr_fields as $fname => $fvalue )
			if( isset( $fvalue['value'] ) )
				$this->arr_fields_filter[$fname] = $fvalue;

		if( isset( $arrayState[$this->id] ) ) {
			// this test first - not correct in foreach
			if( isset( $arrayState[$this->id]['directory_lessmore'] ) )
				$this->more_filter = $arrayState[$this->id]['directory_lessmore'];

			$isFieldsSet = FALSE;
			foreach( $arrayState[$this->id] as $key => $val ) {

				switch( $key ) {
					case $this->_getOpFileMonitorId():
						$this->itemSelected = key ( $arrayState[$this->id][$this->_getOpFileMonitorId()] );
						$this->op = 'filemonitor';
					break;
					case $this->_getOpFileStatusId():
						$this->itemSelected = key ( $arrayState[$this->id][$this->_getOpFileStatusId()] );
						$this->op = 'filestatus';
					break;
					case $this->_getOpFileVersionId():
						$this->itemSelected = key ( $arrayState[$this->id][$this->_getOpFileVersionId()] );
						$this->op = 'fileversion';
					break;
					case $this->_getOpCommentFileId():
						$this->itemSelected = key ( $arrayState[$this->id][$this->_getOpCommentFileId()] );
						$this->op = 'commentfile';
					break;
					case $this->_getOpFilepermId():
						$this->itemSelected = key ( $arrayState[$this->id][$this->_getOpFilepermId()] );
						$this->op = 'editfileperm';
					break;
					case $this->_getOpEditItemId():
						$this->itemSelected = key ( $arrayState[$this->id][$this->_getOpEditItemId()] );
						$this->op = 'editfile';
					break;
					case $this->_getOpDeleteItemId():
						$this->itemSelected = key ( $arrayState[$this->id][$this->_getOpDeleteItemId()] );
						$this->op = 'deletefile';
					break;
					case 'cfield_state':
						if( !$isFieldsSet )
							$this->cFields = unserialize(urldecode($val));
					break;
					case DIRECTORY_CFIELD:
						$isFieldsSet = TRUE;
						foreach( $val as $nField => $idField ) {
							$this->cFields[$nField] = $idField;
						}
					break;
					case 'directory_more':
						$this->more_filter = 'more';
					break;
					case 'directory_less':
						$this->more_filter = 'less';
					break;
					case 'flat_mode':
						$this->flat_mode = ($val == 'flat_mode');
					break;
					case 'add_filter':
						$id_field = $arrayState[$this->id]['add_field_filter'];
						if( is_numeric( $id_field ) ) {
							$this->arr_fields_filter['ff'.count($this->arr_fields_filter).'_'.$id_field] = $arr_all_fields[$id_field];
						} else {
							$this->arr_fields_filter['ff'.count($this->arr_fields_filter).'_'.$id_field] = $this->add_nat_fields[$id_field];
						}
					break;
					case 'del_filter':
						if( is_array( $val ) ) {
							unset($this->arr_fields_filter[key($val)]);
						} else {
							$this->arr_fields_filter = array();
						}
					break;
				}
			}
		} else {
			// default initializations
			$this->cFields = unserialize(urldecode($GLOBALS['current_user']->preference->getPreference( 'ui.kms.documents.custom_columns' )));
			$this->arr_fields_filter = unserialize(urldecode($GLOBALS['current_user']->preference->getPreference( 'ui.kms.documents.filters.current' )));
		}

		if (!is_array($this->arr_fields_filter))
			$this->arr_fields_filter=array();

		foreach( $this->arr_fields_filter as $fname => $fvalue ) {
			if( isset( $fvalue['value'] ) ) {
				if( isset( $fvalue['fieldname'] ) ) {
					if( $fvalue['field_type'] == 'upload' ) {
						$this->data->addFieldFilter( $fvalue['fieldname'], '', '<>');
					} else {
						if( $fvalue['value'] == '' ) {
							$search_op = " = ";
							$search_val = "";
						} else {
							$search_op = " LIKE ";
							$search_val = "%".$fvalue['value']."%";
						}
						$this->data->addFieldFilter( $fvalue['fieldname'], $search_val, $search_op);
					}
				} else {
					if( $fvalue[FIELD_INFO_TYPE] == 'upload' ) {
						$this->data->addCustomFilter( 	" LEFT JOIN ".Field::_getUserEntryTable()." AS ".$fname
														." ON ( $fname.id_common = '".(int)$fvalue[FIELD_INFO_ID]."'"
														." AND $fname.id_user = idst ) ",
														" ($fname.user_entry IS ".(($fvalue['value']=='true')?'NOT':'')." NULL ) " );
					} else {
						if( $fvalue['value'] == '' )
							$where = " ($fname.user_entry = '' OR $fname.user_entry IS NULL )";
						else
							$where = " ($fname.user_entry LIKE '%".$fvalue['value']."%' ) ";
						$this->data->addCustomFilter( 	" LEFT JOIN ".Field::_getUserEntryTable()." AS ".$fname
														." ON ( $fname.id_common = '".(int)$fvalue[FIELD_INFO_ID]."'"
														." AND $fname.id_user = idst ) ",
														$where );
					}
				}
			}
		}

	}





	function fetchRecord() {

		require_once($GLOBALS["where_framework"]."/lib/lib.mimetype.php");

		$arrResult = $this->data->fetchRecord();
		if( $arrResult === FALSE )
			return FALSE;

		//$arrResult['userid'] = $this->aclManager->relativeId($arrResult['userid']);
		//$arrResult['fullname'] = join( array( $arrResult['firstname'], $arrResult['lastname'] ), ' ');

		$is_owner=($arrResult['owner'] == $GLOBALS["current_user"]->getIdSt() ? true : false);

		$this->docman->loadFilePerm($arrResult['folder_id']);
		$monitorized_files=$this->docman->getMonitorizedFiles(array($arrResult['folder_id']));

		for( $i = 0; $i < $this->nFields; $i++ ) {
			if( is_numeric($this->cFields[$i]) )
				$arrResult[DIRECTORY_CFIELD.'_'.$i] = $this->field_list->showFieldForUser($arrResult['cv_id'],$this->cFields[$i],TRUE);
			else if (isset($this->cFields[$i]))
				$arrResult[DIRECTORY_CFIELD.'_'.$i] = $arrResult[$this->cFields[$i]];
			else
				$arrResult[DIRECTORY_CFIELD.'_'.$i] = "&nbsp;";
		}
		if( !$this->selector_mode ) {

			if ($this->docman->userHavePermForFile($arrResult['file_id'], "editfile")) {

				if (in_array($arrResult["file_id"], $monitorized_files)) {
					$monitor_img="monitor_on";
					$monitor_title='_DOCUMENTS_FILEMONITOR_ON';
				}
				else {
					$monitor_img="monitor_off";
					$monitor_title='_DOCUMENTS_FILEMONITOR_OFF';
				}

				$arrResult['filemonitor'] = '<input type="image" class="tree_view_image" '
								.' src="'.getPathImage().'standard/'.$monitor_img.'.gif"'
								.' id="'.$this->id.'_'.$this->_getOpFileMonitorId().'_'.$arrResult['file_id'].'" '
								.' name="'.$this->id.'['.$this->_getOpFileMonitorId().']['.$arrResult['file_id'].']" '
								.' title="'.$this->lang->def($monitor_title).'" '
								.' alt="'.$this->lang->def($monitor_title).'" />';

				$arrResult['filestatus'] = '<input type="image" class="tree_view_image" '
								.' src="'.getPathImage().'documents/status.gif"'
								.' id="'.$this->id.'_'.$this->_getOpFileStatusId().'_'.$arrResult['cv_id'].'" '
								.' name="'.$this->id.'['.$this->_getOpFileStatusId().']['.$arrResult['cv_id'].']" '
								.' title="'.$this->lang->def( '_DOCUMENTS_FILESTATUS' ).'" '
								.' alt="'.$this->lang->def( '_DOCUMENTS_FILESTATUS' ).'" />';

				$arrResult['fileversion'] = '<input type="image" class="tree_view_image" '
								.' src="'.getPathImage().'documents/file_version.gif"'
								.' id="'.$this->id.'_'.$this->_getOpFileVersionId().'_'.$arrResult['file_id'].'" '
								.' name="'.$this->id.'['.$this->_getOpFileVersionId().']['.$arrResult['file_id'].']" '
								.' title="'.$this->lang->def( '_DOCUMENTS_FILEVERSION' ).'" '
								.' alt="'.$this->lang->def( '_DOCUMENTS_FILEVERSION' ).'" />';
			}
			else {
				$arrResult['filemonitor']="&nbsp;";
				$arrResult['filestatus']="&nbsp;";
				$arrResult['fileversion']="&nbsp;";
			}

			if ($this->docman->userHavePermForFile($arrResult['file_id'], "commentfile") && ($GLOBALS["kms"]["feature_comments"] == "on")) {

				$arrResult['commentfile'] = '<input type="image" class="tree_view_image" '
								.' src="'.getPathImage().'documents/comment.gif"'
								.' id="'.$this->id.'_'.$this->_getOpCommentFileId().'_'.$arrResult['file_id'].'" '
								.' name="'.$this->id.'['.$this->_getOpCommentFileId().']['.$arrResult['file_id'].']" '
								.' title="'.$this->_getCommentFileLabel().'" '
								.' alt="'.$this->_getCommentFileAlt().'" />';
			}
			else {
				$arrResult['commentfile']="&nbsp;";
			}


			if (!$GLOBALS["current_user"]->isAnonymous()) {
				if ($this->docman->isGodAdmin() || $is_owner) {

					$arrResult['fileperm'] = '<input type="image" class="tree_view_image" '
									.' src="'.getPathImage().'documents/assign_user.gif"'
									.' id="'.$this->id.'_'.$this->_getOpFilepermId().'_'.$arrResult['file_id'].'" '
									.' name="'.$this->id.'['.$this->_getOpFilepermId().']['.$arrResult['file_id'].']" '
									.' title="'.$this->_getFilepermLabel().'" '
									.' alt="'.$this->_getFilepermAlt().'" />';
				}
				else {
					$arrResult['fileperm']="&nbsp;";
				}


				if ($this->docman->userHavePermForFile($arrResult['file_id'], "editfile")) {
					$arrResult['edit'] = '<input type="image" class="tree_view_image" '
									.' src="'.$this->_getEditImage().'"'
									.' id="'.$this->id.'_'.$this->_getOpEditItemId().'_'.$arrResult['file_id'].'" '
									.' name="'.$this->id.'['.$this->_getOpEditItemId().']['.$arrResult['file_id'].']" '
									.' title="'.$this->_getEditLabel().'" '
									.' alt="'.$this->_getEditAlt().'" />';
				}
				else {
					$arrResult['edit']="&nbsp;";
				}

				if ($this->docman->userHavePermForFile($arrResult['file_id'], "delfile")) {
					$arrResult['delete'] = '<input type="image" class="tree_view_image" '
									.' src="'.$this->_getDeleteImage().'"'
									.' id="'.$this->id.'_'.$this->_getOpDeleteItemId().'_'.$arrResult['file_id'].'" '
									.' name="'.$this->id.'['.$this->_getOpDeleteItemId().']['.$arrResult['file_id'].']" '
									.' title="'.$this->_getDeleteLabel().'" '
									.' alt="'.$this->_getDeleteAlt().'" />';
				}
				else {
					$arrResult['delete']="&nbsp;";
				}
			}

			$type=mimetype(end(explode(".", $arrResult["fname"])));
			$arrResult['ftype']="<img src=\"".getPathImage().mimeDetect($arrResult["fname"])."\" alt=\"$type\" title=\"$type\" />\n";

			$file_url ="index.php?modname=documents&amp;op=download";
			$file_url.="&amp;treeid=".$arrResult['folder_id']."&amp;cvid=".$arrResult['cv_id'];
			$arrResult['fname']="<a href=\"".$file_url."\">".$arrResult['fname']."</a>\n";

		}/* else {
			$arrResult['selection'] = '<input type="checkbox"'
							.' id="'.DIRECTORY_ID.DIRECTORY_OP_SELECTITEM.'_'.$arrResult['idst'].'" '
							.' name="'.DIRECTORY_ID.'['.DIRECTORY_OP_SELECTITEM.']['.$arrResult['idst'].']" '
							.' value="'.$arrResult['userid'].'"'
							.' title="'.$this->_getSelectedLabel().'" '
							.' alt="'.$this->_getSelectedAlt().'" ';
			if( array_search( $arrResult['idst'], $this->itemSelectedMulti ) !== FALSE )
				$arrResult['selection'] .= ' CHECKED ';
			$arrResult['selection'] .= '/>';

		} */
		$this->printedItems[] = $arrResult['file_id'];
		return $arrResult;
	}

	function printOut() {
		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');

		$ord = importVar('ord', false, 'trans');
		$flip = importVar('flip', true, 0);
		$filter = new Form();
		$out = $filter->getOpenFieldset($this->lang->def('_DIRECTORY_FILTER'));
		$out .= $filter->getHidden('ord', 'ord', $ord);
		$out .= $filter->getHidden('flip', 'flip', $flip);

		// --- print check box for flat mode
		if( $this->show_flat_mode_flag )
			$out .= $filter->getCheckbox( $this->lang->def('_DIRECTORY_FILTER_FLATMODE'),
							$this->id.'_flat_mode',
							$this->id.'[flat_mode]',
							'flat_mode',
							$this->flat_mode,
							"onclick=\"window.document.forms['directory_org_chart'].submit();\"" );
		else
			$out .= $filter->getHidden(	$this->id.'_flat_mode',
										$this->id.'[flat_mode]',
										($this->flat_mode ? 'flat_mode':''));

		// line for add a field filter
		$out .= $filter->openFormLine();
		foreach( $this->add_nat_fields as $nat_id => $nat_info ) {
			$local_arr_fields_translation[$nat_id] = $this->lang->def('_DIRECTORY_FILTER_'.$nat_id);
		}

		$out .= $filter->getInputDropdown( 'valing_middle',
											$this->id.'_add_field_filter',
											$this->id.'[add_field_filter]',
											$this->arr_fields_translation,
											'',
											'');
		$out .= $filter->getButton( $this->id.'_add_filter',
									$this->id.'[add_filter]',
									$this->lang->def('_DIRECTORY_FILTER_ADD'),
									'button valing_middle');
		$out .= $filter->closeFormLine();


		foreach( $this->arr_fields_filter as $field_id => $field_prop ) {
			if( !isset( $field_prop['fieldname'] ) ) {
				// custom field
				$arr_field_info = $this->field_list->getBaseFieldInfo( $field_prop[FIELD_INFO_TYPE] );
				require_once($GLOBALS['where_framework'].'/modules/field/'.$arr_field_info[FIELD_BASEINFO_FILE]);
				$del_spot = '<input type="image" class="float_left" '
							.' src="'.getPathImage().'standard/rem.gif"'
							.' id="'.$this->id.'_del_filter_'.$field_id.'"'
							.' name="'.$this->id.'[del_filter]['.$field_id.']"'
							.' title="'.$this->lang->def('_DIRECTORY_FILTER_DEL').'"'
							.' alt="'.$this->lang->def('_DIRECTORY_FILTER_DEL').'" />';
				$out .= eval("return "
									.$arr_field_info[FIELD_BASEINFO_CLASS]
									."::play_filter("
									."'".$field_id."',"
									."FALSE,"
									."'".$field_prop[FIELD_INFO_TRANSLATION]."',"
									."'".$this->id."',"
									."'',"
									."'".$del_spot."',"
									.$field_prop[FIELD_INFO_ID]
									.");");

			} else {
				// base field
				$arr_field_info = $this->field_list->getBaseFieldInfo( $field_prop['field_type'] );
				require_once($GLOBALS['where_framework'].'/modules/field/'.$arr_field_info[FIELD_BASEINFO_FILE]);
				$del_spot = '<input type="image" class="float_left" '
							.' src="'.getPathImage().'standard/rem.gif"'
							.' id="'.$this->id.'_del_filter_'.$field_id.'"'
							.' name="'.$this->id.'[del_filter]['.$field_id.']"'
							.' title="'.$this->lang->def('_DIRECTORY_FILTER_DEL').'"'
							.' alt="'.$this->lang->def('_DIRECTORY_FILTER_DEL').'" />';
				$out .= eval("return "
									.$arr_field_info[FIELD_BASEINFO_CLASS]
									."::play_filter("
									."'".$field_id."',"
									."FALSE,"
									."'".$this->lang->def('_DIRECTORY_FILTER_'.$field_prop['fieldname'])."',"
									."'".$this->id."',"
									."'',"
									."'".$del_spot."'"
									.");");

			}
		}

		$out .= $filter->openButtonSpace();
		$out .= $filter->getButton(	$this->id.'_del_filter',
									$this->id.'[del_filter]',
									$this->lang->def('_RESET'));
		$out .= $filter->getButton('search', 'search', $this->lang->def('_SEARCH'));
		$out .= $filter->closeButtonSpace();
		$out .= $filter->getCloseFieldset();

		//$this->getRows( $this->_getStartRow(), $this->_getRowsPage());
		$out .= parent::printOut();
		return $out;
	}
}
/*
class GroupListView extends ListView {

	var $lang = NULL;
	var $selector_mode = TRUE;
	var $itemSelectedMulti = array();
	var $printedItems = array();

	function _getOpEditItemId() 	{ return '_listview_opedititem_';	}
	function _getEditLabel() { return $this->lang->def('_DIRECTORY_EDITGROUP'); }
	function _getEditAlt() { return $this->lang->def('_DIRECTORY_EDITGROUP'); }
	function _getEditImage() { return getPathImage().'standard/mod.gif'; }

	function _getOpDeleteItemId() 	{ return '_listview_opdeleteitem_';	}
	function _getDeleteLabel() { return $this->lang->def('_DIRECTORY_DELGROUP'); }
	function _getDeleteAlt() { return $this->lang->def('_DIRECTORY_DELGROUP'); }
	function _getDeleteImage() { return getPathImage().'standard/rem.gif'; }

	function _getOpAddToItemId() 	{ return '_listview_opaddtogroup_';	}
	function _getAddToLabel() { return $this->lang->def('_DIRECTORY_ADDTOGROUP'); }
	function _getAddToAlt() { return $this->lang->def('_DIRECTORY_ADDTOGROUP'); }
	function _getAddToImage() { return getPathImage().'directory/addto.gif'; }

	function _getOpAssignFieldId() 	{ return '_listview_opassignfieldgroup_';	}
	function _getAssignFieldLabel() { return $this->lang->def('_DIRECTORY_ASSIGNFIELDGROUP'); }
	function _getAssignFieldAlt() { return $this->lang->def('_DIRECTORY_ASSIGNFIELDGROUP'); }
	function _getAssignFieldImage() { return getPathImage().'directory/assign_field.gif'; }


	function _getOpMembersId() 	{ return '_listview_opmembersgroup_';	}
	function _getMembersLabel() { return $this->lang->def('_DIRECTORY_MEMBERSGROUP'); }
	function _getMembersAlt() { return $this->lang->def('_DIRECTORY_MEMBERSGROUP'); }
	function _getMembersImage() { return getPathImage().'directory/group.gif'; }

	function _getOpSelectedItemId() 	{ return '_listview_opselectedgroup_';	}
	function _getSelectedLabel() { return $this->lang->def('_DIRECTORY_SELECTGROUP'); }
	function _getSelectedAlt() { return $this->lang->def('_DIRECTORY_SELECTGROUP'); }

	function printState() {
		$out = parent::printState();
		$out = '<input type="hidden"'
			.' id="'.DIRECTORY_ID.DIRECTORY_ID_PRINTEDITEM.'"'
			.' name="'.DIRECTORY_ID.'['.DIRECTORY_ID_PRINTEDITEM.']"'
			.' value="'.urlencode(serialize($this->printedItems)).'" />'."\n";
		return $out;
	}

	function GroupListView($title, &$data, &$rend, $id) {
		$this->lang =& DoceboLanguage::createInstance('documents', 'kms');
		parent::ListView($title, $data, $rend, $id);
	}

	function _getCols() {
		$this->lang =& DoceboLanguage::createInstance('documents', 'kms');
		$totCol = $this->data->getFieldCount();
		$colInfos = array();
		if( $this->selector_mode ) {
			$colInfos[] = array( 	'hLabel' => '',
									'hClass' => "image",
									'fieldClass' => "image",
									'data' => 'selection',
									'toDisplay' => true,
									'sortable' => false );
		}
		$colInfos[] = array( 	'hLabel' => $this->lang->def( '_DIRECTORY_GROUPID' ),
								'hClass' => "",
								'fieldClass' => "",
								'data' => 'groupid',
								'toDisplay' => true,
								'sortable' => true );
		$colInfos[] = array( 	'hLabel' => $this->lang->def( '_DIRECTORY_GROUPDESCRIPTION' ),
								'hClass' => "",
								'fieldClass' => "",
								'data' => 'description',
								'toDisplay' => true,
								'sortable' => true );
		if( !$this->selector_mode ) {
			$colInfos[] = array( 	'hLabel' => '<img src="'.$this->_getMembersImage().'" '
										.'alt="'.$this->lang->def( '_DIRECTORY_MEMBERSGROUP' ).'" '
										.'title="'.$this->lang->def( '_DIRECTORY_MEMBERSGROUP' ).'" />',
									'hClass' => "image",
									'fieldClass' => "image",
									'data' => 'members',
									'toDisplay' => true,
									'sortable' => false );
			$colInfos[] = array( 	'hLabel' => '<img src="'.$this->_getAddToImage().'" '
										.'alt="'.$this->lang->def( '_DIRECTORY_ADDTOGROUP' ).'" '
										.'title="'.$this->lang->def( '_DIRECTORY_ADDTOGROUP' ).'" />',
									'hClass' => "image",
									'fieldClass' => "image",
									'data' => 'addto',
									'toDisplay' => true,
									'sortable' => false );
			$colInfos[] = array( 	'hLabel' => '<img src="'.$this->_getAssignFieldImage().'" '
										.'alt="'.$this->_getAssignFieldAlt().'" '
										.'title="'.$this->_getAssignFieldLabel().'" />',
									'hClass' => "image",
									'fieldClass' => "image",
									'data' => 'assignfield',
									'toDisplay' => true,
									'sortable' => false );
			$colInfos[] = array( 	'hLabel' => '<img src="'.$this->_getEditImage().'" '
										.'alt="'.$this->lang->def( '_DIRECTORY_EDITGROUP' ).'" '
										.'title="'.$this->lang->def( '_DIRECTORY_EDITGROUP' ).'" />',
									'hClass' => "image",
									'fieldClass' => "image",
									'data' => 'edit',
									'toDisplay' => true,
									'sortable' => false );
			$colInfos[] = array( 	'hLabel' => '<img src="'.$this->_getDeleteImage().'" '
										.'alt="'.$this->lang->def( '_DIRECTORY_DELGROUP' ).'" '
										.'title="'.$this->lang->def( '_DIRECTORY_DELGROUP' ).'" />',
									'hClass' => "image",
									'fieldClass' => "image",
									'data' => 'delete',
									'toDisplay' => true,
									'sortable' => false );
		}
		return $colInfos;
	}

	function extendedParsing( $arrayState ) {

		if( isset($arrayState['editgroupsave']) ) {
			$idst = $_POST['idst'];
			$groupid = $_POST['groupid'];
			$description = $_POST['description'];
			if( $idst !== '' ) {
				$this->aclManager->updateGroup( $idst, $groupid, $description );
			} else {
				$this->aclManager->registerGroup( $groupid, $description );
			}
		} elseif( isset($arrayState['deletegroup']) ) {
			$idst = $_POST['idst'];
			if( $idst !== '' ) $this->aclManager->deleteGroup( $idst );
		}
		if( isset( $arrayState[$this->id] ) ) {
			if( isset( $arrayState[$this->id][$this->_getOpEditItemId()] )) {
				$this->itemSelected = key ( $arrayState[$this->id][$this->_getOpEditItemId()] );
				$this->op = 'editgroup';
			}
			if( isset( $arrayState[$this->id][$this->_getOpDeleteItemId()] )) {
				$this->itemSelected = key ( $arrayState[$this->id][$this->_getOpDeleteItemId()] );
				$this->op = 'deletegroup';
			}
			if( isset( $arrayState[$this->id][$this->_getOpAddToItemId()] )) {
				$this->itemSelected = key ( $arrayState[$this->id][$this->_getOpAddToItemId()] );
				$this->op = 'addtogroup';
			}
			if( isset( $arrayState[$this->id][$this->_getOpAssignFieldId()] )) {
				$this->itemSelected = key ( $arrayState[$this->id][$this->_getOpAssignFieldId()] );
				$this->op = 'assignfield';
			}
			if( isset( $arrayState[$this->id][$this->_getOpMembersId()] )) {
				$this->itemSelected = key ( $arrayState[$this->id][$this->_getOpMembersId()] );
				$this->op = 'membersgroup';
			}
		}

	}

	function fetchRecord() {
		$arrResult = $this->data->fetchRecord();
		if( $arrResult === FALSE )
			return FALSE;
		$arrResult['groupid'] = $this->aclManager->relativeId($arrResult['groupid']);
		if( !$this->selector_mode ) {
			$arrResult['members'] = '<input type="image" class="tree_view_image" '
							.' src="'.$this->_getMembersImage().'"'
							.' id="'.$this->id.'_'.$this->_getOpMembersId().'_'.$arrResult['groupid'].'" '
							.' name="'.$this->id.'['.$this->_getOpMembersId().']['.$arrResult['groupid'].']" '
							.' title="'.$this->_getMembersLabel().'" '
							.' alt="'.$this->_getMembersAlt().'" />';
			$arrResult['addto'] = '<input type="image" class="tree_view_image" '
							.' src="'.$this->_getAddToImage().'"'
							.' id="'.$this->id.'_'.$this->_getOpAddToItemId().'_'.$arrResult['groupid'].'" '
							.' name="'.$this->id.'['.$this->_getOpAddToItemId().']['.$arrResult['groupid'].']" '
							.' title="'.$this->_getAddToLabel().'" '
							.' alt="'.$this->_getAddToAlt().'" />';
			$arrResult['assignfield'] = '<input type="image" class="tree_view_image" '
							.' src="'.$this->_getAssignFieldImage().'"'
							.' id="'.$this->id.'_'.$this->_getOpAssignFieldId().'_'.$arrResult['groupid'].'" '
							.' name="'.$this->id.'['.$this->_getOpAssignFieldId().']['.$arrResult['groupid'].']" '
							.' title="'.$this->_getAssignFieldLabel().'" '
							.' alt="'.$this->_getAssignFieldAlt().'" />';
			$arrResult['edit'] = '<input type="image" class="tree_view_image" '
							.' src="'.$this->_getEditImage().'"'
							.' id="'.$this->id.'_'.$this->_getOpEditItemId().'_'.$arrResult['groupid'].'" '
							.' name="'.$this->id.'['.$this->_getOpEditItemId().']['.$arrResult['groupid'].']" '
							.' title="'.$this->_getEditLabel().'" '
							.' alt="'.$this->_getEditAlt().'" />';
			$arrResult['delete'] = '<input type="image" class="tree_view_image" '
							.' src="'.$this->_getDeleteImage().'"'
							.' id="'.$this->id.'_'.$this->_getOpDeleteItemId().'_'.$arrResult['groupid'].'" '
							.' name="'.$this->id.'['.$this->_getOpDeleteItemId().']['.$arrResult['groupid'].']" '
							.' title="'.$this->_getDeleteLabel().'" '
							.' alt="'.$this->_getDeleteAlt().'" />';
		} else {
			$arrResult['selection'] = '<input type="checkbox"'
							.' id="'.DIRECTORY_ID.DIRECTORY_OP_SELECTITEM.'_'.$arrResult['idst'].'" '
							.' name="'.DIRECTORY_ID.'['.DIRECTORY_OP_SELECTITEM.']['.$arrResult['idst'].']" '
							.' value="'.$arrResult['groupid'].'"'
							.' title="'.$this->_getSelectedLabel().'" '
							.' alt="'.$this->_getSelectedAlt().'" ';
			if( array_search( $arrResult['idst'], $this->itemSelectedMulti ) !== FALSE )
				$arrResult['selection'] .= ' CHECKED ';
			$arrResult['selection'] .= '/>';

		}
		$this->printedItems[] = $arrResult['idst'];
		return $arrResult;
	}

}

class GroupMembersListView extends ListView {

	var $printedItems = array();
	function _getMemberTypeImage() { return getPathImage().'directory/addto.gif'; }
	function _getMemberTypeUser() { return getPathImage().'directory/user.gif'; }
	function _getMemberTypeGroup() { return getPathImage().'directory/group.gif'; }
	function _getMemberTypeTree() { return getPathImage().'directory/tree.gif'; }

	function _getOpDeleteItemId() 	{ return '_listview_opdeleteitem_';	}
	function _getDeleteLabel() { return $this->lang->def('_DIRECTORY_DELGROUP'); }
	function _getDeleteAlt() { return $this->lang->def('_DIRECTORY_DELGROUP'); }
	function _getDeleteImage() { return getPathImage().'standard/rem.gif'; }

	function GroupMembersListView( $idst, $title, &$data, &$rend, $id ) {
		$this->idst = $idst;
		parent::ListView($title, $data, $rend, $id );
	}

	function getTreeTranslation( $groupid ) {
		require_once(dirname(__FILE__).'/../modules/documents/tree.org_chart.php');
		$repoDb = new TreeDb_OrgDb($GLOBALS['prefix_fw'].'_org_chart_tree');
		$arr_translations = $repoDb->getFolderTransaltions(substr($groupid, 3));
		return $arr_translations[getLanguage()];
	}

	function extendedParsing( $arrayState ) {
		if( isset( $arrayState[$this->id] ) ) {
			if( isset( $arrayState[$this->id][$this->_getOpDeleteItemId()] )) {
				$idstMember = key ( $arrayState[$this->id][$this->_getOpDeleteItemId()] );
				echo "idstMember: $idstMember\n\n";
				echo "idst:". $this->idst."\n\n";
				$this->aclManager->removeFromGroup($this->idst, $idstMember);
			}
		}

	}

	function _getCols() {
		$this->lang =& DoceboLanguage::createInstance('documents', 'kms');
		$totCol = $this->data->getFieldCount();
		$colInfos = array();
		$colInfos[] = array( 	'hLabel' => '' /*<img src="'.$this->_getMemberTypeImage().'" '
										.'alt="'.$this->lang->def( '_DIRECTORY_MEMBERTYPE' ).'" '
										.'title="'.$this->lang->def( '_DIRECTORY_MEMBERTYPE' ).'" />'*/ /*,
								'hClass' => "image",
								'fieldClass' => "image",
								'data' => 'itemtype',
								'toDisplay' => true,
								'sortable' => false );
		$colInfos[] = array( 	'hLabel' => $this->lang->def( '_DIRECTORY_ITEMID' ),
								'hClass' => "",
								'fieldClass' => "",
								'data' => 'iditem',
								'toDisplay' => true,
								'sortable' => false );
		$colInfos[] = array( 	'hLabel' => '<img src="'.$this->_getDeleteImage().'" '
										.'alt="'.$this->lang->def( '_DIRECTORY_REMOVEFROMGROUP' ).'" '
										.'title="'.$this->lang->def( '_DIRECTORY_REMOVEFROMGROUP' ).'" />',
								'hClass' => "image",
								'fieldClass' => "image",
								'data' => 'delete',
								'toDisplay' => true,
								'sortable' => false );
		return $colInfos;
	}

	function fetchRecord() {
		$arrResult = $this->data->fetchRecord();
		if( $arrResult === FALSE )
			return FALSE;
		$arrData['idst'] = $arrResult['idstMember'];
		if( $arrResult['groupid'] != NULL ) {
			if( $arrResult['hidden'] == 'true' ) {
				$arrData['itemtype'] = '<img src="'.$this->_getMemberTypeTree().'" '
											.'alt="'.$this->lang->def( '_DIRECTORY_MEMBERTYPETREE' ).'" '
											.'title="'.$this->lang->def( '_DIRECTORY_MEMBERTYPETREE' ).'" />';

				$arrData['iditem'] = $this->getTreeTranslation($this->aclManager->relativeId($arrResult['groupid']));
			} else {
				$arrData['itemtype'] = '<img src="'.$this->_getMemberTypeGroup().'" '
											.'alt="'.$this->lang->def( '_DIRECTORY_MEMBERTYPEGROUP' ).'" '
											.'title="'.$this->lang->def( '_DIRECTORY_MEMBERTYPEGROUP' ).'" />';
				$arrData['iditem'] = $this->aclManager->relativeId($arrResult['groupid']);
			}
		} else {
			$arrData['itemtype'] = '<img src="'.$this->_getMemberTypeUser().'" '
										.'alt="'.$this->lang->def( '_DIRECTORY_MEMBERTYPEUSER' ).'" '
										.'title="'.$this->lang->def( '_DIRECTORY_MEMBERTYPEUSER' ).'" />';
			$arrData['iditem'] = $this->aclManager->relativeId($arrResult['userid']);
		}
		$arrData['delete'] = '<input type="image" class="tree_view_image" '
							.' src="'.$this->_getDeleteImage().'"'
							.' id="'.$this->id.'_'.$this->_getOpDeleteItemId().'_'.$arrResult['idstMember'].'" '
							.' name="'.$this->id.'['.$this->_getOpDeleteItemId().']['.$arrResult['idstMember'].']" '
							.' title="'.$this->_getDeleteLabel().'" '
							.' alt="'.$this->_getDeleteAlt().'" />';
		$this->printedItems[] = $arrResult['idstMember'];
		return $arrData;
	}
} */
?>
