<?php

/************************************************************************/
/* DOCEBO KMS                                                           */
/* ============================================                         */
/*                                                                      */
/* Copyright (c) 2005                                                   */
/* http://www.docebo.com                                                */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

if(!defined('IN_DOCEBO')) die('You cannot access this file directly');

/**
 * @package  DoceboKMS
 * @version  $Id: tree.documents.php 113 2006-03-08 18:08:42Z ema $
 */

require_once($GLOBALS['where_framework'].'/lib/lib.treedb.php');
require_once($GLOBALS['where_framework'].'/lib/lib.treeview.php');
require_once($GLOBALS['where_framework'].'/lib/lib.field.php');

define('ORGDB_POS_TRANSLATION',0);

define("DOCUMENTS_FIELD_NO","No");
define("DOCUMENTS_FIELD_NORMAL","Normal");
define("DOCUMENTS_FIELD_DESCEND","Descend");
define("DOCUMENTS_FIELD_INHERIT","Inherit");

define("DOCUMENTS_FOLDER_FIELD_GROUP", "/kms/filesystem/fields");

class TreeDb_FilesystemDb extends TreeDb {

	// with other fields, only for view
	var $withOtherFields = TRUE;

	// retrieve only folders for get path in following array
	// if array is NULL retrieve all
	var $filter_path = FALSE;

	var $folder_perm_list=array();

	var $d_folder_id=NULL;
	var $flow_id=NULL;


	// Constructor of TreeDb_FilesystemDb class
	function TreeDb_FilesystemDb($table_name) {

		$this->table = $table_name;
		$this->fields = array(
			'id' => 'folder_id',
			'idParent' => 'idParent',
			'path' => 'path',
			'lev' => 'lev',
			'flow_id' => 'flow_id'
		);
	}

	function _getOtherTables() { return ' INNER JOIN '.$GLOBALS['prefix_kms'].'_filesystem';	}

	function _getJoinFilter($table = FALSE) {
		if( $table === FALSE )
			return 'folder_id = id_dir';
		else
			return $table.'.folder_id = '.$GLOBALS['prefix_kms'].'_filesystem'.'.id_dir';
	}

	function _getOtherFields($tname = FALSE) {
		if( $this->withOtherFields ) {
			if( $tname === FALSE )
				return ', translation, flow_id';
			else
				return ', '.$GLOBALS['prefix_kms'].'_filesystem'.'.translation, '.$tname.'.flow_id';
		} else {
			if( $tname === FALSE )
				return ', d_folder_id, flow_id';
			else
				return ', '.$GLOBALS['prefix_kms'].'_filesystem_tree'.'.d_folder_id, '.$tname.'.flow_id';
		}
	}

	function _getOtherValues() {
		if( $this->withOtherFields ) {
			return ", '".addslashes($this->translation)."', '".(int)$this->flow_id."' ";
		}
		else {
			return ", '".(int)$this->d_folder_id."', '".(int)$this->flow_id."' ";
		}
	}

	function _getParentJoinFilter( $t1name, $t2name ) {
		if( $this->filter_path !== FALSE ) {
			$in_condition = "IN ('".implode("','",$this->filter_path)."')";
			return " AND (".$t2name.".".$this->fields['path']." ".$in_condition.")";
		} else {
			return "";
		}
	}

	function _getFilter_temp($tname = FALSE) {
		$out = '';
		if( $this->withOtherFields ) {
			if( $tname === FALSE )
				$out .= "AND (lang_code = '".getLanguage()."')";
			else
				$out .= "AND (".$GLOBALS['prefix_kms'].'_filesystem'.".lang_code = '".getLanguage()."')";
		}
		if( $this->filter_path !== FALSE ) {
			$in_condition = "IN ('".implode("','",$this->filter_path)."')";
			if( $tname === FALSE )
				$out .= " AND (".$this->fields['path']." ".$in_condition;
			else
				$out .= " AND (".$tname.".".$this->fields['path']." ".$in_condition.")";
		}
		return $out;
	}

	function _getFilter($tname = FALSE) {
		$out = '';
		if( $this->withOtherFields ) {
			if( $tname === FALSE )
				$out.="AND (lang_code = '".getLanguage()."')";
			else
				$out.="AND (".$GLOBALS['prefix_kms'].'_filesystem'.".lang_code = '".getLanguage()."')";
		}
		if( $this->filter_path !== FALSE ) {
			$in_condition = "IN ('".implode("','",$this->filter_path)."')";
			if( $tname === FALSE )
				$out.=" AND (".$this->fields['path']." ".$in_condition.")";
			else
				$out.=" AND (".$tname.".".$this->fields['path']." ".$in_condition.")";
		}
		return $out;
	}

	function getMaxChildPos( $idFolder ) {
		$query = "SELECT MAX(SUBSTRING_INDEX(path, '/', -1))"
				." FROM ". $this->table
				." WHERE (". $this->fields['idParent'] ." = '". (int)$idFolder ."')";

		$rs = mysql_query( $query )
				or die( "Error [$query] ". mysql_error() );
		if( mysql_num_rows( $rs ) == 1 ) {
			list( $result ) = mysql_fetch_row( $rs );
			return $result;
		} else {
			return '00000001';
		}
	}

	function getNewPos( $idFolder ) {
		return substr('00000000' .($this->getMaxChildPos( $idFolder )+1), -8);
	}

	function moveUp( $idFolder ) {
		$folder = $this->getFolderById( $idFolder );
		// $parent = $this->tdb->getFolderById( $folder->idParent );
		$arrIdSiblings = $this->getChildrensIdById( $folder->idParent );
		if( !is_array( $arrIdSiblings ) )
			return;
		$pos = array_search( $idFolder, $arrIdSiblings );
		if( $pos === NULL || $pos === FALSE ) // prior to php 4.2.0 and after
			return;
		if( $pos == 0 ) // I know it's possible the merge with previous if but this is clear ...
			return;
		$folder2 = $this->getFolderById( $arrIdSiblings[$pos-1] );
		$tmpArr = explode( '/', $folder->path );
		$folderName = $tmpArr[count($tmpArr)-1];
		$tmpArr = explode( '/', $folder2->path );
		$folderName2 = $tmpArr[count($tmpArr)-1];
		parent::renameFolder( $folder, $folderName2."tmp" );
		parent::renameFolder( $folder2, $folderName );
		parent::renameFolder( $folder, $folderName2 );
	}

	function moveDown( $idFolder ) {
		$folder = $this->getFolderById( $idFolder );
		// $parent = $this->tdb->getFolderById( $folder->idParent );
		$arrIdSiblings = $this->getChildrensIdById( $folder->idParent );
		if( !is_array( $arrIdSiblings ) )
			return;
		$pos = array_search( $idFolder, $arrIdSiblings );
		if( $pos === NULL || $pos === FALSE ) // prior to php 4.2.0 and after
			return;
		if( $pos == (count($arrIdSiblings)-1) )
			return;
		$folder2 = $this->getFolderById( $arrIdSiblings[$pos+1] );
		$tmpArr = explode( '/', $folder->path );
		$folderName = $tmpArr[count($tmpArr)-1];
		$tmpArr = explode( '/', $folder2->path );
		$folderName2 = $tmpArr[count($tmpArr)-1];
		parent::renameFolder( $folder, $folderName2."tmp" );
		parent::renameFolder( $folder2, $folderName );
		parent::renameFolder( $folder, $folderName2 );
	}

	function getFolderPermissionsList() {

		return $this->folder_perm_list;

	}


	function addFolderById($idParent, $folderName) {

		$this->withOtherFields = FALSE;
		$id_d = parent::addFolderById( $idParent, addslashes($folderName));
		$this->d_folder_id=$id_d;
		$id = parent::addFolderById( $idParent, addslashes($folderName));
		if ((int)$id_d > 0) {
			$qtxt="DELETE FROM ".$GLOBALS["prefix_kms"]."_filesystem_tree WHERE folder_id='".$id_d."'";
			$q=mysql_query($qtxt);
		}

		//echo("<br /><br />id_d: $id_d, id: $id <br /><br />\n"); die();

		$pl=$this->getFolderPermissionsList();
		$aclManager =& $GLOBALS['current_user']->getACLManager();

		foreach($pl as $key=>$val) {
			$idST=$aclManager->registerGroup("KMS_Folder_".$val."_".$id,'',TRUE);
			$idST_d=$aclManager->registerGroup("KMS_Folder_".$val."_d_".$id,'',TRUE);
		}

		// Todo: change the following code to use a more standard way
		// Temp:
		require_once($GLOBALS["where_framework"]."/lib/lib.pubflow.php");
		$pf_manager=new PublicationFlowManager();
		$flow_id=$pf_manager->getFlowIdFromCode(_PUBFLOW_CODE_ONESTATE);

		$qtxt="UPDATE ".$GLOBALS["prefix_kms"]."_filesystem_tree SET flow_id='".$flow_id."' WHERE folder_id='".$id."'";
		$q=mysql_query($qtxt);

		//$aclManager =& $GLOBALS['current_user']->getACLManager();
		/*$idST = $aclManager->registerGroup($this->getGroupId($id),'',TRUE);
		$idST = $aclManager->registerGroup($this->getGroupDescendantsId($id),'',TRUE);
		$aclManager->addToGroup( $this->getGroupDescendantsST($idParent), $idST ); */
		$this->withOtherFields = TRUE;
		return $id;
	}

	function addFolderByIdTranslation($idParent, $folderName) {
		$id = $this->addFolderById( $idParent, $this->getNewPos( $idParent ));
		foreach( $folderName as $lang_code => $translation ) {
			$query = "INSERT INTO ".$GLOBALS['prefix_kms'].'_filesystem'
					."( id_dir, lang_code, translation ) "
					."VALUES ('".$id."','".$lang_code."','".$translation."')";
			$this->_executeQuery( $query );
		}
		return $id;
	}

	function updateFolderByIdTranslation( $idFolder, $folderName) {
		$array_translations = $this->getFolderTransaltions( $idFolder );
		foreach( $folderName as $lang_code => $translation ) {
			if( isset( $array_translations[$lang_code] )) {
				$query = "UPDATE ".$GLOBALS['prefix_kms'].'_filesystem'
						."   SET translation = '".$translation."'"
						." WHERE id_dir = '".$idFolder."'"
						."   AND lang_code = '".$lang_code."'";
			} else {
				$query = "INSERT INTO ".$GLOBALS['prefix_kms'].'_filesystem'
						."( id_dir, lang_code, translation ) "
						."VALUES ('".$idFolder."','".$lang_code."','".$translation."')";
			}
			$this->_executeQuery( $query );
		}
	}

	function updateFolderExtraInfo($folder_id) { // temp ?
		$qtxt="UPDATE ".$this->table." SET flow_id='".(int)$_POST["flow_id"]."' WHERE folder_id='".(int)$folder_id."'";
		$q=$this->_executeQuery($qtxt);

		return $q;
	}

	function getFolderTransaltions( $idFolder ) {
		$query = "SELECT lang_code, translation "
				."  FROM ".$GLOBALS['prefix_kms'].'_filesystem'
				." WHERE id_dir = '".$idFolder."'";
		$rs = mysql_query( $query );
		$arrTranslations = array();
		while( list( $lang_code, $translation ) = mysql_fetch_row( $rs ) ) {
			$arrTranslations[$lang_code] = $translation;
		}
		return $arrTranslations;
	}

	function getFoldersCurrTranslation( $arr_groupsid ) {
		$query = "SELECT id_dir, translation "
				."  FROM ".$GLOBALS['prefix_kms'].'_filesystem'
				." WHERE CONCAT( '/dfd_', id_dir) IN ('".implode("','",$arr_groupsid)."')"
				."   AND lang_code = '".getLanguage()."'";
		$rs = mysql_query( $query );
		$arrTranslations = array();
		while( list( $id_dir, $translation ) = mysql_fetch_row( $rs ) ) {
			$arrTranslations['/dfd_'.$id_dir] = $translation;
		}
		return $arrTranslations;
	}


	function addItem($idParent, $org_name) {
		$idReference = parent::addFolderById( $idParent, addslashes($org_name));
		return $idReference;
	}

	function modifyItem( $arrData ) {
		$folder = $this->getFolderById( $arrData['idItem'] );
		$this->changeOtherData( $folder );
	}

	function _deleteTree( $folder ) {
		// first delete all childs (recursive)
		$rs = $this->getChildrensById( $folder->id );
		if( $rs !== FALSE ) {
			$fc = new FoldersCollection($this, $rs );
			while( $child = $fc->getNext() ) {
				$this->_deleteTree( $child );
			}
		}
		$this->withOtherFields = FALSE;
		$result = parent::_deleteTree( $folder );
		$this->withOtherFields = TRUE;
		// delete translations
		if( $result ) {
			$query = "DELETE FROM ".$GLOBALS['prefix_kms'].'_filesystem'
					." WHERE id_dir = '".(int)$folder->id."'";
			$this->_executeQuery( $query );
		}


		$pl=$this->getFolderPermissionsList();
		$aclManager =& $GLOBALS['current_user']->getACLManager();

		foreach($pl as $key=>$val) {
			$idst=$aclManager->getGroupST("KMS_Folder_".$val."_".(int)$folder->id);
			$idst_d=$aclManager->getGroupST("KMS_Folder_".$val."_d_".(int)$folder->id);
			$aclManager->deleteGroup($idst);
			$aclManager->deleteGroup($idst_d);
		}

		/*$aclManager =& $GLOBALS['current_user']->getACLManager();
		$idST = $this->getGroupDescendantsST($folder->id);
		// detach this descendant group from parent descendant group
		$aclManager->removeFromGroup( $this->getGroupDescendantsST($folder->idParent), $idST );
		// delete descendant group
		$aclManager->deleteGroup( $idST );
		// delete OU group
		$aclManager->deleteGroup( $this->getGroupST($folder->id) ); */

		return $result;
	}

	function moveFolder( &$folder, &$parentFolder, $newfoldername = FALSE ) {
		$aclManager =& $GLOBALS['current_user']->getACLManager();
		$idST = $this->getGroupDescendantsST($folder->id);
		$aclManager->removeFromGroup( $this->getGroupDescendantsST($folder->idParent), $idST );
		$this->withOtherFields = FALSE;
		parent::moveFolder( $folder, $parentFolder, $this->getNewPos( $parentFolder->id ) );
		$this->withOtherFields = TRUE;
		$aclManager->addToGroup( $this->getGroupDescendantsST($parentFolder->id), $idST );
	}

	function getDescendantsSTFromST( $arr_idst ) {
		$aclManager =& $GLOBALS['current_user']->getACLManager();
		$arr_groupid = $aclManager->getGroupsId( $arr_idst );
		foreach( $arr_groupid as $key => $val ) {
			$arr_groupid[$key] = substr_replace($val, '/ocd', 0, 3);
		}
		//-debug-// print_r( $arr_groupid );
		$arr_result = $aclManager->getArrGroupST( $arr_groupid );
		//-debug-// print_r( $arr_result );
		return array_values($arr_result);
	}

	function getGroupId( $idFolder ) {
		return 'df_'.$idFolder;
	}

	function getFoldersIdFromIdst( $arr_idst ) {
		$aclManager =& $GLOBALS['current_user']->getACLManager();
		$arr_groupid = $aclManager->getGroupsId( $arr_idst );
		foreach( $arr_groupid as $key => $val ) {
			$arr_groupid[$key] = substr($val, 4);
		}
		return $arr_groupid;
	}

	function setFilterPathFromFolderId( $arr_folders ) {
		// the array of path
		$arr_path = $this->getPathFromFolderId($arr_folders);
		// the array of admitted path
		$this->filter_path = array();
		foreach( $arr_path as $path ) {
			$arr_tok = explode('/', substr($path,1));
			$tok_path = '';
			foreach( $arr_tok as $tok ) {
				$tok_path .= '/'. $tok;
				$this->filter_path[] = $tok_path;
			}
		}
		$this->filter_path = array_unique( $this->filter_path );
	}

	function getGroupDescendantsId( $idFolder ) {
		return 'dfd_'.$idFolder;
	}

	function getGroupST( $idFolder ) {
		$acl =& $GLOBALS['current_user']->getACL();
		return $acl->getGroupST( $this->getGroupId($idFolder) );
	}

	function getGroupDescendantsST( $idFolder ) {
		$acl =& $GLOBALS['current_user']->getACL();
		return $acl->getGroupST( $this->getGroupDescendantsId($idFolder) );
	}

	/**
	 * given an array of idst search for GroupDescendants and reduce
	 * to ....
	 * for any idst wich groupid is dfd_xxx remove all contained idst groups
	 * form given record
	 **/
	/*function removeDescentants( $arr_idst ) {
		$aclManager =& $GLOBALS['current_user']->getACLManager();

		// get array of groupid
		$arr_id = $aclManager->getGroupsId( $arr_idst );

		// array of processed idst
		$arr_processed = array();

		$count = 0;
		while( count($arr_idst) > $count ) {
			if( !isset( $arr_processed[$arr_idst[$count]] ) ) { // already processed?
				if( strncmp($arr_id[$arr_idst[$count]],'/dfd_', 5) == 0 ) {
					$arr_processed[$arr_idst[$count]] = $arr_idst[$count];
					$arr_desc = $aclManager->getGroupGDescendants($arr_idst[$count]);

					if( count($arr_desc) > 0 ) {

						// compute all regular groups of descendants
						$arr_descid =  $aclManager->getGroupsId( $arr_desc );
						for( $index = 0; $index < count($arr_desc); $index++ )
							$arr_descid[$arr_desc[$index]] = substr_replace($arr_descid[$arr_desc[$index]], '/df_', 0, 5);
						$arr_std_id = $aclManager->getArrGroupST($arr_descid);
						$arr_desc = array_merge( $arr_desc, $arr_std_id );
						$arr_idst = array_values(array_diff( $arr_idst, $arr_desc ));
						$count = 0;
						// skip count increment
						continue;
					}
				}
			}
			$count++;
		}
		return $arr_idst;
	} */

}

class TreeView_FilesystemView extends TreeView {

	var $selector_mode = FALSE;
	var $simple_selector = FALSE;
	var $can_edit_folder = FALSE;
	var $itemSelectedMulti = array();
	var $filter_nodes = FALSE;
	var $printed_items = array();
	var $docman=NULL;
	var $custom_folder_class=array();
	var $custom_folder_image=array();

	var $fpath="";
	var $fpath_internal="";


	function  TreeView_FilesystemView($tdb, $id, $rootname = 'root') {
		$this->docman=new DocumentsManager($this);
		parent::TreeView($tdb, $id, $rootname);
	}

	function _getRenameImage()			{ return getPathImage().'standard/mod.gif'; }

	function _getOpMonitorFolder() 		{ return 'monitorfolder';}
	function _getLabelMonitorFolder() 		{ return $this->lang->def('_DOCUMENTS_MONITOR_FOLDER');}

	function _getOpAssignField() 		{ return 'assignfield';}
	function _getImgAssignField()		{ return getPathImage().'documents/assign_field.gif';}
	function _getLabelAssignField() 	{ return $this->lang->def('_DOCUMENTS_ASSIGN_FIELD_ALT'); }

	function _getOpFolderField() 		{ return 'folderfield';}
	function _getImgFolderField()		{ return getPathImage().'documents/folder_field.gif';}
	function _getLabelFolderField() 	{ return $this->lang->def('_DOCUMENTS_FOLDER_FIELD_ALT'); }

	function _getOpAssignUser() 		{ return 'assignUser';}
	function _getImgAssignUser()		{ return getPathImage().'documents/assign_user.gif';}
	function _getLabelAssignUser() 		{ return $this->lang->def('_DOCUMENTS_ASSIGN_USER_ALT'); }

	function _getOpCreateDocument() 		{ return 'createDocument';}
	function _getImgCreateUser()		{ return getPathImage().'standard/user.gif';}
	function _getLabelCreateUser() 		{ return $this->lang->def('_DOCUMENTS_CREATE_USER_ALT'); }

	function _getAddImage() 	{ return getPathImage().'documents/add_node.gif'; }
	function _getAddLabel() 	{ return $this->lang->def('_DOCUMENTS_ADDNODE'); }
	function _getAddAlt() 		{ return $this->lang->def('_DOCUMENTS_ADDNODE_ALT'); }

	function load() {
		$ot = parent::load();
		$ot .='<input type="hidden"'
			.' id="'.DIRECTORY_ID.'_'.DIRECTORY_ID_PRINTEDITEM.'"'
			.' name="'.DIRECTORY_ID.'['.DIRECTORY_ID_PRINTEDITEM.']"'
			.' value="'.urlencode(serialize($this->printed_items)).'" />'."\n";
		return $ot;
	}

	function setFilePath($fpath, $fpath_internal) {
		$this->fpath=$fpath;
		$this->fpath_internal=$fpath_internal;
	}

	function setFilterNodes( $arr_idst ) {
		$this->filter_nodes = $arr_idst;
		$this->tdb->setFilterPathFromFolderId( $arr_idst );
	}

	function isFolderAccessible( $folder = FALSE ) {
		if( is_array( $this->filter_nodes ) ) {
			if( $folder === FALSE )
				return (array_search( $this->selectedFolder, $this->filter_nodes ) !== FALSE);
			else
				return (array_search( $folder->id, $this->filter_nodes ) !== FALSE);
		} else
			return  TRUE;
	}

	function loadState() {
		if( isset($_SESSION['documents_chart_state']) )
			$this->setState( unserialize(stripslashes($_SESSION['documents_chart_state'])));
	}

	function saveState() {
		$_SESSION['documents_chart_state'] = addslashes(serialize($this->getState()));
	}



	function getFolderPermissionsList() {
		return $this->tdb->getFolderPermissionsList();
	}


	function canAdd() {
		$res=false;

		$saved_perm=$this->docman->loadFolderSavedPerm($this->selectedFolder);
		$addfolder=$this->docman->checkFolderPerm("addfolder", $saved_perm);

		if( ($this->isFolderAccessible()) &&
			(($addfolder) || ($this->docman->isGodAdmin())) &&
			(!$GLOBALS["current_user"]->isAnonymous())) {

				$res=true;

		}

		return $res;
	}


	/*function loadActions() {
		$res="";

		$saved_perm=$this->docman->loadFolderSavedPerm($this->selectedFolder);

		$addfolder=$this->docman->checkFolderPerm("addfolder", $saved_perm);
		$addfile=$this->docman->checkFolderPerm("addfile", $saved_perm);

		if( ($this->isFolderAccessible()) &&
			(($addfolder) || ($addfile) || ($this->docman->isGodAdmin())) &&
			(!$GLOBALS["current_user"]->isAnonymous())) {

			$res.=parent::loadActions();
		}

		return $res;
	}*/



	function _getOtherActions() {

		$saved_perm=$this->docman->loadFolderSavedPerm($this->selectedFolder);
		//print_r($saved_perm);


		if( $this->isFolderSelected() ) {
			if( ($this->isFolderAccessible()) &&
				(($this->docman->checkFolderPerm("addfile", $saved_perm)) || ($this->docman->isGodAdmin())) ) {
				return array(
/*					$this->id.$this->_getOpAssignField() => array(	$this->id .'['.$this->_getOpAssignField().']',
																	$this->lang->def('_DOCUMENTS_ASSIGN_FIELD'),
																	getPathImage().'documents/assign_field.gif' ),
					$this->id.$this->_getOpAssignUser() => array(	$this->id .'['.$this->_getOpAssignUser().']',
																	$this->lang->def('_DOCUMENTS_ASSIGN_USER'),
																	getPathImage().'documents/assign_user.gif' ),
*/					$this->id.$this->_getOpCreateDocument() => array(	$this->id .'['.$this->_getOpCreateDocument().']',
																	$this->lang->def('_CREATE_DOCUMENT'),
																	getPathImage().'standard/add.gif' )
				);
			} else {
				return array();
			}
		}
		else if ($this->docman->isGodAdmin()) {
			return array(
				/*$this->id.$this->_getOpFolderField() => array(	$this->id .'['.$this->_getOpFolderField().']',
																	$this->lang->def('_DOCUMENTS_FOLDER_FIELD'),
																	getPathImage().'documents/folder_field.gif' ),*/
	/*			$this->id.$this->_getOpAssignField() => array(	$this->id .'['.$this->_getOpAssignField().']',
																$this->lang->def('_DOCUMENTS_ASSIGN_FIELD'),
																getPathImage().'documents/assign_field.gif' ),
	*/			$this->id.$this->_getOpCreateDocument() => array(	$this->id .'['.$this->_getOpCreateDocument().']',
																$this->lang->def('_CREATE_DOCUMENT'),
																getPathImage().'standard/add.gif' )
			);
		}
		else {
			return array();
		}
	}

	function getSelectedFolderDesId() {
	// TODO: optimize this function to get the id in a better way
	// also in class.filesystem.php there is a ugly "$arr_idst_groups[]=$folder_id-1;" that has to be changed
		return $this->getSelectedFolderId()-1;
	}

	function getFolderPrintName( &$folder ) {
		if($folder->level == 0)
			return "root";
		else { 			//-debug-// print_r($folder->otherValues);
			if( $this->filter_nodes === FALSE )
				return $folder->otherValues[ORGDB_POS_TRANSLATION];
			if( $this->isFolderAccessible($folder) )
				return $folder->otherValues[ORGDB_POS_TRANSLATION];
			else {
				return $this->lang->def('_DOCUMENTS_HIDDENNODE');
			}
		}
	}

	function getFolderPrintOther( &$folder ) {
		if( $this->selector_mode && $this->simple_selector && $folder->id != 0 ) {
			return 'onclick="var c = document.getElementById( \''.$folder->idtag.'\' );'
					.'c.checked = !c.checked; return false;"';
		}
	}

	function getPreFolderName( &$folder ) {
		if( $this->selector_mode && $this->simple_selector && $folder->id != 0 ) {
			$idst = $this->tdb->getGroupST( $folder->id );
			$this->printed_items[] = $idst;
			$folder->idtag = DIRECTORY_ID.DIRECTORY_OP_SELECTITEM.'_'.$idst;
			$out = '<input type="checkbox"'
					.' id="'.$folder->idtag.'" '
					.' name="'.DIRECTORY_ID.'['.DIRECTORY_OP_SELECTITEM.']['.$idst.']" '
					.' value="'.$idst.'"';
			//$out = Form::getInputDropDown( 'dropdown',
			//								DIRECTORY_ID.DIRECTORY_OP_SELECTITEM.'_'.$idst,
			//								DIRECTORY_ID.'['.DIRECTORY_OP_SELECTITEM.']['.$idst.']',
			//								array( "No", "Si", "Si+sottovoci" ),
			//								0);
			if( array_search( $idst, $this->itemSelectedMulti ) !== FALSE )
				$out .= ' checked="checked" ';
			$out .= ' />';
			return $out;
		} else
			return '';
	}

	function extendedParsing( $arrayState, $arrayExpand, $arrayCompress ) {

		include_once($GLOBALS['where_framework']."/lib/lib.upload.php");

		if( isset($arrayState['editdocumentsave']) ) {
/*			$idst = $_POST['idst'];
			$userid = $_POST['userid'];
			$firstname = $_POST['firstname'];
			$lastname = $_POST['lastname'];
			$pass = $_POST['pass'];
			$userlevel = $_POST['userlevel'];
			$olduserlevel = $_POST['olduserlevel'];
			if( $pass === '' ) $pass = FALSE;
			$email = $_POST['email']; */

			$file_id=(int)$_POST["file_id"];

			if( (int)$file_id > 0 ) { // Update document
				//-extra field-----------------------------------------------
				require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
				$fields = new FieldList();
				$fields->setGroupFieldsTable($GLOBALS['prefix_kms']."_filesystem_field");
				$fields->setFieldEntryTable($GLOBALS['prefix_kms']."_filesystem_fieldentry");
				if( $fields->isFilledFieldsForUser($file_id) ) {
					/*$this->aclManager->updateUser( 	$idst, $userid, $firstname, $lastname,
												$pass, $email, FALSE, FALSE,
												FALSE); */

					// Update document info:
					$fname=$_FILES["file"]["name"];

					if ($fname != "") {
						$user_st=$GLOBALS['current_user']->getIdSt();
						$real_fname=time().rand(10,99)."_".$fname;
						$tmp_fname=$_FILES["file"]["tmp_name"];

						sl_open_fileoperations();
						$f1=sl_upload($tmp_fname, $this->fpath_internal.$real_fname);
						sl_close_fileoperations();

						if ($f1) {
							$folder_id=(int)$_POST["folder_id"];

							// Versioning..
							$qtxt ="INSERT INTO ".$GLOBALS["prefix_kms"]."_file_version (file_id, folder_id, owner, fname, real_fname, file_date) ";
							$qtxt.="VALUES('".$file_id."', '".$folder_id."', '".$user_st."', '".$fname."', '".$real_fname."', NOW())";

							$q=mysql_query($qtxt);
							list($cv_id)=mysql_fetch_row(mysql_query("SELECT LAST_INSERT_ID()"));

							// One Step publication flow?
							require_once($GLOBALS["where_framework"]."/lib/lib.pubflow.php");
							$pf_manager=new PublicationFlowManager();
							if ($this->getFolderFlowId($folder_id) == $pf_manager->getFlowIdFromCode(_PUBFLOW_CODE_ONESTATE)) {
								$this->docman->updateFileToPublished($cv_id);
								$qtxt="UPDATE ".$GLOBALS["prefix_kms"]."_file_version SET published='".PUBLISHED_CURRENT."' WHERE version_id='".$cv_id."'";
								$q=mysql_query($qtxt);
							}

						}
					}


					//-extra field-----------------------------------------------
					$arr_idst_groups = unserialize( urldecode( $_POST['arr_idst_groups'] ) );
					$fields->storeFieldsForUser($file_id, $arr_idst_groups);
					//-----------------------------------------------------------


					//-alert-----------------------------------------------------
					require_once($GLOBALS["where_kms"] . "/lib/lib.kms_common.php");
					$members=$this->docman->getUsersMonitoringFile($file_id);
					$replace=array("[fname]"=>$fname);
					sendKmsGenericEvent(
							/* members:    */ $members,
							/* class:      */ "KmsDocumentModified",
							/* module:     */ "documents",
							/* action:     */ "edit",
							/* log:        */ "Edited document ".$file_id,
							/* sub_string: */ "_DOCUMENTS_MODIFIED_ALERT_SUB",
							/* txt_string: */ "_DOCUMENTS_MODIFIED_ALERT_TXT",
							/* replace:    */ $replace
						);
					//-----------------------------------------------------------


					/*// remove from old group level
					$this->aclManager->removeFromGroup($olduserlevel,$idst );

					// add to group level
					$this->aclManager->addToGroup($userlevel,$idst ); */

				} else {
					$this->op = 'reedit_document';
				}
			} else { // Insert document

				if( isset( $_POST['arr_idst_groups'] ) ) {
					$arr_idst_groups = unserialize( urldecode( $_POST['arr_idst_groups'] ) );
					//$acl =& $GLOBALS['current_user']->getACL();
					//$arr_idst_all = $acl->getArrSTGroupsST($arr_idst_groups);
					$arr_idst_all = $arr_idst_groups;
				} else {
					$arr_idst_groups = FALSE;
					$arr_idst_all = FALSE;
				}
				//-verify mandatory extra field--------------------------------
				require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
				$fields = new FieldList();
				$fields->setGroupFieldsTable($GLOBALS['prefix_kms']."_filesystem_field");
				$fields->setFieldEntryTable($GLOBALS['prefix_kms']."_filesystem_fieldentry");
				if( $arr_idst_groups != FALSE && $fields->isFilledFieldsForUser(0, $arr_idst_all) ) {
					/* $idst = $this->aclManager->registerUser(  	$userid, $firstname, $lastname,
														$pass, $email, '', '',
														''); */

					// Creates a NEW document
					$user_st=$GLOBALS['current_user']->getIdSt();
					$fname=$_FILES["file"]["name"];
					$real_fname=time().rand(10,99)."_".$fname;
					$tmp_fname=$_FILES["file"]["tmp_name"];

					sl_open_fileoperations();
					$f1=sl_upload($tmp_fname, $this->fpath_internal.$real_fname);
					sl_close_fileoperations();

					$file_id=0;

					if ($f1) {
						$folder_id=$_POST["folder_id"];

						$qtxt ="INSERT INTO ".$GLOBALS["prefix_kms"]."_file (folder_id, owner, fname, real_fname) ";
						$qtxt.="VALUES('".$folder_id."', '".$user_st."', '".$fname."', '".$real_fname."')";

						$q=mysql_query($qtxt);

						list($file_id)=mysql_fetch_row(mysql_query("SELECT LAST_INSERT_ID()"));


						// Versioning..
						$qtxt ="INSERT INTO ".$GLOBALS["prefix_kms"]."_file_version (file_id, folder_id, owner, fname, real_fname, file_date) ";
						$qtxt.="VALUES('".$file_id."', '".$_POST["folder_id"]."', '".$user_st."', '".$fname."', '".$real_fname."', NOW())";

						$q=mysql_query($qtxt);

						list($cv_id)=mysql_fetch_row(mysql_query("SELECT LAST_INSERT_ID()"));


						$qtxt ="UPDATE ".$GLOBALS["prefix_kms"]."_file SET cv_id='".$cv_id."' WHERE file_id='".$file_id."'";
						$q=mysql_query($qtxt);

					}
					/* else
						die("Upload Error"); */


					/*foreach( $arr_idst_groups as $idst_group ) {
							$this->aclManager->addToGroup($idst_group,$idst );
					}
					// add to group level
					$this->aclManager->addToGroup($userlevel,$idst ); */


					if ($file_id > 0) {
						//-save extra field------------------------------------------
							$fields->storeFieldsForUser($file_id, $arr_idst_all);
						//-----------------------------------------------------------

						$url ="index.php?modname=documents&op=selnewdocperm&file_id=".$file_id;
						$url.="&cvid=".$cv_id."&treeid=".$_POST["folder_id"];
						jumpTo($url);
					}

				} else {
					$this->op = 'reedit_person';
				}
			}
		} elseif( isset($arrayState['deletedocument']) ) {
			$idst = $_POST['idst'];
			if( $idst !== '' ) $this->aclManager->deleteUser( $idst );
		}
		if(!isset($arrayState[$this->id])) {

			return;
		}
		foreach($arrayState[$this->id] as $key => $action) {
			if( $key == 'save_newfolder' ) {
				$array_lang 	= $GLOBALS['globLangManager']->getAllLangCode();
				$mand_lang 		= getLanguage();
				if( !isset( $action[$mand_lang] ) ) {
					$this->op = 'newfolder';
				} else {
					$folderName = array();
					foreach( $array_lang as $langItem ) {
						$folderName[$langItem] = $arrayState[$this->id]['new_folder'][$langItem];
					}
					$this->tdb->addFolderByIdTranslation( $this->selectedFolder, $folderName );
					$this->refresh = TRUE;
				}
			} elseif( $key == 'save_renamefolder' ) {
				$array_lang 	= $GLOBALS['globLangManager']->getAllLangCode();
				$mand_lang 		= getLanguage();
				if( !isset( $action[$mand_lang] ) ) {
					$this->op = 'renamefolder';
				} else {
					$folderName = array();
					foreach( $array_lang as $langItem ) {
						$folderName[$langItem] = $arrayState[$this->id]['rename_folder'][$langItem];
					}
					$this->tdb->updateFolderByIdTranslation( $this->selectedFolder, $folderName );
					$this->tdb->updateFolderExtraInfo($this->selectedFolder);

					/* $folder_idst = $this->tdb->getGroupST( $this->getSelectedFolderId() );
					$acl =& $GLOBALS['current_user']->getACL();
					$aclManager =& $acl->getACLManager();
					$idst_field_group = $aclManager->getGroupST(DOCUMENTS_FOLDER_FIELD_GROUP); */

					//-extra field-----------------------------------------------
					/* require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
					$fields = new FieldList();
					$fields->storeFieldsForUser($folder_idst, array($idst_field_group), FALSE ); */
					//-----------------------------------------------------------

					$this->refresh = TRUE;
				}
			} elseif( $key == 'save_formfield' ) {
				require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
				$arr_fields = $arrayState[$this->id]['field_set'];
				$fl = new FieldList();
				$acl =& $GLOBALS['current_user']->getACL();
				$aclManager =& $acl->getACLManager();

				$arr_all_fields = $fl->getAllFields();
				$idst_group = $aclManager->getGroupST(DOCUMENTS_FOLDER_FIELD_GROUP);
				// remove all fields
				foreach( $arr_all_fields as $id_field => $field ) {
					$fl->removeFieldFromGroup($id_field, $idst_group);
				}

				// add selected fields
				foreach( $arr_fields as $id_field ) {
					$fl->addFieldToGroup( $id_field, $idst_group );
				}
			} elseif( $key == 'next1_assignfield' ) {
				$this->op = 'assign2_field';
			} elseif( $key == 'next2_assignfield' ) {
				$this->op = 'assign3_field';
			} elseif( $key == 'save_assignfield' ) {
				$arr_fields = $arrayState[$this->id]['field_set'];
				$arr_fields_mandatory = $arrayState[$this->id]['field_mandatory'];
				$arr_fields_useraccess = $arrayState[$this->id]['field_useraccess'];
				require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
				$fl = new FieldList();
				$fl->setGroupFieldsTable($GLOBALS['prefix_kms']."_filesystem_field");

				foreach( $arr_fields as $id_filed => $status ) {
					switch( $status ) {
						case DOCUMENTS_FIELD_NO:
							$fl->removeFieldFromGroup(
									$id_filed,
									$this->getSelectedFolderId()
									);
							$fl->removeFieldFromGroup(
									$id_filed,
									$this->getSelectedFolderDesId()
									);
						break;
						case DOCUMENTS_FIELD_NORMAL:
							$fl->addFieldToGroup(
									$id_filed,
									$this->getSelectedFolderId(),
									isset($arr_fields_mandatory[$id_filed])?$arr_fields_mandatory[$id_filed]:'false',
									isset($arr_fields_useraccess[$id_filed])?$arr_fields_useraccess[$id_filed]:'readonly'
									);

						break;
						case DOCUMENTS_FIELD_DESCEND:
							$fl->addFieldToGroup(
									$id_filed,
									$this->getSelectedFolderDesId(),
									isset($arr_fields_mandatory[$id_filed])?$arr_fields_mandatory[$id_filed]:'false',
									isset($arr_fields_useraccess[$id_filed])?$arr_fields_useraccess[$id_filed]:'readonly'
									);
						break;
					}
				}
			} elseif( $key == $this->_getOpFolderField()) {
				if( is_array( $action ) )
					$this->selectedFolder = key($action);
				$this->op = 'folder_field';
			} elseif( $key == $this->_getOpAssignField()) {
				if( is_array( $action ) )
					$this->selectedFolder = key($action);
				$this->op = 'assign_field';
			} elseif( $key == $this->_getOpAssignUser() ) {
				if( is_array( $action ) )
					$this->selectedFolder = key($action);
				$this->op = 'addtotree';
			} elseif( $key == $this->_getOpMonitorFolder() ) {
				if( is_array( $action ) )
					$this->selectedFolder = key($action);
				$this->op = 'monitorfolder';
			} elseif( $key == $this->_getOpCreateDocument() ) {
				if( is_array( $action ) )
					$this->selectedFolder = key($action);
				$this->op = 'create_document';
			}
		}
	}

	function canMove() { return FALSE; /*($this->isFolderSelected() && $this->isFolderAccessible());*/ }
	function canRename() { return FALSE; /*return ($this->isFolderSelected() && $this->isFolderAccessible());*/ }
	function canDelete() { return FALSE; /*return ($this->isFolderSelected() && $this->isFolderAccessible());*/ }


	function canInlineMove() {	return (!$this->selector_mode && $this->can_edit_folder); }
	function canInlineRename() { return (!$this->selector_mode && $this->can_edit_folder); }
	function canInlineDelete() { return (!$this->selector_mode && $this->can_edit_folder); }

	/**
	 * functions canInlineXXXXItem()
	 * return TRUE if the XXXX action is available for specific item
	 **/
	function canInlineMoveItem( &$stack, $level ) {
		return ( $level > 0 && $this->isFolderAccessible($stack[$level]['folder']) );
	}

	function canInlineRenameItem( &$stack, $level ) {
		return ( $this->isFolderAccessible($stack[$level]['folder']) );
	}
	function canInlineDeleteItem( &$stack, $level ) {
		return ($level > 0 && $this->isFolderAccessible($stack[$level]['folder']));
	}

	/**
	 * @param array $class_arr [folder_id] = 'image file name'
	 *
	 **/
	function setCustomFolderImage($image_arr) {
		$this->custom_folder_image=$image_arr;
	}

	/**
	 * @param array $class_arr [folder_id] = 'css class name'
	 *
	 **/
	function setCustomFolderClass($class_arr) {
		$this->custom_folder_class=$class_arr;
	}

	function getImage(&$stack, $currLev, $maxLev ) {
		$arr_result = parent::getImage( $stack, $currLev, $maxLev );
		$enabled = TRUE;
		if( $this->filter_nodes === FALSE || $this->isFolderAccessible($stack[$currLev]['folder']) )
			$enabled = TRUE;
		else
			$enabled = FALSE;
		$folder_id=$stack[$maxLev]['folder']->id;
		if( $maxLev > 0 && $currLev == $maxLev && !$enabled ) {
			$arr_toks = explode('.',$arr_result[1]);
			$arr_result[1] = implode( '.',array_slice($arr_toks,0,count($arr_toks)-1))
							.'_disabled.'
							.$arr_toks[count($arr_toks)-1];
		}
		else {
			if ((isset($this->custom_folder_image[$folder_id])) && ($currLev == $maxLev))
				$arr_result[1]=$this->custom_folder_image[$folder_id];
		}
		if (isset($this->custom_folder_class[$folder_id]))
			$arr_result[0]=$this->custom_folder_class[$folder_id];

		return $arr_result;
	}

	function printElement(&$stack, $level) {

		$folder_perm=$this->docman->hasFolderPerm($stack[$level]['folder']->id, "addfolder");
		$monitorized_folders=$this->docman->getMonitorizedFolders();

		$this->can_edit_folder=($folder_perm && !$GLOBALS["current_user"]->isAnonymous() ? true:false);
		$tree = parent::printElement($stack, $level);

		if( !$this->selector_mode ) {
			// assign field to user
			if( $this->isFolderAccessible($stack[$level]['folder']) && $this->can_edit_folder )
				$tree .= '<input type="image" class="tree_view_image" '
					.' src="'.$this->_getImgAssignField().'"'
					.' id="'.$this->id.'_'.$this->_getOpAssignField().'_'.$stack[$level]['folder']->id.'" '
					.' name="'.$this->id.'['.$this->_getOpAssignField().']['.$stack[$level]['folder']->id.']" '
					.' title="'.$this->_getLabelAssignField().'" '
					.' alt="'.$this->_getLabelAssignField().'" />';

			if($level > 0  && $this->can_edit_folder) {
				if( $this->isFolderAccessible($stack[$level]['folder']) )
					$tree .= '<input type="image" class="tree_view_image" '
						.' src="'.$this->_getImgAssignUser().'"'
						.' id="'.$this->id.'_'.$this->_getOpAssignUser().'_'.$stack[$level]['folder']->id.'" '
						.' name="'.$this->id.'['.$this->_getOpAssignUser().']['.$stack[$level]['folder']->id.']" '
						.' title="'.$this->_getLabelAssignUser().'" '
						.' alt="'.$this->_getLabelAssignUser().'" />';
			} else {
			// assign field to folder
				/*$tree .= '<input type="image" class="tree_view_image" '
					.' src="'.$this->_getImgFolderField().'"'
					.' id="'.$this->id.'_'.$this->_getOpFolderField().'_'.$stack[$level]['folder']->id.'" '
					.' name="'.$this->id.'['.$this->_getOpFolderField().']['.$stack[$level]['folder']->id.']" '
					.' title="'.$this->_getLabelFolderField().'" '
					.' alt="'.$this->_getLabelFolderField().'" />'; */
			}

			// Folder monitoring
			if( $this->isFolderAccessible($stack[$level]['folder'] )) {

				if (in_array($stack[$level]['folder']->id, $monitorized_folders)) {
					$monitor_img="monitor_on";
					$monitor_title='_DOCUMENTS_FOLDERMONITOR_ON';
				}
				else {
					$monitor_img="monitor_off";
					$monitor_title='_DOCUMENTS_FOLDERMONITOR_OFF';
				}

				if (!$GLOBALS["current_user"]->isAnonymous()) {
					$tree .= '<input type="image" class="tree_view_image" '
						.' src="'.getPathImage().'standard/'.$monitor_img.'.gif'.'"'
						.' id="'.$this->id.'_'.$this->_getOpMonitorFolder().'_'.$stack[$level]['folder']->id.'" '
						.' name="'.$this->id.'['.$this->_getOpMonitorFolder().']['.$stack[$level]['folder']->id.']" '
						.' title="'.$this->_getLabelMonitorFolder().'" '
						.' alt="'.$this->_getLabelMonitorFolder().'" />';
				}
			}
		} elseif( !$this->simple_selector ) {
			$stack[$level]['desc'] = FALSE;
			$idst = $this->tdb->getGroupST( $stack[$level]['folder']->id );
			$idst_desc = $this->tdb->getGroupDescendantsST( $stack[$level]['folder']->id );
			if( $level > 0 && $stack[$level-1]['desc'] ) {
				$stack[$level]['desc'] = TRUE;
				$disabled = ' disabled="disabled" ';
			} else {
				$disabled = '';
			}
			$radio_name = DIRECTORY_ID.'['.DIRECTORY_OP_SELECTRADIO.']['.$idst.'_'.$idst_desc.']';
			$found = FALSE;
			$tree .= '<div class="special_input">';
			$tree .= Form::getLabel( 	DIRECTORY_ID.DIRECTORY_OP_SELECTRADIO.'_'.$idst,
										$this->lang->def('_DOCUMENTS_INHERIT'),
										'label_bold tree_view_image' );
			$tree .= '<input type="radio" class="tree_view_image"'
					.' id="'.DIRECTORY_ID.DIRECTORY_OP_SELECTRADIO.'_'.$idst.'" '
					.' name="'.$radio_name.'" '
					.' value="'.$idst_desc.'"'
					.$disabled;
			if( array_search( $idst_desc, $this->itemSelectedMulti ) !== FALSE ) {
				$tree .= ' checked="checked" ';
				$stack[$level]['desc'] = TRUE;
				$found = TRUE;
			}
			$tree .= ' />';
			$tree .= Form::getLabel( 	DIRECTORY_ID.DIRECTORY_OP_SELECTRADIO.'_'.$idst,
										$this->lang->def('_DOCUMENTS_YES'),
										'label_bold tree_view_image' );
			$tree .= '<input type="radio"  class="tree_view_image"'
					.' id="'.DIRECTORY_ID.DIRECTORY_OP_SELECTRADIO.'_'.$idst.'" '
					.' name="'.$radio_name.'" '
					.' value="'.$idst.'"'
					.$disabled;
			if( array_search( $idst, $this->itemSelectedMulti ) !== FALSE ) {
				$tree .= ' checked="checked" ';
				$found = TRUE;
			}
			$tree .= ' />';
			$tree .= Form::getLabel( 	DIRECTORY_ID.DIRECTORY_OP_SELECTRADIO.'_'.$idst,
										$this->lang->def('_DOCUMENTS_NO'),
										'label_bold tree_view_image' );
			$tree .= '<input type="radio" class="tree_view_image"'
					.' id="'.DIRECTORY_ID.DIRECTORY_OP_SELECTRADIO.'_'.$idst.'" '
					.' name="'.$radio_name.'" '
					.' value=""'
					.$disabled;
			if( !$found ) {
				$tree .= ' checked="checked" ';
			}
			$tree .= ' />';
			$tree .= '</div>';
		}
		return $tree;
	}


	function loadNewFolder() {
		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
		$form = new Form();

		$tree = $form->getFormHeader($this->lang->def('_DOCUMENTS_NEW_FOLDER'));
		$tree .= $form->openElementSpace();
		$tree .= $this->printState();

		$array_lang 	= $GLOBALS['globLangManager']->getAllLangCode();
		$mand_lang = getLanguage();
		foreach($array_lang as $k => $lang_code ) {
			$tree .= $form->getTextfield(( ($mand_lang == $lang_code) ? '<span class="mandatory">*</span>' : '' ).$lang_code,
									'new_folder_'.$lang_code,
									$this->id.'[new_folder]['.$lang_code.']',
									255,
									'',
									$lang_code.' '.$this->lang->def('_DOCUMENTS_NEW_FOLDER') );
		}

		$tree .= $form->closeElementSpace()
				.$form->openButtonSpace()
				.$form->getButton('save_newfolder'.$this->id, $this->id.'[save_newfolder]', $this->lang->def('_SAVE'))
				.$form->getButton($this->_getCancelId(), $this->_getCancelId(), $this->lang->def('_UNDO'))
				.$form->closeButtonSpace();

		return $tree;
	}

	function loadRenameFolder() {
		$tdb =& $this->tdb;
		$folder_id=$this->getSelectedFolderId();
		$folder = $tdb->getFolderById( $folder_id );
		$folder_idst = $tdb->getGroupST( $folder_id );
		$acl =& $GLOBALS['current_user']->getACL();
		$aclManager =& $acl->getACLManager();
		$idst_field_group = $aclManager->getGroupST(DOCUMENTS_FOLDER_FIELD_GROUP);

		$flow_id=$this->docman->getFolderFlowId($folder_id);

		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
		$form = new Form();

		$tree = $form->getFormHeader($this->lang->def('_DOCUMENTS_RENAME_FOLDER'));
		$tree .= $form->openElementSpace();
		$tree .= $this->printState();

		$array_lang 	= $GLOBALS['globLangManager']->getAllLangCode();
		$mand_lang 		= getLanguage();
		$array_translations = $tdb->getFolderTransaltions($this->getSelectedFolderId());

		foreach($array_lang as $k => $lang_code ) {
			$tree .= $form->getTextfield(( ($mand_lang == $lang_code) ? '<span class="mandatory">*</span>' : '' ).$lang_code,
									'rename_folder_'.$lang_code,
									$this->id.'[rename_folder]['.$lang_code.']',
									255,
									$array_translations[$lang_code],
									$lang_code.' '.$this->lang->def('_DOCUMENTS_RENAME_FOLDER') );
		}

		// Publication flow selection
		require_once($GLOBALS["where_framework"]."/lib/lib.pubflow.php");
		$pf=new PublicationFlow("kms");
		$tree.=$pf->getFlowDropdown($form, $flow_id);

		$tree .= $form->closeElementSpace();

		// -- begin -- custom fields for folder
		/*$tree .= $form->getOpenFieldset( $this->lang->def( '_ASSIGNED_EXTRAFIELD' ) );
		require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
		$fl = new FieldList();
		$tree .= $fl->playFieldsForUser( $folder_idst,
										 array($idst_field_group),
										 FALSE,
										 FALSE );
		$tree .= $form->getCloseFieldset(); */
		// -- end -- custom fields for folder


		$tree .= $form->openButtonSpace()
				.$form->getButton('save_renamefolder'.$this->id, $this->id.'[save_renamefolder]', $this->lang->def('_SAVE'))
				.$form->getButton($this->_getCancelId(), $this->_getCancelId(), $this->lang->def('_UNDO'))
				.$form->closeButtonSpace();

		return $tree;
	}

	function loadFolderField() {
		require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
		$form = new Form();
		$fl = new FieldList();
		$acl =& $GLOBALS['current_user']->getACL();
		$aclManager =& $acl->getACLManager();

		$tree = $form->getFormHeader($this->lang->def('_DOCUMENTS_LIST_FIELDS'));
		$tree .= $form->openElementSpace();
		$tree .= $this->printState();
		$arr_all_fields = $fl->getAllFields();
		$idst_group = $aclManager->getGroupST(DOCUMENTS_FOLDER_FIELD_GROUP);
		$arr_fields = $fl->getFieldsFromIdst(array($idst_group));
		foreach($arr_all_fields as $field ) {
			$tree .= $form->getCheckbox(
									$field[FIELD_INFO_TRANSLATION],
									$this->id.'_'.$field[FIELD_INFO_ID],
									$this->id.'[field_set]['.$field[FIELD_INFO_ID].']',
									$field[FIELD_INFO_ID],
									isset($arr_fields[$field[FIELD_INFO_ID]]) );
		}

		$tree .= $form->closeElementSpace()
				.$form->openButtonSpace()
				.$form->getButton('save_formfield'.$this->id, $this->id.'[save_formfield]', $this->lang->def('_SAVE'))
				.$form->getButton($this->_getCancelId(), $this->_getCancelId(), $this->lang->def('_UNDO'))
				.$form->closeButtonSpace();

		return $tree;

	}

	function loadAssignField() {
		$tdb =& $this->tdb;
		$folder = $tdb->getFolderById( $this->getSelectedFolderId() );

		require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
		$form = new Form();
		$fl = new FieldList();
		$fl->setGroupFieldsTable($GLOBALS['prefix_kms']."_filesystem_field");

		$tree = $form->getFormHeader($this->lang->def('_DOCUMENTS_LIST_FIELDS'));
		$tree .= $form->openElementSpace();
		$tree .= $this->printState();

		/* $acl =& $GLOBALS['current_user']->getACL();
		$aclManager =& $acl->getACLManager(); */

		$arr_all_fields = $fl->getAllFields();
		$idst_group = $this->getSelectedFolderId();
		$idst_group_d=$this->getSelectedFolderDesId(); // descendants
		//$idst_desc = $tdb->getGroupDescendantsST($this->getSelectedFolderId());
		//$arr_fields_normal = $fl->getFieldsFromIdst(array($idst_group));
		//$arr_fields_descend = $fl->getFieldsFromIdst(array($idst_desc));
		//$arr_idst_inherit = array_merge( $acl->getGroupGroupsST($idst_desc), $acl->getGroupGroupsST($idst_group));
		//$arr_fields_inherit = $fl->getFieldsFromIdst($arr_idst_inherit);
		$arr_fields = $fl->getFieldsFromIdst(array($idst_group), FALSE);
		$arr_fields_d = $fl->getFieldsFromIdst(array($idst_group_d), FALSE);
		//-debug-// print_r($arr_fields);

		/* foreach($arr_all_fields as $field ) {
			$tree .= $form->getCheckbox(
									$field[FIELD_INFO_TRANSLATION],
									$this->id.'_'.$field[FIELD_INFO_ID],
									$this->id.'[field_set]['.$field[FIELD_INFO_ID].']',
									$field[FIELD_INFO_ID],
									isset($arr_fields[$field[FIELD_INFO_ID]]) );
		} */

/*		if( count( $arr_idst_inherit ) )
			$arr_groupid = $aclManager->getGroupsId( $arr_idst_inherit );
		else
			$arr_groupid = array(); */
//		$arr_tree_translations = $tdb->getFoldersCurrTranslation($arr_groupid);
		$arr_values = array(
						$this->lang->def('_DOCUMENTS_FIELD_NO') => DOCUMENTS_FIELD_NO,
						$this->lang->def('_DOCUMENTS_FIELD_NORMAL') => DOCUMENTS_FIELD_NORMAL,
						$this->lang->def('_DOCUMENTS_FIELD_DESCEND') => DOCUMENTS_FIELD_DESCEND,
					);
/*		$tree .= $form->getHidden(	$this->id.'_idst_group',
										$this->id.'[idst_group]',
										$idst_group);
		$tree .= $form->getHidden(	$this->id.'_idst_desc',
										$this->id.'[idst_desc]',
										$idst_desc); */
		foreach($arr_all_fields as $field ) {
			$def_value = DOCUMENTS_FIELD_NO;
/*			if( isset($arr_fields_d[$field[FIELD_INFO_ID]]) )
				$def_value = DOCUMENTS_FIELD_INHERIT; */
			if( isset($arr_fields[$field[FIELD_INFO_ID]]) )
				$def_value = DOCUMENTS_FIELD_NORMAL;
			elseif( isset($arr_fields_d[$field[FIELD_INFO_ID]]) )
				$def_value = DOCUMENTS_FIELD_DESCEND;

			$tree .= $form->openFormLine();
			$tree .= '<div class="label_effect">'.$field[FIELD_INFO_TRANSLATION].'</div>';
			foreach( $arr_values as $label => $value ) {
				$tree .= '<input class="radio" type="radio"'
						.' id="'.$this->id.'_'.$field[FIELD_INFO_ID].'_'.$value.'"'
						.' name="'.$this->id.'[field_set]['.$field[FIELD_INFO_ID].']"'
						.' value="'.$value.'"'
						.( ($value == $def_value)? ' checked="checked"' : '' )
						.( ($value == DOCUMENTS_FIELD_NO And $def_value == DOCUMENTS_FIELD_INHERIT)?' disabled="true"' : '' )
						.' />';
				$tree .= $form->getLabel( $this->id.'_'.$field[FIELD_INFO_ID].'_'.$value, $label, 'label_bold' );
			}
			if( $def_value == DOCUMENTS_FIELD_INHERIT ) {
				$gid = $arr_fields_inherit[$field[FIELD_INFO_ID]][FIELD_INFO_GROUPID];
				if( $gid == '/dfd_0' )
					$text = $GLOBALS['title_organigram_chart'];
				else {
					if( isset( $arr_tree_translations[$gid] ) )
						$text = $arr_tree_translations[$gid];
					else
						$text = $arr_groupid[$gid];
				}
				$tree .= '<span class="label_bold">'
						.$this->lang->def('_DOCUMENTS_FIELD_INHERIT')
						.' ['.$text.']'
						.'</span>';
			}
			//$tree .= $form->getLabel( $id, $field[FIELD_INFO_TRANSLATION] );
			$tree .= $form->closeFormLine();
		}

		$tree .= $form->closeElementSpace()
				.$form->openButtonSpace()
				.$form->getButton('next1_assignfield'.$this->id, $this->id.'[next1_assignfield]', $this->lang->def('_SAVE'))
				.$form->getButton($this->_getCancelId(), $this->_getCancelId(), $this->lang->def('_UNDO'))
				.$form->closeButtonSpace();

		return $tree;
	}

	function loadAssignField2() {
		$arr_fields = $_POST[$this->id]['field_set'];
		$idst_group = $_POST[$this->id]['idst_group'];
		$idst_desc = $_POST[$this->id]['idst_desc'];
		require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
		$fl = new FieldList();
		$fl->setGroupFieldsTable($GLOBALS['prefix_kms']."_filesystem_field");
		$arr_all_fields = $fl->getAllFields();
		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
		$form = new Form();
		$tree = $form->getFormHeader($this->lang->def('_DOCUMENTS_LIST_FIELDS_MANDATORY'));
		$tree .= $form->openElementSpace();
		$tree .= $this->printState();
		// print custom fields status
		$arr_fields_normal = $fl->getFieldsFromIdst(array($idst_group));
		$arr_fields_descend = $fl->getFieldsFromIdst(array($idst_desc));
		foreach( $arr_fields_descend as $id_field => $field )
			$arr_fields_normal[$id_field] = $field;


		$tree .= $form->getHidden(	$this->id.'_idst_group',
										$this->id.'[idst_group]',
										$idst_group);
		$tree .= $form->getHidden(	$this->id.'_idst_desc',
										$this->id.'[idst_desc]',
										$idst_desc);

		foreach( $arr_fields as $id_filed => $status ) {
			$tree .= $form->getHidden(	$this->id.'_'.$id_filed,
										$this->id.'[field_set]['.$id_filed.']',
										$status);
		}

		$tree .= $form->openFormLine();
		$tree .= '<div class="label_effect">&nbsp;</div>';
		$tree .= '<div class="label_head">'.$this->lang->def('_DOCUMENTS_FIELD_MANDATORY').'</div>';
		$tree .= '<div class="label_head">'.$this->lang->def('_DOCUMENTS_FIELD_WRITE').'</div>';
		$tree .= $form->closeFormLine();
		// checkbox for mandatory and useraccess
		foreach( $arr_fields as $id_filed => $status ) {
			if( $status == DOCUMENTS_FIELD_NORMAL || $status == DOCUMENTS_FIELD_DESCEND ) {
				$tree .= $form->openFormLine();
				// field title
				$tree .= '<div class="label_effect">'.$arr_all_fields[$id_filed][FIELD_INFO_TRANSLATION].'</div>';
				// checkbox for mandatory
				$tree .= '<input class="label_head" type="checkbox"'
							.' id="'.$this->id.'_'.$id_filed.'_mandatory"'
							.' name="'.$this->id.'[field_mandatory]['.$id_filed.']"'
							.' value="true"';
				if( isset( $arr_fields_normal[$id_filed] ) && $arr_fields_normal[$id_filed][FIELD_INFO_MANDATORY] == 'true' )
					$tree .= ' checked="checked"';
				$tree .= ' />';
				$tree .= $form->getLabel( $this->id.'_'.$id_filed.'_mandatory', $this->lang->def('_DOCUMENTS_FIELD_MANDATORY'), 'label_bold accessibility_tips' );
				// checkbox for useraccess
				$tree .= '<input class="label_head" type="checkbox"'
							.' id="'.$this->id.'_'.$id_filed.'_useraccess"'
							.' name="'.$this->id.'[field_useraccess]['.$id_filed.']"'
							.' value="readwrite"';
				if( isset( $arr_fields_normal[$id_filed] ) && $arr_fields_normal[$id_filed][FIELD_INFO_USERACCESS] == 'readwrite' )
					$tree .= ' checked="checked"';
				$tree .= ' />';
				$tree .= $form->getLabel( $this->id.'_'.$id_filed.'_useraccess', $this->lang->def('_DOCUMENTS_FIELD_WRITE'), 'label_bold accessibility_tips' );
				$tree .= $form->closeFormLine();

			}
		}


		$tree .= $form->closeElementSpace()
				.$form->openButtonSpace()
				.$form->getButton('save_assignfield'.$this->id, $this->id.'[save_assignfield]', $this->lang->def('_SAVE'))
				.$form->getButton($this->_getCancelId(), $this->_getCancelId(), $this->lang->def('_UNDO'))
				.$form->closeButtonSpace();

		return $tree;
	}

	function loadAssignField3() {
		$arr_fields = $_POST[$this->id]['field_set'];
		$idst_group = $_POST[$this->id]['idst_group'];
		require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
		$fl = new FieldList();
		$arr_all_fields = $fl->getAllFields();
		$arr_fields_normal = $fl->getFieldsFromIdst(array($idst_group));
		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
		$form = new Form();
		$tree = $form->getFormHeader($this->lang->def('_DOCUMENTS_LIST_FIELDS'));
		$tree .= $form->openElementSpace();
		$tree .= $this->printState();

		$tree .= $form->getHidden(	$this->id.'_idst_group',
									$this->id.'[idst_group]',
									$idst_group);
		// print custom fields status
		foreach( $arr_fields as $id_filed => $status ) {
			$tree .= $form->getHidden(	$this->id.'_'.$id_filed,
										$this->id.'[field_set]['.$id_filed.']',
										$status);
		}

		// first print already ordered fields
		foreach( $arr_fields_normal as $id_filed => $field ) {

		}


		$tree .= $form->closeElementSpace()
				.$form->openButtonSpace()
				.$form->getButton('next1_assignfield'.$this->id, $this->id.'[save_assignfield]', $this->lang->def('_SAVE'))
				.$form->getButton($this->_getCancelId(), $this->_getCancelId(), $this->lang->def('_UNDO'))
				.$form->closeButtonSpace();

		return $tree;
	}


	function getFolderFlowId($folder_id) {
		return $this->docman->getFolderFlowId($folder_id);
	}


	/**
	 * @param array $folder_arr
	 * @param boolean $req_zero if true only the folder with "ghosts" and zero visible files are
	 *                returned; else will return the folder with, for example, 2 visible files and 3 "ghosts"
	 * @return array list of folder id that have files that are not visible to the
	 *         current user.
	 **/
	function getFoldersWithGhosts($folder_arr=FALSE, $req_zero=TRUE) {

		$fl_data = new FileSystemRetriever($GLOBALS['dbConn'], $GLOBALS['prefix_kms']);

		$file_perm=$this->docman->getFilePerm(); //print_r($file_perm);
		if (isset($file_perm["viewfile"]))
			$view_perm=$file_perm["viewfile"];
		else
			$view_perm=array(0);

		$qtxt_1="SELECT folder_id, count(file_id) as tot FROM ".$fl_data->prefix."_file ";
		$qtxt_2=" GROUP BY folder_id";

		if (is_array($folder_arr)) {
			$where=$fl_data->getFileTable().".folder_id IN (".implode(",", $folder_arr).")";
			$fl_data->addCustomFilter("", $where);
		}

		$qtxt=$qtxt_1.$fl_data->getFilteredWhere().$qtxt_2;
		$q=mysql_query($qtxt); //echo $qtxt;

		$unfiltered_arr=array();
		if (($q) && (mysql_num_rows($q) > 0)) {
			while($row=mysql_fetch_array($q)) {
				$unfiltered_arr[$row["folder_id"]]=$row["tot"];
			}
		} //print_r($unfiltered_arr);


		$where=$fl_data->getFileTable().".file_id IN (".implode(",", $view_perm).")";
		$fl_data->addCustomFilter("", $where);

		$qtxt=$qtxt_1.$fl_data->getFilteredWhere().$qtxt_2;
		$q=mysql_query($qtxt); //echo $qtxt;

		$filtered_arr=array();
		if (($q) && (mysql_num_rows($q) > 0)) {
			while($row=mysql_fetch_array($q)) {
				$filtered_arr[$row["folder_id"]]=$row["tot"];
			}
		} //print_r($filtered_arr);


		$with_ghost=array();
		foreach ($unfiltered_arr as $key=>$val) {

			if (isset($filtered_arr[$key]))
				$filtered_val=$filtered_arr[$key];
			else
				$filtered_val=0;

			if ($val > $filtered_val) {
				if (($filtered_val == 0) || (!$req_zero))
					$with_ghost[]=$key;
			}

		}

		return $with_ghost;
	}


	/**
	 * @param array $folder_arr
	 * @return array list of folder id that have no files that are visible to the
	 *         current user.
	 *
	 * NOTE: this has to be called after the parsePositionData() else the
	 * posFlat array will be empty.
	 **/
	function getEmptyFolders($folder_arr=FALSE) {

		$fl_data = new FileSystemRetriever($GLOBALS['dbConn'], $GLOBALS['prefix_kms']);


		if (!$this->docman->isGodAdmin()) { // Check only folder that have files visible to the current user

			$file_perm=$this->docman->getFilePerm();
			if (isset($file_perm["viewfile"]))
				$view_perm=$file_perm["viewfile"];
			else
				$view_perm=array(0);

			$where=$fl_data->getFileTable().".file_id IN (".implode(",", $view_perm).")";
			$fl_data->addCustomFilter("", $where);
		}

		$qtxt_1="SELECT folder_id, count(file_id) as tot FROM ".$fl_data->prefix."_file ";
		$qtxt_2=" GROUP BY folder_id";

		if (is_array($folder_arr)) {
			$where=$fl_data->getFileTable().".folder_id IN (".implode(",", $folder_arr).")";
			$fl_data->addCustomFilter("", $where);
		}
		else { // Todo: get array of loaded folders
			$folder_arr=$this->getPosFlat();
		}


		$qtxt=$qtxt_1.$fl_data->getFilteredWhere().$qtxt_2;
		$q=mysql_query($qtxt); //echo $qtxt;

		$not_empty_arr=array();
		if (($q) && (mysql_num_rows($q) > 0)) {
			while($row=mysql_fetch_array($q)) {
				if ($row["tot"] > 0)
					$not_empty_arr[]=$row["folder_id"];
			}
		} //print_r($filtered_arr);

		$empty_arr=array_diff($folder_arr, $not_empty_arr);

		return $empty_arr;
	}

}




// Class DocumentFieldList extends FieldList {

	/** @var string $field_table the main definition field table */
	// var $field_table = '';
	/** @var string $type_field_table the fields type definition table */
// 	var $type_field_table = '';
	/** @var string $doc_field_table the fields <-> group relation table */
// 	var $doc_field_table = '';
	/** @var string $field_entry_table the fields value table */
// 	var $field_entry_table = FALSE;

/*	function getGroupFieldsTable() { return $this->doc_field_table; }

	function DocumentFieldList() {
		$this->field_table = $GLOBALS['prefix_fw'].FIELDTABLE;
		$this->type_field_table = $GLOBALS['prefix_fw'].TYPEFIELDTABLE;
		$this->doc_field_table = $GLOBALS['prefix_kms']."_filesystem_field";
	}

	/**
	 * @param int $id_st idst to be associated to the user
	 * @param array $arr_idst (optional) array of idst of groups
	 *					if this parameter is skipped the groups will be taken
	 *					from $idst_user
 	 * @return html with the form code for play a set of fields
	 **/
/*	function playFieldsForDocument($idst_user, $arr_idst = FALSE, $freeze = FALSE, $add_root = TRUE ) {

		$acl =& $GLOBALS['current_user']->getACL();
		if( $arr_idst === FALSE )
			$arr_idst = $acl->getUserGroupsST($idst_user);
		if( $add_root ) {
			$acl_man =& $acl->getAclManager();
			$tmp = $acl_man->getGroup( false, '/df_0' );
			$arr_idst[] = $tmp[0];
			$tmp = $acl_man->getGroup( false, '/dfd_0' );
			$arr_idst[] = $tmp[0];
		}
		$query = "SELECT ft.id_common, ft.type_field, tft.type_file, tft.type_class, gft.mandatory"
				."  FROM ( ".$this->getFieldTable() ." AS ft"
				."  JOIN ".$this->getTypeFieldTable(). " AS tft )"
				."  JOIN ".$this->getGroupFieldsTable(). " AS gft"
				." WHERE ft.lang_code = '".getLanguage()."'"
				."	 AND ft.type_field = tft.type_field"
				."   AND ft.id_common = gft.id_field"
				."   AND gft.idst IN ('".implode("','", $arr_idst)."')"
				." GROUP BY ft.id_common "
				." ORDER BY ft.sequence, gft.idst, gft.id_field";

		$play_txt = '';
		$re_fields = mysql_query($query);
		echo doDebug($query);
		while(list($id_common, $type_field, $type_file, $type_class, $mandatory) = mysql_fetch_row($re_fields)) {

			require_once($GLOBALS['where_framework'].'/modules/field/'.$type_file);
			$quest_obj = eval("return new $type_class( $id_common );");
			if( $this->field_entry_table !== FALSE )
				$quest_obj->setFieldEntryTable($this->field_entry_table);
			$play_txt .= $quest_obj->play( $idst_user, $freeze, $this->_mandatoryField($mandatory) );
		}
		return $play_txt;
	}

} */

?>
