<?php

/************************************************************************/
/* DOCEBO LMS - Learning managment system									*/
/* ============================================							*/
/*																			*/
/* Copyright (c) 2005														*/
/* http://www.docebo.com													*/
/*																			*/
/* This program is free software. You can redistribute it and/or modify	*/
/* it under the terms of the GNU General Public License as published by	*/
/* the Free Software Foundation; either version 2 of the License.		*/
/************************************************************************/

/**
 * @version  $Id: class.report_delay_two.php 113 2006-03-08 18:08:42Z ema $
 * @author	 Fabio Pirovano <fabio [at] docebo [dot] com>
 */

require_once($GLOBALS['where_lms'].'/admin/modules/report/class.report.php');
require_once($GLOBALS['where_lms'].'/lib/lib.course.php');

class Report_DelayTwo extends Report {
	
	var $lang;
	
	function Report_DelayTwo($id_report) {
		$this->lang =& DoceboLanguage::createInstance('ru_report');
		parent::Report($id_report);
	}
	
	function play($jump_url, $back_url) {
		
		$lang =& DoceboLanguage::createInstance('report');
		
		$page_title = getTitleArea(array(
			str_replace('&', '&amp;', $back_url) => $lang->def('_REPORT'),
			$this->report_name
		), 'report', $lang->def('_ALT_REPORT'));
		
		// choose the action to perform
		if(isset($_POST['cancelselector'])) {
			
			jumpTo($back_url);
		} elseif(isset($_POST['okselector'])) {
			
			$GLOBALS['page']->add(
				$page_title
				.'<div class="std_block">'
				.getBackUi(str_replace('&', '&amp;', $back_url), $lang->def('_BACK')), 'content');
			$this->show_report($jump_url);
			$GLOBALS['page']->add('</div>', 'content');
		} elseif(isset($_POST['export_cvs'])) {
			
			$this->exportAsCvs();
			
		} else {
			
			// first step load selector 
			require_once($GLOBALS['where_framework'].'/class.module/class.directory.php');
			
			$aclManager = new DoceboACLManager();
			$user_select = new Module_Directory();
			
			$user_select->show_user_selector = TRUE;
			$user_select->show_group_selector = TRUE;
			$user_select->show_orgchart_selector = TRUE;
			$user_select->show_orgchart_simple_selector = FALSE;
			$user_select->multi_choice = TRUE;
			
			$user_select->setPageTitle($page_title);
			$user_select->loadSelector(str_replace('&', '&amp;', $jump_url), 
					false, 
					$lang->def('_CHOOSE_USER_FOR_REPORT'), 
					true, 
					true );
			
		}
	}
	function show_report($jump_url) {
		
		require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
		require_once($GLOBALS['where_framework'].'/class.module/class.directory.php');
		
		$GLOBALS['page']->add(
			"\n".'<link href="'.getPathTemplate('lms').'style/report/style_report_delay.css" rel="stylesheet" type="text/css" />'."\n"
		, 'page_head');
		
		$lang =& DoceboLanguage::createInstance('rd2_report');
		
		$acl_man 		= new DoceboACLManager();
		$course_man 	= new Man_Course();
		
		$user_select 	= new Module_Directory();
		$elem_selected 	= $user_select->getSelection($_POST);
		$user_selected 	=& $acl_man->getAllUsersFromIdst($elem_selected);
		
		if(empty($user_selected)) {
			
			$GLOBALS['page']->add($lang->def('_NULL_SELECTION'), 'content');
			return;
		}
		$users_info =& $acl_man->getUsers($user_selected);
		
		// Retrive all the course
		$course =& $course_man->getAllCoursesWithMoreInfo();
		if(empty($course)) {
			
			$GLOBALS['page']->add($lang->def('_NULL_COURSE_SELECTION'), 'content');
			return;
		}
		
		// Export as cvs
		$GLOBALS['page']->add(
			Form::openForm('export', ereg_replace('&', '&amp;', $jump_url))
			.Form::openElementSpace('text_withborder')
			.Form::getHidden('user_selected', 'user_selected', urlencode(serialize($user_selected)))
			.form::getButton('export_cvs', 'export_cvs', $lang->def('_CSVEXPORT'), 'export_cvs')
			.Form::closeElementSpace()
			.Form::closeForm()
		, 'content');
		
		// Table
		$GLOBALS['page']->add(
			'<table class="report_table" summary="'.$lang->def('_RD2_SUMMAMRY_MANAGMENT').'">'
			.'<caption>'.$lang->def('_RD2_CAPTION').'</caption>'
			.'<thead>'
			.'<tr>'."\n\t"
				.'<th colspan="2">'.$lang->def('_TH_COURSE').'</th>'."\n\t"
				.'<th colspan="2">'.$lang->def('_TH_USER').'</th>'."\n"
				.'<th>'.$lang->def('_TH_TIMESTD').'</th>'."\n\t"
				.'<th>'.$lang->def('_TH_TIME_LATE').'</th>'."\n\t"
				.'<th rowspan="2" class="image">'.$lang->def('_TH_RISK_LEVEL').'</th>'."\n\t"
			.'</tr>'
			.'<tr>'."\n\t"
				.'<th>'.$lang->def('_TH_CODE_COURSE').'</th>'."\n\t"
				.'<th>'.$lang->def('_TH_NAME_COURSE').'</th>'."\n\t"
				.'<th>'.$lang->def('_TH_CODE_USER').'</th>'."\n\t"
				.'<th>'.$lang->def('_TH_NAME_USER').'</th>'."\n\t"
				.'<th class="image">'.$lang->def('_TH_NUM_WEEK').'</th>'."\n\t"
				.'<th class="image">'.$lang->def('_TH_NUM_WEEK').'</th>'."\n\t"
			.'</tr>'
			.'</thead>'."\n\n"
			.'<tbody>'
		, 'content');
		
		// find some information
		$i = 0;
		$avg_medium_time = $avg_effective_time = $avg_risk_lv = 0;
		$now = time();
		$re_time = mysql_query("
		SELECT idUser, idCourse, status, UNIX_TIMESTAMP(date_inscr), UNIX_TIMESTAMP(date_first_access), UNIX_TIMESTAMP(date_complete)
		FROM ".$GLOBALS['prefix_lms']."_courseuser 
		WHERE idUser IN (".implode(',', $user_selected).") 
		ORDER BY idCourse");
		while(list($id_user, $id_course, $user_status, $d_iscr, $d_first, $d_complete) = mysql_fetch_row($re_time)) {
			
			$medium_time = $course[$id_course]['mediumTime'];
			if($d_complete === NULL) {
				//not complete
				//late is difference between iscr and now
				$day_late = (int)(($now - $d_iscr) / 86400) - $medium_time;
			} else {
				//complete
				//late is difference between iscr and complete
				$day_late = (int)(($d_complete - $d_iscr) / 86400) - $medium_time;
			}
			$avg_medium_time += $medium_time ; 
			$avg_effective_time += $day_late;
			
			$row = '<tr class="row'.( ++$i%2 ? '' : '-col' ).'">'."\n"
				.'<td>'.$course[$id_course]['code'].'</td>'."\n\t"
				.'<td>'.$course[$id_course]['name'].'</td>'."\n\t"
				.'<td>'.$acl_man->relativeId($users_info[$id_user][ACL_INFO_USERID]).'</td>'."\n\t"
				.'<td>'.$users_info[$id_user][ACL_INFO_FIRSTNAME].' '.$users_info[$id_user][ACL_INFO_LASTNAME].'</td>'."\n\t"
				.'<td class="image">'.number_format( ($medium_time / 7), 2, '.', '').' ('.$medium_time.' gg)'.'</td>'."\n\t"
				.'<td class="image">'.number_format( ($day_late / 7), 2, '.', '').' ('.$day_late.' gg)'.'</td>'."\n\t"
				.'<td class="image">';
			//risk level
			if( $day_late < 30 ) {
				$row .= 1;
				$avg_risk_lv += 1;
			}
			elseif( $day_late < 60 ) {
				$row .= 2;
				$avg_risk_lv += 2;
			}
			else {
				$row .= 3;
				$avg_risk_lv += 3;
			}
			$row .= '</td>'."\n\t";
			$row .= '</tr>'."\n";
				
			$GLOBALS['page']->add( $row, 'content');
		}
		$GLOBALS['page']->add('<tr class="total">'."\n\t"
				.'<td colspan="4">'.$lang->def('_AVERANGE').'</td>'."\n\t"
				.'<td class="image">'.($i ? number_format( ($avg_medium_time / (7 * $i) ), 2, '.', '') : '&nbsp;' ).'</td>'
				.'<td class="image">'.($i ? number_format( ($avg_effective_time / (7 * $i) ), 2, '.', '') : '&nbsp;' ).'</td>'
				.'<td class="image">'.($i ? number_format( ($avg_risk_lv / $i ), 2, '.', '') : '&nbsp;' ).'</td>'
			.'</tr>'
			.'</thead>'."\n\n"
			.'<tbody>'
		, 'content');
		
		$GLOBALS['page']->add( 
			'</tbody>'
			.'</table>', 'content');
	}
	
	function exportAsCvs() {
		
		ob_end_clean();
		//content type forcing dowlad
		header("Content-type: application/download\n");
		//cache control
		header("Cache-control: private");
		//sending creation time
		header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
		//content type
		header('Content-Disposition: attachment; filename="report_delay2 '.gmdate('d-m-Y H i s').'.csv"');
		
		require_once($GLOBALS['where_framework'].'/class.module/class.directory.php');
		require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
		
		$lang =& DoceboLanguage::createInstance('rd2_report');
		
		$acl_man 		= new DoceboACLManager();
		$course_man 	= new Man_Course();
		
		$user_selected = unserialize(urldecode($_POST['user_selected']));
		
		if(empty($user_selected)) exit();
		$users_info =& $acl_man->getUsers($user_selected);
		
		// Retrive all the course
		$course =& $course_man->getAllCoursesWithMoreInfo();
		if(empty($course)) exit;
		
		// Table
		echo $lang->def('_RD2_CAPTION')."\n\n";
		
		echo strip_tags($lang->def('_TH_COURSE').';;'
				.$lang->def('_TH_USER').';;'
				.$lang->def('_TH_TIMESTD').';'
				.$lang->def('_TH_TIME_LATE').';'
				.$lang->def('_TH_RISK_LEVEL')
			."\n"
				.$lang->def('_TH_CODE_COURSE').';'
				.$lang->def('_TH_NAME_COURSE').';'
				.$lang->def('_TH_CODE_USER').';'
				.$lang->def('_TH_NAME_USER').';'
				.$lang->def('_TH_NUM_WEEK').';'
				.$lang->def('_TH_NUM_WEEK').';'
			."\n");
		
		// find some information
		$i = 0;
		$avg_medium_time = $avg_effective_time = $avg_risk_lv = 0;
		$now = time();
		$re_time = mysql_query("
		SELECT idUser, idCourse, status, UNIX_TIMESTAMP(date_inscr), UNIX_TIMESTAMP(date_first_access), UNIX_TIMESTAMP(date_complete)
		FROM ".$GLOBALS['prefix_lms']."_courseuser 
		WHERE idUser IN (".implode(',', $user_selected).") 
		ORDER BY idCourse");
		while(list($id_user, $id_course, $user_status, $d_iscr, $d_first, $d_complete) = mysql_fetch_row($re_time)) {
			
			$medium_time = $course[$id_course]['mediumTime'];
			if($d_complete === NULL) {
				//not complete
				//late is difference between iscr and now
				$day_late = (int)(($now - $d_iscr) / 86400) - $medium_time;
			} else {
				//complete
				//late is difference between iscr and complete
				$day_late = (int)(($d_complete - $d_iscr) / 86400) - $medium_time;
			}
			$avg_medium_time += $medium_time ; 
			$avg_effective_time += $day_late;
			
			$row = ereg_replace(';', '', $course[$id_course]['code']).';'
				.ereg_replace(';', '', $course[$id_course]['name']).';'
				.ereg_replace(';', '', $acl_man->relativeId($users_info[$id_user][ACL_INFO_USERID])).';'
				.ereg_replace(';', '', $users_info[$id_user][ACL_INFO_FIRSTNAME].' '.$users_info[$id_user][ACL_INFO_LASTNAME]).';'
				.number_format( ($medium_time / 7), 2, '.', '').' ('.$medium_time.' gg)'.';'
				.number_format( ($day_late / 7), 2, '.', '').' ('.$day_late.' gg)'.';';
			//risk level
			if( $day_late < 30 ) {
				$row .= 1;
				$avg_risk_lv += 1;
			}
			elseif( $day_late < 60 ) {
				$row .= 2;
				$avg_risk_lv += 2;
			}
			else {
				$row .= 3;
				$avg_risk_lv += 3;
			}
			echo $row."\n";
			$i++;
		}
		echo $lang->def('_AVERANGE').';;;'
				.($i ? number_format( ($avg_medium_time / (7 * $i) ), 2, '.', '') : '' ).';'
				.($i ? number_format( ($avg_effective_time / (7 * $i) ), 2, '.', '') : '' ).';'
				.($i ? number_format( ($avg_risk_lv / $i ), 2, '.', '') : '' );
		
		exit();
	}
}

?>