<?php

/************************************************************************/
/* DOCEBO LMS - Learning managment system								*/
/* ============================================							*/
/*																		*/
/* Copyright (c) 2005													*/
/* http://www.docebo.com												*/
/*																		*/
/* This program is free software. You can redistribute it and/or modify	*/
/* it under the terms of the GNU General Public License as published by	*/
/* the Free Software Foundation; either version 2 of the License.		*/
/************************************************************************/

/**
 * @package  DoceboLms
 * @subpackage course
 * @version  $Id: subscribe.php 446 2006-06-17 07:23:27Z fabio $
 * @author	 Fabio Pirovano <fabio[at]docebo-com>
 */

require_once($GLOBALS['where_lms'].'/lib/lib.levels.php');

function subscribeadd() {
	checkPerm('subscribe', false, 'course');
	
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_framework'].'/class.module/class.directory.php');
	
	$id_course = importVar('id_course', true, 0);
	
	$lang =& DoceboLanguage::CreateInstance('subscribe', 'lms');
	$out =& $GLOBALS['page'];
	
	$user_select = new Module_Directory();
	$user_select->show_user_selector = TRUE;
	$user_select->show_group_selector = TRUE;
	$user_select->show_orgchart_selector = TRUE;
	$user_select->show_orgchart_simple_selector = TRUE;
	if(isset($_GET['load'])) {
		// ema -- add requested_tab to show user selector
		$user_select->requested_tab = PEOPLEVIEW_TAB;
		$user_alredy_subscribed = getSubscribed($id_course);
		$user_select->resetSelection($user_alredy_subscribed);
	}
	$user_select->loadSelector('index.php?modname=subscribe&amp;op=subscribeadd&amp;id_course='.$id_course.'&amp;jump=1', 
			$lang->def('_SUBSCRIBE'), 
			$lang->def('_CHOOSE_SUBSCRIBE'), 
			true, 
			true );
	
}

function chooselevel() {
	checkPerm('subscribe', false, 'course');
	
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.newtypeone.php');
	require_once($GLOBALS['where_framework'].'/class.module/class.directory.php');
	
	$id_course 		= importVar('id_course', true, 0);
	$course_info 	= Man_Course::getCourseInfo($id_course);
	
	$out 			=& $GLOBALS['page'];
	$acl_man		=& $GLOBALS['current_user']->getAclManager();
	$lang 			=& DoceboLanguage::CreateInstance('subscribe', 'lms');
	$levels 		= CourseLevel::getLevels();
	
	// Find limitation
	$can_subscribe = true;
	$max_num_subscribe 	= $course_info['max_num_subscribe'];
	$subscribe_method 	= $course_info['subscribe_method'];
	if($GLOBALS['current_user']->getUserLevelId() != ADMIN_GROUP_GODADMIN) {
		
		$limited_subscribe = $GLOBALS['current_user']->preference->getPreference('admin_rules.limit_course_subscribe');
		$max_subscribe 		= $GLOBALS['current_user']->preference->getPreference('admin_rules.max_course_subscribe');
		$direct_subscribe 	= $GLOBALS['current_user']->preference->getPreference('admin_rules.direct_course_subscribe');
		
		if($limited_subscribe == 'on') $limited_subscribe = true;
		else $limited_subscribe = false;
		if($direct_subscribe == 'on') $direct_subscribe = true;
		else $direct_subscribe = false;
	} else {
		
		$limited_subscribe 	= false;
		$max_subscribe 		= 0 ;
		$direct_subscribe 	= true;
	}
	
	// Print page
	$page_title = array(
		'index.php?modname=course&amp;op=course_list' => $lang->def('_COURSES'),
		$lang->def('_SUBSCRIBE'), 
		$course_info['name']
	);
	$GLOBALS['page']->add(
		getTitleArea($page_title, 'subscribe')
		.'<div class="std_block">'
		.getBackUi('index.php?modname=course&amp;op=course_list', $lang->def('_BACK'))
	, 'content');
	// User selected
	$user_alredy_subscribed 	= getSubscribed($id_course);
	$num_all_user = count($user_alredy_subscribed);
	
	if(!isset($_POST['user_level_sel'])) {
		
		$user_select 	= new Module_Directory();
		$entity_selected 	= $user_select->getSelection($_POST);
		// convert to user only
		
		$user_selected =& $acl_man->getAllUsersFromIdst($entity_selected);
		
		$user_selected = array_diff($user_selected, $user_alredy_subscribed);
		$num_selected = count($user_selected);
	} else {
		
		$num_selected = 0;
		$user_selected = array();
		while(list($id_user, $lv) = each($_POST['user_level_sel'])) {
			
			$user_selected[$id_user] = $id_user;
			if($lv != 0) $num_selected++;
		}
		reset($_POST['user_level_sel']);
	}
	$user_selected_info =& $acl_man->getUsers($user_selected);
	
	if($num_selected == 0) {
		$GLOBALS['page']->add($lang->def('_SELECTION_EMPTY').'</div>', 'content');
		return;
	}
	// Report error and limitation
	$free_space = $max_num_subscribe - $num_all_user;
	if($max_num_subscribe != 0 && $free_space <= 0) {
		$GLOBALS['page']->add(getResultUi($lang->def('_COURSELIMITREACHED').'</div>'), 'content');
		$can_subscribe = false;
		return;
	}
	
	if(($limited_subscribe && $max_num_subscribe != 0 && $max_subscribe < $free_space) || ($limited_subscribe && $max_num_subscribe == 0)) {
		
		$GLOBALS['page']->add(getResultUi(str_replace('[user_subscribe_limit]', ''.$max_subscribe, $lang->def('_YOUCANSUBSCRIBE')).'<br />'), 'content');
		if($num_selected > $max_subscribe) $can_subscribe = false;
	} elseif($max_num_subscribe != 0) {
		
		if($free_space < $num_selected) {
			
			$GLOBALS['page']->add(getResultUi(str_replace('[max_subscribe]', ''.$free_space, $lang->def('_EMPTYSPACE')).'<br />'), 'content');
			$can_subscribe = false;
		}
	}
	if($subscribe_method != 3 && !$direct_subscribe) 
		$GLOBALS['page']->add(getResultUi($lang->def('_BEFORE_THIS_APPROVE').'<br />'), 'content');
	
	if(isset($_POST['subscribe']) && $can_subscribe) {
		// do subscription
		
		//retrive id of group of the course for the varioud level
		$level_idst =& getCourseLevel($id_course);
		if(count($level_idst) == 0) {
			
			//if the group doesn't exists create it
			$level_idst =& createCourseLevel($id_course);
		}
		// Subscirbing user
		$waiting = 0;
		$user_subscribed = array();
		$user_waiting = array();
		if($subscribe_method != 3 && !$direct_subscribe) $waiting = 1;
		while(list($id_user, $lv_sel) = each($_POST['user_level_sel'])) {
			
			if($lv_sel != 0) {
				
				// Add in group for permission
				$acl_man->addToGroup($level_idst[$lv_sel], $id_user);
				
				// Add in table
				$re = mysql_query("
				INSERT INTO ".$GLOBALS['prefix_lms']."_courseuser 
				( idUser, idCourse, level, waiting, subscribed_by, date_inscr ) 
				VALUES 
				( '".$id_user."', '".$id_course."', '".$lv_sel."', '".$waiting."', '".getLogUserId()."', '".date("Y-m-d H:i:s")."' )	");
				if($re) {
					if($waiting) $user_waiting[] = $id_user;
					else $user_subscribed[] = $id_user;
				}
			}
		}
		$GLOBALS['current_user']->loadUserSectionST('/lms/course/private/');
		$GLOBALS['current_user']->SaveInSession();
	
		require_once($GLOBALS['where_framework'].'/lib/lib.eventmanager.php');
		$array_subst = array(	'[url]' => $GLOBALS['lms']['url'],
								'[course]' => $course_info['name'] );
		if(!empty($user_subscribed)) {
			// message to user that is waiting 
			$msg_composer = new EventMessageComposer('subscribe', 'lms');
			
			$msg_composer->setSubjectLangText('email', '_NEW_USER_SUBSCRIBED_SUBJECT', false);
			$msg_composer->setBodyLangText('email', '_NEW_USER_SUBSCRIBED_TEXT', $array_subst);
			
			$msg_composer->setSubjectLangText('sms', '_NEW_USER_SUBSCRIBED_SUBJECT_SMS', false);
			$msg_composer->setBodyLangText('sms', '_NEW_USER_SUBSCRIBED_TEXT_SMS', $array_subst);
			
			// send message to the user subscribed
			createNewAlert(	'UserCourseInserted', 'subscribe', 'insert', '1', 'User subscribed',
						$user_subscribed, $msg_composer  );
								
		}
		if(!empty($user_waiting)) {
			// message to user that is waiting 
			$msg_composer = new EventMessageComposer('subscribe', 'lms');
			
			$msg_composer->setSubjectLangText('email', '_NEW_USER_SUBS_WAITING_SUBJECT', false);
			$msg_composer->setBodyLangText('email', '_NEW_USER_SUBS_WAITING_TEXT', $array_subst);
			
			$msg_composer->setSubjectLangText('sms', '_NEW_USER_SUBS_WAITING_SUBJECT_SMS', false);
			$msg_composer->setBodyLangText('sms', '_NEW_USER_SUBS_WAITING_TEXT_SMS', $array_subst);
			
			// send message to the user subscribed
			createNewAlert(	'UserCourseInsertModerate', 'subscribe', 'insert', '1', 'User subscribed with moderation',
						$user_waiting, $msg_composer  );
		}
		
		if($GLOBALS['current_user']->getUserLevelId() != ADMIN_GROUP_GODADMIN) {
			$GLOBALS['current_user']->preference->setPreference('admin_rules.max_course_subscribe', ($max_subscribe - $num_selected));
		}
		backcourse('ok');
	}
	
	$GLOBALS['page']->add(
		Form::openForm('levelselection', 'index.php?modname=subscribe&amp;op=chooselevel')
		.Form::getHidden('id_course', 'id_course', $id_course)
	, 'content');
	
	$tb = new TypeOne( 0, $lang->def('_CAPTION_SELECT_LEVELS'), $lang->def('_SUMMARY_SELECT_LEVEL') );
	$type_h = array('', '');
	$content_h = array($lang->def('_USERNAME'), $lang->def('_FIRST_NAME_LAST_NAME'));
	foreach($levels as $lv => $lv_name) {
		$type_h[]	 = 'image';
		$content_h[] = $lv_name;
	}
	$type_h[]	 = 'image';
	$content_h[] = $lang->def('_NOSUBSCRIBE');
	$tb->addHead($content_h, $type_h);
	
	$num_user_sel = 0;
	$enought_credit = true;
	reset($user_selected_info);
	while( (list($id_user, $user_info) = each($user_selected_info)) && ($enought_credit)) {
		
		// if the user isn't alredy subscribed to the course
		if(!isset($user_alredy_subscribed[$id_user])) {
			
			$content = array(	substr($user_info[ACL_INFO_USERID], 1), 
								$user_info[ACL_INFO_LASTNAME].' '.$user_info[ACL_INFO_FIRSTNAME]);
			foreach($levels as $lv => $lv_name) {
				
				$content[] = Form::getInputRadio(	'user_level_sel_'.$id_user.'_'.$lv, 
													'user_level_sel['.$id_user.']', 
													$lv, 
													( isset($_POST['user_level_sel']) ? $lv == $_POST['user_level_sel'][$id_user] : $lv == 3 ), 
													'' )
							.'<label class="access-only" for="user_level_sel_'.$id_user.'_'.$lv.'">'.$lv_name.'</label>';
			}
			$content[] = Form::getInputRadio(	'user_level_sel_'.$id_user.'_0', 
													'user_level_sel['.$id_user.']', 
													0, 
													( isset($_POST['user_level_sel']) ? 0 == $_POST['user_level_sel'][$id_user] : false ), 
													'' )
							.'<label class="access-only" for="user_level_sel_'.$id_user.'_0">'.$lang->def('_NOSUBSCRIBE').'</label>';
			$tb->addBody($content);
			$num_user_sel++;
		}
	}
	$GLOBALS['page']->add($tb->getTable(), 'content');
	$GLOBALS['page']->add(
		Form::openButtonSpace()
		.'<br />'
		.Form::getButton('subscribe', 'subscribe', $lang->def('_SUBSCRIBE'))
		.Form::getButton('cancelselector', 'cancelselector', $lang->def('_UNDO'))
		.Form::closeButtonSpace()
		.Form::closeForm()
	, 'content');
	$GLOBALS['page']->add('</div>', 'content');
}

function backcourse($result = false) {
	
	jumpTo('index.php?modname=course&op=course_list'.( $result !== false ? '&result_subscribe='.$result : '' ) );
}

/******************************************************************************/

function subscribemod() {
	checkPerm('subscribe', false, 'course');
	
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.newtypeone.php');
	
	$id_course 		= importVar('id_course', true, 0);
	$course_info 	= Man_Course::getCourseInfo($id_course);
	
	$out 			=& $GLOBALS['page'];
	$lang 			=& DoceboLanguage::CreateInstance('subscribe', 'lms');
	$acl_man		=& $GLOBALS['current_user']->getAclManager();
	$levels 		= CourseLevel::getLevels();
	
	// Retrive info about the selected user
	$user_alredy_subscribed 	= getSubscribed($id_course, false, false, true);
	$user_levels 				= getSubscribedLevel($id_course);
	$user_selected_info 		=& $acl_man->getUsers($user_alredy_subscribed);
	
	$page_title = array(
		'index.php?modname=course&op=course_list' => $lang->def('_COURSES'),
		$course_info['name'] ,
		$lang->def('_SUBSCRIBE')
	);
	$GLOBALS['page']->add(
		getTitleArea($page_title, 'subscribe')
		.'<div class="std_block">'
		.Form::openForm('levelselection', 'index.php?modname=subscribe&amp;op=subscribeupdate')
		.Form::getHidden('id_course', 'id_course', $id_course)
		, 'content');
	
	$tb 	= new TypeOne( 0, $lang->def('_CAPTION_SELECT_LEVELS'), $lang->def('_SUMMARY_SELECT_LEVEL') );
	
	$type_h = array('', '');
	$content_h = array($lang->def('_USERNAME'), $lang->def('_FIRST_NAME_LAST_NAME'));
	foreach($levels as $lv => $lv_name) {
		$type_h[]	 = 'image';
		$content_h[] = $lv_name;
	}
	$tb->addHead($content_h, $type_h);
	
	$num_user_sel = 0;
	if(is_array($user_selected_info)) {
			
		reset($user_selected_info);
		while( (list($id_user, $user_info) = each($user_selected_info))) {
			
			// if the user isn't alredy subscribed to the course
			$content = array(	substr($user_info[ACL_INFO_USERID], 1), 
								$user_info[ACL_INFO_LASTNAME].' '.$user_info[ACL_INFO_FIRSTNAME]);
			foreach($levels as $lv => $lv_name) {
				
				$content[] = Form::getInputRadio(	'user_level_sel_'.$id_user.'_'.$lv, 
													'user_level_sel['.$id_user.']', 
													$lv, 
													($lv == $user_levels[$id_user]), 
													'' )
							.'<label class="access-only" for="user_level_sel_'.$id_user.'_'.$lv.'">'.$lv_name.'</label>';
			}
			$tb->addBody($content);
		}
		$GLOBALS['page']->add($tb->getTable(), 'content');
	}
	$GLOBALS['page']->add(
		Form::openButtonSpace()
		.'<br />'
		.Form::getButton('subscribe', 'subscribe', $lang->def('_MOD_SUBSCRIBE'))
		.Form::getButton('cancelselector', 'cancelselector', $lang->def('_UNDO'))
		.Form::closeButtonSpace()
		.Form::closeForm()
	, 'content');
	$GLOBALS['page']->add('</div>', 'content');
}

function subscribeupdate() {
	checkPerm('subscribe', false, 'course');
	
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	
	$id_course = importVar('id_course', true, 0);
	$course_info 	= Man_Course::getCourseInfo($id_course);
	
	$lang =& DoceboLanguage::CreateInstance('subscribe', 'lms');
	$out =& $GLOBALS['page'];
	$acl_man	=& $GLOBALS['current_user']->getAclManager();
	
	if(!isset($_POST['user_level_sel'])) {
		
		//the user selection is empty, return to course selection
		backcourse('err_1');
	}
	//retrive id of group of the course for the various level
	$level_idst =& getCourseLevel($id_course);
	$actual_user_level = getSubscribedLevel($id_course);
	if(count($level_idst) == 0) {
		
		//if the group doesn't exists create it
		$level_idst =& createCourseLevel($id_course);
	}
	// Subscirbing user
	$re = true;
	$user_subs = array();
	while(list($id_user, $lv_sel) = each($_POST['user_level_sel'])) {
		
		$lv_old = $actual_user_level[$id_user];
		
		if($lv_sel != $lv_old) {
			
			// Add in group for permission
			$acl_man->removeFromGroup($level_idst[$lv_old], $id_user);
			$acl_man->addToGroup($level_idst[$lv_sel], $id_user);
			
			// Add in table
			$re_sing = mysql_query("
			UPDATE ".$GLOBALS['prefix_lms']."_courseuser 
			SET level = '".$lv_sel."' 
			WHERE idUser = '".$id_user."' AND 
					idCourse = '".$id_course."'");
			if($re_sing) $user_subs[] = $id_user;
			$re &= $re_sing;
		}
	}
	
	$GLOBALS['current_user']->loadUserSectionST('/lms/course/private/');
	$GLOBALS['current_user']->SaveInSession();
	
	require_once($GLOBALS['where_framework'].'/lib/lib.eventmanager.php');
	$array_subst = array(	'[url]' => $GLOBALS['lms']['url'],
							'[course]' => $course_info['name'] );
	if(!empty($user_subs)) {
		// message to user that is waiting 
		$msg_composer = new EventMessageComposer('subscribe', 'lms');
		
		$msg_composer->setSubjectLangText('email', '_MOD_USER_SUBSCRIPTION_SUBJECT', false);
		$msg_composer->setBodyLangText('email', '_MOD_USER_SUBSCRIPTION_TEXT', $array_subst);
		
		$msg_composer->setSubjectLangText('sms', '_MOD_USER_SUBSCRIPTION_SUBJECT_SMS', false);
		$msg_composer->setBodyLangText('sms', '_MOD_USER_SUBSCRIPTION_TEXT_SMS', $array_subst);
		
		// send message to the user subscribed
		createNewAlert(	'UserCourseLevelChanged', 'subscribe', 'modify', '1', 'User subscribed',
					$user_subs, $msg_composer  );
							
	}
	backcourse( ( $re ? 'ok' : 'err_2' ) );
}

/************************************************************************************/

function subscribedel() {
	checkPerm('subscribe', false, 'course');
	
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.newtypeone.php');
	
	$id_course 			= importVar('id_course', true, 0);
	$course_to_save 	= Man_Course::saveCourseStatus();
	
	$out 			=& $GLOBALS['page'];
	$lang 			=& DoceboLanguage::CreateInstance('subscribe', 'lms');
	$acl_man		=& $GLOBALS['current_user']->getAclManager();
	$levels 		= CourseLevel::getLevels();
	
	$user_alredy_subscribed	= getSubscribed($id_course, false, false, true);
	$user_levels 				= getSubscribedLevel($id_course);
	
	$user_selected_info =& $acl_man->getUsers($user_alredy_subscribed);
	
	$GLOBALS['page']->add(
		getTitleArea($lang->def('_SUBSCRIBE'), 'subscribe')
		.'<div class="std_block">'
		.Form::openForm('levelselection', 'index.php?modname=subscribe&amp;op=subscriberemove')
		.Form::getHidden('id_course', 'id_course', $id_course)
		, 'content');
	
	$tb 	= new TypeOne( 0, $lang->def('_CAPTION_SELECT_LEVELS'), $lang->def('_SUMMARY_SELECT_LEVEL') );
	
	$type_h = array('', '', '', 'image');
	$content_h = array($lang->def('_USERNAME'), $lang->def('_FIRST_NAME_LAST_NAME'), $lang->def('_LEVEL_NAME'),
				'<img src="'.getPathImage().'standard/rem.gif" alt="'.$lang->def('_ALT_DEL').'">');
	
	$tb->addHead($content_h, $type_h);
	
	$num_user_sel = 0;
	if(is_array($user_selected_info)) {
		
		reset($user_selected_info);
		while( (list($id_user, $user_info) = each($user_selected_info))) {
			
			// if the user isn't alredy subscribed to the course
			$content = array(	substr($user_info[ACL_INFO_USERID], 1), 
								$user_info[ACL_INFO_LASTNAME].' '.$user_info[ACL_INFO_FIRSTNAME],
								$levels[$user_levels[$id_user]],
								$content[] = Form::getInputCheckbox('user_to_remove'.$id_user, 
													'user_to_remove['.$id_user.']', 
													$id_user, 
													false, 
													'' )
							.'<label class="access-only" for="user_to_remove'.$id_user.'">'.$user_info[ACL_INFO_USERID].'</label>');
			
			$tb->addBody($content);
		}
		$GLOBALS['page']->add($tb->getTable(), 'content');
	}
	$GLOBALS['page']->add(
		Form::openButtonSpace()
		.'<br />'
		.Form::getButton('subscribe', 'subscribe', $lang->def('_DEL_SUBSCRIBE'))
		.Form::getButton('cancelselector', 'cancelselector', $lang->def('_UNDO'))
		.Form::closeButtonSpace()
		.Form::closeForm()
	, 'content');
	$GLOBALS['page']->add('</div>', 'content');
}

function subscriberemove() {
	checkPerm('subscribe', false, 'course');
	
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	
	$id_course = importVar('id_course', true, 0);
	$course_info 	= Man_Course::getCourseInfo($id_course);
	
	$lang =& DoceboLanguage::CreateInstance('subscribe', 'lms');
	$out =& $GLOBALS['page'];
	$acl_man	=& $GLOBALS['current_user']->getAclManager();
	
	if(!isset($_POST['user_to_remove'])) {
		
		//the user selection is empty, return to course selection
		backcourse(true);
	}
	
	$group_levels 	= getCourseLevel($id_course);
	$user_levels 	= getSubscribedLevel($id_course);
	// Subscirbing user
	$re = true;
	$user_del = array();
	while(list($id_user, $v) = each($_POST['user_to_remove'])) {
		
		
		$re_sing = removeSubscription($id_course, $id_user, $group_levels[$user_levels[$id_user]]);
		if($re_sing) $user_del[] = $id_user;
		$re &= $re_sing;
	}
	
		require_once($GLOBALS['where_framework'].'/lib/lib.eventmanager.php');
	$array_subst = array(	'[url]' => $GLOBALS['lms']['url'],
							'[course]' => $course_info['name'] );
	if(!empty($user_del)) {
		// message to user that is waiting 
		$msg_composer = new EventMessageComposer('subscribe', 'lms');
		
		$msg_composer->setSubjectLangText('email', '_DEL_USER_SUBSCRIPTION_SUBJECT', false);
		$msg_composer->setBodyLangText('email', '_DEL_USER_SUBSCRIPTION_TEXT', $array_subst);
		
		$msg_composer->setSubjectLangText('sms', '_DEL_USER_SUBSCRIPTION_SUBJECT_SMS', false);
		$msg_composer->setBodyLangText('sms', '_DEL_USER_SUBSCRIPTION_TEXT_SMS', $array_subst);
		
		// send message to the user subscribed
		createNewAlert(	'UserCourseRemoved', 'subscribe', 'remove', '1', 'User removed form a course',
					$user_del, $msg_composer  );
							
	}
	backcourse( ( $re ? 'ok_2' : 'err_2' ) );
}

/************************************************************************************/


function waitinguser() {
	checkPerm('moderate', false, 'course');
	
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.newtypeone.php');
	
	$id_course 		= importVar('id_course', true, 0);
	$man_course		= new Man_Course();
	$course_info 	= $man_course->getCourseInfo($id_course);
	
	$out 			=& $GLOBALS['page'];
	$lang 			=& DoceboLanguage::CreateInstance('admin_course_managment', 'lms');
	$lang 			=& DoceboLanguage::CreateInstance('subscribe', 'lms');
	$acl_man		=& $GLOBALS['current_user']->getAclManager();
	$levels 		= CourseLevel::getLevels();
	
	$waiting_users	=& $man_course->getWaitingSubscribed($id_course);
	$users_name =& $acl_man->getUsers($waiting_users['all_users_id']);
	
	$page_title = array(
		'index.php?modname=course&amp;op=course_ist' => $lang->def('_COURSE', 'admin_course_managment', 'lms'),
		$course_info['name'],
		$lang->def('_USERWAITING', 'admin_course_managment', 'lms')
	);
	$GLOBALS['page']->add(
		getTitleArea($page_title, 'subscribe')
		.'<div class="std_block">'
		.Form::openForm('approve users', 'index.php?modname=subscribe&amp;op=approveusers')
		.Form::getHidden('id_course', 'id_course', $id_course)
		, 'content');
	
	$tb 	= new TypeOne( 0, $lang->def('_SELECT_WHO_CONFIRM'), $lang->def('_SUMMARY_SELECT_WHO_CONFIRM') );
	
	$type_h = array('', '', '', '', 'image', 'image');
	$content_h = array($lang->def('_USERNAME'), $lang->def('_FIRST_NAME_LAST_NAME'), $lang->def('_LEVEL_NAME'),
		$lang->def('_SUBSCRIBED_BY'),
		$lang->def('_APPROVE'),
		$lang->def('_DENY')
	);
	$tb->addHead($content_h, $type_h);
	
	if(is_array($waiting_users['users_info'])) {
		
		reset($waiting_users['users_info']);
		while((list($id_user, $info) = each($waiting_users['users_info']))) {
			
			$id_sub_by = $info['subscribed_by'];
			$subscribed 	= ( $users_name[$id_sub_by][ACL_INFO_LASTNAME].''.$users_name[$id_sub_by][ACL_INFO_FIRSTNAME] != '' 
				? $users_name[$id_sub_by][ACL_INFO_LASTNAME].' '.$users_name[$id_sub_by][ACL_INFO_FIRSTNAME]
				: $acl_man->relativeId($users_name[$id_sub_by][ACL_INFO_USERID]) );
			$more = ( isset($_GET['id_user']) &&  $_GET['id_user'] == $id_user 
				? '<a href="index.php?modname=subscribe&amp;op=waitinguser&amp;id_course='.$id_course.'"><img src="'.getPathImage().'standard/less.gif"></a> '
				: '<a href="index.php?modname=subscribe&amp;op=waitinguser&amp;id_course='.$id_course.'&amp;id_user='.$id_user.'"><img src="'.getPathImage().'standard/more.gif"></a> ');
			$content = array(
				$more.
				$acl_man->relativeId($users_name[$id_user][ACL_INFO_USERID]),
				$users_name[$id_user][ACL_INFO_LASTNAME].' '.$users_name[$id_user][ACL_INFO_FIRSTNAME],
				$levels[$info['level']],
				$subscribed.' ['.$users_name[$id_user][ACL_INFO_EMAIL].']'
			);
			$content[] = Form::getInputCheckbox(
					'approve_user_'.$id_user, 
					'approve_user['.$id_user.']', 
					$id_user, 
					false, 
					'' ).'<label class="access-only" for="approve_user_'.$id_user.'">'.$users_name[$id_user][ACL_INFO_USERID].'</label>';
			
			$content[] = Form::getInputCheckbox(
					'deny_user_'.$id_user, 
					'deny_user['.$id_user.']', 
					$id_user, 
					false, 
					'' ).'<label class="access-only" for="deny_user_'.$id_user.'">'.$users_name[$id_user][ACL_INFO_USERID].'</label>';
			
			$tb->addBody($content);
			if (isset($_GET['id_user']) &&  $id_user == $_GET['id_user']) {
				$field = new FieldList();
				$tb->addBodyExpanded($field->playFieldsForUser( $id_user, false, true ), 'user_specific_info');
			}
		}
	}

	$GLOBALS['page']->add(
		$tb->getTable()
		.'<br />'
		.Form::openElementSpace()
		.Form::getSimpleTextarea($lang->def('_SUBSCRIBE_ACCEPT'), 'subscribe_accept', 'subscribe_accept') 
		.Form::getSimpleTextarea($lang->def('_SUBSCRIBE_REFUSE'), 'subscribe_refuse','subscribe_refuse')
		.Form::closeElementSpace()
		.Form::openButtonSpace()
		.'<br />'
		.Form::getButton('subscribe', 'subscribe', $lang->def('_SAVE'))
		.Form::getButton('cancelselector', 'cancelselector', $lang->def('_UNDO'))
		.Form::closeButtonSpace()
		.Form::closeForm()
	, 'content');
	$GLOBALS['page']->add('</div>', 'content');
}

function approveusers() {
	checkPerm('moderate', false, 'course');
	
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.preference.php');
	
	$id_course 		= importVar('id_course', true, 0);
	$course_info 	= Man_Course::getCourseInfo($id_course);
	
	$re= true;
	$approve_user 	= array();
	$deny_user 		= array();
	if(isset($_POST['approve_user'])) {
		
		while(list(, $id_user) = each($_POST['approve_user'])) {
			
			$text_query = "
			UPDATE ".$GLOBALS['prefix_lms']."_courseuser
			SET waiting = 0
			WHERE idCourse = '".$id_course."' AND idUser = '".$id_user."'";
			$result = mysql_query($text_query);
			if($result) $approve_user[] = $id_user;
			$re &= $result;
		}
	}
	if(isset($_POST['deny_user'])) {
		
		$man_course		= new Man_Course();
		$waiting_users	=& $man_course->getWaitingSubscribed($id_course);
		$tot_deny 		= array();
		$group_levels 	= getCourseLevel($id_course);
		
		while(list($id_user) = each($_POST['deny_user'])) {
			
			$level 		= $waiting_users['users_info'][$id_user]['level'];
			$sub_by 	= $waiting_users['users_info'][$id_user]['subscribed_by'];
			$result 	= removeSubscription($id_course, $id_user, $group_levels[$level]);
			if($sub_by != 0 && ($id_user != $sub_by)) {
				
				if(isset($tot_deny[$sub_by])) $tot_deny[$sub_by]++;
				else $tot_deny[$sub_by] = 1;
			}
			$result &= mysql_query($text_query);
			if($result) $deny_user[] = $id_user;
			$re &= $result;
		}
		//print_r($tot_deny);
		if(!empty($tot_deny)) {
			
			while(list($id_user, $inc) = each($tot_deny)) {
				
				$pref = new UserPreferences($id_user);
				$max_subscribe = $pref->getPreference('admin_rules.max_course_subscribe');
				$pref->setPreference('admin_rules.max_course_subscribe', ($max_subscribe + $inc));
			}
		}
	}
	require_once($GLOBALS['where_framework'].'/lib/lib.eventmanager.php');
	$array_subst = array(	'[url]' => $GLOBALS['lms']['url'],
							'[course]' => $course_info['name'] );
	if(!empty($approve_user)) {
		
		$msg_composer = new EventMessageComposer('subscribe', 'lms');
		
		$msg_composer->setSubjectLangText('email', '_APPROVED_SUBSCRIBED_SUBJECT', false);
		$msg_composer->setBodyLangText('email', '_APPROVED_SUBSCRIBED_TEXT', $array_subst);
		$msg_composer->setBodyLangText('email', "\n\n".$_POST['subscribe_accept'], array(), true);
		
		$msg_composer->setSubjectLangText('sms', '_APPROVED_SUBSCRIBED_SUBJECT_SMS', false);
		$msg_composer->setBodyLangText('sms', '_APPROVED_SUBSCRIBED_TEXT_SMS', $array_subst);
		
		// send message to the user subscribed
		createNewAlert(	'UserCourseInserted', 'subscribe', 'approve', '1', 'User course approve',
					$approve_user, $msg_composer, true );
							
	}
	if(!empty($deny_user)) {
		
		$msg_composer = new EventMessageComposer('subscribe', 'lms');
		
		$msg_composer->setSubjectLangText('email', '_DENY_SUBSCRIBED_SUBJECT', false);
		$msg_composer->setBodyLangText('email', '_DENY_SUBSCRIBED_TEXT', $array_subst);
		$msg_composer->setBodyLangText('email', "\n\n".$_POST['subscribe_deny'], array(), true);
		
		$msg_composer->setSubjectLangText('sms', '_DENY_SUBSCRIBED_SUBJECT_SMS', false);
		$msg_composer->setBodyLangText('sms', '_DENY_SUBSCRIBED_TEXT_SMS', $array_subst);
		
		// send message to the user subscribed
		createNewAlert(	'UserCourseInserted', 'subscribe', 'deny', '1', 'User course deny',
					$deny_user, $msg_composer, true );
	}
	backcourse( ( $re ? 'ok' : 'err' ) );

}

function removeSubscription($id_course, $id_user, $lv_group) {
	
	$acl_man =& $GLOBALS['current_user']->getAclManager();
	$acl_man->removeFromGroup($lv_group, $id_user);
	
	return mysql_query("
	DELETE FROM ".$GLOBALS['prefix_lms']."_courseuser 
	WHERE idUser = '".$id_user."' AND idCourse = '".$id_course."'");
}

/****************************************************************************************/

function subscribeDispatch($op) {
	
	if(isset($_POST['okselector'])) {
		$op = 'chooselevel';
	}
	if(isset($_POST['cancelselector'])) {
		$op = 'backcourse';
	}
	switch($op) {
		case "subscribeadd" : {
			subscribeadd();
		};break;
		case "chooselevel" : {
			chooselevel();
		};break;

		case "subscribemod" : {
			subscribemod();
		};break;
		case "subscribeupdate" : {
			subscribeupdate();
		};break;

		case "subscribedel" : {
			subscribedel();
		};break;
		case "subscriberemove" : {
			subscriberemove();
		};break;

		case "waitinguser" : {
			waitinguser();
		};break;
		case "approveusers" : {
			approveusers();
		};break;

		case "backcourse" : {
			backcourse();
		};break;
	}
}

?>
