<?php

/************************************************************************/
/* DOCEBO LMS - Learning Managment System                               */
/* ============================================                         */
/*                                                                      */
/* Copyright (c) 2004                                                   */
/* http://www.docebo.com                                                */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

if(!defined('IN_DOCEBO')) die('You cannot access this file directly');

/**
 * @package 	DoceboLMS
 * @category 	utilities
 * @author 		Fabio Pirovano <fabio@docebo.com>
 * @version 	$Id: lib.preoperation.php 446 2006-06-17 07:23:27Z fabio $
 */

// here control for sql injection

//save login password from modification
if( ($ldap_used == 'on') && isset($_POST['modname']) && ($_POST['modname'] == 'login') && isset($_POST['passIns'])) { 
	$password_login = $_POST['passIns'];
}

chkInput($_GET);
chkInput($_POST);
chkInput($_COOKIE);

if(!internalFirewall()) 
	die('Your ip address is not allowed on this site !');

require_once($GLOBALS['where_framework'].'/lib/lib.domxml.php');

if( ($ldap_used == 'on') && isset($_POST['modname']) && ($_POST['modname'] == 'login') && isset($_POST['passIns'])) { 
	$_POST['passIns'] = stripslashes($password_login);
}

$GLOBALS['modname'] = importVar('modname');
$GLOBALS['op'] 		= importVar('op');

// redirection
if( !isset($_GET['no_redirect']) && !isset($_POST['no_redirect']) ) {
	if( (!isset($GLOBALS['modname']) || ($GLOBALS['modname'] != 'login')) && $GLOBALS['current_user']->isAnonymous() ) {
		$GLOBALS['op'] 		= 'login';
		$GLOBALS['modname'] = 'login';
	}
}

if($GLOBALS['modname'] == '' && $GLOBALS['op'] == '' && !$GLOBALS['current_user']->isAnonymous() && !isset($_SESSION['idCourse'])) {
	$_SESSION['current_main_menu'] = '1';
	$_SESSION['sel_module_id'] = '1';
	$GLOBALS['modname'] = 'course';
	$GLOBALS['op'] 		= 'mycourses';
}

// ip control
if(isset($_GLOBALS['framework']['session_ip_control']) && $_GLOBALS['framework']['session_ip_control'] == 'on') {
	
	if($GLOBALS['current_user']->isLoggedIn() && ($GLOBALS['current_user']->getLogIp() != $_SERVER['REMOTE_ADDR'])) {
		echo "logip: ".$GLOBALS['current_user']->getLogIp()."\n";
		echo "addr: ".$_SERVER['REMOTE_ADDR']."\n";
		die('Ip incoerent!');
	}
}

if($GLOBALS['lms']['stop_concurrent_user'] == 'on') {

	if(!$GLOBALS['current_user']->isAnonymous() && isset($_SESSION['idCourse'])) {
		
		//two user logged at the same time
		require_once($GLOBALS['where_lms'].'/lib/lib.track_user.php');
		
		if(!TrackUser::checkSession(getLogUserId())) {
			
			TrackUser::resetUserSession(getLogUserId());
			
			$_SESSION = array();
			session_destroy();
			
			// Recreate Anonymous user
			$GLOBALS['current_user'] =& DoceboUser::createDoceboUserFromSession('public_area');
			$GLOBALS['logout'] 	= true;
			die('Two user logged at the same time with the same username'
				.'<br /><a href="index.php">Back to login</a>');
		}
	}
}


//operation that is needed before loading grafiphs element, menu and so on
switch($GLOBALS['op']) {
	
	//login control
	case "confirm" : {
		if($GLOBALS['modname'] == 'login') {
			
			require_once($GLOBALS['where_framework'].'/lib/lib.usermanager.php');
			$manager = new UserManager();
			$login_data = $manager->getLoginInfo();
			$manager->saveUserLoginData();
			
			if($login_data['userid'] != '') {
				
				$GLOBALS['current_user'] =& DoceboUser::createDoceboUserFromLogin( 	$login_data['userid'], 
																					$login_data['password'], 
																					'public_area', 
																					$login_data['lang'] );
				
				if( $GLOBALS['current_user'] === FALSE ) {
					$GLOBALS['current_user'] 	=& DoceboUser::createDoceboUserFromSession('public_area');
					$GLOBALS['access_fail'] 	= true;
					$GLOBALS['op'] 				= 'login';
					
				} else {
					
					//loading related ST
					$GLOBALS['current_user']->loadUserSectionST('/lms/course/public/');
					
					// perform other platfomrs login operation
					require_once($GLOBALS['where_framework'].'/lib/lib.platform.php');
					$pm =& PlatformManager::createInstance();
					$pm->doCommonOperations("login");
					
					$GLOBALS['current_user']->SaveInSession();
					
					if($GLOBALS['current_user']->isPasswordElapsed()) {
						// reset pwd
						jumpTo('index.php?modname=profile&op=renewalpwd');
					} else {
						jumpTo('index.php?modname=course&op=mycourses');
					}
					// end login
				}
			}
		}
	};break;
	case "logout" : {
		require_once($GLOBALS['where_lms'].'/lib/lib.track_user.php');
		
		if(!$GLOBALS['current_user']->isAnonymous() && isset($_SESSION['idCourse'])) {
		
			TrackUser::setActionTrack(getLogUserId(), $_SESSION['idCourse'], '', '');
		}
		if(!$GLOBALS['current_user']->isAnonymous()) {
			TrackUser::logoutSessionCourseTrack();
			$_SESSION = array();
			session_destroy();
			
			// load standard language module and put it global
			$glang =& DoceboLanguage::createInstance( 'standard', 'framework');
			$glang->setGlobal();
			
			// Recreate Anonymous user
			$GLOBALS['current_user'] =& DoceboUser::createDoceboUserFromSession('public_area');
			$GLOBALS['logout'] 	= true;
			
			require_once($GLOBALS['where_framework'].'/lib/lib.platform.php');
			$pm =& PlatformManager::createInstance();
			$pm->doCommonOperations("logout");
		}
		
		$GLOBALS['op'] 		= 'login';
		$GLOBALS['modname'] = 'login';
	};break;
	case "aula" : {
		
		require_once($GLOBALS['where_lms'].'/lib/lib.track_user.php');
		
		if(!$GLOBALS['current_user']->isAnonymous() && isset($_SESSION['idCourse'])) {
		
			TrackUser::setActionTrack(getLogUserId(), $_SESSION['idCourse'], '', '');
		}
		
		//control if user can enter into the course selected
		list($level_c, $status_user, $waiting_user) = mysql_fetch_row(mysql_query("
		SELECT level, status, waiting 
		FROM ".$GLOBALS['prefix_lms']."_courseuser 
		WHERE idCourse = '".(int)$_GET['idCourse']."' AND idUser = '".getLogUserId()."'"));
		
		require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
		$GLOBALS['course_descriptor'] = new DoceboCourse($_GET['idCourse']);
		$course_info = $GLOBALS['course_descriptor']->getAllInfo();
		$course_info['course_status'] 	= $GLOBALS['course_descriptor']->getValue('status');
		$course_info['user_status'] 	= $status_user;
		$course_info['waiting'] 		= $waiting_user;
		$course_info['level'] 			= $level_c;
		if($level_c == 2) $_SESSION['is_ghost'] = true;
		else $_SESSION['is_ghost'] = false;
		
		if(Man_Course::canEnterCourse($course_info)) {
			
			if($status_user == _CUS_SUBSCRIBED) {
				
				require_once($GLOBALS['where_lms'].'/lib/lib.stats.php');
				saveTrackStatusChange(getLogUserId(), $_GET['idCourse'], _CUS_BEGIN);
			}
		
			$now = date("Y-m-d H:i:s");
			$_SESSION['timeEnter'] 	= $now;
			$_SESSION['idCourse'] 		= (int)$_GET['idCourse'];
			$_SESSION['levelCourse'] 	= $level_c;
			
			$GLOBALS['current_user']->loadUserSectionST('/lms/course/private/'.$level_c.'/');
			$GLOBALS['current_user']->SaveInSession();
			
			TrackUser::createSessionCourseTrack();
			
			// NOTE: load first page of the course/*
			$first_page = firstPage();
			
			$_SESSION['current_main_menu'] = $first_page['idMain'];
			if($first_page['modulename'] != '') {
				
				jumpTo( 'index.php?modname='.$first_page['modulename'].'&op='.$first_page['op'].'&sel_module='.$first_page['idModule']);
			}
		} else {
			
			$_SESSION['current_main_menu'] = '1';
			$_SESSION['sel_module_id'] = '1';
			$GLOBALS['modname'] = 'course';
			$GLOBALS['op'] 		= 'mycourses';
		}
	};break;
	//registering menu information
	case "unregistercourse" : {
		
		//if a course is selected the selection is deleted
		if (isset($_SESSION['idCourse'])) {
			
			TrackUser::closeSessionCourseTrack();
			
			unset($_SESSION['idCourse']);
		}
		$_SESSION['current_main_menu'] = '1';
		$_SESSION['sel_module_id'] = '1';
		$_SESSION['is_ghost'] = false;
		$GLOBALS['modname'] = 'course';
		$GLOBALS['op'] 		= 'mycourses';
	};break;
	case "selectMain" : {
		$_SESSION['current_main_menu'] = (int)$_GET['idMain'];
		$first_page = firstPage( $_SESSION['current_main_menu'] );
		
		if($first_page['modulename'] != '') 
			jumpTo( 'index.php?modname='.$first_page['modulename'].'&op='.$first_page['op'].'&sel_module='.$first_page['idModule']);
	};break;
	//change language for register user
	case "registerconfirm" : {
		setLanguage($_POST['language']);
	};break;
	case "registerme" : {
		list($language_reg) = mysql_fetch_row(mysql_query("
		SELECT language
		FROM ".$GLOBALS['prefix_lms']."_user_temp 
		WHERE random_code = '".$_GET['random_code']."'"));
		if($language_reg != '') setLanguage($language_reg);
	};break;
	
}
// special operation
if(isset($_GET['sop'])) {
	
	switch($_GET['sop']) {
		case "resetselmodule" : {
			unset($_SESSION['sel_module_id']);
		};break;
	}
}

// istance the course description class
if(isset($_SESSION['idCourse']) && !isset($GLOBALS['course_descriptor'])) {

	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	
	$GLOBALS['course_descriptor'] = new DoceboCourse($_SESSION['idCourse']);
}


?>