<?php

/************************************************************************/
/* DOCEBO LMS - Learning Managment System                               */
/* ============================================                         */
/*                                                                      */
/* Copyright (c) 2004                                                   */
/* http://www.docebo.com                                                */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

if($GLOBALS['current_user']->isAnonymous()) die("You can't access");

require_once($GLOBALS['where_lms'].'/lib/lib.levels.php');
require_once($GLOBALS['where_lms'].'/lib/lib.course.php');

function &courserow($course, $advices = false, $messages = false, $forums = false, $lobj = false) {
	
	$levels 	= CourseLevel::getLevels();
	/*
	$course = (
				[idCourse] => 			int
				[code] => 				varchar
				[name] => 				varchar
				[description] => 		text
				[date_begin] => 		datetime
				[date_end] => 			datetime
				[date_first_access] => 	datetime
				[valid_time] => 		int
				[course_status] => 		int(1)
				[waiting] => 			int(1)
				[userStatusOp] => 		int(1)
				[level] => 				int
				[user_status] => 		int
				[prerequisites_satisfied] => bool
			)
	*/
	$lang 	= DoceboLanguage::createInstance('course');
	$id_c	= $course['idCourse'];
	
	$cont 	= array($course['code']);
	if($course['is_select'] == true) {
		
		$course_cell = '<a href="index.php?modname=course&amp;op=mycourses" title="'.$lang->def('_LESS_COURSE_INFO').'">'
			.'<img src="'.getPathImage('fw').'standard/less.gif" alt="'.$lang->def('_LESS_COURSE_INFO').'" /></a>'
			.'&nbsp;&nbsp;';
	} else {
		
		$course_cell = '<a href="index.php?modname=course&amp;op=mycourses&amp;idCourse='.$id_c.'" '
			.'title="'.$lang->def('_MORE_COURSE_INFO').'">'
			.'<img src="'.getPathImage('fw').'standard/more.gif" alt="'.$lang->def('_MORE_COURSE_INFO').'" /></a>'
			.'&nbsp;&nbsp;';
	}
	if(Man_Course::canEnterCourse($course)) {
		
		$lock = '';
		$course_cell .= '<a class="course_enter" href="index.php?modname=course&amp;op=aula&amp;idCourse='.$id_c.'" '
				.'title="'.$lang->def('_ENTERT').'">'.$course['name'].'</a>';
	} else {
		
		$lock = '<img src="'.getPathImage().'course/lock.gif" alt="'.$lang->def('_NOENTER').'" /> ';
		$course_cell .= '<span class="course_lock">'
			.$course['name']
			.'</span>';
	}
	if($course['is_select'] == true) {
		
		$course_cell .= '<div class="course_extra_info">'
			.'<span>'.$lang->def('_DESCRIPTION').' : </span>'.$course['description'].'<br />'
			.'<span>'.$lang->def('_SUBSCRIBED_ON').' : </span>'
				.$GLOBALS['regset']->databaseToRegional($course['date_inscr']).'<br />'
			.'<span>'.$lang->def('_FIRST_ACCESS_ON').' : </span>'
				.$GLOBALS['regset']->databaseToRegional($course['date_first_access']).'<br />'
			.'</div>';
	}
	$cont[] = $course_cell;
	$cont[] = $lock;
	$cont[] = $levels[$course['level']];
	switch($course['user_status']) {
		case _CUS_SUBSCRIBED : $cont[] = '<img src="'.getPathImage().'course/us_subscribed.gif" title="'.$lang->def('_SUBSCRIBED').'" alt="'.$lang->def('_SUBSCRIBED').'" />';break;
		case _CUS_BEGIN : $cont[] = '<img src="'.getPathImage().'course/us_started.gif" title="'.$lang->def('_STARTED').'" alt="'.$lang->def('_STARTED').'" />';break;
		case _CUS_END : $cont[] = '<img src="'.getPathImage().'course/us_finished.gif" title="'.$lang->def('_FINISHED').'" alt="'.$lang->def('_FINISHED').'" />';break;
		case _CUS_SUSPEND : $cont[] = '<img src="'.getPathImage().'course/us_suspended.gif" title="'.$lang->def('_SUSPENDED').'" alt="'.$lang->def('_SUSPENDED').'" />';break;
		
	}
	$cont[] = ( ( isset($advices[$id_c]) && $advices[$id_c] > 0) 				? $advices[$id_c] 	: '' );
	$cont[] = ( ( isset($messages[$id_c]) && $messages[$id_c] > 0) 				? $messages[$id_c] 	: '' );
	$cont[] = ( ( isset($forums[$id_c]) && $forums[$id_c] > 0) 					? $forums[$id_c] 	: '' );
	$cont[] = ( ( isset($lobj[$id_c]) && $lobj[$id_c] > 0) 						? $lobj[$id_c] 	: '' );
	return $cont;
}

function mycourses() {
	checkPerm('view');
	
	require_once($GLOBALS['where_framework'].'/lib/lib.newtypeone.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.coursepath.php');
	
	$acl_man	=& $GLOBALS['current_user']->getAclManager();
	$ml_lang 	= DoceboLanguage::createInstance('menu');
	$lang 		= DoceboLanguage::createInstance('course');
	$course_sel = importVar('idCourse', true, 0);
	$path_sel 	= importVar('idPath', true, 0);
	
	$courses 	= array();
	$pathcourse = array();
	
	// Finding course path of the user
	$re_path = mysql_query("
	SELECT p.idPath, p.path_code, p.path_name, p.path_descr
	FROM ".$GLOBALS['prefix_lms']."_coursepath AS p JOIN 
		".$GLOBALS['prefix_lms']."_coursepath_user AS u 
	WHERE p.idPath = u.idPath AND 
		u.idUser = '".getLogUserId()."' AND 
		u.waiting = '0' 
	ORDER BY p.path_name");
	$id_path = '';
	while($assoc = mysql_fetch_assoc($re_path)) {
		
		$pathcourse[$assoc['idPath']] = $assoc;
		$id_path .= $assoc['idPath'].',';
	}
	// Finding information about courses of the pathcourse
	if($id_path != '') {
		$re_pathcourses = mysql_query("
		SELECT idPath, idCourse, prerequisites 
		FROM ".$GLOBALS['prefix_lms']."_coursepath_courses 
		WHERE idPath IN ( ".substr($id_path, 0, -1)." )
		ORDER BY sequence ");
		while(list($idp, $idc, $prere) = mysql_fetch_row($re_pathcourses)) {
			
			$courses[$idc]['in_path'] = true;
			$pathcourse[$idp]['course'][$idc] = $prere;
		}
	}
	// List of  courses
	$re_courses = mysql_query("
	SELECT idCourse
	FROM ".$GLOBALS['prefix_lms']."_courseuser 
	WHERE idUser = '".getLogUserId()."'");
	$courses_subscribed = array();
	while(list($id_c) = mysql_fetch_row($re_courses)) {
		$courses_subscribed[] = $id_c;
	}
	// find last access to the courses
	require_once($GLOBALS['where_lms'].'/lib/lib.track_user.php');
	$last_access_courses = TrackUser::getLastAccessToCourse( getLogUserId() );
	
	// retrive unreaded messages
	require_once($GLOBALS['where_lms'].'/lib/lib.advice.php');
	$advices = Man_Advice::getCountUnreaded( getLogUserId(), $courses_subscribed, $last_access_courses );
	
	// retrive unreaded messages
	require_once($GLOBALS['where_lms'].'/lib/lib.message.php');
	$messages = Man_Message::getCountUnreaded( getLogUserId(), $courses_subscribed, $last_access_courses );
	
	// retrive unreaded forum messages
	require_once($GLOBALS['where_lms'].'/lib/lib.forum.php');
	$forums = Man_Forum::getCountUnreaded( getLogUserId(), $courses_subscribed, $last_access_courses );
	
	// retrive new lesson
	require_once($GLOBALS['where_lms'].'/lib/lib.orgchart.php');
	$org_chart = OrganizationManagement::getCountUnreaded( getLogUserId(), $courses_subscribed, $last_access_courses );
	
	
	// Finding courses
	$re_courses = mysql_query("
	SELECT c.idCourse, c.code, c.name, c.description, 
		c.date_begin, c.date_end, c.valid_time, c.status AS course_status, u.waiting, 
		c.userStatusOp, u.level, u.status as user_status, u.date_inscr, u.date_first_access
	FROM ".$GLOBALS['prefix_lms']."_course AS c JOIN 
		".$GLOBALS['prefix_lms']."_courseuser AS u 
	WHERE c.idCourse = u.idCourse AND 
		u.idUser = '".getLogUserId()."'
	ORDER BY user_status, c.name");
	
	$tb_course 	= new TypeOne(0, $lang->def('_COURSELIST'), $lang->def('_COURSE_LIST_SUMMARY'));
	$tb_course->setTableStyle('course_block');
	$type_h = array('code_course', '', 'image', 'level_course', 'image', 'image', 'image', 'image', 'image', 'image');
	$cont_h = array(
		$lang->def('_CODE'), 
		$lang->def('_COURSE'), 
		'<img class="access-only" src="'.getPathImage().'course/lock.gif" alt="'.$lang->def('_NOENTER').'" />&nbsp;',
		$lang->def('_LEVEL'), 
		$lang->def('_USERSTATUS'), 
		'<img class="img_courselist" src="'.getPathImage().'course/advice.gif" '
			.'title="'.$lang->def('_T_ADVICE').'" alt="'.$lang->def('_ALT_ADVICE').'" />', 
			
		'<img class="img_courselist" src="'.getPathImage().'course/message.gif" '
			.'title="'.$lang->def('_T_MESSAGE').'" alt="'.$lang->def('_ALT_MESSAGE').'" />', 
			
		'<img class="img_courselist" src="'.getPathImage().'course/forum.gif" '
			.'title="'.$lang->def('_T_FORUM').'" alt="'.$lang->def('_ALT_FORUM').'" />', 
			
		'<img class="img_courselist" src="'.getPathImage().'course/lesson.gif" '
			.'title="'.$lang->def('_T_LESSON').'" alt="'.$lang->def('_ALT_LESSON').'" />', 
	);
	$tb_course->setColsStyle($type_h);
	$tb_course->addHead($cont_h);
	
	$GLOBALS['page']->add(
		getTitleArea($lang->def('_MY_COURSES'), 'course', $lang->def('_MY_COURSES'))
		.'<div class="std_block">', 'content');
	
	while($assoc = mysql_fetch_assoc($re_courses)) {
		
		$id_c 					= $assoc['idCourse'];
		$array_status[$id_c] 	= $assoc['user_status'];
		
		if($id_c == $course_sel) $assoc['is_select'] = true;
		else $assoc['is_select'] = false;
		if(!isset($courses[$id_c]['in_path']) || !$courses[$id_c]['in_path']) {
			
			$cont =& courserow($assoc, $advices, $messages, $forums, $org_chart);
			$tb_course->addBody($cont);
		} else {
			
			$courses[$id_c] = $assoc;
		}
	}
	$GLOBALS['page']->add($tb_course->getTable(), 'content');
	
	//-course-path-------------------------------------------------------------
	
	if(!empty($pathcourse)) {
		$tb_path = new TypeOne(0, $lang->def('_LIST_PATHCOURSE'), $lang->def('_SUMMARY_PATHCOURSE'));
		$tb_path->setTableStyle('course_path_block');
		
		$type = array('code_course', '');
		$cont_h = array($lang->def('_CODE_PATH'), $lang->def('_PATHCOURSE'));
		$tb_path->setColsStyle($type);
		$tb_path->addHead($cont_h);
		
		reset($pathcourse);
		$tb_course->setCaption('');
		$tb_course->setTableStyle('course_block course_block_cell');
		while(list($key, $value) = each($pathcourse)) {
			
			$path_cell = '';
			if($key == $path_sel) {
				
				$path_cell .= '<a href="index.php?modname=course&amp;op=mycourses" title="'.$lang->def('_LESS_COURSEPATH_INFO').'">'
					.'<img src="'.getPathImage('fw').'standard/less.gif" alt="'.$lang->def('_LESS_COURSEPATH_INFO').'" /></a>'
					.'&nbsp;&nbsp;';
			} else {
				
				$path_cell .= '<a href="index.php?modname=course&amp;op=mycourses&amp;idPath='.$key.'" '
					.'title="'.$lang->def('_MORE_COURSEPATH_INFO').'">'
					.'<img src="'.getPathImage('fw').'standard/more.gif" alt="'.$lang->def('_MORE_COURSEPATH_INFO').'" /></a>'
					.'&nbsp;&nbsp;';
			}
			$path_cell .= '<span class="course_path">'.$value['path_name'].'</span>';
			if($key == $path_sel) {
				
				$path_cell .= '<div class="course_path_info">'
					.'<span>'.$lang->def('_DESCRIPTION').' : </span>'.$value['path_descr']
					.'</div>';
			}
			$cont = array($value['path_code'], $path_cell);
			$tb_path->addBody($cont);
			if(isset($pathcourse[$key]['course']) && is_array($pathcourse[$key]['course']) && !empty($pathcourse[$key]['course'])) {
				// Time for course list
				$tb_course->emptyBody();
				
				while(list($id_course, $prere) = each($pathcourse[$key]['course'])) {
					
					if(CoursePath_Manager::checkPrerequisites($prere, $courses)) {
						$courses[$id_course]['prerequisites_satisfied'] = true;
					} else {
						$courses[$id_course]['prerequisites_satisfied'] = false;
					}
					
					$cont =& courserow($courses[$id_course], $advices, $messages, $forums, $org_chart);
					$tb_course->addBody($cont);
				}
				$tb_path->addBody( array('', $tb_course->getTable() ) );
			}
		}
		$GLOBALS['page']->add($tb_path->getTable(), 'content');
	}
	$GLOBALS['page']->add('</div>', 'content');
}

function courseDispatch($op) {
switch($op) {
	case "unregistercourse" :
	case "mycourses" : {
		mycourses();
	};break;
}
}

?>