<?php

/************************************************************************/
/* DOCEBO LMS - Learning managment system									*/
/* ============================================							*/
/*																			*/
/* Copyright (c) 2005														*/
/* http://www.docebo.com													*/
/*																			*/
/* This program is free software. You can redistribute it and/or modify	*/
/* it under the terms of the GNU General Public License as published by	*/
/* the Free Software Foundation; either version 2 of the License.		*/
/************************************************************************/

/**
 * @version  $Id: coursecatalogue.php 160 2006-03-24 15:50:06Z fabio $
 * @author	 Fabio Pirovano <fabio [at] docebo-com>
 * @package course
 * @subpackage course list
 */

define("_SUCCESS_wait","_SUBSCRIPTION_OK_WAIT");
define("_SUCCESS_subs","_SUBSCRIPTION_OK");
define("_FAIL_subs","_SUBSCRIPTION_ERROR");

define("_SUCCESS_buy","_BUYED_CORRECTLY");
define("_FAIL_buy","_BUYED_FAIL");

if($GLOBALS['current_user']->isAnonymous()) die('You can\'t access');

require_once($GLOBALS['where_lms'].'/lib/lib.levels.php');

function &getUserCourse($id_user, $no_wait = FALSE) {
	
	$course = array();
	$query_course = "
	SELECT idCourse
	FROM ".$GLOBALS['prefix_lms']."_courseuser
	WHERE idUser = '".$id_user."'";
	if ($no_wait) $query_course .= "AND waiting = 0";
	$re_course = mysql_query($query_course);
	while(list($id) = mysql_fetch_row($re_course)) {
		
		$course[$id] = $id;
	}
	return $course;
}

function &getUserCourseWait($id_user) {
	
	$course = array();
	$query_course = "
	SELECT idCourse
	FROM ".$GLOBALS['prefix_lms']."_courseuser
	WHERE idUser = '".$id_user."' AND waiting = 1";
	$re_course = mysql_query($query_course);
	while(list($id) = mysql_fetch_row($re_course)) {
		
		$course[$id] = $id;
	}
	return $course;
}

function &getUserCoursepath($id_user, $no_wait = FALSE) {
	
	$course = array();
	$query_course = "
	SELECT idPath
	FROM ".$GLOBALS['prefix_lms']."_coursepath_user
	WHERE idUser = '".$id_user."' ";
	if ($no_wait) $query_course .= "AND waiting = 0";
	$re_course = mysql_query($query_course);
	while(list($id) = mysql_fetch_row($re_course)) {
		
		$course[$id] = $id;
	}
	return $course;
}

function &getUserCoursepathWait($id_user) {
	
	$course = array();
	$query_course = "
	SELECT idPath
	FROM ".$GLOBALS['prefix_lms']."_coursepath_user
	WHERE idUser = '".$id_user."' AND waiting = 1";
	$re_course = mysql_query($query_course);
	while(list($id) = mysql_fetch_row($re_course)) {
		
		$course[$id] = $id;
	}
	return $course;
}

function &courserow($course, $filter) {
	
	$levels 	= CourseLevel::getLevels();
	/*
	$course = (
				[idCourse] => 			int
				[code] => 				varchar
				[name] => 				varchar
				[description] => 		text
				[date_end] => 			datetime
				[course_status] => 		int(1)
				[subscribe_method]
			)
	*/
	$lang 	= DoceboLanguage::createInstance('course');
	$id_c	= $course['idCourse'];
	
	if($filter != '') $course['code'] = eregi_replace($filter, '<span class="filter_evidence">'.$filter.'</span>', $course['code']);
	$cont 	= array($course['code']);
	if($course['subscribed']) {
		
		if($course['waiting']) $cont[] = '<img src="'.getPathImage().'course/waiting.gif" title="'.$lang->def('_WAITING_T').'" alt="'.$lang->def('_WAITING_ALT').'" />';
		else $cont[] = '<img src="'.getPathImage().'course/subscribed.gif" title="'.$lang->def('_SUBSCRIBED_T').'" alt="'.$lang->def('_SUBSCRIBED_ALT').'" />';
	} else {
		
		switch($course['subscribe_method']) {
			case "0" : $cont[] = '<img src="'.getPathImage().'course/sub_admin.gif" title="'.$lang->def('_COURSE_S_GODADMIN').'" alt="'.$lang->def('_COURSE_S_GODADMIN').'" />';break;
			case "1" : $cont[] = '<img src="'.getPathImage().'course/sub_moderate.gif" title="'.$lang->def('_COURSE_S_MODERATE').'" alt="'.$lang->def('_COURSE_S_MODERATE').'" />';break;
			case "2" : $cont[] = '<img src="'.getPathImage().'course/sub_free.gif" title="'.$lang->def('_COURSE_S_FREE').'" alt="'.$lang->def('_COURSE_S_FREE').'" />';break;
		}
	}
	if($filter != '') $cont[] = eregi_replace($filter, '<span class="filter_evidence">'.$filter.'</span>', $course['name']);
	else $cont[] = $course['name'];
	if($filter != '') $cont[] = eregi_replace($filter, '<span class="filter_evidence">'.$filter.'</span>', $course['description']);
	else $cont[] = $course['description'];
	
	return $cont;
}

function courselist() {
	checkPerm('view');
	
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.newtypeone.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.catalogue.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.coursepath.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	
	$lang =& DoceboLanguage::createInstance('course');
	$lang =& DoceboLanguage::createInstance('coursecatalogue');
	
	$GLOBALS['page']->add(
		getTitleArea($lang->def('_TITLE_COURSECATALOGUE'), 'coursecatalogue', $lang->def('_ALT_COURSECATALOGUE') )
		.'<div class="std_block">', 'content');
			
	$GLOBALS['page']->add(
		Form::openForm('coursecatalogue_filter', 'index.php?modname=coursecatalogue&amp;op=course')
		.Form::getOpenFieldset($lang->def('_FILTER'))
		.Form::getTextfield($lang->def('_FILTER_FIELD'), 'filter_field', 'filter_field', '255', 
			( isset($_POST['filter_field']) ? $_POST['filter_field'] : '' ))
		.Form::openButtonSpace()
		.Form::getButton('filter', 'filter', $lang->def('_APPLY_FILTER'), 'button_nowh')
		.Form::closeButtonSpace()
		.Form::getCloseFieldset()
		.Form::closeForm(), 'content');
	
	$search = ( isset($_POST['filter_field']) ? $_POST['filter_field'] : '' );
	$levels = CourseLevel::getLevels();
	
	$cat_man = new Catalogue_Manager();
	$catalogues =& $cat_man->getUserAllCatalogueId( getLogUserId() );
	
	$user_course 			=& getUserCourse( getLogUserId() );
	$user_course_wait 		=& getUserCourseWait( getLogUserId() );
	$user_coursepath 		=& getUserCoursepath( getLogUserId() );
	$user_coursepath_wait 	=& getUserCoursepathWait( getLogUserId() );
	
	if(empty($catalogues)) {
		
		// no catalogues assigned to this user
		if($GLOBALS['lms']['on_catalogue_empty'] == 'on') {
			
			// show all courses and coursepath
			$query_path = "
			SELECT p.idPath, p.path_code, p.path_name, p.path_descr, p.subscribe_method 
			FROM ".$GLOBALS['prefix_lms']."_coursepath AS p ";
			if(isset($_POST['filter_field'])) {
				
				$query_path .= " WHERE p.path_code LIKE '%".$search."%' "
									."OR p.path_name LIKE '%".$search."%' "
									."OR p.path_descr LIKE '%".$search."%'";
			}
			$query_path .= " ORDER BY p.path_name ";
			
			$query_course = "
			SELECT c.idCourse, c.code, c.name, c.description, c.date_end, c.status AS course_status, 
				c.subscribe_method,  c.show_rules, c.selling, c.prize
			FROM ".$GLOBALS['prefix_lms']."_course AS c ";
			if(isset($_POST['filter_field'])) {
				
				$query_course .= " WHERE c.code LIKE '%".$search."%' "
									."OR c.name LIKE '%".$search."%' "
									."OR c.description LIKE '%".$search."%'";
			}
			$query_course .= " ORDER BY c.name";
		} else {
			
			// show nothing
			$GLOBALS['page']->add(	$lang->def('_YOU_CANT_SEE_NOTHING')
									.'</div>', 'content');
			return;
		}
	} else {
		
		// at least one catalogue is assigned to this user
		
		$cat_courses 		=& $cat_man->getAllCourseOfUser( getLogUserId() );
		$cat_pathcourses 	=& $cat_man->getAllCoursepathOfUser( getLogUserId() );
		
		$query_path = "
		SELECT p.idPath, p.path_code, p.path_name, p.path_descr, p.subscribe_method 
		FROM ".$GLOBALS['prefix_lms']."_coursepath AS p
		WHERE p.idPath IN ( ".implode(',', $cat_pathcourses)." )";
		if(isset($_POST['filter_field'])) {
			
			$query_path .= " AND ( p.path_code LIKE '%".$search."%' "
								."OR p.path_name LIKE '%".$search."%' "
								."OR p.path_descr LIKE '%".$search."%' ) ";
		}
		$query_path .= " ORDER BY p.path_name ";
		if(empty($cat_pathcourses)) $query_path = "";
		
		
		$query_course = "
		SELECT c.idCourse, c.code, c.name, c.description, c.date_end, c.status AS course_status, 
			c.subscribe_method,  c.show_rules, c.selling, c.prize 
		FROM ".$GLOBALS['prefix_lms']."_course AS c 
		WHERE c.idCourse IN ( ".implode(',', $cat_courses)." ) ";
		if(isset($_POST['filter_field'])) {
			
			$query_course .= " AND ( c.code LIKE '%".$search."%' "
								."OR c.name LIKE '%".$search."%' "
								."OR c.description LIKE '%".$search."%' ) ";
		}
		$query_course .= " ORDER BY c.name";
		if(empty($cat_courses)) $query_course = "";
	}
	
	// Finding course path of the user
	if($query_path != '') 		$re_path = mysql_query($query_path);
	if($query_course != '') 	$re_course = mysql_query($query_course);
	
	$subscr_img = '<img src="'.getPathImage().'course/go_subscribe.gif" alt="'.$lang->def('_GO_SUBSCRIBE').'" />';
	$selling_img = '<img src="'.getPathImage().'course/go_selling.gif" alt="'.$lang->def('_GO_SELLING').'" />';
	$tb_course 	= new TypeOne(0, $lang->def('_COURSELIST'), $lang->def('_COURSE_LIST_SUMMARY'));
	$tb_course->setTableStyle('course_block');
	$type_h = array('code_course', 'image', '', 'subscribe_course');
	$cont_h = array(
		$lang->def('_CODE', 'course'), 
		'<span class="access-only">'.$lang->def('_COURSE_STATUS_REPORT').'</span>&nbsp;',
		$lang->def('_COURSE', 'course'), 
		$lang->def('_SUBSCRIBE_COURSE', 'course')
	);
	$tb_course->setColsStyle($type_h);
	$tb_course->addHead($cont_h);
	
	if($query_course != '')
	while($course = mysql_fetch_assoc($re_course)) {
		
		$id_c = $course['idCourse'];
		if($course['show_rules'] != 2 || isset($user_course[$id_c])) {
			// Dispaly of the courses
			if($search != '') {
				$course['code'] = eregi_replace($search, '<span class="filter_evidence">'.$search.'</span>', $course['code']);
				$course['name'] = eregi_replace($search, '<span class="filter_evidence">'.$search.'</span>', $course['name']);
				$course['description'] = eregi_replace($search, '<span class="filter_evidence">'.$search.'</span>', $course['description']);
			}
			$can_subscribe = false;
			$write = '';
			$cont = array($course['code']);
			if(isset($user_course[$id_c])) {
				
				if(isset($user_course_wait[$id_c])) {
					$cont[] = '<img src="'.getPathImage().'course/waiting.gif" title="'.$lang->def('_WAITING_T', 'course')
								.'" alt="'.$lang->def('_WAITING_ALT', 'course').'" /> ';
					$write = $lang->def('_WAITING_WRITE', 'course');
				} else {
					$cont[] = '<img src="'.getPathImage().'course/user_subscribed.gif" title="'.$lang->def('_SUBSCRIBED_T', 'course')
								.'" alt="'.$lang->def('_SUBSCRIBED_ALT', 'course').'" /> ';
				}
			} else {
				if($course['selling'] == 1) {
					$cont[] = '';
					$write = '';
				} else {
					
					switch($course['subscribe_method']) {
						case "0" : {
							$cont[] = '<img src="'.getPathImage().'course/subscribe_admin.gif" '
								.'title="'.$lang->def('_COURSE_S_GODADMIN', 'course').'" alt="'.$lang->def('_COURSE_S_GODADMIN', 'course').'" /> ';
							$write = $lang->def('_CANNOT_SUBSCRIBE', 'course');
						};break;
						case "1" : {
							$cont[] = '<img src="'.getPathImage().'course/subscribe_waiting.gif" '
								.'title="'.$lang->def('_COURSE_S_MODERATE', 'course').'" alt="'.$lang->def('_COURSE_S_MODERATE', 'course').'" /> ';
							$can_subscribe = true;
							$write = $lang->def('_COURSE_S_MODERATE', 'course');
						};break;
						case "2" : {
							$cont[] = '<img src="'.getPathImage().'course/subscribe_free.gif" '
								.'title="'.$lang->def('_COURSE_S_FREE', 'course').'" alt="'.$lang->def('_COURSE_S_FREE', 'course').'" /> ';
							$can_subscribe = true;
							$write = $lang->def('_COURSE_S_FREE', 'course');
						};break;
					}
				}
			}
			if($write == '') $write = '&nbsp;';
			$cont[] = $course['name'];
			if($course['selling'] == 1 && !isset($user_course[$id_c])) {
					
				$cont[] = '<a href="index.php?modname=coursecatalogue&amp;op=subscribecourse&amp;id='.$id_c.'" '
					.'title="'.$lang->def('_BUY_COURSE_T').'">'.$selling_img.' '.$lang->def('_BUY_COURSE').' ('.$course['prize'].')'.'</a>';
			} elseif($can_subscribe && $course['selling'] != 1) {
					
					$cont[] = ( $can_subscribe ? '<a href="index.php?modname=coursecatalogue&amp;op=subscribecourse&amp;id='.$id_c.'" '
						.'title="'.$lang->def('_SUBSCRIBE_COURSE_T').'">'.$subscr_img.' '.$lang->def('_SUBSCRIBE_COURSE').'</a> ('.$write.')' : '' );
			} else $cont[] = $write;
			$tb_course->addBody($cont);
		}
	}
	$GLOBALS['page']->add($tb_course->getTable(), 'content');
	
	//-course-path-------------------------------------------------------------
	$tb_path = new TypeOne(0, $lang->def('_LIST_PATHCOURSE'), $lang->def('_SUMMARY_PATHCOURSE'));
	$tb_path->setTableStyle('course_path_block');
	
	$type = array('code_course', 'image', '', 'subscribe_course');
	$cont_h = array(	$lang->def('_CODE_PATH', 'course'), 
						'<span class="access-only">'.$lang->def('_COURSE_STATUS_REPORT').'</span>&nbsp;',
						$lang->def('_PATHCOURSE', 'course'),
						$lang->def('_SUBSCRIBE_COURSEPATH', 'course') );
	$tb_path->setColsStyle($type);
	$tb_path->addHead($cont_h);
	
	if($query_path != '')
	while($value = mysql_fetch_assoc($re_path)) {
		
		$id_p = $value['idPath'];
		if($search != '') {
			$value['path_code'] = eregi_replace($search, '<span class="filter_evidence">'.$search.'</span>', $value['path_code']);
			$value['path_name'] = eregi_replace($search, '<span class="filter_evidence">'.$search.'</span>', $value['path_name']);
			$value['path_descr'] = eregi_replace($search, '<span class="filter_evidence">'.$search.'</span>', $value['path_descr']);
		}
		
		$can_subscribe = false;
		$write = '';
		$cont = array(	$value['path_code']);
		if(isset($user_coursepath[$id_p])) {
			
			if(isset($user_coursepath_wait[$id_p])) {
				$cont[] = '<img src="'.getPathImage().'course/waiting.gif" title="'.$lang->def('_WAITING_T', 'course')
							.'" alt="'.$lang->def('_WAITING_ALT', 'course').'" /> ';
				$write = $lang->def('_WAITING_WRITE', 'course');
			} else {
				$cont[] = '<img src="'.getPathImage().'course/subscribed.gif" title="'.$lang->def('_SUBSCRIBED_T', 'course')
							.'" alt="'.$lang->def('_SUBSCRIBED_ALT', 'course').'" /> ';
			}
		} else {
			
			switch($value['subscribe_method']) {
				case "0" : {
					$cont[] = '<img src="'.getPathImage().'course/sub_admin.gif" '
						.'title="'.$lang->def('_COURSEPATH_S_GODADMIN', 'course').'" alt="'.$lang->def('_COURSEPATH_S_GODADMIN', 'course').'" /> ';
					$write = $lang->def('_CANNOT_SUBSCRIBE', 'course');
				};break;
				case "1" : {
					$cont[] = '<img src="'.getPathImage().'course/sub_moderate.gif" '
						.'title="'.$lang->def('_COURSEPATH_S_MODERATE', 'course').'" alt="'.$lang->def('_COURSEPATH_S_MODERATE', 'course').'" /> ';
					$can_subscribe = true;
					$write = $lang->def('_COURSEPATH_S_MODERATE', 'course');
				};break;
				case "2" : {
					$cont[] = '<img src="'.getPathImage().'course/sub_free.gif" '
						.'title="'.$lang->def('_COURSEPATH_S_FREE', 'course').'" alt="'.$lang->def('_COURSEPATH_S_FREE', 'course').'" /> ';
					$can_subscribe = true;
					$write = $lang->def('_COURSEPATH_S_FREE', 'course');
				};break;
			}
		}
		$cont[] = '<span class="course_path">'.$value['path_name'].'</span>';
		if($can_subscribe) {
			
			$cont[] = ( $can_subscribe ? '<a href="index.php?modname=coursecatalogue&amp;op=subscribecoursepath&amp;id='.$id_p.'" '
				.'title="'.$lang->def('_SUBSCRIBE_COURSEPATH_T').'">'.$subscr_img.' '.$lang->def('_SUBSCRIBE_COURSEPATH').'</a> ('.$write.')' : '' );
		} else $cont[] = $write;
		$tb_path->addBody($cont);
	}
	$GLOBALS['page']->add($tb_path->getTable(), 'content');
	
	$GLOBALS['page']->add('</div>', 'content');
}

function subscribecourse() {
	checkPerm('view');
	
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.catalogue.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.coursepath.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	
	$lang =& DoceboLanguage::createInstance('course');
	$lang =& DoceboLanguage::createInstance('coursecatalogue');
	
	$sel_course = importVar('id', true, 0);
	$man_course = new Man_Course();
	$course = $man_course->getCourseInfo($sel_course);
	
	
	$page_title = array(
		'index.php?modname=coursecatalogue&amp;op=courselist' => $lang->def('_TITLE_COURSECATALOGUE'),
		$lang->def('_SUBSCRIBE_COURSE', 'course').' : '.$course['name'] );
	$GLOBALS['page']->add(
		getTitleArea($page_title, 'coursecatalogue', $lang->def('_ALT_COURSECATALOGUE') )
		.'<div class="std_block">', 'content');
	if(isset($_GET['re'])) $GLOBALS['page']->add(guiResultStatus($lang, $_GET['re']), 'content');
	
	$cat_man 		= new Catalogue_Manager();
	$catalogues 	=& $cat_man->getUserAllCatalogueId( getLogUserId() );
	
	$user_course 			=& getUserCourse( getLogUserId() );
	$user_course_wait 		=& getUserCourseWait( getLogUserId() );
	
	if(!empty($catalogues)) {
		
		// at least one catalogue is assigned to this user
		$cat_courses 		=& $cat_man->getAllCourseOfUser( getLogUserId() );
		if(!isset($cat_courses[$sel_course])) {
		
			$GLOBALS['page']->add(
				getErrorUi($lang->def('_THIS_ISNT_IN_POOL')).'</div>', 
			'content');
			return;
		}
	}
	
	$can_subscribe = false;
	if(isset($user_course[$sel_course])) {
		
		if(isset($user_course_wait[$sel_course])) {
			$GLOBALS['page']->add(
				getErrorUi($lang->def('_YOU_ARE_WAITING')).'</div>', 
			'content');
			return;
		} else {
			$GLOBALS['page']->add(
				getErrorUi($lang->def('_YOU_ARE_ALREDY_SUBSCRIBED')).'</div>', 
			'content');
			return;
		}
	} elseif($course['selling'] != 1) {
		
		$waiting = 1;
		switch($course['subscribe_method']) {
			case "0" : {
				$GLOBALS['page']->add(
					getErrorUi($lang->def('_CANNOT_SUBSCRIBE')).'</div>', 
				'content');
				return;
			};break;
			case "1" : {
				$write = $lang->def('_MUST_WAIT_FOR_MODERATION', 'course');
				$can_subscribe = true;
			};break;
			case "2" : {
				$write = $lang->def('_DIRECT_SUBSCRIPTION', 'course');
				$can_subscribe = true;
				$waiting = 0;
			};break;
		}
	}
	if(isset($write)) $GLOBALS['page']->add(getResultUi($write), 'content');
	
	if(isset($_GET['confirm'])) {
		
		if($course['selling'] == 1) {
			
			//retrive id of group of the course for the varioud level
			$level_idst =& getCourseLevel($sel_course);
			
			// Add in group for permission
			$acl_man =& $GLOBALS['current_user']->getAclManager();
			$acl_man->addToGroup($level_idst[3], getLogUserId());
			
			// Add in table
			$re = mysql_query("
			INSERT INTO ".$GLOBALS['prefix_lms']."_courseuser 
			( idUser, idCourse, level, waiting, subscribed_by ) 
			VALUES 
			( '".getLogUserId()."', '".$sel_course."', '3', '1', '".getLogUserId()."' )	");
			
			$array_subst = array(	'[url]' => $GLOBALS['lms']['url'],
								'[course]' => $course['name'],
								'[price]' => $course['prize'] );
		
			require_once($GLOBALS['where_framework'].'/lib/lib.eventmanager.php');
			if($re) {
				
				// message to user that is waiting 
				$msg_composer = new EventMessageComposer('subscribe', 'framework');
				
				$msg_composer->setSubjectLangText('email', '_NEW_USER_SUBS_BUY_SUBJECT', false);
				$msg_composer->setBodyLangText('email', '_NEW_USER_SUBS_BUY_TEXT', $array_subst);
				
				$msg_composer->setSubjectLangText('sms', '_NEW_USER_SUBS_BUY_SUBJECT_SMS', false);
				$msg_composer->setBodyLangText('sms', '_NEW_USER_SUBS_BUY_TEXT_SMS', $array_subst);
				
				// send message to the user subscribed
				createNewAlert(	'UserCourseBuy', 'subscribe', 'insert', '1', 'User buy a course',
							array(getLogUserId()), $msg_composer, true );
			} 
			jumpTo('index.php?modname=coursecatalogue&amp;op=courselist&amp;re='.( $re ? 'ok_buy' : 'err_buy' ));
			
		} elseif($can_subscribe) {
			
			//retrive id of group of the course for the varioud level
			$level_idst =& getCourseLevel($sel_course);
			
			// Add in group for permission
			$acl_man =& $GLOBALS['current_user']->getAclManager();
			$acl_man->addToGroup($level_idst[3], getLogUserId());
			
			// Add in table
			$re = mysql_query("
			INSERT INTO ".$GLOBALS['prefix_lms']."_courseuser 
			( idUser, idCourse, level, waiting, subscribed_by ) 
			VALUES 
			( '".getLogUserId()."', '".$sel_course."', '3', '".$waiting."', '".getLogUserId()."' )	");
			
			$array_subst = array(	'[url]' => $GLOBALS['lms']['url'],
								'[course]' => $course['name'] );
		
			require_once($GLOBALS['where_framework'].'/lib/lib.eventmanager.php');
			if($re) {
				
				if($waiting) {
					
					// message to user that is waiting 
					$msg_composer = new EventMessageComposer('subscribe', 'lms');
					
					$msg_composer->setSubjectLangText('email', '_NEW_USER_SUBS_WAITING_SUBJECT', false);
					$msg_composer->setBodyLangText('email', '_NEW_USER_SUBS_WAITING_TEXT', $array_subst);
					
					$msg_composer->setSubjectLangText('sms', '_NEW_USER_SUBS_WAITING_SUBJECT_SMS', false);
					$msg_composer->setBodyLangText('sms', '_NEW_USER_SUBS_WAITING_TEXT_SMS', $array_subst);
					
					// send message to the user subscribed
					createNewAlert(	'UserCourseInsertModerate', 'subscribe', 'insert', '1', 'User subscribed with moderation',
								array(getLogUserId()), $msg_composer  );
				} else {
					
					// message to user that is waiting 
					$msg_composer = new EventMessageComposer('subscribe', 'lms');
					
					$msg_composer->setSubjectLangText('email', '_NEW_USER_SUBSCRIBED_SUBJECT', false);
					$msg_composer->setBodyLangText('email', '_NEW_USER_SUBSCRIBED_TEXT', $array_subst);
					
					$msg_composer->setSubjectLangText('sms', '_NEW_USER_SUBSCRIBED_SUBJECT_SMS', false);
					$msg_composer->setBodyLangText('sms', '_NEW_USER_SUBSCRIBED_TEXT_SMS', $array_subst);
					
					// send message to the user subscribed
					createNewAlert(	'UserCourseInserted', 'subscribe', 'insert', '1', 'User subscribed',
								array(getLogUserId()), $msg_composer  );
				}
			}
			
			jumpTo('index.php?modname=coursecatalogue&amp;op=courselist&amp;re='.( $re ? ( $waiting ? 'ok_wait' : 'ok_subs' ) : 'err_subs' ));
		}
	} elseif($course['selling'] == 1) {
		
		// sure to buy
		$GLOBALS['page']->add(
			'<div class="boxinfo_title">'
			.$lang->def('_ARESURE_BY_COURSE')
			.'</div>'
			.'<div class="boxinfo_container">'
			.'<b>'.$lang->def('_CODE', 'course').' : </b>'.$course['code'].'<br />'
			.'<b>'.$lang->def('_COURSE', 'course').' : </b>'.$course['name'].'<br />'
			.'<b>'.$lang->def('_PRICE_COURSE', 'course').' : </b>'.$course['prize'].'<br />'
			.'<b>'.$lang->def('_DESCRIPTION', 'course').' : </b>'.$course['description']
			.'</div>'
			.'<div class="confirm_container">'
				.'<a href="index.php?modname=coursecatalogue&amp;op=subscribecourse&amp;id='.$sel_course.'&amp;confirm=1" title="'.$lang->def('_CONFIRM').'">'
					.'<img src="'.getPathImage().'standard/confirm.gif" alt="'.$lang->def('_CONFIRM').'" />'.$lang->def('_CONFIRM').'</a>'
				.'<a href="index.php?modname=coursecatalogue&amp;op=courselist" title="'.$lang->def('_UNDO').'">'
					.'<img src="'.getPathImage().'standard/undo.gif" alt="'.$lang->def('_UNDO').'" />'.$lang->def('_UNDO').'</a>'
			.'</div>'
		, 'content');
		
	} else {
		
		// sure to subscribe
		
		$GLOBALS['page']->add(
			'<div class="boxinfo_title">'
			.$lang->def('_ARESURE_SUBSCRIBE')
			.'</div>'
			.'<div class="boxinfo_container">'
			.'<span>'.$lang->def('_CODE', 'course').' : </span>'.$course['code'].'<br />'
			.'<span>'.$lang->def('_COURSE', 'course').' : </span>'.$course['name'].'<br />'
			.'<span>'.$lang->def('_DESCRIPTION', 'course').' : </span>'.$course['description']
			.'</div>'
			.'<div class="confirm_container">'
				.'<a href="index.php?modname=coursecatalogue&amp;op=subscribecourse&amp;id='.$sel_course.'&amp;confirm=1" title="'.$lang->def('_CONFIRM').'">'
					.'<img src="'.getPathImage().'standard/confirm.gif" alt="'.$lang->def('_CONFIRM').'" />'.$lang->def('_CONFIRM').'</a>'
				.'<a href="index.php?modname=coursecatalogue&amp;op=courselist" title="'.$lang->def('_UNDO').'">'
					.'<img src="'.getPathImage().'standard/undo.gif" alt="'.$lang->def('_UNDO').'" />'.$lang->def('_UNDO').'</a>'
			.'</div>'
		, 'content');
	}
	$GLOBALS['page']->add('</div>', 'content');
}


function subscribecoursepath() {
	checkPerm('view');
	
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.catalogue.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.coursepath.php');
	require_once($GLOBALS['where_lms'].'/lib/lib.course.php');
	
	$lang =& DoceboLanguage::createInstance('course');
	$lang =& DoceboLanguage::createInstance('coursecatalogue');
	
	$sel_coursepath = importVar('id', true, 0);
	$man_coursepath = new CoursePath_Manager();
	$coursepath = $man_coursepath->getCoursepathInfo($sel_coursepath);
	
	$page_title = array(
		'index.php?modname=coursecatalogue&amp;op=courselist' => $lang->def('_TITLE_COURSECATALOGUE'),
		$lang->def('_SUBSCRIBE_COURSE', 'course').' : '.$coursepath['path_name'] );
	$GLOBALS['page']->add(
		getTitleArea($page_title, 'coursecatalogue', $lang->def('_ALT_COURSECATALOGUE') )
		.'<div class="std_block">', 'content');
	
	$cat_man 		= new Catalogue_Manager();
	$catalogues 	=& $cat_man->getUserAllCatalogueId( getLogUserId() );
	
	$user_coursepath 		=& getUserCoursepath( getLogUserId() );
	$user_coursepath_wait 	=& getUserCoursepathWait( getLogUserId() );
	
	if(!empty($catalogues)) {
		
		// at least one catalogue is assigned to this user
		$cat_courses 		=& $cat_man->getAllCoursepathOfUser( getLogUserId() );
		if(!isset($cat_courses[$sel_coursepath])) {
		
			$GLOBALS['page']->add(
				getErrorUi($lang->def('_THIS_ISNT_IN_POOL')).'</div>', 
			'content');
			return;
		}
	}
	
	$can_subscribe = false;
	if(isset($user_coursepath[$sel_coursepath])) {
		
		if(isset($user_coursepath_wait[$sel_coursepath])) {
			$GLOBALS['page']->add(
				getErrorUi($lang->def('_YOU_ARE_WAITING')).'</div>', 
			'content');
			return;
		} else {
			$GLOBALS['page']->add(
				getErrorUi($lang->def('_YOU_ARE_ALREDY_SUBSCRIBED')).'</div>', 
			'content');
			return;
		}
	} else {
		
		$waiting = 1;
		switch($coursepath['subscribe_method']) {
			case "0" : {
				$GLOBALS['page']->add(
					getErrorUi($lang->def('_CANNOT_SUBSCRIBE')).'</div>', 
				'content');
				return;
			};break;
			case "1" : {
				$write = $lang->def('_MUST_WAIT_FOR_MODERATION_PC', 'course');
				$can_subscribe = true;
			};break;
			case "2" : {
				$write = $lang->def('_DIRECT_SUBSCRIPTION', 'course');
				$can_subscribe = true;
				$waiting = 0;
			};break;
		}
	}
	$GLOBALS['page']->add(getResultUi($write), 'content');
	
	if(isset($_GET['confirm'])) {
		if($can_subscribe) {
			
			// Add in table
			$re = mysql_query("
			INSERT INTO ".$GLOBALS['prefix_lms']."_coursepath_user 
			( idUser, idPath, waiting, subscribed_by ) 
			VALUES 
			( '".getLogUserId()."', '".$sel_coursepath."', '".$waiting."', '".getLogUserId()."' )	");
			
			jumpTo('index.php?modname=coursecatalogue&amp;op=courselist&amp;re='.( $re ? ( $waiting ? 'ok_wait' : 'ok' ) : 'err' ));
		}
	} else {
		
		$GLOBALS['page']->add(
			'<div class="boxinfo_title">'
			.$lang->def('_ARESURE_SUBSCRIBE')
			.'</div>'
			.'<div class="boxinfo_container">'
			.'<span>'.$lang->def('_CODE_PATH', 'course').' : </span>'.$coursepath['path_code'].'<br />'
			.'<span>'.$lang->def('_PATHCOURSE', 'course').' : </span>'.$coursepath['path_name'].'<br />'
			.'<span>'.$lang->def('_DESCRIPTION', 'course').' : </span>'.$coursepath['path_descr']
			.'</div>'
			.'<div class="confirm_container">'
				.'<a href="index.php?modname=coursecatalogue&amp;op=subscribecoursepath&amp;id='.$sel_coursepath.'&amp;confirm=1" title="'.$lang->def('_CONFIRM').'">'
					.'<img src="'.getPathImage().'standard/confirm.gif" alt="'.$lang->def('_CONFIRM').'" />'.$lang->def('_CONFIRM').'</a>'
				.'<a href="index.php?modname=coursecatalogue&amp;op=courselist" title="'.$lang->def('_UNDO').'">'
					.'<img src="'.getPathImage().'standard/undo.gif" alt="'.$lang->def('_UNDO').'" />'.$lang->def('_UNDO').'</a>'
			.'</div>'
		, 'content');
	}
	$GLOBALS['page']->add('</div>', 'content');
}

function coursecatalogueDispatch($op) {
	
	switch($op) {
		case "subscribecourse" : {
			subscribecourse();
		};break;
		case "subscribecoursepath" : {
			subscribecoursepath();
		};break;
		default : {
			courselist();
		}
	}
}

?>