<?php

/************************************************************************/
/* DOCEBO LMS - Learning Managment System                               */
/* ============================================                         */
/*                                                                      */
/* Copyright (c) 2004                                                   */
/* http://www.docebo.com                                                */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

if(!$GLOBALS['current_user']->isAnonymous()) {

function profile() {
	checkPerm('view');
	
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
	
	$acl_man 	=& $GLOBALS['current_user']->getAClManager();
	$lang 		=& DoceboLanguage::createInstance('profile');
	$mod_perm = checkPerm('mod', true, 'profile');
	$user_info = $acl_man->getUser(getLogUserId(), false);
	
	$GLOBALS['page']->add(
		getTitleArea($lang->def('_PROFILE'), 'profile', $lang->def('_PROFILE_ALT'))
		.'<div class="std_block">', 'content');
	
	if(isset($_GET['result'])) {
		switch($_GET['result']) {
			case "ok" 	: $GLOBALS['page']->add(getResultUi($lang->def('_OKSAVE')), 'content');break;
			
			case "err" 	: $GLOBALS['page']->add(getErrorUi($lang->def('_ERRSAVE')), 'content');break;
			case "err_notsupported" : $GLOBALS['page']->add(getErrorUi($lang->def('_ERRSAVE_NOT_TOOLARGE')), 'content');break;
			case "err_pwd_match" 	: $GLOBALS['page']->add(getErrorUi($lang->def('_PASSNOMATCH')), 'content');break;
			case "err_old_pwd" 		: $GLOBALS['page']->add(getErrorUi($lang->def('_OLDPASSWRONG')), 'content');break;
			case "err_mandatory" 	: $GLOBALS['page']->add(getErrorUi($lang->def('_SOME_MANDATORY_EMPTY')), 'content');break;
		}
	}
	
	$GLOBALS['page']->add('<div class="boxinfo_title">'.$lang->def('_USERPARAM').'</div>'
		.Form::getLineBox($lang->def('_USERID'), $acl_man->relativeId($user_info[ACL_INFO_USERID]) )
		.Form::getLineBox($lang->def('_SURNAME'), $user_info[ACL_INFO_LASTNAME] )
		.Form::getLineBox($lang->def('_NAME'), $user_info[ACL_INFO_FIRSTNAME] )
		.Form::getLineBox($lang->def('_EMAIL'), $user_info[ACL_INFO_EMAIL] ), 'content');
	
	$expand_extra_field = isset($_GET['more_extra']);
	//echo '<div class="boxinfo_title">'.$lang->def('_EXTRAFIELD').'</div>';
	
	if($expand_extra_field) {
		$GLOBALS['page']->add('<a href="index.php?modname=profile&amp;op=profile" title="'.$lang->def('_COLLAPSE_EXTRA').'">'
			.'<img src="'.getPathImage('fw').'standard/less.gif" alt="'.$lang->def('_ALT_LESS').'" />'
			.$lang->def('_COLLAPSE_EXTRA').'</a>', 'content');
		
		$extra_field = new FieldList();
		$GLOBALS['page']->add($extra_field->playFieldsForUser( getLogUserId(), false, true, true, array('readonly') ), 'content');
	} else {
		
		$GLOBALS['page']->add('<a href="index.php?modname=profile&amp;op=profile&amp;more_extra=1" title="'.$lang->def('_EXPAND_EXTRA').'">'
			.'<img src="'.getPathImage('fw').'standard/more.gif" alt="'.$lang->def('_ALT_MORE').'" />'
			.$lang->def('_EXPAND_EXTRA').'</a>', 'content');
	}
	
	$GLOBALS['page']->add(
		Form::getBreakRow()
		.'<div class="boxinfo_title">'.$lang->def('_USERSTRUCTURALPARAM').'</div>'
		.$GLOBALS['current_user']->preference->getFreezeMask('ui.')
		
		.'<div class="boxinfo_title">'.$lang->def('_USERFORUMPARAM').'</div>'
		.'<table class="profile_images">'
		.'<tr><td>', 'content');
	// NOTE: photo
	$path = $GLOBALS['where_files_relative'].'/doceboCore/'.$GLOBALS['framework']['pathphoto'];
	if($user_info[ACL_INFO_PHOTO] != "") {
		
		$img_size = @getimagesize($path.$user_info[ACL_INFO_PHOTO]);
		$GLOBALS['page']->add('<img class="profile_image'
			.( $img_size[0] > 150 || $img_size[1] > 150 ? ' image_limit' : '' )
			.'" src="'.$path.$user_info[ACL_INFO_PHOTO].'" alt="'.$lang->def('_PHOTO').'" /><br />', 'content');
	} else {
		$GLOBALS['page']->add('<div class="text_italic">'.$lang->def('_NOPHOTO').'</div>', 'content');
	}
	if( $mod_perm ) {
		$GLOBALS['page']->add('<a href="index.php?modname=profile&amp;op=newphoto">'.$lang->def('_NEWPHOTO').'</a>', 'content');
	}
	$GLOBALS['page']->add('</td>'
		.'<td>', 'content');
	// NOTE: avatar
	if($user_info[ACL_INFO_AVATAR] != "") {
		
		$img_size = @getimagesize($path.$user_info[ACL_INFO_AVATAR]);
		$GLOBALS['page']->add('<img class="profile_image'
			.( $img_size[0] > 150 || $img_size[1] > 150 ? ' image_limit' : '' )
			.'" src="'.$path.$user_info[ACL_INFO_AVATAR].'" alt="'.$lang->def('_AVATAR').'" /><br />', 'content');
	} else {
		
		$GLOBALS['page']->add('<div class="text_italic">'.$lang->def('_NOAVATAR').'</div>', 'content');
	}
	if( $mod_perm ) {
		
		$GLOBALS['page']->add('<a href="index.php?modname=profile&amp;op=newavatar">'.$lang->def('_NEWAVATAR').'</a>', 'content');
	}
	// NOTE: signature
	$GLOBALS['page']->add('</td></tr></table>'	
		.'<div class="title">'.$lang->def('_SIGNATURE').'</div>'
		.'<div class="profile_signature">'.$user_info[ACL_INFO_SIGNATURE].'</div><br />'."\n", 'content');
	
	if( $mod_perm ) {
		
		$GLOBALS['page']->add('<a href="index.php?modname=profile&amp;op=modprofile">'
			.'<img src="'.getPathImage().'standard/mod.gif" alt="'.$lang->def('_MOD').'" /> '.$lang->def('_CHANGEINFO').'</a>', 'content');
	}
	$GLOBALS['page']->add('</div>', 'content');
}


// XXX: modprofile
function modprofile() {
	checkPerm('mod');
	
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
	
	$acl_man 	=& $GLOBALS['current_user']->getAClManager();
	$lang 		=& DoceboLanguage::createInstance('profile');
	
	$user_info = $acl_man->getUser(getLogUserId(), false);
	
	$GLOBALS['page']->add(
		getTitleArea($lang->def('_PROFILE'), 'profile', $lang->def('_PROFILE_ALT'))
		.'<div class="std_block">'
		.getBackUi('index.php?modname=profile&amp;op=profile', $lang->def('_BACK'))
		
		.Form::openForm('profileform', 'index.php?modname=profile&amp;op=saveprofile', false, false, 'multipart/form-data')
		
		.'<div class="boxinfo_title">'.$lang->def('_USERPARAM').'</div>'
		.Form::getLineBox($lang->def('_USERID'), substr($user_info[ACL_INFO_USERID], 1) )
		.Form::getTextfield($lang->def('_SURNAME'), 'profile_lastname', 'profile[lastname]', 255, $user_info[ACL_INFO_LASTNAME])
		.Form::getTextfield($lang->def('_NAME'), 'profile_firstname', 'profile[firstname]', 255, $user_info[ACL_INFO_FIRSTNAME])
		.Form::getTextfield($lang->def('_EMAIL'), 'profile_email', 'profile[email]', 255, $user_info[ACL_INFO_EMAIL])
		
		.'<div class="boxinfo_title">'.$lang->def('_USERPWDPARAM').'</div>'
		.Form::getPassword($lang->def('_OLD_PWD'), 'profile_oldpwd', 'profile[oldpwd]', 30)
		.Form::getPassword($lang->def('_NEW_PWD'), 'profile_newpwd', 'profile[newpwd]', 30)
		.Form::getPassword($lang->def('_RE_PWD'), 'profile_repwd', 'profile[repwd]', 30)
		
		.Form::getBreakRow()
		.Form::openButtonSpace()
		.Form::getButton('save_info', 'save_info', $lang->def('_SAVE'))
		.Form::getButton('undo', 'undo', $lang->def('_UNDO'))
		.Form::closeButtonSpace()
	, 'content');
		
	$extra_field = new FieldList();
	$play_field = $extra_field->playFieldsForUser( getLogUserId(), false, false, true, array('readonly') );
	if($play_field != '') {
		$GLOBALS['page']->add(
			'<div class="boxinfo_title">'.$lang->def('_EXTRAFIELD').'</div>'
			.$play_field
			.Form::getBreakRow()
		, 'content');
	}
	$GLOBALS['page']->add(
		'<div class="boxinfo_title">'.$lang->def('_USERSTRUCTURALPARAM').'</div>'
		.$GLOBALS['current_user']->preference->getModifyMask('ui.')
		.Form::getBreakRow()
		
		.'<div class="boxinfo_title">'.$lang->def('_USERFORUMPARAM').'</div>'
		.Form::getTextarea($lang->def('_SIGNATURE'), 'profile_signature', 'profile_signature', $user_info[ACL_INFO_SIGNATURE])
		
		.Form::openButtonSpace()
		.Form::getButton('save_info', 'save_info', $lang->def('_SAVE'))
		.Form::getButton('undo', 'undo', $lang->def('_UNDO'))
		.Form::closeButtonSpace()
		.Form::closeForm()
		.'</div>'
	, 'content');
}

function saveprofile() {
	checkPerm('mod');
	
	require_once($GLOBALS['where_framework'].'/lib/lib.field.php');
	
	if(isset($_POST['undo'])) jumpTo('index.php?modname=profile&amp;op=profile');
	
	$extra_field = new FieldList();
	$lang 		=& DoceboLanguage::createInstance('profile');
	$acl_man 	=& $GLOBALS['current_user']->getAclManager();
	$user_info 	= $acl_man->getUser(getLogUserId(), false);
	
	$new_pwd = false;
	if($_POST['profile']['oldpwd'] != ''
		|| ($_POST['profile']['newpwd'] != '' && $_POST['profile']['repwd'] != '') ) {
		
		//change password
		if($user_info[ACL_INFO_PASS] == $acl_man->encrypt($_POST['profile']['oldpwd'])) {
			
			if($_POST['profile']['newpwd'] != $_POST['profile']['repwd']) {
				
				jumpTo( 'index.php?modname=profile&op=profile&result=err_pwd_match');
			} else {
				$new_pwd = $_POST['profile']['newpwd'];
			}
		} else jumpTo( 'index.php?modname=profile&op=profile&result=err_old_pwd');
	}
	
	// Control mandatory
	$re_filled = $extra_field->isFilledFieldsForUser(getLogUserId());
	if(!$re_filled) {
		
		jumpTo( 'index.php?modname=profile&op=profile&result=err_mandatory');
	}
	
	$result = $acl_man->updateUser( 
		getLogUserId(), 
		FALSE, 
		$_POST['profile']['firstname'], 
		$_POST['profile']['lastname'],
		$new_pwd, 
		$_POST['profile']['email'], 
		FALSE, 
		FALSE,
		$_POST['profile_signature'] );
	if(!$result) jumpTo( 'index.php?modname=profile&op=profile&result=err');
	
	$extra_field->storeFieldsForUser( getLogUserId() );
	
	$result = $GLOBALS['current_user']->preference->savePreferences( $_POST, 'ui.' );

	if(!$result) jumpTo( 'index.php?modname=profile&op=profile&result=err');
	else jumpTo( 'index.php?modname=profile&op=profile&result=ok');
}

function newphoto() {
	checkPerm('mod');
	
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	$lang 		=& DoceboLanguage::createInstance('profile');
	
	$GLOBALS['page']->add(
		getTitleArea($lang->def('_PROFILE'), 'profile')
		.'<div class="std_block">'
		.getBackUi('index.php?modname=profile&amp;op=profile', $lang->def('_BACK'))
		.Form::openForm('new_photo', 'index.php?modname=profile&amp;op=upphoto', false, false, 'multipart/form-data' )
		.Form::openElementSpace()
		.Form::getFilefield($lang->def('_LOADPHOTO'), 'photo', 'photo')
		.Form::closeElementSpace()
		.Form::openButtonSpace()
		.Form::getButton('send', 'send', $lang->def('_SENDIMG'))
		.Form::getButton('undo', 'undo', $lang->def('_UNDO'))
		.Form::closeButtonSpace()
		.Form::closeForm()
		.'</div>'
	, 'content');
}

function newavatar() {
	checkPerm('mod');
	
	require_once($GLOBALS['where_framework'].'/lib/lib.form.php');
	$lang 		=& DoceboLanguage::createInstance('profile');
	
	$GLOBALS['page']->add(
		getTitleArea($lang->def('_PROFILE'), 'profile')
		.'<div class="std_block">'
		.getBackUi('index.php?modname=profile&amp;op=profile', $lang->def('_BACK'))
		.Form::openForm('new_photo', 'index.php?modname=profile&amp;op=upavatar', false, false, 'multipart/form-data' )
		.Form::openElementSpace()
		.Form::getFilefield($lang->def('_LOADAVATAR'), 'avatar', 'avatar')
		.Form::closeElementSpace()
		.Form::openButtonSpace()
		.Form::getButton('send', 'send', $lang->def('_SENDIMG'))
		.Form::getButton('undo', 'undo', $lang->def('_UNDO'))
		.Form::closeButtonSpace()
		.Form::closeForm()
		.'</div>'
	, 'content');
}

function upphoto() {
	checkPerm('mod');
	
	require_once($GLOBALS['where_framework'].'/lib/lib.upload.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.multimedia.php');
	
	$acl_man 			=& $GLOBALS['current_user']->getAclManager();
	$user_info 			= $acl_man->getUser(getLogUserId(), false);
	$name_old_photo		=  $user_info[ACL_INFO_PHOTO];
	
	$path = '/doceboCore/'.$GLOBALS['framework']['pathphoto'];
	$file = '';
	sl_open_fileoperations();
	if(isset($_FILES['photo']['tmp_name']) && $_FILES['photo']['tmp_name'] != '') {
		
		//resize photo
		$file = getLogUserId().'_'.mt_rand(0, 100).'_'.time().'_'.$_FILES['photo']['name'];
		$re = createImageFromTmp($_FILES['photo']['tmp_name'], 
							$path.$file, 
							$_FILES['photo']['name'],
							150,
							150,
							true );
		if($re < 0) {
			$error = 1;
			if($re == -4) $error = 2;
			$file = '';
		} else {
			$error = 0;
		}
	}
	sl_close_fileoperations();
	if($error) jumpTo( 'index.php?modname=profile&op=profile&result='.( $error == 1 ? 'err' : 'err_notsupported' ));
	if($name_old_photo != '' && sl_file_exists($path.$name_old_photo)) {
		if(!sl_unlink($path.$name_old_photo)) {
			jumpTo( 'index.php?modname=profile&op=profile&result=err');
		}
	}
	$result = $acl_man->updateUser( getLogUserId(), FALSE, FALSE, FALSE,FALSE, FALSE, 
									$file, 
									FALSE, FALSE );
	if(!$result) {
		sl_unlink($path.$file);
		jumpTo( 'index.php?modname=profile&op=profile&result=err');
	}
	jumpTo('index.php?modname=profile&op=profile&result=ok');
}

function upavatar() {
	checkPerm('mod');
	
	require_once($GLOBALS['where_framework'].'/lib/lib.upload.php');
	require_once($GLOBALS['where_framework'].'/lib/lib.multimedia.php');
	
	$acl_man 			=& $GLOBALS['current_user']->getAclManager();
	$user_info 			= $acl_man->getUser(getLogUserId(), false);
	$name_old_avatar		=  $user_info[ACL_INFO_AVATAR];
	
	$path = '/doceboCore/'.$GLOBALS['framework']['pathphoto'];
	$file = '';
	sl_open_fileoperations();
	if(isset($_FILES['avatar']['tmp_name']) && $_FILES['avatar']['tmp_name'] != '') {
		
		//resize photo
		$file = getLogUserId().'_'.mt_rand(100, 200).'_'.time().'_'.$_FILES['avatar']['name'];
		$re = createImageFromTmp($_FILES['avatar']['tmp_name'], 
							$path.$file, 
							$_FILES['avatar']['name'],
							150,
							150,
							true );
		if($re < 0) {
			$error = 1;
			$file = '';
		} else {
			$error = 0;
		}
	}
	sl_close_fileoperations();
	if($error) jumpTo( 'index.php?modname=profile&op=profile&result=err');
	if($name_old_avatar != '' && file_exists($GLOBALS['where_files_relative'].$path.$name_old_avatar)) {
		if(!sl_unlink($path.$name_old_avatar)) {
			jumpTo( 'index.php?modname=profile&op=profile&result=err');
		}
	}
	$result = $acl_man->updateUser( getLogUserId(), FALSE, FALSE, FALSE,FALSE, FALSE, FALSE, 
									$file, 
									FALSE );
	if(!$result) {
		sl_unlink($path.$file);
		jumpTo( 'index.php?modname=profile&op=profile&result=err');
	}
	jumpTo('index.php?modname=profile&op=profile&result=ok');
}

// XXX: renewal expired password
function renewalpwd() {
	
	require_once($GLOBALS['where_framework'].'/lib/lib.usermanager.php');
	$user_manager = new UserManager();
	$lang 		=& DoceboLanguage::createInstance('profile');
	
	
	if($user_manager->clickSaveElapsed()) {
		
		$error = $user_manager->saveElapsedPassword();
		if($error['error'] == true) {
			
			$GLOBALS['page']->add(
				getTitleArea($lang->def('_TITLE_CHANGE'), 'profile')
				.'<div class="std_block">'
				.$error['msg']
				.$user_manager->getElapsedPassword('index.php?modname=profile&amp;op=renewalpwd')
				.'</div>', 'content');
		} else {
			jumpTo('index.php?modname=course&amp;op=mycourses');
		}
		
	} else {
		
		$GLOBALS['page']->add(
			getTitleArea($lang->def('_TITLE_CHANGE'), 'profile')
			.'<div class="std_block">'
			.$user_manager->getElapsedPassword('index.php?modname=profile&amp;op=renewalpwd')
			.'</div>', 'content');
			
	}
}

function profileDispatch($op) {
	if(isset($_POST['undo'])) $op = 'profile';
	switch($op) {
		case "profile" : {
			profile();
		};break;
		case "modprofile" : {
			modprofile();
		};break;
		case "saveprofile" : {
			saveprofile();
		};break;
		
		case "newphoto" : {
			newphoto();
		};break;
		case "upphoto" : {
			upphoto();
		};break;
		case "newavatar" : {
			newavatar();
		};break;
		case "upavatar" : {
			upavatar();
		};break;
		
		case "renewalpwd" : {
			renewalpwd();
		};break;
	}
}

}

?>