<?php

/************************************************************************/
/* DOCEBO SCS - Synchronous Collaboration System							*/
/* ============================================                         */
/*                                                                      */
/* Copyright (c) 2004                                                   */
/* http://www.docebo.com                                                */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

if(!defined('IN_DOCEBO')) die('You cannot access this file directly');

require_once($GLOBALS['where_scs'].'/setting.php');

define("_TELESKILL_STREAM_TIMEOUT", "10");

define("TELESKILL_ROOMID", 		0);
define("TELESKILL_UID", 		1);
define("TELESKILL_ZONE", 		2);
define("TELESKILL_TITLE", 		3);
define("TELESKILL_START_DATE", 	4);
define("TELESKILL_END_DATE", 	5);

class Teleskill_Management {
	
	function _query($query) {
		
		$re = mysql_query($query);
		if(!$re) echo '<!-- Teleskill_Management - query : '.$query.' error : '.mysql_error().' -->';
		else echo '<!-- Teleskill_Management - query : '.$query.' -->';
		return $re;
	}
	
	function _getRoomTable() {
		
		return $GLOBALS['prefix_scs'].'_teleskill_room';
	}
	
	function Teleskill_Management() {
		
	}
	
	/**
	 * The only purpose of this function is to send the message to the server, read the server answer, 
	 * discard the header and return the other content
	 *
	 * @param 	string	$xml_request 	is the xml request that will be sended to teleskill
	 *
	 * @return 	mixed 	the xml returned by teleskill or false if error
	 */
	function _sendXmlRequest($xml_request) {
		
		$xml_answer = false;
		
		$remote_url = $GLOBALS['scs']['url_checkin_teleskill'];
		$tmp_url = parse_url($remote_url);
		
		$post_data = urlencode('message').'='.urlencode($xml_request);
		
		$post_request = "POST $remote_url HTTP/1.0\r\n"
			."Host: ".$tmp_url['host']."\r\n"
			."User-Agent: PHP Script\r\n"
			."Content-type: application/x-www-form-urlencoded\r\n"
			."Content-length: ".strlen($post_data)."\r\n"
			."Connection: close\r\n\r\n"
			.$post_data."\r\n\r\n";
		
		$socket = fsockopen($tmp_url['host'], 80);
		
		if(!$socket) return false;
		socket_set_timeout($socket, _TELESKILL_STREAM_TIMEOUT);
		fputs($socket, $post_request);
		
		// discad header
		$head = fgets($socket);
		if(substr_count($head, "200 OK") > 0) {
			
			$hedaer_row = 0;
			while(!(fgets($socket) == "\r\n") && $hedaer_row < 100) { ++$hedaer_row; }
			if($hedaer_row == 100) return false;
		} else return false;
		while(!feof($socket)) {
			
			$xml_answer .= fgets($socket, 4096);
		}
		fclose($socket);
		
		return $xml_answer;
	}
	
	/**
	 * send a message type 5 to the server and read the answer
	 * @param 	datetime 	$start_time 	room start time
	 * @param 	datetime 	$end_time 		room end time
	 * 
	 * @return mixed 	true if the user can open the room, else return an array with
	 *					array( errorcode => 1, errormessage => string ) 
	 */
	function canOpenRoom($start_time, $end_time) {
		
		$bw_code = getBrowserCode();
		$pos = strpos($bw_code, ';');
		if($pos !== false) $bw_code = substr($bw_code, 0, $pos);
		
		$request = trim(''
		.'<?xml version="1.0" encoding="utf-8"?'.'>
		<ews type="5" lang="'.$bw_code.'">
			<clientcode>'.$GLOBALS['scs']['code_teleskill'].'</clientcode>
			<startdate>'.$start_time.'</startdate>
			<enddate>'.$end_time.'</enddate>
		</ews>');
		
		$xml_answer = $this->_sendXmlRequest($request);
		
		if($xml_answer === false) return array('errorcode' => -1, 'errormessage' => '');
		
		$dom_answer = new DoceboDOMDocument();
		$dom_answer->loadXML( trim($xml_answer) );
		
		$dlist_code = $dom_answer->getElementsByTagName('errorcode');
		$dlist_msg 	= $dom_answer->getElementsByTagName('errormessage');
		$dnode_code = $dlist_code->item(0);
		$dnode_msg 	= $dlist_msg->item(0);
		
		$e_code 	= $dnode_code->textContent;
		$e_msg 		= $dnode_msg->textContent;
		
		if($e_code == 0) return true;
		
		return array('errorcode' => $e_code, 'errormessage' => $e_msg);
	}
	
	/**
	 * send a message type 1 to the server and read the answer
	 * @param 	int 		$uid 			unique identifier for the zone
	 * @param 	string 		$lms 			the label of the zone
	 * @param 	string 		$title 			the room title
	 * @param 	datetime 	$start_date 	room start datetime (Y-m-d H:i:s)
	 * @param 	datetime 	$end_date 		room end datetime (Y-m-d H:i:s)
	 * @param 	string 		$descr 			the room description
	 * @param 	string 		$logo 			the absolute url of the logo
	 * 
	 * @return array	return an array 
	 *					array( errorcode => int, errormessage => string, roomid => int ) 
	 */
	function openRoom($uid, $zone, $title, $start_date, $end_date, $descr = false, $logo = false) {
		
		$bw_code = getBrowserCode();
		$pos = strpos($bw_code, ';');
		if($pos !== false) $bw_code = substr($bw_code, 0, $pos);
		
		$request = ''
		.'<?xml version="1.0" encoding="utf-8"?'.'>
		<ews type="1" lang="'.$bw_code.'">
			<clientcode>'.$GLOBALS['scs']['code_teleskill'].'</clientcode>
			<startdate>'.$start_date.'</startdate>
			<enddate>'.$end_date.'</enddate>
			<title>'.$title.'</title>';
		if($descr != false) $request .= '	<descr>'.$descr.'</descr>';
		if($logo != false) 	$request .= '	<logo>'.$logo .'</logo>';
		$request .= '</ews>';
		
		$xml_answer = trim($this->_sendXmlRequest($request));
		
		if($xml_answer === false) return array('errorcode' => -1, 'errormessage' => '', 'roomid' => '');
		
		$dom_answer = new DoceboDOMDocument();
		$dom_answer->loadXML( $xml_answer );
		
		$dlist_code 	= $dom_answer->getElementsByTagName('errorcode');
		$dlist_msg 		= $dom_answer->getElementsByTagName('errormessage');
		$dlist_roomid 	= $dom_answer->getElementsByTagName('roomid');
		$dnode_code 	= $dlist_code->item(0);
		$dnode_msg 		= $dlist_msg->item(0);
		$dnode_roomid 	= $dlist_roomid->item(0);
		
		$e_code 	= $dnode_code->textContent;
		$e_msg 		= $dnode_msg->textContent;
		$roomid 	= $dnode_roomid->textContent;
		
		if($e_code == 0) {
			
			//save in database the roomid for user login
			
			$insert_room = "
			INSERT INTO ".$this->_getRoomTable()." 
			( uid, zone, roomid, title, start_date, end_date ) VALUES (
				'".$uid."', 
				'".$zone."', 
				'".$roomid."', 
				'".$title."', 
				'".$start_date."', 
				'".$end_date."' 
			)";
			
			$re = $this->_query($insert_room);
			if(!$re) {
				//the room record isn't saved ...
				
			}
		}
		return array(	'errorcode' => $e_code, 
						'errormessage' => $e_msg, 
						'roomid' => $roomid );
	}
	
	/**
	 * send a message type 1 to the server and read the answer
	 * @param 	int 	$roomid 	the room identifier
	 * @param 	int 	$role 		the role in the room 1 = normal, 2 = tutor
	 * @param 	string 	$userid 	the userid
	 * @param 	string 	$user_name 	the user real name
	 * @param 	string 	$email 		the user email
	 * 
	 * @return array 	return an array 
	 *					array( errorcode => int, errormessage => string, url => string, fullroom => int )
	 *					if fullroom == 1 the room is full 
	 */
	function loginIntoRoom($roomid, $role, $userid, $user_name, $email = false) {
		
		$bw_code = getBrowserCode();
		$pos = strpos($bw_code, ';');
		if($pos !== false) $bw_code = substr($bw_code, 0, $pos);
		
		$request = ''
		.'<?xml version="1.0" encoding="utf-8"?'.'>
		<ews type="3" lang="'.$bw_code.'">
			<clientcode>'.$GLOBALS['scs']['code_teleskill'].'</clientcode>
			<roomid>'.$roomid.'</roomid>
			<lmsuserid>'.$userid.'</lmsuserid>
			<role>'.$role.'</role>
			<name>'.$user_name.'</name>';
		$request .= ' <email>'.$email.'</email >';
		$request .= '</ews>';
		
		$xml_answer = trim($this->_sendXmlRequest($request));
		
		if($xml_answer === false) return array('errorcode' => -1, 'errormessage' => '', 'url' => '', 'fullroom' => 0);
		
		$dom_answer = new DoceboDOMDocument();
		$dom_answer->loadXML( $xml_answer );
		$dlist_code 	= $dom_answer->getElementsByTagName('errorcode');
		$dlist_msg 		= $dom_answer->getElementsByTagName('errormessage');
		$dlist_url 		= $dom_answer->getElementsByTagName('url');
		$dlist_fullroom	= $dom_answer->getElementsByTagName('fullroom');
		$dnode_code 	= $dlist_code->item(0);
		$dnode_msg 		= $dlist_msg->item(0);
		$dnode_url 		= $dlist_url->item(0);
		$dnode_fullroom = $dlist_fullroom->item(0);
		
		$e_code 	= $dnode_code->textContent;
		$e_msg 		= $dnode_msg->textContent;
		$log_url 	= $dnode_url->textContent;
		$fullroom 	= $dnode_fullroom->textContent;
		
		return array('errorcode' => $e_code, 'errormessage' => $e_msg, 'url' => $log_url, 'fullroom' => $fullroom);
	}
	
	/**
	 * create a new room and log the user
	 * $uid, $zone, 
	 * @param 	string 		$title 			the room title
	 * @param 	datetime 	$start_date 	room start datetime (Y-m-d H:i:s)
	 * @param 	datetime 	$end_date 		room end datetime (Y-m-d H:i:s)
	 * @param 	int 		$roomid 		the room identifier
	 * @param 	int 		$role 			the role in the room 1 = normal, 2 = tutor
	 * @param 	string 		$userid 		the userid
	 * @param 	string 		$user_name 		the user real name
	 * @param 	string 		$email 			the user email
	 * @param 	string 		$descr 			the room description
	 * @param 	string 		$logo 			the absolute url of the logo
	 *
	 * @return  mixed 		return an array 
	 *						array( errorcode => int, errormessage => string, url => string ) or false 
	 */
	function createRoomAndLogin($uid, $zone, $title, $start_date, $end_date, $userid, $user_name, $role, $email = false, $descr = false, $logo = false) {
		
		$re_room = $this->openRoom($uid, $zone, $title, $start_date, $end_date, $descr, $logo);
		
		if($re_room === false) return false;
		if($re_room['errorcode'] != 0) {
			
			unset($re_room['roomid']);
			$re_room['url'] = '';
			return $re_room;
		}
		
		$re_login = $this->loginIntoRoom($re_room['roomid'], $role, $userid, $user_name, $email);
		
		return $re_login;
	}
	
	function roomActive($uid, $zone, $at_date = false) {
		
		$room_open = "
		SELECT roomid, uid, zone, title, start_date, end_date 
		FROM ".$this->_getRoomTable()." 
		WHERE uid = '".$uid."' AND zone = '".$zone."'";
		if($at_date !== false) {
			
			$room_open .= " AND start_date <= '".$at_date."' AND '".$at_date."' <= end_date ";
		}
		$re_room = $this->_query($room_open);
		
		return $re_room;
	}
	
	function roomPlanned($uid, $zone, $at_date = false) {
		
		$room_open = "
		SELECT roomid, uid, zone, title, start_date, end_date 
		FROM ".$this->_getRoomTable()." 
		WHERE uid = '".$uid."' 
			AND zone = '".$zone."' 
			AND start_date > '".$at_date."'  ";
		$re_room = $this->_query($room_open);
		
		return $re_room;
	}
	
	function totalRoom($re_room) {
		
		return mysql_num_rows($re_room);
	}
	
	function nextRow($re_room) {
		
		return mysql_fetch_row($re_room);
	}
	
	function deleteOldRoom($uid, $zone, $at_date = false) {
		
		$room_open = "
		DELETE FROM ".$this->_getRoomTable()." 
		WHERE uid = '".$uid."' 
			AND zone = '".$zone."' 
			AND end_date < '".$at_date."'  ";
		$re_room = $this->_query($room_open);
		
		return $re_room;
	}
}

?>