<?php

class Upgrade_Course extends Upgrade {
	
	var $platfom = 'lms';
	
	var $mname = 'course';
	
	function _registerGroup($groupid, $descr = '') {
		
		$query = "
		INSERT INTO core_st ( idst ) VALUES ( '' );
		INSERT INTO core_group "
		." (idst, groupid, description, hidden ) VALUES ( LAST_INSERT_ID(), '".$groupid."', '".$descr."' ,'true' );";
		$this->db_man->query($query);
				
		return $this->db_man->lastInsertId();
	}
	
	function _registerGroupMembers($id_user, $id_group) {
		
		$query = "INSERT INTO core_group_members "
					."( idst, idstMember ) "
					."VALUES ( '".$id_group."','".$id_user."' )";
		$this->db_man->query($query);
	}
	
	/**
	 * upgrade the module version
	 * @param string 	$start_version 	the start version, automaticaly prooceed to the next
	 *
	 * @return mixed 	true if the version jump was successful, else an array with an error code and an error message
	 * 					array( 'error_code', 'error_msg' )
	 **/
	function oneStepUpgrade($start_version) {
		
		switch($start_version) {
			case "2.0.4" : {
				
				$query = "CREATE TABLE `core_admin_course` (
				  `idst_user` int(11) NOT NULL default '0',
				  `type_of_entry` varchar(50) NOT NULL default '',
				  `id_entry` int(11) NOT NULL default '0',
				  PRIMARY KEY  (`idst_user`,`type_of_entry`,`id_entry`)
				)";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 1);
				
				$query = "
				ALTER TABLE `learning_course` 
				CHANGE `name` `name` VARCHAR( 255 ) NOT NULL ,
				CHANGE `language` `lang_code` VARCHAR( 100 ) NOT NULL ,
				CHANGE `difficult` `difficult` ENUM( 'veryeasy', 'easy', 'medium', 'difficult', 'verydifficult' ) NOT NULL DEFAULT 'medium',
				CHANGE `canModifyPolicy` `show_extra_info` TINYINT( 1 ) NOT NULL DEFAULT '0',
				CHANGE `showProgress` `show_progress` TINYINT( 1 ) NOT NULL DEFAULT '1',
				CHANGE `hideCourse` `show_rules` TINYINT( 1 ) NOT NULL DEFAULT '0',
				CHANGE `prize` `prize` VARCHAR( 255 ) NOT NULL DEFAULT '',
				CHANGE `autosubscribe` `subscribe_method` TINYINT( 1 ) NOT NULL DEFAULT '0';";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 2);
				
				$query = "
				ALTER TABLE `learning_course` 
				ADD `level_show_user` INT( 11 ) DEFAULT '0' NOT NULL AFTER `status` ,
				ADD `show_time` TINYINT( 1 ) NOT NULL AFTER `show_progress` ,
				ADD `img_course` VARCHAR( 255 ) NOT NULL AFTER `imgSponsor`,
				ADD `date_begin` DATE NOT NULL AFTER `show_rules` ,
				ADD `date_end` DATE NOT NULL AFTER `date_begin` ,
				ADD `valid_time` INT( 10 ) NOT NULL AFTER `date_end` ,
				ADD `max_num_subscribe` INT( 11 ) NOT NULL AFTER `valid_time` ,
				ADD `max_sms_budget` DOUBLE NOT NULL AFTER `max_num_subscribe` ;";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 3);
				
				$query = "
				ALTER TABLE `learning_course` 
				DROP `levelUploadForum`;";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 4);
				
				$query = "ALTER TABLE `learning_coursefile` RENAME `learning_course_file` ;";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 5);
				
				$query = "ALTER TABLE `learning_course_file` 
				CHANGE `idFile` `id_file` INT( 11 ) NOT NULL AUTO_INCREMENT,
				CHANGE `idCourse` `id_course` INT( 11 ) NOT NULL DEFAULT '0',
				CHANGE `title` `title` VARCHAR( 255 ) NOT NULL;";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 6);
				
				$query = "ALTER TABLE `learning_courseuser` 
				ADD `waiting` TINYINT( 1 ) NOT NULL ,
				ADD `subscribed_by` INT( 11 ) NOT NULL ;";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 7);
				
				$query = "ALTER TABLE `learning_courseuser` DROP `onair`;";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 8);
				
				$query = "
				UPDATE `learning_courseuser` 
				SET level = 7 
				WHERE level = 8";
				$this->db_man->query($query);
				
				// invert user level 4 and 5
				
				$user_mentor = array();
				$query = "
				SELECT idUser, idCourse 
				FROM  `learning_courseuser` 
				WHERE level = 5";
				$re_mentor = $this->db_man->query($query);
				while(list($id_user, $id_c) = $this->db_man->fetchRow($re_mentor)) {
					
					$user_mentor[] = array('user' => $id_user, 'course' => $id_c);
				}
				
				$query = "
				UPDATE `learning_courseuser` 
				SET level = 5 
				WHERE level = 4";
				$this->db_man->query($query);
				reset($user_mentor);
				while(list(, $value) = each($user_mentor)) {
					
					$query = "
					UPDATE `learning_courseuser` 
					SET level = 4 
					WHERE idUser = '".$value['user']."' AND idCourse = '".$value['course']."'";
					$this->db_man->query($query);
				}
				
				// create all the group needed and subscribe user
				
				$levels = array(1, 2, 3, 4, 5, 6, 7);
				$query_course = "
				SELECT idCourse 
				FROM learning_course ";
				$re_courses = $this->db_man->query($query_course);
				while(list($id_course) = $this->db_man->fetchRow($re_courses)) {
					
					// all user group
					$id_all = $this->_registerGroup('/lms/course/'.$id_course.'/group/alluser', 'all the user of a course');
					foreach($levels as $lv_num) {
						
						$group_courselv[$id_course.'_'.$lv_num] = $this->_registerGroup('/lms/course/'.$id_course.'/subscribed/'.$lv_num);
						$this->_registerGroupMembers($group_courselv[$id_course.'_'.$lv_num], $id_all);
					}
				}
				$query = "
				SELECT idCourse, idUser, level 
				FROM learning_courseuser 
				WHERE idCourse <> 0";
				$re_courses = $this->db_man->query($query);
				while(list($id_course, $id_user, $level) = $this->db_man->fetchRow($re_courses)) {
					if($level == 8) $level = 7;
					$this->_registerGroupMembers($id_user, $group_courselv[$id_course.'_'.$level]);
				}
				
				
				$query = "UPDATE learning_course SET difficult = 'medium'";
				$this->db_man->query($query);
				
				$this->end_version = '3.0';
				return true;
			};break;
			case "3.0.2" : {
				
				$query = "INSERT INTO `core_event_class` (`idClass`, `class`, `platform`, `description`) VALUES ('', 'UserCourseBuy', 'lms', '_EVENT_USERCOURSEBUY');
        			INSERT INTO `core_event_consumer_class` ( `idConsumer` , `idClass` )
						VALUES (
						'1', LAST_INSERT_ID()
						);
					INSERT INTO `core_event_manager` ( `idEventMgr` , `idClass` , `permission` , `channel` , `recipients` , `show_level` )
						VALUES (
						'', LAST_INSERT_ID(), 'mandatory', 'email', 'user', 'godadmin,admin,user'
						);";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 1);
				
				$this->end_version = '3.0.3';
				return true;
			};break;
			
		}
		return true;
	}
}

?>