<?php

class Upgrade_SettingLms extends Upgrade {
	
	var $platfom = 'lms';
	
	var $mname = 'setting';
	
	/**
	 * upgrade the module version
	 * @param string 	$start_version 	the start version, automaticaly prooceed to the next
	 *
	 * @return mixed 	true if the version jump was successful, else an array with an error code and an error message
	 * 					array( 'error_code', 'error_msg' )
	 **/
	function oneStepUpgrade($start_version) {
		
		switch($start_version) {
			case "2.0.4" : {
				
				$query = "ALTER TABLE `learning_setting` ADD `extra_info` TEXT NOT NULL ;";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 1);
				
				$query = "DELETE FROM learning_setting WHERE param_name = 'pathcourse';
				DELETE FROM learning_setting WHERE param_name = 'pathmessage';
				DELETE FROM learning_setting WHERE param_name = 'pathforum';
				DELETE FROM learning_setting WHERE param_name = 'pathlesson';
				DELETE FROM learning_setting WHERE param_name = 'pathsponsor';
				DELETE FROM learning_setting WHERE param_name = 'pathscorm';
				DELETE FROM learning_setting WHERE param_name = 'pathchat';
				DELETE FROM learning_setting WHERE param_name = 'pathprj';
				DELETE FROM learning_setting WHERE param_name = 'pathuserfiles';
				DELETE FROM learning_setting WHERE param_name = 'UserFilesPath';
				DELETE FROM learning_setting WHERE param_name = 'UserFilePath';
				
				DELETE FROM learning_setting WHERE regroup = '3';
				DELETE FROM learning_setting WHERE regroup = '4';
				DELETE FROM learning_setting WHERE regroup = '5';";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 2);
				
				$query = "
				UPDATE `learning_setting` SET param_value = CONCAT(param_value, 'doceboLms/') WHERE param_name = 'url';
				INSERT INTO `learning_setting` VALUES ('pathcourse', 'course/', 'string', 255, 2, 2, 1, 0, '');
				INSERT INTO `learning_setting` VALUES ('pathmessage', 'message/', 'string', 255, 2, 5, 1, 0, '');
				INSERT INTO `learning_setting` VALUES ('pathforum', 'forum/', 'string', 255, 2, 3, 1, 0, '');
				INSERT INTO `learning_setting` VALUES ('pathproject', 'project/', 'string', 255, 2, 3, 1, 0, '');
				INSERT INTO `learning_setting` VALUES ('pathlesson', 'item/', 'string', 255, 2, 4, 1, 0, '');
				INSERT INTO `learning_setting` VALUES ('visu_course', '10', 'int', 5, 1, 2, 1, 0, '');
				INSERT INTO `learning_setting` VALUES ('pathsponsor', 'sponsor/', 'string', 255, 2, 8, 1, 0, '');
				INSERT INTO `learning_setting` VALUES ('pathscorm', 'scorm/', 'string', 255, 2, 7, 1, 0, '');
				INSERT INTO `learning_setting` VALUES ('pathchat', 'chat/', 'string', 255, 2, 1, 1, 0, '');
				INSERT INTO `learning_setting` VALUES ('user_use_mygroup', '1', 'menuvoice_course_public', 1, 7, 4, 1, 0, '/public/mygroup/view');
				INSERT INTO `learning_setting` VALUES ('course_list_plan', 'on', 'enum', 3, 1, 8, 1, 0, '');
				INSERT INTO `learning_setting` VALUES ('visuNewsHomePage', '4', 'int', 5, 1, 0, 1, 1, '');
				INSERT INTO `learning_setting` VALUES ('visuItem', '10', 'int', 5, 1, 1, 1, 0, '');
				INSERT INTO `learning_setting` VALUES ('user_use_alert', '1', 'menuvoice_course_public', 1, 7, 3, 1, 0, '/public/userevent/view');
				INSERT INTO `learning_setting` VALUES ('pathprj', 'project/', 'string', 255, 2, 0, 1, 1, '');
				INSERT INTO `learning_setting` VALUES ('user_use_profile', '1', 'menuvoice_course_public', 1, 7, 5, 1, 0, '/public/profile/view;/public/profile/mod');
				INSERT INTO `learning_setting` VALUES ('pathtest', 'test/', 'string', 255, 2, 9, 1, 0, '');
				INSERT INTO `learning_setting` VALUES ('use_coursepath', '1', 'menuvoice', 1, 7, 1, 1, 0, '/coursepath/view');
				INSERT INTO `learning_setting` VALUES ('use_course_catalogue', '1', 'menuvoice', 1, 7, 2, 1, 0, '/catalogue/view');
				INSERT INTO `learning_setting` VALUES ('on_catalogue_empty', 'on', 'enum', 3, 1, 10, 1, 0, '');
				INSERT INTO `learning_setting` VALUES ('forum_as_table', 'off', 'enum', 3, 1, 6, 1, 0, '');";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 3);
				
				$query = "
				UPDATE `learning_setting` 
				SET param_load = 1, param_value = '3.0' 
				WHERE param_name = 'lms_version'";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 4);
				
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 5);
				
				$this->end_version = '3.0';
				return true;
			};break;
			case "3.0.2" : {
				
				$query = "INSERT INTO `learning_setting` VALUES ('user_use_coursecatalogue', '1', 'menuvoice_course_public', 1, 7, 6, 1, 0, '/public/coursecatalogue/view')";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 1);
				
				$query = "INSERT INTO `learning_setting` VALUES ('home_course_catalogue', 'off', 'enum', 3, 1, 10, 1, 0, '')";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 2);
				
				$query = "INSERT INTO `learning_setting` VALUES ('stop_concurrent_user', 'on', 'enum', 3, 3, 1, 1, 0, '')";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 3);
				
				$this->end_version = '3.0.3';
				return true;
			};break;
		}
		return true;
	}
	
}

?>