<?php

class Upgrade_Settingscs extends Upgrade {
	
	var $platfom = 'scs';
	
	var $mname = 'setting';
	
	/**
	 * upgrade the module version
	 * @param string 	$start_version 	the start version, automaticaly prooceed to the next
	 *
	 * @return mixed 	true if the version jump was successful, else an array with an error code and an error message
	 * 					array( 'error_code', 'error_msg' )
	 **/
	function oneStepUpgrade($start_version) {
		
		switch($start_version) {
			case "2.0.4" : {
				
				$query = "CREATE TABLE `conference_setting` (
				  `param_name` varchar(255) NOT NULL default '',
				  `param_value` varchar(255) NOT NULL default '',
				  `value_type` varchar(255) NOT NULL default 'string',
				  `max_size` int(3) NOT NULL default '255',
				  `regroup` int(5) NOT NULL default '0',
				  `sequence` int(5) NOT NULL default '0',
				  `param_load` tinyint(1) NOT NULL default '1',
				  `hide_in_modify` tinyint(1) NOT NULL default '0',
				  `extra_info` text NOT NULL,
				  PRIMARY KEY  (`param_name`)
				)";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 1);
				
				$query = "
				INSERT INTO `conference_setting` VALUES ('defaultTemplate', 'standard', 'string', 255, 0, 1, 1, 1, '');
				INSERT INTO `conference_setting` VALUES ('url_checkin_teleskill', 'http://ews.teleskill.it/ews/checkin.asp', 'string', 255, 2, 1, 1, 0, '');
				INSERT INTO `conference_setting` VALUES ('url_videoconference_teleskill', '', 'string', 255, 2, 2, 1, 0, '');
				INSERT INTO `conference_setting` VALUES ('org_name_teleskill', '', 'string', 255, 2, 4, 1, 0, '');
				INSERT INTO `conference_setting` VALUES ('code_teleskill', '', 'string', 255, 2, 3, 1, 0, '');";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 2);
				
				$this->end_version = '3.0';
				return true;
			};break;
			case "3.0.2" : {
				
				$query = "
				UPDATE `conference_setting` 
				SET param_name = 'url_checkin_teleskill' 
				WHERE param_value = 'http://ews.teleskill.it/ews/server.asp'";
				if(!$this->db_man->query($query)) return $this->_getErrArray($start_version, 1);
				
				$this->end_version = '3.0.3';
				return true;
			};break;
			
		}
		return true;
	}
}

?>