<?php


function sl_open_fileoperations_ftp() {
	$ftpuser = $GLOBALS['ftpuser'];
	$ftppass = $GLOBALS['ftppass'];
	$ftphost = $GLOBALS['ftphost'];
	$ftpport = $GLOBALS['ftpport'];

	$result = FALSE;
	
	if( isset($GLOBALS['ftptimeout']) ) {
		$timeout = $GLOBALS['ftptimeout'];
	} else {
		$timeout = ini_get('max_execution_time');
		if( $timeout == 0 ) {
			$timeout = 20;
		} elseif( $timeout > 60 ) {
			$timeout = 50;
		} else {
			$timeout = round(($timeout*8)/10);
		}
	}
	
	$GLOBALS['ftpConn'] = @ftp_connect( $ftphost, $ftpport, $timeout );
	if( $GLOBALS['ftpConn'] === FALSE ) {
		return FALSE;
	}
	if( @ftp_login($GLOBALS['ftpConn'], $ftpuser, $ftppass) )
		return TRUE;
	else
		return FALSE;
}

function sl_close_fileoperations_ftp() {
	ftp_close($GLOBALS['ftpConn']);
}


function chooseLang() {
	
	echo '<h3 class="title_area">'._CHOOSE_LANG.'</h3>';
	
	echo Form::openForm('choose_lang', 'index.php')
		.Form::getHidden('step', 'step', 'choose_start')
		.Form::openElementSpace()
		
		.Form::getDropdown(_LANG_SELECTION, 'sel_lang', 'sel_lang', DoceboUpgradeGui::getLanguageList("language"))

		.Form::closeElementSpace()
		.Form::openButtonSpace()
		
		.Form::getButton('upgrade', 'upgrade', _NEXTSTEP)
		
		.Form::closeButtonSpace()
		.Form::closeForm();
}

function chooseStart() {
	
	echo '<h3 class="title_area">'._TITLE_1OF2.'</h3>';
	
	$lang = DoceboUpgradeGui::getLanguage();
	$db_sorg = new DoceboSql($GLOBALS['dbhost'], $GLOBALS['dbuname'], $GLOBALS['dbpass'], $GLOBALS['dbname']);
	
	$query = "
	SELECT param_value
	FROM ".$GLOBALS['prefix_fw']."_setting
	WHERE param_name = 'core_version'";
	list($version) = $db_sorg->fetchRow($db_sorg->querySingle($query));
	
	$db_sorg->closeConn();
	if(($lang == 'portuguese' || $lang == 'portuguese-br') && $version == '3.0.4') {
		
		echo 'Hello, we saw that you are trying to upgrade docebo from the Brazilian interface, '
				.'due to a package error we noticed that the brazilian language were installed with blank definition. '
				.'Please operate as follows:<br/>'
			.'<br />'
			.'- Upgrade docebo from the english version<br/>'
			.'- If you need to upgrade portguese language please do it manually from the admin area after upgrading to docebo 3.0.5<br/>';
		return;
	}
	
	
	if (version_compare(phpversion(), "5.0.0", "<")) {
		if(!function_exists('overload')) {
			
			echo '<strong class="error">'._YOU_DONT_HAVE_FUNCTION_OVERLOAD.'</strong><br />';
			return;
		}
		if (!extension_loaded('domxml')) {
			echo '<strong class="error">'._DOMXML_REQUIRED.'</strong><br />';
			return;
		}
	}
	
	require_once($GLOBALS['where_upgrade'].'/lib/lib.upgrade_management.php');
	$upd_man = new UpdateManager();
	if(!$upd_man->openXmlDescription($GLOBALS['where_upgrade'].'/lib/upgrade_info.xml')) {
		
		echo 'Error reading xml instructions : '.$GLOBALS['where_upgrade'].'/lib/upgrade_info.xml';
		return ;
	}
	$start_version_list = $upd_man->getStartVersionList();
	
	// Check some thigs
	$exists_old_dir 	= array();
	$dir_mustnot_exists = array('addons', 'admin', 'class.module', 'core', 'fileCourses', 
		'menu', 'modules', 'patch', 'templates');
	
	foreach($dir_mustnot_exists as $dir_name) {
		
		if(is_dir($GLOBALS['where_upgrade'].'/../'.$dir_name.'/')) {
			$exists_old_dir[] = $dir_name;
		}
	}
	if(!empty($exists_old_dir)) {
		
		echo '<strong class="error">'._IS_PRESENT_DIRECTORIES.'</strong>'
			.'<ul><li>'.implode('</li><li>',$exists_old_dir).'</li></ul><br />';
		return;
	}
	
	// Check some thigs
	$lacking_dir 	= array();
	$dir_must_exists = array('doceboCore', 'doceboCms', 'doceboKms', 'doceboLms', 'doceboScs');
	foreach($dir_must_exists as $dir_name) {
		
		if(!is_dir($GLOBALS['where_upgrade'].'/../'.$dir_name.'/')) {
			$lacking_dir[] = $dir_name;
		}
	}
	if(!empty($lacking_dir)) {
		
		echo '<strong class="error">'._LACKING_DIRECTORIES.'</strong>'
			.'<ul><li>'.implode('</li><li>',$lacking_dir).'</li></ul><br />';
		return;
	}
	
	// Write permission 
	$checked_dir 	= array();
	$dir_to_check = array(
		'files/common/users', 
		'files/doceboCore/photo', 
		'files/doceboLms/course',
		'files/doceboLms/forum', 
		'files/doceboLms/item', 
		'files/doceboLms/message', 
		'files/doceboLms/project', 
		'files/doceboLms/scorm', 
		'files/doceboLms/test' );
	foreach($dir_to_check as $dir_name) {
		
		if(!is_dir($GLOBALS['where_upgrade'].'/../'.$dir_name.'/')) {
			$checked_dir[] = $dir_name;
		} elseif(!is_writable($GLOBALS['where_upgrade'].'/../'.$dir_name.'/')) {
			$checked_dir[] = $dir_name;
		}
	}
	if(!empty($checked_dir)) {
		
		echo '<strong class="error">'._CHECKED_DIRECTORIES.'</strong>'
			.'<ul><li>'.implode('</li><li>',$checked_dir).'</li></ul><br /><br />';
	}
	
	// Empty dir
	$empty_dir 	= array();
	$dir_to_check = array('files/doceboLms/course',
		'files/doceboLms/scorm');
	foreach($dir_to_check as $dir_name) {
		
		if(is_dir($GLOBALS['where_upgrade'].'/../'.$dir_name.'/')) {
			
			$i = 0;
			$tmp = dir($GLOBALS['where_upgrade'].'/../'.$dir_name.'/');
			while($elem = $tmp->read()) {
				
				if(($elem != ".") && ($elem != "..") && ($elem != "index.htm")) ++$i;
			}
			closedir($tmp->handle);
			if($i < 2) $empty_dir[] = $dir_name;
		}
	}
	if(!empty($empty_dir)) {
		
		echo '<strong class="error">'._EMPTY_DIRECTORIES.'</strong>'
			.'<ul><li>'.implode('</li><li>',$empty_dir).'</li></ul><br />';
	}
	
	// control db connection
	$db_sorg = new DoceboSql($GLOBALS['dbhost'], $GLOBALS['dbuname'], $GLOBALS['dbpass'], $GLOBALS['dbname'], false);
	if( !$db_sorg->isConnected() || !$db_sorg->isDbSelected() ) {
		
		echo '<strong class="error">'._CANT_CONNECT_WITH_DB.'</strong><br />';
		return;
	}
	$db_sorg->closeConn();
	
	// control ftp connectio
	if($GLOBALS['uploadType'] == 'ftp') {
		if(!sl_open_fileoperations_ftp()) {
			
			echo '<strong class="error">'._CANT_CONNECT_WITH_FTP.'</strong><br />';
			return;
		}
		sl_close_fileoperations_ftp();
	}
	
	// Select from to
	echo Form::openForm('step1of2', 'index.php')
		.Form::getHidden('step', 'step', 'update')
		.Form::openElementSpace()
		
		.Form::getDropdown(_START_VERSION, 'start_version', 'start_version', $start_version_list, $version)
		.Form::getLineBox(_END_VERSION, $upd_man->getMaxEndVersion())
		
		.Form::closeElementSpace()
		.Form::openButtonSpace()
		
		.Form::getButton('upgrade', 'upgrade', _DOUPGRADE)
		
		.Form::closeButtonSpace()
		.Form::closeForm();
}

function update() {
	
	require_once($GLOBALS['where_upgrade'].'/lib/lib.docebosql.php');
	require_once($GLOBALS['where_upgrade'].'/lib/class.upgrade_def.php');
	require_once($GLOBALS['where_upgrade'].'/lib/lib.upgrade_management.php');
	
	// open database connection
	$db_sorg = new DoceboSql($GLOBALS['dbhost'], $GLOBALS['dbuname'], $GLOBALS['dbpass'], $GLOBALS['dbname']);
	
	$upd_man = new UpdateManager();
	if(!$upd_man->openXmlDescription($GLOBALS['where_upgrade'].'/lib/upgrade_info.xml')) {
		
		echo 'Error reading xml instructions : '.$GLOBALS['where_upgrade'].'/lib/upgrade_info.xml';
	}
	
	echo '<h3 class="title_area">'._TITLE_2OF2.'</h3>';
	// Module description 
	$modules = $upd_man->getModulesDescriptors();
	
	// version to travel with
	$version_list = $upd_man->getVersionListFrom($_POST['start_version']);
	
	foreach($version_list as $version) {
		
		$step_sequence = $upd_man->getVersionStepSequence($version);
		
		echo '<h4 class="title_area">'._UPGRADING_VERSION.$version.'</h4>'
			.'<ul>';
		$error_occurred = false;
		foreach($step_sequence as $module_id) {
			
			require_once($GLOBALS['where_upgrade'].'/class_'.$modules[$module_id]['platform'].'/'.$modules[$module_id]['class_file']);
			
			$class_name = $modules[$module_id]['class_name'];
			$upd = eval("return new $class_name();");
			
			$upd->setDbMan($db_sorg);
			$re = $upd->oneStepUpgrade($version);
			if(is_array($re)) {
				
				echo '<li><strong class="upd_error">'._FAILED_OPERATION.'</strong>'.$re['error_code'].'<br />'
					.$re['error_msg']
					.'</li>'
					.'</ul>';
				return;
				$error_occurred = true;
			} else {
				
				echo '<li><strong class="upd_ok">'._SUCCESSFULL_OPERATION.'</strong>'.$module_id.'</li>';
			}
		}
		echo '</ul>';
	}
	if(!$error_occurred) {
		
		$platform = array('framework', 'scs', 'lms', 'cms', 'kms');
		$langlist = DoceboUpgradeGui::getLanguageList();
		
		foreach ($platform as $platform_code) {
			
			$_SESSION["lang_to_load"][$platform_code]=array();
			foreach($langlist as $lang) {
				
				$_SESSION["lang_to_load"][$platform_code][$lang]=$lang;
			}
		}
		echo Form::openForm('step2of3_toend', 'index.php')
			.Form::getHidden('step', 'step', 'loadlang')
			.( version_compare($_POST['start_version'], '3.0.2', '<=')   
				? Form::getHidden('lastutf', 'lastutf', 'true')
				: '' )
			.Form::openButtonSpace()
			
			.Form::getButton('upgrade_add', 'upgrade_add', _NEXT_ONLY_ADD)
			
			.Form::closeButtonSpace()
			.Form::closeForm()
			
			.Form::openForm('step2of3_tolang', 'index.php')
			.Form::getHidden('step', 'step', 'loadlang')
			.( version_compare($_POST['start_version'], '3.0.2', '<=')   
				? Form::getHidden('lastutf', 'lastutf', 'true')
				: '' )
			.Form::openButtonSpace()
			
			.Form::getButton('upgrade_over', 'upgrade_over', _NEXT_OVERWRITELANG)
			
			.Form::closeButtonSpace()
			.Form::closeForm();
			
	}
}

function loadLang() {
	
	require_once($GLOBALS['where_upgrade'].'/lib/lib.docebosql.php');
	require_once($GLOBALS['where_upgrade'].'/lib/lib.lang.php');
	
	$GLOBALS["db"] = new DoceboSql($GLOBALS['dbhost'], $GLOBALS['dbuname'], $GLOBALS['dbpass'], $GLOBALS['dbname']);
	
	if(isset($_POST['upgrade_over'])) $overwrite = true;
	else $overwrite = false;
	
	$goto_next_step = FALSE;
	
	$platform_code 	= end(array_keys($_SESSION["lang_to_load"]));
	$lang 			= array_pop($_SESSION["lang_to_load"][$platform_code]);
	
	if(count($_SESSION["lang_to_load"][$platform_code]) < 1) {
		
		array_pop($_SESSION["lang_to_load"]);
	}
	if (count($_SESSION["lang_to_load"]) < 1) {
		// all language loaded
		$goto_next_step = TRUE;
	}
	
	$text ='<h3 class="title_area">'._TITLE_STEP3.'</h3>'
		.Form::openForm('upgrade', 'index.php')
		.Form::openElementSpace()
		
		._LANG_INSTALLED." ("._LANGUAGE.": <b>".$lang."</b>, "._PLATFORM." : <b>".$platform_code."</b>)";
	
	$fn=$GLOBALS['where_upgrade'].'/data/lang/platform['.$platform_code.']_lang['.$lang.'].xml';
	
	if(file_exists($fn)) lang_importXML($fn, $overwrite);
	else $text .= '<p>'._LANGUAGE_NOT_FOUND.'<p>';

	$GLOBALS["db"]->closeConn();

	if(isset($_POST['lastutf'])) $last_step = 'changeutf';
	else $last_step = 'end';

	$text .= Form::getHidden('step', 'step', ( !$goto_next_step ? 'loadlang' : $last_step ) )
		.( isset($_POST['upgrade_over'])
			? Form::getHidden('upgrade_over', 'upgrade_over', '1' )
			: '' )
		.( isset($_POST['lastutf'])
			? Form::getHidden('lastutf', 'lastutf', 'true' )
			: '' )
		.Form::closeElementSpace()
		
		.Form::openButtonSpace()
		.Form::getButton('next', 'next', _NEXT)
		.Form::closeButtonSpace()
		.Form::closeForm();
	echo $text;
}

function changeutf() {

	require(dirname(__FILE__).'/../goto_utf/scan_db.php');

	$text ='<h3 class="title_area">'._CONVERT_TO_UTF.'</h3>'
			.'<p>'._CONVERT_TO_UTF_COMMENT.'</p>';
	

	$report = convertToUtf8Db($GLOBALS['dbhost'], 
					$GLOBALS['dbuname'], 
					$GLOBALS['dbpass'], 
					$GLOBALS['dbname']);
	
	echo $text.$report;
	echo Form::openForm('step3of3_utf', 'index.php')
		.Form::getHidden('step', 'step', 'end')
		.Form::openButtonSpace()
		
		.Form::getButton('next', 'next', _NEXT)
		
		.Form::closeButtonSpace()
		.Form::closeForm();		
}

function endstep() {
	
	$text ='<h3 class="title_area">'._ENDSTEP.'</h3>'
			.'<p>'._END_PHRASE.'</p>';
	echo $text;
}

// XXX: switch
function dispatchStep($step) {
	
	switch($step) {
		case "end" : endstep();break;
		case "changeutf" : changeutf();break;
		case "loadlang" : loadLang();break;
		case "update" : update();break;
		case "choose_start" : chooseStart();break;
		default : chooseLang();break;
	}
}

?>